Package: MatrixQCvis
Type: Package
Title: Shiny-based interactive data-quality exploration for omics data
Version: 1.20.0
Date: 2025-06-26
Authors@R: c(person("Thomas", "Naake", role = c("aut", "cre"), 
		email = "thomasnaake@googlemail.com",
		comment = c(ORCID = "0000-0001-7917-5580")),
    person("Wolfgang", "Huber", role = c("aut"), 
		email = "wolfgang.huber@embl.de",
		comment = c(ORCID = "0000-0002-0474-2218")))
VignetteBuilder: knitr
Description: 
	Data quality assessment is an integral part of preparatory data analysis 
	to ensure sound biological information retrieval. 
	We present here the MatrixQCvis package, which provides shiny-based 
	interactive visualization of data quality metrics at the per-sample and 
	per-feature level. It is broadly applicable to quantitative omics data types 
	that come in matrix-like format (features x samples). It enables the detection 
	of low-quality samples, drifts, outliers and batch effects in data sets.
	Visualizations include amongst others bar- and violin plots of the (count/intensity) 
	values, mean vs standard deviation plots, MA plots, empirical cumulative 
	distribution function (ECDF) plots, visualizations of the distances 
	between samples, and multiple 
	types of dimension reduction plots. Furthermore, MatrixQCvis allows for 
	differential expression analysis based on the limma (moderated t-tests) and 
	proDA (Wald tests) packages. MatrixQCvis builds upon the popular 
	Bioconductor SummarizedExperiment S4 class and enables thus the facile 
	integration into existing workflows. The package 
	is especially tailored towards metabolomics and proteomics mass spectrometry 
	data, but also allows to assess the data quality of other data types that 
	can be represented in a SummarizedExperiment object.
Depends: R (>= 4.1.0), DT (>= 0.33), SummarizedExperiment (>= 1.20.0),
        plotly (>= 4.9.3), shiny (>= 1.6.0)
Imports: ComplexHeatmap (>= 2.7.9), dplyr (>= 1.0.5), ExperimentHub (>=
        2.6.0), ggplot2 (>= 3.3.3), grDevices (>= 4.1.0), Hmisc (>=
        4.5-0), htmlwidgets (>= 1.5.3), impute (>= 1.65.0), imputeLCMD
        (>= 2.0), limma (>= 3.47.12), MASS (>= 7.3-58.1), methods (>=
        4.1.0), pcaMethods (>= 1.83.0), proDA (>= 1.5.0), rlang (>=
        0.4.10), rmarkdown (>= 2.7), Rtsne (>= 0.15), shinydashboard
        (>= 0.7.1), shinyhelper (>= 0.3.2), shinyjs (>= 2.0.0), stats
        (>= 4.1.0), sva (>= 3.52.0), tibble (>= 3.1.1), tidyr (>=
        1.1.3), umap (>= 0.2.7.0), UpSetR (>= 1.4.0), vsn (>= 3.59.1)
Suggests: BiocGenerics (>= 0.37.4), BiocStyle (>= 2.19.2), hexbin (>=
        1.28.2), httr (>= 1.4.7), jpeg (>= 0.1-10), knitr (>= 1.33),
        statmod (>= 1.5.0), testthat (>= 3.0.2)
biocViews: Visualization, ShinyApps, GUI, QualityControl,
        DimensionReduction, Metabolomics, Proteomics, Transcriptomics
License: GPL-3
Encoding: UTF-8
RoxygenNote: 7.3.1
git_url: https://git.bioconductor.org/packages/MatrixQCvis
git_branch: RELEASE_3_23
git_last_commit: 521dbc7
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 23:05:01 UTC; biocbuild
Author: Thomas Naake [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-7917-5580>),
  Wolfgang Huber [aut] (ORCID: <https://orcid.org/0000-0002-0474-2218>)
Maintainer: Thomas Naake <thomasnaake@googlemail.com>

# _MatrixQCvis_ - Interactive exploration of data quality

## Overview

The _MatrixQCvis_ package provides shiny-based interactive visualization of 
data quality metrics at the per-sample and per-feature level. It is broadly 
applicable to quantitative omics data types that come in matrix-like format 
(features x samples). It enables the detection of low-quality samples, drifts, 
outliers and batch effects in data sets. Visualizations include amongst 
others bar- and violin plots of the (count/intensity) values, mean vs standard 
deviation plots, MA plots, empirical cumulative distribution function (ECDF) 
plots, visualizations of the distances between samples, and multiple types of 
dimension reduction plots. 

Furthermore, _MatrixQCvis_ allows for differential expression analysis based 
on the _limma_ (moderated t-tests) and _proDA_ (Wald tests) packages. 
_MatrixQCvis_ builds upon the popular Bioconductor _SummarizedExperiment_ 
S4 class and enables thus the facile integration into existing workflows. 

The package is especially tailored towards metabolomics and proteomics mass 
spectrometry data, but also allows to assess the data quality of other data 
types that can be represented in a _SummarizedExperiment_ object.

## Installation

To install _MatrixQCvis_ from GitHub, install the package via `devtools`:
```r 
if (!requireNamespace("devtools", quietly = TRUE))
    install.packages("devtools")
library(devtools)
install_github("tnaake/MatrixQCvis")
```

Alternatively, the _MatrixQCvis_ package can also be installed via the 
Bioconductor project. 

For the [release](http://bioconductor.org/packages/release/bioc/html/MatrixQCvis.html) 
version enter:

```r
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")
BiocManager::install("MatrixQCvis")
```

For the [development](http://bioconductor.org/packages/devel/bioc/html/MatrixQCvis.html) 
version enter:
```r
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

# the following initializes usage of Bioc devel
BiocManager::install(version = "devel")

BiocManager::install("MatrixQCvis")
```

The version at the Bioconductor development branch and the code in the Github repository 
are places where we publicly disclose our development process and users are 
supposed to refer to the Bioconductor releae version as the authoritative version for 
use.

## Quick start

_MatrixQCvis_ is based on the _SummarizedExperiment_ class. The shiny 
application can be started with passing a _SummarizedExperiment_ object 
(in the following denoted as _se_) or without such an object. The 
second function call will load an interface to load a 
_SummarizedExperiment_ object stored in a RDS file. 

```r
library("MatrixQCvis")

## initialize the application with passing a SummarizedExperiment object
shinyQC(se)

## initialize the application without passing a SummarizedExperiment object
shinyQC()
```

#' @name tP_PCAUI
#' 
#' @title Tab panel UI for tab panel 'PCA'
#' 
#' @description
#' The module defines the UI in the tab panel 'PCA'.
#' 
#' @details 
#' \code{tP_PCAUI} returns the HTML code for the tab-pane 'PCA'. 
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' 
#' @return 
#' \code{shiny.tag} with HTML content
#' 
#' @author Thomas Naake
#' 
#' @examples
#' tP_PCAUI("test")
#' 
#' @importFrom shiny NS tabPanel fluidRow column downloadButton
#' @importFrom shiny checkboxInput plotOutput
#' @importFrom shinydashboard box
#' @importFrom shinyhelper helper
#' @importFrom plotly plotlyOutput
#' 
#' @noRd
tP_PCAUI <- function(id) {
    ns <- shiny::NS(id)
    tabPanel(title = "PCA", value = "PCA",
        shiny::fluidRow(
            shiny::column(width = 12, 
                plotly::plotlyOutput(outputId = ns("plot"), height = "auto") |>
                    shinyhelper::helper(content = "tabPanel_PCA"),
                shiny::downloadButton(outputId = ns("downloadPlot"), ""))
        ),
        shiny::fluidRow(
            shinydashboard::box(title = "Parameters", width = 6, 
                collapsible = TRUE, 
                shiny::fluidRow(
                    shiny::column(width = 6,
                        shiny::selectInput(inputId = ns("x"), 
                            label = "x-axis", choices = "PC1", 
                            selected = "PC1")),
                    shiny::column(width = 6,
                        shiny::selectInput(inputId = ns("y"), 
                            label = "y-axis", choices = "PC2", 
                            selected = "PC2"))
                ), 
                shiny::fluidRow(
                    shiny::column(3, 
                        shiny::checkboxInput(inputId = ns("scale"),
                            label = "scale", value = TRUE)),
                    shiny::column(3, 
                        shiny::checkboxInput(inputId = ns("center"),
                           label = "center", value = TRUE)),
                    shiny::column(width = 6, 
                        shiny::selectInput(inputId = ns("color"), 
                            label = "Color", choices = "none"))
                ),
                shiny::fluidRow(
                    shiny::column(width = 6),
                    shiny::column(width = 6, 
                        shiny::selectInput(inputId = ns("size"), 
                            label = "Size", choices = "none"))  
                )
            ),
            shiny::column(width = 6, 
                shinydashboard::box(title = "Scree plot", width = 12, 
                    collapsible = TRUE, collapsed = TRUE,
                    shiny::plotOutput(outputId = ns("PCAVarplot"))),
                shinydashboard::box(title = "Loadings plot", width = 12,
                    collapsible = TRUE, collapsed = TRUE,
                    plotly::plotlyOutput(outputId = ns("PCALoadings")))
            )
        )
    )
}

#' @name tP_PCoAUI
#' 
#' @title Tab panel UI for tab panel 'PCoA'
#' 
#' @description
#' The module defines the UI in the tab panel 'PCoA'.
#' 
#' @details 
#' \code{tP_PCoAUI} returns the HTML code for the tab-pane 'PCoA'. 
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' 
#' @return 
#' \code{shiny.tag} with HTML content
#'
#' @author Thomas Naake
#' 
#' @examples
#' tP_PCoAUI("test")
#' 
#' @importFrom shiny NS tabPanel fluidRow column uiOutput selectInput
#' @importFrom shinydashboard box
#' @importFrom shinyhelper helper
#' 
#' @noRd
tP_PCoAUI <- function(id) {
    ns <- shiny::NS(id)
    shiny::tabPanel(title = "PCoA", 
        shiny::fluidRow(
            shiny::column(width = 12, 
                plotly::plotlyOutput(outputId = ns("plot"), 
                                                        height = "auto") |>
                    shinyhelper::helper(content = "tabPanel_PCoA"),
                shiny::downloadButton(outputId = ns("downloadPlot"), ""))
            ), 
        shiny::fluidRow(
            shinydashboard::box(title = "Parameters", width = 6, 
                collapsible = TRUE, 
                shiny::fluidRow(
                    shiny::column(width = 6,
                        shiny::selectInput(inputId = ns("x"), 
                            label = "x-axis", choices = "Axis.1", 
                            selected = "Axis.1")),
                    shiny::column(width = 6,
                        shiny::selectInput(inputId = ns("y"), 
                            label = "y-axis", choices = "Axis.2", 
                            selected = "Axis.2"))
                ),
                shiny::fluidRow(
                    shiny::column(width = 6, 
                        shiny::selectInput(inputId = ns("dist"),
                            label = "Distance measure",
                            choices = c("euclidean", "maximum", 
                                "manhattan", "canberra", "minkowski"), 
                            selected = "euclidean")),
                    shiny::column(width = 6, 
                        shiny::selectInput(inputId = ns("color"), 
                            label = "Color", choices = "none"))
                ),
                shiny::fluidRow(
                    shiny::column(width = 6),
                    shiny::column(width = 6, 
                        shiny::selectInput(inputId = ns("size"), 
                            label = "Size", choices = "none"))
                )
            )
        )
    )
}

#' @name tP_NMDSUI
#' 
#' @title Tab panel UI for tab panel 'NMDS'
#' 
#' @description
#' The module defines the UI in the tab panel 'NMDS'.
#' 
#' @details
#' \code{tP_NMDSUI} returns the HTML code for the tab-pane 'NMDS'. 
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' 
#' @return 
#' \code{shiny.tag} with HTML content
#' 
#' @author Thomas Naake
#' 
#' @examples
#' tP_NMDSUI("test")
#' 
#' @importFrom shiny NS tabPanel fluidRow column downloadButton 
#' @importFrom shiny uiOutput selectInput
#' @importFrom shinydashboard box
#' @importFrom shinyhelper helper
#' @importFrom plotly plotlyOutput
#' 
#' @noRd
tP_NMDSUI <- function(id) {
    ns <- shiny::NS(id)
    shiny::tabPanel(title = "NMDS", 
        shiny::fluidRow(
            shiny::column(width = 12, 
                plotly::plotlyOutput(outputId = ns("plot"), height = "auto") |>
                    shinyhelper::helper(content = "tabPanel_NMDS"),
                shiny::downloadButton(outputId = ns("downloadPlot"), ""))), 
        shiny::fluidRow(
            shinydashboard::box(title = "Parameters", width = 6, 
                collapsible = TRUE,
                shiny::fluidRow(
                    shiny::column(width = 6,
                        shiny::selectInput(inputId = ns("x"), 
                            label = "x-axis", choices = "MDS1", 
                            selected = "MDS1")),
                    shiny::column(width = 6,
                        shiny::selectInput(inputId = ns("y"), 
                            label = "y-axis", choices = "MDS2", 
                            selected = "MDS2"))
                ),
                shiny::fluidRow(
                    shiny::column(width = 6, 
                        shiny::selectInput(inputId = ns("dist"),
                            label = "Distance measure",
                            choices = c("euclidean", "maximum", 
                                "manhattan", "canberra", "minkowski"), 
                            selected = "euclidean")),
                    shiny::column(width = 6, 
                        shiny::selectInput(inputId = ns("color"), 
                        label = "Color", choices = "none"))
                ),
                shiny::fluidRow(
                    shiny::column(width = 6),
                    shiny::column(width = 6, 
                        shiny::selectInput(inputId = ns("size"), 
                            label = "Size", choices = "none"))
                )
            )
        )
    )
}

#' @name tP_tSNEUI
#' 
#' @title Tab panel UI for tab panel 'tSNE'
#' 
#' @description
#' The module defines the UI in the tab panel 'tSNE'.
#' 
#' @details
#' \code{tP_tSNEUI} returns the HTML code for the tab-pane 'tSNE'. 
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' 
#' @return 
#' \code{shiny.tag} with HTML content
#' 
#' @author Thomas Naake
#' 
#' @examples
#' tP_tSNEUI("test")
#' 
#' @importFrom shiny NS tabPanel fluidRow column downloadButton 
#' @importFrom shiny uiOutput selectInput plotOutput sliderInput checkboxInput
#' @importFrom shinydashboard box
#' @importFrom shinyhelper helper
#' @importFrom plotly plotlyOutput
#' 
#' @noRd
tP_tSNEUI <- function(id) {
    ns <- shiny::NS(id)
    shiny::tabPanel(title = "tSNE", 
        shiny::fluidRow(
            shiny::column(width = 12, 
                plotly::plotlyOutput(outputId = ns("plot"), height = "auto") |>
                    shinyhelper::helper(content = "tabPanel_tSNE"),
                shiny::downloadButton(outputId = ns("downloadPlot"), ""))),
        shiny::fluidRow(
            shinydashboard::box(
                title = "Principal components", status = "primary", width = 12,
                collapsible = TRUE, collapsed = TRUE,
                shiny::fluidRow(
                    shiny::column(width = 6, 
                        shiny::plotOutput(outputId = ns("PCAVarplotPerm"))),
                    shiny::column(width = 6, 
                        shiny::plotOutput(outputId = ns("PCAVarPvalueplot")))
                )
            )
        ),
        shiny::fluidRow(
            shinydashboard::box(title = "Parameters", width = 6, 
                collapsible = TRUE, 
                shiny::fluidRow(
                    shiny::column(width = 6,
                        shiny::selectInput(inputId = ns("x"), label = "x-axis", 
                            choices = "X1", selected = "X1")),
                    shiny::column(width = 6,
                        shiny::selectInput(inputId = ns("y"), label = "y-axis", 
                            choices = "X2", selected = "X2"))
                ),
                shiny::fluidRow(
                    shiny::column(width = 6, 
                        shiny::sliderInput(inputId = ns("perplexity"), 
                            label = "Perplexity", min = 1, max = 5, value = 2, 
                            step = 1)),
                        shiny::column(width = 6, 
                            shiny::sliderInput(inputId = ns("maxIter"),
                                label = "Number of iterations", 
                                min = 100, max = 10000, value = 1000))
                                
                ),
                shiny::fluidRow(
                    shiny::column(width = 6, 
                        shiny::sliderInput(inputId = ns("initialDims"),
                            label = "Number of retained dimensions in initial PCA",
                            min = 1, max = 5, value = 3, step = 1)),
                    shiny::column(width = 6, 
                        shiny::sliderInput(inputId = ns("dims"),
                            label = "Output dimensionality",
                            min = 2, max = 3, value = 3, step = 1))
                ),
                shiny::fluidRow( 
                    shiny::column(3, 
                        shiny::checkboxInput(inputId = ns("scale"),
                            label = "scale", value = TRUE)),
                    shiny::column(3, 
                        shiny::checkboxInput(inputId = ns("center"),
                            label = "center", value = TRUE)),
                    shiny::column(width = 6, 
                        shiny::selectInput(inputId = ns("color"), 
                            label = "Color", choices = "none"))
                ),
                fluidRow(
                    shiny::column(width = 6),
                    shiny::column(width = 6, 
                        shiny::selectInput(inputId = ns("size"), 
                            label = "Size", choices = "none"))
                )
            )
        )
    )
}



#' @name tSNEUIServer
#' 
#' @title Server for UI for tSNE
#' 
#' @description 
#' The module defines the UI in the tab panel 'tSNE'.
#' 
#' @details
#' \code{tP_sSNEUIServer} defines the UI for the tab-pane 'tSNE' from the 
#' server-side. Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param sample_n \code{numeric(1)} and \code{reactive} value, number of 
#' samples
#' 
#' @author Thomas Naake
#' 
#' @return 
#' \code{shiny.render.function}
#' 
#' @importFrom shiny NS moduleServer updateSliderInput
#' @importFrom plotly plotlyOutput
#' 
#' @noRd
tSNEUIServer <- function(id, sample_n) {
    ns <- shiny::NS(id)
    shiny::moduleServer(
        id,
        function(input, output, session) {
            
            shiny::observe({
                shiny::updateSliderInput(session = session, 
                    inputId = "perplexity", 
                    max = ceiling((sample_n() - 1) / 3),
                    value = ceiling(sample_n()^0.5))
            })
            
            shiny::observe({
                shiny::updateSliderInput(session = session, 
                    inputId = "initialDims", max = sample_n())
            })
        }
    )
}


#' @name tP_umapUI
#' 
#' @title Tab panel UI for tab panel 'UMAP'
#' 
#' @description 
#' The module defines the UI in the tab panel 'UMAP'.
#' 
#' @details
#' \code{tP_umapUI} returns the HTML code for the tab-pane 'UMAP'. 
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param se \code{SummarizedExperiment} object
#' 
#' @return 
#' \code{shiny.tag} with HTML content
#' 
#' @author Thomas Naake
#' 
#' @importFrom shiny NS tabPanel fluidRow column downloadButton
#' @importFrom shiny uiOutput selectInput
#' @importFrom shinydashboard box
#' @importFrom shinyhelper helper
#' @importFrom plotly plotlyOutput
#' 
#' @examples
#' tP_UMAPUI("test")
#' 
#' @noRd
tP_umapUI <- function(id) {
    ns <- shiny::NS(id)
    shiny::tabPanel(title = "UMAP", 
        shiny::fluidRow(
            shiny::column(width = 12, 
                plotly::plotlyOutput(outputId = ns("plot"), 
                    height = "auto") |>
                    shinyhelper::helper(content = "tabPanel_UMAP"),
                shiny::downloadButton(outputId = ns("downloadPlot"), ""))), 
        shiny::fluidRow(
            shinydashboard::box(title = "Parameters", width = 6, 
                collapsible = TRUE, 
                shiny::fluidRow(
                    shiny::column(width = 6,
                        shiny::selectInput(inputId = ns("x"), label = "x-axis", 
                            choices = "X1", selected = "X1")),
                    shiny::column(width = 6,
                        shiny::selectInput(inputId = ns("y"), label = "y-axis", 
                            choices = "X2", selected = "X2"))
                ),
                shiny::fluidRow(
                    shiny::column(width = 6, 
                        shiny::sliderInput(
                            inputId = ns("minDist"), 
                            label = "Minimum distance", min = 0.01, 
                            max = 10, value = 0.1)),
                    shiny::column(width = 6, 
                        shiny::sliderInput(inputId = ns("nNeighbors"), 
                            label = "Number of neighbors", min = 2, 
                            max = 10, value = 10, step = 1))
                ),
                shiny::fluidRow(
                    shiny::column(width = 6, 
                        shiny::sliderInput(
                            inputId = ns("spread"), 
                            label = "Spread", min = 0.01, max = 10, value = 1)),
                    shiny::column(width = 6, 
                        shiny::selectInput(inputId = ns("color"), 
                            label = "Color", choices = "none"))
                ),
                shiny::fluidRow(
                    shiny::column(width = 6),
                    shiny::column(width = 6, 
                        shiny::selectInput(inputId = ns("size"), 
                            label = "Size", choices = "none"))
                )
            )
        )
    )
}

#' @name umapUIServer
#' 
#' @title Server for UI for UMAP
#' 
#' @description 
#' The module defines the UI in the tab panel 'UMAP'.
#' 
#' @details
#' \code{umapUIServer} defines the UI for the tab-pane 'UMAP' from the 
#' server-side. Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param sample_n \code{numeric(1)} and \code{reactive} value, number of 
#' samples
#'
#' @author Thomas Naake
#' 
#' @return 
#' \code{shiny.render.function}
#' 
#' @importFrom shiny moduleServer updateSliderInput
#' @importFrom SummarizedExperiment colData
#' 
#' @noRd
umapUIServer <- function(id, sample_n) {
    shiny::moduleServer(
        id,
        function(input, output, session) {
            
            shiny::observe({
                shiny::updateSliderInput(session = session,
                    inputId = "nNeighbors", max = sample_n)
            })
        }
    )
}

#' @name dimRedServer
#' 
#' @title Module for server expressions of tab panel 'Dimension reduction'
#' 
#' @description
#' The module defines the server expressions in the tab panel 
#' 'Dimension reduction'.
#' 
#' @details
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param assay \code{matrix} and \code{reactive} value, obtained from 
#' \code{assay(SummarizedExperiment)}
#' @param type \code{character}
#' @param label \code{character}
#' @param params \code{reactiveValues}
#' @param innerWidth \code{numeric} and \code{reactive} value, specifying the 
#' width of the window size
#' @param selectedTab \code{character} and \code{reactive} value, specifying
#' the selected tab panel, e.g. \code{"PCA"}
#' 
#' @return 
#' \code{shiny.render.function} expression
#'
#' @author Thomas Naake
#' 
#' @importFrom shiny moduleServer reactive fluidRow column updateSelectInput
#' @importFrom shiny reactiveValuesToList downloadHandler req bindCache
#' @importFrom plotly renderPlotly
#' @importFrom htmlwidgets saveWidget
#' @importFrom SummarizedExperiment colData
#' 
#' @noRd
#' 
dimRedServer <- function(id, se, assay, type = "PCA", label = "PC", params, 
    innerWidth, selectedTab) {
    
    shiny::moduleServer(
        id, 
        function(input, output, session) {
            
            ## create reactiveValues to store results from dimensionReduction,
            ## only update/calculate when the user has selected the tab
            ## (selectedTab() == id) and if the values were not previously 
            ## calcuated (rv$run), update also if there are changes to the 
            ## parameters
            rv <- reactiveValues(
                run = FALSE, dimensionReduction_list = NULL, coordinates = NULL,
                explainedVar = NULL, innerWidth = "600px")
            
            observeEvent({reactiveValuesToList(params()); se(); assay()}, {
                rv$run <- FALSE
            })
            
            observeEvent({selectedTab(); rv$run}, {
                if (selectedTab() == id & !rv$run) {
                    rv$dimensionReduction_list <- dimensionReduction(
                        x = assay(), type = type, 
                        params = reactiveValuesToList(params()))
                    rv$coordinates <- rv$dimensionReduction_list[[1]]
                    
                    if (id %in% c("PCA", "PCoA")) {
                        rv$explainedVar <- explVar(
                            d = rv$dimensionReduction_list[[2]], type = id)
                    }
                    rv$run <- TRUE
                }
            })
            
            observeEvent(innerWidth(), {
                rv$innerWidth <- innerWidth() * 3 / 5
            })
            
            ## create an expression that retrieves information on the columns of
            ## dimensionReduction tbl (from PCA, PCoA, or NMDS), i.e. the 
            ## principal components or axis (remove the last column = namesDf)
            shiny::observe({
                if (!is.null(rv$coordinates)) {
                    cn <- colnames(rv$coordinates)
                    cn <- cn[-length(cn)]
                    
                    shiny::updateSelectInput(session = session, inputId = "x", 
                        choices = cn, selected = cn[1])
                    shiny::updateSelectInput(session = session, inputId = "y", 
                        choices = cn, selected = cn[2])
                }
            })
            
            shiny::observe({
                shiny::updateSelectInput(session = session, 
                    inputId = "color", 
                    choices = c("none", colnames(se()@colData)))
            })
            
            shiny::observe({
                shiny::updateSelectInput(session = session, 
                    inputId = "size", 
                    choices = c("none", colnames(se()@colData)))
            })
            
            ## reactive plot for dimension reduction plots
            output$plot <- plotly::renderPlotly({
                
                if (!is.null(rv$coordinates)) {
                    dimensionReductionPlot(rv$coordinates, se = se(), 
                            color = input$color, size = input$size,
                            x_coord = input$x, y_coord = input$y,
                            explainedVar = rv$explainedVar,
                            height = rv$innerWidth)
                }
            })

            output$downloadPlot <- shiny::downloadHandler(
                filename = function() {
                    paste(type, "_", input$x, "_", input$y, "_", 
                        input$color, "_", input$size, ".html", sep = "")
                },
                content = function(file) {
                    htmlwidgets::saveWidget(
                        dimensionReductionPlot(tbl = rv$coordinates, se = se(), 
                            color = input$color, size = input$size,
                            x_coord = input$x, y_coord = input$y,
                            explainedVar = rv$explainedVar,
                            height = rv$innerWidth), file)
                }
            )
        }
    )
}

#' @name screePlotServer
#' 
#' @title Module for server expressions of tab panels 'PCA' and 'tSNE' 
#' (scree plot)
#' 
#' @description
#' The module defines the server expressions in the tab panel 
#' 'Dimension Reduction', specifically for the tab panels 'PCA' and 'tSNE'.
#' 
#' @details 
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param assay \code{matrix} and \code{reactive} value, obtained from 
#' \code{assay(SummarizedExperiment)}
#' @param center \code{logical} and \code{reactive} value
#' @param scale \code{logical} and \code{reactive} value
#' 
#' @return
#' \code{shiny.render.function} expression
#'
#' @importFrom shiny moduleServer reactive renderPlot
#' @importFrom shinyhelper helper
#' @importFrom plotly plotlyOutput
#'
#' @author Thomas Naake
#' 
#' @noRd
screePlotServer <- function(id, assay, center, scale) {
    shiny::moduleServer(
        id, 
        function(input, output, session) {
            
            var_x <- shiny::reactive({
                pca <- dimensionReduction(assay(), 
                    params = list(center = center(), scale = scale()), 
                    type = "PCA")
                explVar(d = pca[[2]], type = "PCA")
            })
            
            if (id == "PCA") {
                ## Scree plot for PCA Panel
                output$PCAVarplot <- shiny::renderPlot({
                    plotPCAVar(var_x(), NULL)
                })  
            } else { ## tSNE
                var_perm <- shiny::reactive({
                    permuteExplVar(assay(), n = 10, center = center(), 
                        scale = scale(), sample_n = 5000) 
                })
                
                ## Scree plot for tSNE panel including permuted values
                output$PCAVarplotPerm <- shiny::renderPlot({
                    plotPCAVar(var_x(), var_perm())
                })
                
                output$PCAVarPvalueplot <- shiny::renderPlot({
                    plotPCAVarPvalue(var_x(), var_perm())
                })
            }
            
        }
    )
}

#' @name loadingsPlotServer
#' 
#' @title Module for server expressions of tab panel 'PCA' (loading plot)
#' 
#' @description
#' The module defines the server expressions in the tab panel 
#' 'Dimension Reduction', specifically for the tab panel 'PCA'. It defines 
#' the loading plot server expression
#' 
#' @details 
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param assay \code{matrix} and \code{reactive} value, obtained from 
#' \code{assay(SummarizedExperiment)}
#' @param center \code{logical} and \code{reactive} value
#' @param scale \code{logical} and \code{reactive} value
#' 
#' @return
#' \code{shiny.render.function} expression
#'
#' @author Thomas Naake
#' 
#' @importFrom shiny moduleServer reactive reactiveValuesToList
#' @importFrom plotly renderPlotly
#' 
#' @noRd
loadingsPlotServer <- function(id, assay, params) {
    shiny::moduleServer(
        id, 
        function(input, output, session) {
            
            tbl_loadings <- shiny::reactive({
                tblPCALoadings(assay(), shiny::reactiveValuesToList(params()))
            })

            output$PCALoadings <- plotly::renderPlotly({
                plotPCALoadings(tbl_loadings(), 
                    x_coord = input$x, y_coord = input$y) 
            })

        }
    )
}


#' @name tP_dimensionReduction_all
#' 
#' @title Tab panel UI for tab panel 'Dimension Reduction'
#' 
#' @description 
#' The module defines the UI for the tab panel 'Dimension Reduction'.
#' 
#' @details 
#' \code{tP_dimensionReduction_all} returns the HTML code for the tab-pane 
#' 'Dimension Reduction'. Internal function for \code{shinyQC}.
#' 
#' @return 
#' \code{shiny.tag} with HTML content
#'
#' @author Thomas Naake
#' 
#' @examples 
#' tP_dimensionReduction_all()
#' 
#' @importFrom shiny tabPanel 
#' @importFrom shinydashboard tabBox
#' 
#' @noRd
tP_dimensionReduction_all <- function() {
    shiny::tabPanel("Dimension Reduction",
        shinydashboard::tabBox(title = "", width = 12, 
            id = "dimensionReductionTab",
            tP_PCAUI(id = "PCA"),
            tP_PCoAUI(id = "PCoA"),
            tP_NMDSUI(id = "NMDS"),
            tP_tSNEUI(id = "tSNE"),
            tP_umapUI(id = "UMAP")
        )
    )    
}

## create se
a <- matrix(seq_len(1000), nrow = 100, ncol = 10, 
            dimnames = list(seq_len(100), paste("sample", seq_len(10))))
a[c(1, 5, 8), seq_len(5)] <- NA
set.seed(1)
a <- a + rnorm(1000)
cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
rD <- data.frame(spectra = rownames(a))
se <- SummarizedExperiment::SummarizedExperiment(assay = a, rowData = rD, 
                                                                colData = cD)


## tP_PCAUI
test_that("tP_PCAUI", {
    expect_is(tP_PCAUI(""), "shiny.tag")
})

## tP_PCoAUI
test_that("tP_PCoAUI", {
    expect_is(tP_PCoAUI(""), "shiny.tag")
})

## tP_NMDSUI
test_that("tP_NMDSUI", {
    expect_is(tP_NMDSUI(""), "shiny.tag")
})

## tP_tSNEUI
test_that("tP_tSNEUI", {
    expect_is(tP_tSNEUI(""), "shiny.tag")
})

## tSNEUIServer
test_that("tSNEUIServer", {
    shiny::testServer(tSNEUIServer, {
        input <- new.env()
        output <- new.env()
        session <- new.env()
        sample_n <- new.env()
        
        out <- tSNEUIServer("", sample_n = sample_n)
        expect_is(out, "Observer")
    })
})

## tP_umapUI
test_that("tP_umapUI", {
    expect_is(tP_umapUI(""), "shiny.tag")
})

## umapUIServer
test_that("umapUIServer", {
    shiny::testServer(umapUIServer, {
        input <- new.env()
        output <- new.env()
        session <- new.env()
        sample_n <- new.env()
        
        out <- umapUIServer("", sample_n = sample_n)
        expect_is(out, "Observer")
    })
})



## dimRedServer
test_that("dimRedServer", {
    shiny::testServer(dimRedServer, {
        input <- new.env()    
        output <- new.env()
        session <- new.env()
        se <- new.env()
        assay <- new.env()
        type <- "PCA"
        label <- "PC"
        params <- new.env()
        innerWidth <- new.env()
        
        out <- dimRedServer("", se = se, assay = assay, type = type, 
                    label = label, params = params, innerWidth = innerWidth)
        expect_is(out, "shiny.render.function")
    })
})

## screePlotServer
test_that("screePlotServer", {

    shiny::testServer(screePlotServer, {
        input <- new.env()    
        output <- new.env()
        session <- new.env()
        assay <- new.env()
        center <- new.env()
        scale <- new.env()
        
        out <- screePlotServer("", assay = assay, center = center, 
            scale = scale)

        expect_is(out, "shiny.render.function")
    })
})

## loadingsPlotServer
test_that("loadingsPlotServer", {
    
    shiny::testServer(loadingsPlotServer, {
        input <- new.env()    
        output <- new.env()
        session <- new.env()
        assay <- new.env()
        params <- new.env()
        
        out <- loadingsPlotServer("", assay = assay, params = params)
        expect_is(out, "shiny.render.function")
    })
})

## tP_dimensionReduction_all
test_that("tP_intensities_all", {
    expect_is(tP_dimensionReduction_all(), "shiny.tag")
})

#' @name volcanoPlot
#' 
#' @title Volcano plot of fold changes/differences against p-values
#' 
#' @description 
#' The function \code{ComplexHeatmap} creates a volcano plot. On the y-axis the
#' -log10(p-values) are displayed, while on the x-axis the fold 
#' changes/differences are displayed.
#' The output of the function  differs depending on the
#' \code{type} parameter. For \code{type == "ttest"}, the fold changes are 
#' plotted; for \code{type == "proDA"}, the  differences are plotted. 
#' 
#' @details
#' Internal use in \code{shinyQC}.
#' 
#' @param df \code{data.frame} as received from \code{topTable} (\code{ttest}) 
#' or \code{test_diff} (proDA)
#' @param type \code{character}
#' 
#' @examples 
#' ## create se
#' a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
#'             dimnames = list(seq_len(10), paste("sample", seq_len(10))))
#' a[c(1, 5, 8), seq_len(5)] <- NA
#' set.seed(1)
#' a <- a + rnorm(100)
#' a_i <- imputeAssay(a, method = "MinDet")
#' cD <- data.frame(sample = colnames(a), 
#'     type = c(rep("1", 5), rep("2", 5)))
#' rD <- data.frame(spectra = rownames(a))
#' se <- SummarizedExperiment::SummarizedExperiment(assay = a, 
#'                                 rowData = rD, colData = cD)
#' se_i <- SummarizedExperiment::SummarizedExperiment(assay = a_i, 
#'                                 rowData = rD, colData = cD)
#' 
#' ## create model and contrast matrix
#' modelMatrix_expr <- stats::formula("~ 0 + type")
#' contrast_expr <- "type1-type2"
#' modelMatrix <- model.matrix(modelMatrix_expr, data = colData(se))
#' contrastMatrix <- limma::makeContrasts(contrasts = contrast_expr, 
#'                                 levels = modelMatrix)
#' 
#' ## ttest
#' fit <- limma::lmFit(a_i, design = modelMatrix)
#' fit <- limma::contrasts.fit(fit, contrastMatrix)
#' fit <- limma::eBayes(fit, trend = TRUE)
#' df_ttest <- limma::topTable(fit, n = Inf, adjust = "fdr", p = 0.05)
#' df_ttest <- cbind(name = rownames(df_ttest), df_ttest)
#' 
#' ## plot
#' volcanoPlot(df_ttest, type = "ttest")
#' 
#' ## proDA
#' \donttest{
#' fit <- proDA::proDA(a, design = modelMatrix)
#' df_proDA <- proDA::test_diff(fit = fit, contrast = contrast_expr,
#'         sort_by = "adj_pval")
#' 
#' ## plot
#' volcanoPlot(df_proDA, type = "proDA")
#' }
#' 
#' @importFrom limma makeContrasts eBayes topTable
#' @importFrom stats model.matrix
#' @importFrom proDA proDA test_diff
#' @importFrom ggplot2 ggplot aes sym geom_point ylab xlab theme_bw
#' @importFrom plotly ggplotly style
#' 
#' @return \code{plotly}
#' 
#' @export
volcanoPlot <- function(df, type = c("ttest", "proDA")) {
    
    type <- match.arg(type)
    if (type == "ttest") {
        
        ## add -log10(pvalue)
        df <- cbind(df, log10pvalue = -log10(df$P.Value))
        p <- ggplot2::ggplot(df, 
                ggplot2::aes(x = !!ggplot2::sym("logFC"), 
                    y = !!ggplot2::sym("log10pvalue"))) + 
            ggplot2::geom_point() + 
            ggplot2::ylab("-log10(p-value)") + 
            ggplot2::xlab("log fold change") + 
            ggplot2::theme_bw()
        pp <- plotly::ggplotly(p) 
        
        ## define the ttest-specific style for the tooltip
        fc_text <- paste("log fold change:", signif(pp$x$data[[1]]$x, 3))
        pvalue_text <- paste("p-value:", signif(df$P.Value, 3))
    }
    
    if (type == "proDA") {
        
        ## add -log10(pvalue)
        df <- cbind(df, log10pvalue = -log10(df$pval))
        p <- ggplot2::ggplot(df, 
                ggplot2::aes(x = !!ggplot2::sym("diff"), 
                    y = !!ggplot2::sym("log10pvalue"))) + 
            ggplot2::geom_point() + 
            ggplot2::ylab("-log10(p-value)") + 
            ggplot2::xlab("difference") + 
            ggplot2::theme_bw()
        pp <- plotly::ggplotly(p, 
            tooltip = c("pval", "diff", "log10pvalue", "name"))
        
        ## define the proDA-specific style for the tooltip
        fc_text <- paste("diff:", signif(pp$x$data[[1]]$x, 3))
        pvalue_text <- paste("p-value:", signif(df$pval, 3))
    }
    
    ## define the general style for the tooltip
    log10_text <- paste("-log10(p-value):", signif(pp$x$data[[1]]$y, 3))
    name_text <- paste("name:", df$name)
    
    ## return 
    pp |>
        plotly::style(pp, text = paste0(name_text, "</br></br>",  pvalue_text,
                                "</br>", fc_text, "</br>", log10_text))
}

#' @importFrom SummarizedExperiment SummarizedExperiment colData
#' @importFrom limma makeContrasts lmFit contrasts.fit eBayes topTable
#' @importFrom proDA proDA test_diff
#' @importFrom stats model.matrix

## function volcanoPlot
test_that("volcanoPlot", {
    
    ## create se
    a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
                dimnames = list(seq_len(10), paste("sample", seq_len(10))))
    a[c(1, 5, 8), seq_len(5)] <- NA
    set.seed(1)
    a <- a + rnorm(100)
    a_i <- imputeAssay(a, method = "MinDet")
    cD <- data.frame(sample = colnames(a), type = c(rep("1", 5), rep("2", 5)))
    rD <- data.frame(spectra = rownames(a))
    se <- SummarizedExperiment::SummarizedExperiment(assay = a, rowData = rD, 
        colData = cD)
    se_i <- SummarizedExperiment::SummarizedExperiment(assay = a_i, rowData = rD, 
        colData = cD)
    
    modelMatrix_expr <- formula("~ 0 + type")
    contrast_expr <- "type1-type2"
    modelMatrix <- stats::model.matrix(modelMatrix_expr, 
        data = SummarizedExperiment::colData(se))
    contrastMatrix <- limma::makeContrasts(contrasts = contrast_expr, 
        levels = modelMatrix)
    
    ## ttest
    fit <- limma::lmFit(a_i, design = modelMatrix)
    fit <- limma::contrasts.fit(fit, contrastMatrix)
    fit <- limma::eBayes(fit, trend = TRUE)
    df_ttest <- limma::topTable(fit, n = Inf, adjust = "fdr", p = 0.05)
    df_ttest <- cbind(name = rownames(df_ttest), df_ttest)

    ## proDA
    fit <- proDA::proDA(a, design = modelMatrix)
    df_proDA <- proDA::test_diff(fit = fit, contrast = contrast_expr,
                   sort_by = "adj_pval")
    
    expect_is(volcanoPlot(df_ttest, type = "ttest"), "plotly")
    expect_is(volcanoPlot(df_proDA, type = "proDA"), "plotly")
    expect_error(volcanoPlot(df_ttest, type = "proDA"), "non-numeric argument")
    expect_error(volcanoPlot(df_proDA, type = "ttest"), "non-numeric argument")
    expect_error(volcanoPlot(NULL, type = "ttest"), "non-numeric argument")
    expect_error(volcanoPlot(NULL, type = "proDA"), "non-numeric argument")
    expect_error(volcanoPlot(df_proDA, type = NULL), 
        "non-numeric argument")
    expect_error(volcanoPlot(df_proDA, type = "a"), "should be one of ")
    
})

################################################################################
################################### colData ####################################
################################################################################

#' @name tP_colDataUI
#' 
#' @title Tab panel UI for tab panel 'colData'
#' 
#' @description
#' The module defines the UI in the tab panel 'colData'.
#' 
#' @details 
#' \code{tP_colDataUI} returns the HTML code for the tab-pane 'colData'. 
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' 
#' @return 
#' \code{shiny.tag} with HTML content
#' 
#' @author Thomas Naake
#' 
#' @examples
#' tP_colDataUI("test")
#' 
#' @importFrom shiny NS tabPanel fluidRow column uiOutput br
#' @importFrom shinyhelper helper
#' @importFrom DT DTOutput
#' @noRd
tP_colDataUI <- function(id) {
    
    ns <- shiny::NS(id)
    shiny::tabPanel(title = "Sample meta-data",
        shiny::fluidRow(width = 12,
            shiny::column(12, 
                shiny::br() |> 
                    shinyhelper::helper(content = "tabPanel_DE")),
            shiny::column(width = 12, 
                DT::DTOutput(outputId = ns("colDt")) 
            )  
        )
    )
}

#' @name colDataServer
#' 
#' @title Module for server expressions of tab panel 'colData'
#' 
#' @description
#' The module defines the server expressions in the tab panel 
#' 'colData'.
#' 
#' @details
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param se \code{SummarizedExperiment} and \code{reactive} value
#' 
#' @return 
#' \code{shiny.render.function} expression
#'
#' @author Thomas Naake
#' 
#' @importFrom shiny moduleServer
#' @importFrom DT renderDT
#' 
#' @noRd
colDataServer <- function(id, se) {
    shiny::moduleServer(
        id, 
        function(input, output, session) {
            
            output$colDt <- DT::renderDT({as.data.frame(se()@colData)}, 
                options = list(pageLength = 20))
        }
    )
}

################################################################################
################################ Model matrix ##################################
################################################################################

#' @name tP_modelMatrixUI
#' 
#' @title Tab panel UI for tab panel 'Model matrix'
#' 
#' @description
#' The module defines the UI in the tab panel 'Model matrix'.
#' 
#' @details 
#' \code{tP_modelMatrixUI} returns the HTML code for the tab-pane 
#' 'Model matrix'. Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' 
#' @return 
#' \code{shiny.tag} with HTML content
#' 
#' @author Thomas Naake
#' 
#' @examples
#' tP_modelMatrixUI("test")
#' 
#' @importFrom shiny NS tabPanel fluidRow column uiOutput br
#' @importFrom shinyhelper helper
#' @importFrom DT DTOutput
#' 
#' @noRd
tP_modelMatrixUI <- function(id) {
    
    ns <- shiny::NS(id)
    shiny::tabPanel(title = "Model matrix", 
        shiny::fluidRow(width = 12,
            shiny::column(width = 12, 
                shiny::br() |>
                    shinyhelper::helper(content = "tabPanel_DE")),
            shiny::column(width = 12, 
                shiny::verbatimTextOutput(outputId = ns("textModelMatrix")),
                DT::DTOutput(outputId = ns("modelMatrixDataTable")) 
            )  
        )
    )
}

#' @name validFormulaMMServer
#' 
#' @title Module for server expressions of tab 'DE'
#' 
#' @description
#' The module defines the server expressions in the tab 
#' 'DE'. The function returns \code{NULL} if the formula is not valid with the
#' \code{SummarizedExperiment}, otherwise the formula is returned. 
#' 
#' @details
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param expr \code{character} and \code{reactive} value
#' @param action \code{reactive} value
#' @param se \code{SummarizedExperiment} and \code{reactive} value
#' 
#' @return 
#' \code{reactive} expression
#'
#' @author Thomas Naake
#' 
#' @importFrom shiny moduleServer reactive isolate
#' 
#' @noRd
validFormulaMMServer <- function(id, expr, action, se) {
    shiny::moduleServer(
        id,
        function(input, output, session) {
            
            validFormulaMM <- shiny::reactive({
                action()
                fMM <- shiny::isolate(expr())
                validExprModelMatrix(expr = fMM, se = se())
            })
            
            return(validFormulaMM)
        }
    )
}

#' @name validExprModelMatrix
#' 
#' @title Validate if expr is a formula for the model matrix
#' 
#' @description
#' The function \code{validExprModelMatr} returns either a \code{formula} 
#' object if \code{expr} is compatible with \code{se} or \code{NULL} 
#' if \code{expr} is not compatible with \code{se}. Specifically, the 
#' function accesses \code{colnames(colData(se))} and checks if all terms 
#' in \code{expr} are present in \code{colnames(colData(se))}.
#' 
#' @details
#' Internal usage in \code{validFormulaMMServer} within \code{shinyQC}.
#' 
#' @param expr \code{character}
#' @param se \code{SummarizedExperiment}
#'  
#' @return 
#' A \code{formula} object or \code{NULL}
#' 
#' @examples 
#' library(dplyr)
#' library(SummarizedExperiment)
#' 
#' ## create se
#' a <- matrix(seq_len(100), nrow = 10, ncol = 10,
#'             dimnames = list(seq_len(10), paste("sample", seq_len(10))))
#' a[c(1, 5, 8), seq_len(5)] <- NA
#' set.seed(1)
#' a <- a + rnorm(100)
#' cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
#' rD <- data.frame(spectra = rownames(a))
#' se <- SummarizedExperiment(assay = a, rowData = rD, colData = cD)
#' 
#' validExprModelMatrix("~type", se = se) ## returns a formula
#' validExprModelMatrix("~foo", se = se) ## returns NULL
#' 
#' @importFrom SummarizedExperiment colData
#' @importFrom stats as.formula
#' @noRd
validExprModelMatrix <- function(expr, se) {
    
    fMM <- tryCatch(stats::as.formula(expr), error = function(e) NULL)
    mM <- tryCatch(stats::model.matrix(fMM, data = se@colData), 
        error = function(e) NULL)
    
    if (is.null(mM))
        fMM <- NULL
    
    fMM
}


#' @name modelMatrixServer
#'  
#' @title Module for server expressions of tab panel 'Model matrix'
#' 
#' @description
#' The module defines the server expressions in the tab panel 
#' 'Model matrix'. The function returns a reactive expression of the 
#' \code{model.matrix} given a formula and a \code{SummarizedExperiment}.
#' 
#' @details
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param se \code{SummarizedExperiment} and \code{reactive} value
#' @param validFormulaMM \code{formula} and \code{reactive} value
#' 
#' @return 
#' \code{reactive} expression
#'
#' @author Thomas Naake
#' 
#' @importFrom shiny moduleServer reactive
#' @importFrom stats model.matrix
#' 
#' @noRd
modelMatrixServer <- function(id, se, validFormulaMM) {
    shiny::moduleServer(
        id,
        function(input, output, session) {
            
            modelMatrix <- shiny::reactive({
                if (!is.null(validFormulaMM())) {
                    stats::model.matrix(validFormulaMM(), 
                        data = se()@colData)
                }
            })
            
            modelMatrix
        }
    )
}

#' @name modelMatrixUIServer
#' 
#' @title Module for server expressions of tab panel 'Model matrix'
#' 
#' @description
#' The module defines the server expressions in the tab panel 
#' 'Model matrix'.
#' 
#' @details
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param modelMatrix \code{matrix} and \code{reactive} value
#' @param validFormulaMM \code{formula} and \code{reactive} value
#' 
#' @return 
#' \code{shiny.render.function} expression
#'
#' @author Thomas Naake
#' 
#' @importFrom shiny moduleServer renderUI renderText br
#' @importFrom shiny verbatimTextOutput
#' @importFrom DT renderDT DTOutput
#' 
#' @noRd
modelMatrixUIServer <- function(id, modelMatrix, validFormulaMM) {
    moduleServer(
        id, 
        function(input, output, session) {
            
            output$textModelMatrix <- shiny::renderText({
                
                msg <- NULL
                
                if (is.null(validFormulaMM()))
                    msg <- c("formula for model matrix not valid with the",
                             "given colData")
                
                msg
            })

            output$modelMatrixDataTable <- DT::renderDT({
                
                ## if there is a valid formula return the DataTable
                if (!is.null(validFormulaMM())) {
                    
                        mM <- modelMatrix() |> 
                            as.matrix()
                        cbind(rownames(mM), mM)
                }
                
            }, options = list(pageLength = 20))
            
        }
    )
}  

################################################################################
############################### Contrast matrix ################################
################################################################################
#' @name tP_contrastUI
#' 
#' @title Tab panel UI for tab panel 'Contrast matrix'
#' 
#' @description
#' The module defines the UI in the tab panel 'Contrast matrix'.
#' 
#' @details 
#' \code{tP_contrastUI} returns the HTML code for the tab-pane 
#' 'Contrast matrix'. Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' 
#' @return 
#' \code{shiny.tag} with HTML content
#' 
#' @author Thomas Naake
#' 
#' @examples
#' tP_contrastUI("test")
#' 
#' @importFrom shiny NS tabPanel fluidRow column uiOutput br
#' @importFrom shinyhelper helper
#' @importFrom DT DTOutput
#'
#' @noRd
tP_contrastUI <- function(id) {
    
    ns <- shiny::NS(id)
    shiny::tabPanel(title = "Contrast matrix", 
        shiny::fluidRow(width = 12,
            shiny::column(12, 
                shiny::br() |> 
                    shinyhelper::helper(content = "tabPanel_DE")),
            shiny::column(width = 12, 
                shiny::verbatimTextOutput(outputId = ns("textContrastMatrix")),
                DT::DTOutput(ns("contrastMatrix")) 
            )
        ) 
    )
}

#' @name validExprContrastServer
#' 
#' @title Module for server expressions of tab 'DE'
#' 
#' @description
#' The module defines the server expressions in the tab 'DE'. The function
#' returns \code{NULL} if the expression is not compatible with the 
#' \code{modelMatrix}, otherwise the expression is returned.
#' 
#' @details
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param expr \code{character} and \code{reactive} value
#' @param action \code{reactive} value
#' @param modelMatrix \code{matrix} and \code{reactive} value
#' 
#' @return 
#' \code{reactive} expression
#'
#' @author Thomas Naake
#' 
#' @importFrom shiny moduleServer reactive isolate
#' 
#' @noRd
validExprContrastServer <- function(id, expr, action, modelMatrix) {
    shiny::moduleServer(
        id,
        function(input, output, session) {
            
            validExpressionContrast <- shiny::reactive({
                action()
                contrasts <- shiny::isolate(expr())
                validExprContrast(contrasts = contrasts,
                    modelMatrix = modelMatrix())
            })
            
            validExpressionContrast
        }
    )
}

#' @name validExprContrast
#' 
#' @title Validate if expr is an expression for contrasts
#' 
#' @description
#' The function \code{validExprContrast} returns either a \code{formula} object 
#' if \code{expr} is compatible with \code{modelMatrix} or \code{NULL} 
#' if \code{expr} is not compatible with \code{modelMatrix}. Specifically, 
#' the function accesses \code{colnames(modelMatrix)} and checks if all 
#' terms in \code{expr} are present in \code{colnames(modelMatrix)}.
#' 
#' @details
#' Internal usage in \code{validExprConstrastServer} within \code{shinyQC}.
#' 
#' @param expr \code{character}
#' @param modelMatrix \code{model.matrix} as returned from 
#' \code{limma::model.matrix}
#'  
#' @return 
#' A \code{character} or \code{NULL}
#' 
#' @examples 
#' library(limma)
#' 
#' cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
#' 
#' modelMatrix <- model.matrix(~type, cD)
#' 
#' validExprContrast("type2", modelMatrix = modelMatrix) ## returns a formula
#' validExprContrast("foo", modelMatrix = modelMatrix) ## returns NULL
#' 
#' @noRd
validExprContrast <- function(contrasts, modelMatrix) {
    
    tmp <- tryCatch(
        limma::makeContrasts(contrasts = contrasts, levels = modelMatrix),
        error = function(e) NULL)
    
    if (!is.null(tmp)) 
        contrasts
    else
        NULL
}

#' @name contrastMatrixServer
#' 
#' @title Module for server expressions of tab panel 'Contrast matrix'
#' 
#' @description
#' The module defines the server expressions in the tab panel 
#' 'Contrast matrix'. The function returns the contrast matrix given a 
#' expression and a model matrix.
#' 
#' @details
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param validExprContrast \code{character} and \code{reactive} value
#' @param modelMatrix \code{matrix} and \code{reactive} value
#' 
#' @return 
#' \code{reactive} expression
#'
#' @author Thomas Naake
#' 
#' @importFrom limma makeContrasts
#' @importFrom shiny moduleServer reactive
#' 
#' @noRd
contrastMatrixServer <- function(id, validExprContrast, modelMatrix) {
    shiny::moduleServer(
        id,
        function(input, output, session) {
            contrastMatrix <- shiny::reactive({
                if (!is.null(validExprContrast())) {
                    limma::makeContrasts(contrasts = validExprContrast(),
                        levels = modelMatrix())
                }
            })

            return(contrastMatrix)
        }
    )
}

#' @name contrastMatrixUIServer
#'
#' @title Module for server expressions of tab panel 'Contrast matrix'
#'
#' @description
#' The module defines the server expressions in the tab panel
#' 'Contrast matrix'.
#'
#' @details
#' Internal function for \code{shinyQC}.
#'
#' @param id \code{character}
#' @param validFormulaMM \code{formula} and \code{reactive} value
#' @param validExprContrast \code{character} and \code{reactive} value
#' @param contrastMatrix \code{matrix} and \code{reactive} value
#'
#' @return
#' \code{shiny.render.function} expression
#'
#' @author Thomas Naake
#'
#' @importFrom shiny moduleServer renderUI
#' @importFrom shiny  renderText verbatimTextOutput
#' @importFrom DT renderDT DTOutput
#'
#' @noRd
contrastMatrixUIServer <- function(id, validFormulaMM, validExprContrast,
        contrastMatrix) {
    shiny::moduleServer(
        id,
        function(input, output, session) {

            output$textContrastMatrix <- shiny::renderText({

                msg <- NULL

                if (is.null(validFormulaMM()))
                    msg <- c("formula for model matrix not valid with the",
                             "given colData")

                if (!is.null(validFormulaMM()) & is.null(validExprContrast()))
                    msg <- c("contrast expression not valid with",
                             "the given model matrix")

                return(msg)
            })

            output$contrastMatrix <- DT::renderDT({

                cM <- NULL
                ## if there are valid formulas return the contrast matrix
                if (!is.null(validFormulaMM()) & !is.null(validExprContrast())) {
                    cM <- contrastMatrix()
                    cM <- cbind(rownames(cM), cM)

                }
                cM
            }, options = list(pageLength = 20))
            
        }
    )
}

################################################################################
################################### Top DE #####################################
################################################################################
#' @name tP_topDEUI
#'
#' @title Tab panel UI for tab panel 'Top DE'
#'
#' @description
#' The module defines the UI in the tab panel 'Top DE'.
#'
#' @details 
#' \code{tP_topDEUI} returns the HTML code for the tab-pane 'Top DE'.
#' Internal function for \code{shinyQC}.
#'
#' @param id \code{character}
#'
#' @return 
#' \code{shiny.tag} with HTML content
#'
#' @author Thomas Naake
#'
#' @examples
#' tP_topDEUI("test")
#'
#' @importFrom shiny NS tabPanel fluidRow column uiOutput br
#' @importFrom shinyhelper helper
#' @importFrom DT DTOutput
#'
#' @noRd
tP_topDEUI <- function(id) {

    ns <- shiny::NS(id)
    shiny::tabPanel(title = "Top DE",
        shiny::fluidRow(width = 12,
            shiny::column(12,
                shiny::br() |>
                    shinyhelper::helper(content = "tabPanel_DE")),
            shiny::column(width = 12, 
                shiny::verbatimTextOutput(outputId = ns("textDataTable")),
                DT::DTOutput(outputId = ns("dataTable"))
            )  
        )
    )
}

#' @name topDEUIServer
#'
#' @title Module for server expressions of tab panel 'Top DE'
#'
#' @description
#' The module defines the server expressions in the tab panel
#' 'Top DE'.
#'
#' @details
#' Internal function for \code{shinyQC}.
#'
#' @param id \code{character}
#' @param type \code{reactive} value
#' @param validFormulaMM \code{formula} and \code{reactive} value
#' @param validExprContrast \code{character} and \code{reactive} value
#' @param testResult \code{matrix} and \code{reactive} value
#' 
#' @return 
#' \code{shiny.render.function} expression
#'
#' @author Thomas Naake
#'
#' @importFrom shiny moduleServer renderUI br
#' @importFrom shiny renderText verbatimTextOutput
#' @importFrom DT renderDT DTOutput
#' @importFrom SummarizedExperiment colData
#'
#' @noRd
topDEUIServer <- function(id, type, validFormulaMM, validExprContrast,
        testResult) {

    shiny::moduleServer(
        id,
        function(input, output, session) {

            output$textDataTable <- shiny::renderText({

                msg <- NULL

                if (is.null(validFormulaMM()))
                    msg <- c("formula for model matrix not valid with the",
                      "given colData")

                if (!is.null(validFormulaMM()) & is.null(validExprContrast()))
                    msg <- c("contrast expression not valid with",
                        "the given model matrix")

                msg
            })

            output$dataTable <- DT::renderDT({
                dataTable <- NULL
                if (!is.null(validFormulaMM())) {
                    dataTable <- testResult()
                }
                dataTable
            })
        }
    )
}


#' @name fitServer
#'
#' @title Module for server expressions of tab panel 'Top DE'
#'
#' @description
#' The module defines the server expressions in the tab panel
#' 'Top DE'.
#'
#' @details
#' Internal function for \code{shinyQC}. For \code{eBayes}, the \code{trend}
#' argument is set by default to \code{TRUE}. The \code{trend=TRUE} argument
#' will model any mean-variance trend in the data; this is required when
#' there is a mean-variance trend (otherwise the estimates of the prior d.f. and
#' subsequent eBayes shrinkage would be confounded by systematic
#' mean-dependent differences from a common prior variance).
#'
#' @param id \code{character}
#' @param assay \code{matrix} and \code{reactive} value, obtained from
#' \code{assay(SummarizedExperiment)}
#' @param modelMatrix \code{matrix} and \code{reactive} value
#' @param contrastMatrix \code{matrix} and \code{reactive} value
#'
#' @return 
#' \code{reactive} expression
#'
#' @author Thomas Naake
#'
#' @importFrom shiny moduleServer reactive
#' @importFrom limma lmFit contrasts.fit eBayes
#' @importFrom proDA proDA
#'
#' @noRd
fitServer <- function(id, assay, modelMatrix, contrastMatrix) {
    shiny::moduleServer(
        id,
        function(input, output, session) {

            fit <- shiny::reactive({

                if (id == "ttest") {
                    fit <- limma::lmFit(assay(), design = modelMatrix())
                    if (!is.null(contrastMatrix())) 
                        fit <- limma::contrasts.fit(fit, contrastMatrix())
                    fit <- limma::eBayes(fit, trend = TRUE, robust = TRUE)
                }
                if (id == "proDA") {
                    fit <- proDA::proDA(assay(), design = modelMatrix())
                }

                fit
            })
        }
    )
}

#' @name testResultsServer
#'
#' @title Module for server expressions of tab panel 'Top DE'
#'
#' @description
#' The module defines the server expressions in the tab panel
#' 'Top DE'.
#'
#' @details
#' Internal function for \code{shinyQC}.
#'
#' @param id \code{character}
#' @param type \code{reactive} value
#' @param fit_ttest \code{matrix} and \code{reactive} value
#' @param fit_proDA \code{matrix} and \code{reactive} value
#' @param validFormulaMM \code{formula} and \code{reactive} value
#' @param validExprContrast \code{character} and \code{reactive} value
#' 
#' @return 
#' \code{reactive} expression
#'
#' @author Thomas Naake
#' 
#' @importFrom shiny moduleServer reactive
#' @importFrom limma topTable
#' @importFrom proDA test_diff
#' 
#' @noRd
testResultServer <- function(id, type, fit_ttest, fit_proDA, validFormulaMM,
        validExprContrast) {
    shiny::moduleServer(
        id,
        function(input, output, session) {
            testResult <- shiny::reactive({

                if (!is.null(validFormulaMM())) {
                    if (type() == "ttest") {
                        t <- limma::topTable(fit_ttest(), number = Inf,
                                adjust.method = "fdr", p.value = 0.05)
                        t <- cbind(name = rownames(t), t)
                    }
                    if (type() == "proDA") {
                        t <- proDA::test_diff(fit = fit_proDA(),
                            contrast = validExprContrast(),
                            sort_by = "adj_pval")
                    }
                    return(t)
                }
            })
            testResult
        }
    )
}

################################################################################
################################ Volcano plot ##################################
################################################################################

#' @name tP_volcanoUI
#'
#' @title Tab panel UI for tab panel 'Volcano plot'
#'
#' @description
#' The module defines the UI in the tab panel 'Volcano plot'.
#'
#' @details 
#' \code{tP_volcanoUI} returns the HTML code for the tab-pane 'Volcano plot'.
#' Internal function for \code{shinyQC}.
#'
#' @param id \code{character}
#'
#' @return 
#' \code{shiny.tag} with HTML content
#'
#' @author Thomas Naake
#'
#' @examples
#' tP_volcanoUI("test")
#'
#' @importFrom shiny NS tabPanel fluidRow column uiOutput br
#' @importFrom shinyhelper helper
#'
#' @noRd
tP_volcanoUI <- function(id) {

    ns <- shiny::NS(id)
    shiny::tabPanel(title = "Volcano plot",
        shiny::fluidRow(width = 12,
            shiny::column(12,
                shiny::br() |>
                    shinyhelper::helper(content = "tabPanel_DE")),
            shiny::column(width = 12,
                shiny::verbatimTextOutput(outputId = ns("textVolcano")),
                shiny::uiOutput(outputId = ns("volcano"))
            )
        )
    )
}

#' @name volcanoUIServer
#' 
#' @title Module for server expressions of tab panel 'Volcano plot'
#' 
#' @description
#' The module defines the server expressions in the tab panel
#' 'Volcano plot'.
#' 
#' @details
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param type \code{reactive} value
#' @param validFormulaMM \code{formula} and \code{reactive} value
#' @param validExprContrast \code{character} and \code{reactive} value
#' @param testResult \code{matrix} and \code{reactive} value
#' 
#' @return
#' \code{shiny.render.function} expression
#'
#' @author Thomas Naake
#'
#' @importFrom shiny moduleServer renderUI reactive downloadHandler renderText
#' @importFrom shiny verbatimTextOutput br tagList
#' @importFrom plotly renderPlotly
#' @importFrom shinyhelper helper
#' @importFrom htmlwidgets saveWidget
#'
#' @noRd
volcanoUIServer <- function(id, type, validFormulaMM, validExprContrast,
        testResult) {

    shiny::moduleServer(
        id,
        function(input, output, session) {


            output$textVolcano <- shiny::renderText({
                
                msg <- NULL

                if (is.null(validFormulaMM())) {
                    msg <- c("formula for model matrix not valid with the",
                             "given colData")
                }
                
                if (!is.null(validFormulaMM()) & is.null(validExprContrast())) {
                    msg <- c("contrast expression not valid with",
                             "the given model matrix")
                }

                return(msg)
            })

            output$volcano <- shiny::renderUI({
                ns <- session$ns
                if (!is.null(validFormulaMM()) &
                    !is.null(validExprContrast())) {

                    p_volcano <- shiny::reactive({
                        volcanoPlot(testResult(), type())
                    })

                    output$plotVolcano <- plotly::renderPlotly({
                        p_volcano()
                    })

                    output$downloadPlot <- shiny::downloadHandler(
                        filename = function() {
                            paste("Volcano_", type(), ".html")
                        },
                        content = function(file) {
                            htmlwidgets::saveWidget(p_volcano(), file)
                        }
                    )

                    ## return plot and downloadButton
                    shiny::tagList(
                        plotly::plotlyOutput(ns("plotVolcano")),
                        shiny::downloadButton(
                            outputId = ns("downloadPlot"), "")
                    )
                }
            })
        }
    )
}

#' @name tP_DE_all
#' 
#' @title Tab panel UI for tab panel 'DE'
#' 
#' @description
#' The module defines the UI for the tab panel 'DE'.
#' 
#' @details 
#' \code{tP_DE_all} returns the HTML code for the tab-panel
#' 'DE'. Internal function for \code{shinyQC}.
#' 
#' @return
#' \code{shiny.tag} with HTML content
#'
#' @author Thomas Naake
#' 
#' @examples
#' tP_DE_all()
#' 
#' @importFrom shiny tabPanel
#' @importFrom shinydashboard tabBox
#' 
#' @noRd
tP_DE_all <- function() {
    shiny::tabPanel("DE",
        shinydashboard::tabBox(title = "", width = 12,
            tP_colDataUI(id = "colData"),
            tP_modelMatrixUI(id = "modelMatrix"),
            tP_contrastUI(id = "contrast"),
            tP_topDEUI(id = "topDE"),
            tP_volcanoUI(id = "volcano")
        )
    )    
}

#' @importFrom SummarizedExperiment SummarizedExperiment
#' @importFrom shiny testServer

## create se
a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
             dimnames = list(seq_len(10), paste("sample", seq_len(10))))
a[c(1, 5, 8), seq_len(5)] <- NA
set.seed(1)
a <- a + rnorm(100)
cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
rD <- data.frame(spectra = rownames(a))
se <- SummarizedExperiment::SummarizedExperiment(assay = a, rowData = rD, 
    colData = cD)

## tP_colDataUI
test_that("tP_colDataUI", {
    expect_is(tP_colDataUI(""), "shiny.tag")
})

## tP_modelMatrixUI
test_that("tP_modelMatrixUI", {
    expect_is(tP_modelMatrixUI(""), "shiny.tag")
})

## tP_contrastUI
test_that("tP_contrastUI", {
    expect_is(tP_colDataUI(""), "shiny.tag")
})

## tP_topDEUI
test_that("tP_topDEUI", {
    expect_is(tP_topDEUI(""), "shiny.tag")
})

## tP_volcanoUI
test_that("tP_volcanoUI", {
    expect_is(tP_volcanoUI(""), "shiny.tag")
})

## colDataServer
test_that("colDataServer", {
    shiny::testServer(colDataServer, {
        input <- new.env()    
        output <- new.env()
        session <- new.env()
        se <- new.env()
        
        out <- colDataServer("", se = se)
        expect_is(out, "shiny.render.function")
    })
})

## validFormulaMMServer
test_that("validFormulaMMServer", {
    shiny::testServer(validFormulaMMServer, {
        input <- new.env()    
        output <- new.env()
        session <- new.env()
        expr <- new.env()
        action <- new.env()
        se <- new.env()
        
        out <- validFormulaMMServer("", expr = expr, action = action, se = se)
        expect_is(out, "reactiveExpr")
    })
})

## validExprModelMatrix
test_that("validExprModelMatrix", {
    expect_is(validExprModelMatrix("~type", se = se), "formula")
    expect_is(validExprModelMatrix("~foo", se = se), "NULL")
    expect_is(validExprModelMatrix("~", se = se), "NULL")
    expect_is(validExprModelMatrix("~type", se = NULL), 
        "NULL")
})

## modelMatrixServer
test_that("modelMatrixServer", {
    shiny::testServer(modelMatrixServer, {
        input <- new.env()    
        output <- new.env()
        session <- new.env()
        se <- new.env()
        validFormulaMM <- new.env()
        
        out <- modelMatrixServer("modelMatrixServer", se = se, 
            validFormulaMM = validFormulaMM)
        expect_is(out, "reactiveExpr")
    })
})

## modelMatrixUIServer
test_that("modelMatrixUIServer", {
    shiny::testServer(modelMatrixUIServer, {
        input <- new.env()    
        output <- new.env()
        session <- new.env()
        modelMatrix <- new.env()
        validFormulaMM <- new.env()
        
        out <- modelMatrixUIServer("", modelMatrix = modelMatrix, 
            validFormulaMM = validFormulaMM)
        expect_is(out, "shiny.render.function")
    })
})

## validExprContrastServer
test_that("validExprContrastServer", {
    shiny::testServer(validExprContrastServer, {
        input <- new.env()    
        output <- new.env()
        session <- new.env()
        expr <- new.env()
        action <- new.env()
        modelMatrix <- new.env()
        
        out <- validExprContrastServer("", expr = expr, action = action,
            modelMatrix = modelMatrix)
        expect_is(out, "reactiveExpr")
    })
})

## validExprContrast
test_that("validExprContrast", {
    modelMatrix <- stats::model.matrix(~type, colData(se))
    expect_equal(suppressWarnings(validExprContrast("type2", 
        modelMatrix = modelMatrix)), "type2")
    expect_is(suppressWarnings(validExprContrast("type2-", 
        modelMatrix = modelMatrix)), "NULL")
    expect_is(suppressWarnings(validExprContrast("foo", 
        modelMatrix = modelMatrix)), "NULL")
    expect_is(suppressWarnings(validExprContrast("type2", modelMatrix = NULL)), 
        "NULL")
    modelMatrix <- stats::model.matrix(~type + 0, colData(se))
    expect_equal(suppressWarnings(validExprContrast("type2-type1", 
        modelMatrix = modelMatrix)), "type2-type1")
})

## contrastMatrixServer
test_that("contrastMatrixServer", {
    shiny::testServer(contrastMatrixServer, {
        input <- new.env()    
        output <- new.env()
        session <- new.env()
        validExprContrast <- new.env()
        modelMatrix <- new.env()
        
        out <- contrastMatrixServer("", validExprContrast = validExprContrast,
            modelMatrix = modelMatrix)
        expect_is(out, "reactiveExpr")
    })
})

## contrastMatrixUIServer
test_that("contrastMatrixUIServer", {
    shiny::testServer(contrastMatrixUIServer, {
        input <- new.env()    
        output <- new.env()
        session <- new.env()
        validFormulaMM <- new.env()
        validExprContrast <- new.env()
        contrastMatrix <- new.env() 
        
        out <- contrastMatrixUIServer("", validFormulaMM = validFormulaMM,
            validExprContrast = validExprContrast, 
            contrastMatrix = contrastMatrix)
        expect_is(out, "shiny.render.function")
    })
})

## topDEUIServer
test_that("topDEUIServer", {
    shiny::testServer(topDEUIServer, {
        input <- new.env()    
        output <- new.env()
        session <- new.env()
        type <- new.env()
        validFormulaMM <- new.env()
        validExprContrast <- new.env()
        testResult <- new.env()
        
        out <- topDEUIServer("", type = type, 
            validFormulaMM = validFormulaMM, 
            validExprContrast = validExprContrast, testResult = testResult)
        expect_is(out, "shiny.render.function")
    })
})

## fitServer
test_that("fitServer", {
    shiny::testServer(fitServer, {
        input <- new.env()    
        output <- new.env()
        session <- new.env()
        assay <- new.env()
        validFormulaMM <- new.env()
        modelMatrix <- new.env()
        contrastMatrix <- new.env()
        
        out <- fitServer("", assay = assay, 
            modelMatrix = modelMatrix, contrastMatrix = contrastMatrix)
        expect_is(out, "reactiveExpr")
    })
})

## testResultServer
test_that("testResultServer", {
    shiny::testServer(testResultServer, {
        input <- new.env()    
        output <- new.env()
        session <- new.env()
        type <- new.env()
        fit_ttest <- new.env()
        fit_proDA <- new.env()
        validFormulaMM <- new.env()
        validExprContrast <- new.env()
        
        out <- testResultServer("", type = type, 
            fit_ttest = fit_ttest, fit_proDA = fit_proDA, 
            validFormulaMM = validFormulaMM, 
            validExprContrast = validExprContrast)
        expect_is(out, "reactiveExpr")
    })
})

## volcanoUIServer
test_that("volcanoUIServer", {
    shiny::testServer(volcanoUIServer, {
        input <- new.env()    
        output <- new.env()
        session <- new.env()
        type <- new.env()
        validFormulaMM <- new.env()
        validExprContrast <- new.env()
        testResult <- new.env()
        
        out <- volcanoUIServer("", type = type, 
            validFormulaMM = validFormulaMM, 
            validExprContrast = validExprContrast, testResult = testResult)
        expect_is(out, "shiny.render.function")
    })
})

## tP_DE_all
test_that("tP_DE_all", {
    expect_is(tP_DE_all(), "shiny.tag")
    expect_is(tP_DE_all(), "shiny.tag")
})

#' @name dimensionReduction
#'
#' @title Dimensionality reduction with dimensionReduction methods PCA,
#' PCoA, NMDS, UMAP and tSNE
#'
#' @description 
#' The function \code{dimensionReduction} creates a \code{data.frame} 
#' with the coordinates of the projected data (first entry of returned output). 
#' The function allows for the 
#' following projections:
#' Principal Component Analysis (PCA), Principal Coordinates 
#' Analysis/Multidimensional Scaling (PCoA), Non-metric Multidimensional 
#' scaling (NMDS), t-distributed stochastic neighbor embedding (tSNE), and 
#' Uniform Manifold Approximation and Projection (UMAP).
#' 
#' The second list entry will contains the object returned from 
#' \code{prcomp} (PCA), \code{cmdscale} (PCoA), \code{isoMDS} (NMDS), 
#' \code{Rtsne} (tSNE), or \code{umap} (UMAP).
#' 
#' @details 
#' The function \code{dimensionReduction} is a wrapper around the following 
#' functions \code{stats::prcomp} (PCA), \code{stats::cmdscale} (PCoA), 
#' \code{MASS::isoMDS} (NMDS), \code{Rtsne::Rtsne} (tSNE), and 
#' \code{umap::umap} (UMAP). For the function \code{umap::umap} 
#' the method is set to \code{naive}. 
#' 
#' @param x \code{matrix}, containing no missing values, samples are in columns 
#' and features are in rows
#' @param type \code{character}, specifying the type/method to use for 
#' dimensionality reduction. One of \code{PCA}, \code{PCoA}, \code{NMDS}, 
#' \code{tSNE}, or \code{UMAP}. 
#' @param params \code{list}, arguments/parameters given to the functions 
#' \code{stats::prcomp}, \code{stats::dist}, \code{Rtsne::Rtsne}, 
#' \code{umap::umap}
#' 
#' @examples 
#' x <- matrix(rnorm(seq_len(10000)), ncol = 100)
#' rownames(x) <- paste("feature", seq_len(nrow(x)))
#' colnames(x) <- paste("sample", seq_len(ncol(x)))
#' params <- list(method = "euclidean", ## dist
#'     initial_dims = 10, max_iter = 100, dims = 3, perplexity = 3, ## tSNE
#'     min_dist = 0.1, n_neighbors = 15, spread = 1) ## UMAP
#' dimensionReduction(x, type = "PCA", params = params)
#' dimensionReduction(x, type = "PCoA", params = params)
#' dimensionReduction(x, type = "NMDS", params = params)
#' dimensionReduction(x, type = "tSNE", params = params)
#' dimensionReduction(x, type = "UMAP", params = params)
#'
#' @author Thomas Naake
#'
#' @importFrom stats prcomp dist cmdscale
#' @importFrom MASS isoMDS
#' @importFrom Rtsne Rtsne
#' @importFrom umap umap
#' @importFrom methods formalArgs
#' 
#' @return list, first entry contains a \code{tbl}, second entry contains
#' the object returned from \code{prcomp} (PCA), \code{cmdscale} (PCoA),
#' \code{isoMDS} (NMDS), \code{Rtsne} (tSNE), or \code{umap} (UMAP)
#' 
#' @export
dimensionReduction <- function(x, 
    type = c("PCA", "PCoA", "NMDS", "tSNE", "UMAP"), params = list()) {
    
    type <- match.arg(type)
    
    if (type == "PCA") { ## scale, center
        params <- append(params, list(x = t(x)))
        d <- do.call(what = stats::prcomp, params)
        tbl <- d[["x"]] |>
            tibble::as_tibble()
    }
    if (type == "PCoA") {
        params <- append(params, list(x = t(x)))
        ## truncate params
        params <- params[names(params) %in% methods::formalArgs(stats::dist)] 
        d <- do.call(what = stats::dist, args = params)
        d <- stats::cmdscale(d, k = ncol(x) - 1, eig = TRUE)
        tbl <- d$points |>
            tibble::as_tibble()
        colnames(tbl) <- paste("Axis.", seq_len(ncol(tbl)), sep = "")
    }
    if (type == "NMDS") {
        params <- append(params, list(x = t(x)))
        ## truncate params
        params <- params[names(params) %in% formalArgs(dist)] 
        d <- do.call(what = stats::dist, args = params)
        d <- MASS::isoMDS(d, k = 2)
        tbl <- d$points |>
            tibble::as_tibble()
        colnames(tbl) <- paste("MDS", seq_len(ncol(tbl)), sep = "")
    }
    if (type == "tSNE") { 
        ## hyperparameters for tSNE: perplexity, max_iter, initial_dims, dims
        params <- append(params, list(X = t(x)))
        d <- do.call(what = Rtsne::Rtsne, args = params) 
        tbl <- d$Y |>
            tibble::as_tibble()
        colnames(tbl) <- paste("X", seq_len(ncol(tbl)), sep = "")
    }
    if (type == "UMAP") { 
        ## hyperparameters for UMAP: n_neighbors, min_dist, spread
        ## remove first the method from the dist function then add "naive"
        if ("method" %in% names(params)) 
            params <- params[names(params) != "method"]
        params <- append(params, list(d = t(x), method = "naive"))
        d <- do.call(what = umap::umap, args = params)
        tbl <- d$layout |> 
            tibble::as_tibble()
        colnames(tbl) <- paste("X", seq_len(ncol(tbl)), sep = "")
    }
    
    tbl[["name"]] <- colnames(x)
    
    list(tbl, d)
}

#' @name dimensionReductionPlot
#' 
#' @title Plot the coordinates from \code{dimensionReduction} values
#' 
#' @description 
#' The function \code{dimensionReductionPlot} creates a dimension reduction plot. 
#' The function takes as input the \code{tbl} object obtained 
#' from the \code{dimensionReduction} function. The \code{tbl} contains 
#' transformed values by one of the dimension reduction methods. 
#' 
#' @details 
#' The function \code{dimensionReductionPlot} is a wrapper for a
#' \code{ggplot/ggplotly} expression. 
#'
#' @param tbl \code{tbl} as obtained by the function \code{dimensionReduction}
#' @param se \code{SummarizedExperiment}
#' @param color \code{character}, one of \code{"none"} or 
#' \code{colnames(se@@colData)}
#' @param size \code{character}, one of \code{"none"} or 
#' \code{colnames(se@@colData)}
#' @param explainedVar NULL or named \code{numeric}, if \code{numeric} 
#' \code{explainedVar} contains the explained variance per principal component 
#' (names of \code{explainedVar} corresponds to the principal components)
#' @param x_coord \code{character}, column name of \code{tbl} that stores 
#' x coordinates
#' @param y_coord \code{character}, column name of \code{tbl} that stores 
#' y coordinates
#' @param height \code{numeric}, specifying the height of the plot (in pixels)
#' @param interactive \code{logical(1)}, if \code{TRUE} 
#' \code{dimensionReductionPlot} will return a \code{plotly} object, 
#' if \code{FALSE} \code{dimensionReductionPlot} will return a \code{gg} object
#' 
#' @examples
#' library(SummarizedExperiment)
#' 
#' ## create se
#' a <- matrix(seq_len(100), nrow = 10, ncol = 10, byrow = TRUE,
#'             dimnames = list(seq_len(10), paste("sample", seq_len(10))))
#' set.seed(1)
#' a <- a + rnorm(100)
#' cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)),
#'   median_vals = apply(a, 2, median))
#' rD <- data.frame(spectra = rownames(a))
#' se <- SummarizedExperiment(assay = a, rowData = rD, colData = cD)
#' 
#' pca <- dimensionReduction(x = assay(se), type = "PCA", params = list())[[1]]
#' 
#' dimensionReductionPlot(tbl = pca, se = se, color = "type", size = "median_vals",
#'     x_coord = "PC1", y_coord = "PC2")
#'
#' @author Thomas Naake
#'
#' @importFrom plotly ggplotly
#' @importFrom dplyr left_join
#' @importFrom ggplot2 ggplot aes sym xlab ylab geom_point coord_fixed
#' @importFrom ggplot2 theme_classic theme
#' 
#' @return \code{plotly} or \code{gg}
#' 
#' @export
dimensionReductionPlot <- function(tbl, se, 
    color = c("none", colnames(se@colData)), 
    size = c("none", colnames(se@colData)), 
    explainedVar = NULL, x_coord, y_coord, height = 600, interactive = TRUE) {
    
    ## match arguments
    color <- match.arg(color)
    color <- make.names(color)
    size <- match.arg(size)
    size <- make.names(size)
    
    ## access the colData slot and add the rownames as a new column to cD
    ## (will add the column "rowname")
    cD <- se@colData |> as.data.frame()
    colnames(cD) <- make.names(colnames(cD))
    cD[["name"]] <- rownames(cD)
    tT <- c("text")
    
    ## adjust tbl and tooltip depending on the color argument
    if (color != "none") {
        cD_cut <- data.frame(name = cD[["name"]], color = cD[[color]])
        tT <- c(tT, "color")
    } else {
        cD_cut <- data.frame(name = cD[["name"]], color = as.factor(0))
    }
    tbl <- dplyr::left_join(tbl, cD_cut, by = "name", copy = TRUE)
    
    
    
    ## adjust tbl and tooltip depending on the size argument
    if (size != "none") {
        cD_cut <- data.frame(name = cD[["name"]], size = cD[[size]])
        tT <- c(tT, "size")
    } else {
        cD_cut <- data.frame(name = cD[["name"]], size = 1)
    }
    tbl <- dplyr::left_join(tbl, cD_cut, by = "name", copy = TRUE)
    
    ## do the actual plotting
    g <- ggplot2::ggplot(tbl, ggplot2::aes(x = !!ggplot2::sym(x_coord), 
        y = !!ggplot2::sym(y_coord), 
        text = !!ggplot2::sym("name")))
    
    if (!is.null(explainedVar)) {
        g <- g + ggplot2::xlab(paste(x_coord, " (", 
            round(explainedVar[[x_coord]] * 100, 2), "%)", sep = ""))
        g <- g + ggplot2::ylab(paste(y_coord, " (", 
            round(explainedVar[[y_coord]] * 100, 2), "%)", sep = ""))
    } else {
        g <- g + ggplot2::xlab(x_coord) + ggplot2::ylab(y_coord) 
    }
    
    ## color and size
    if (color == "none" & size == "none") {
        g <- g + ggplot2::geom_point()
    } 
    if (color != "none" & size == "none") {
        g <- g + ggplot2::geom_point(
            ggplot2::aes(color = !!ggplot2::sym("color")))
    } 
    if (color == "none" & size != "none") {
        g <- g + ggplot2::geom_point(
            ggplot2::aes(size = !!ggplot2::sym("size")))
    }
    if (color != "none" & size != "none") {
        g <- g + ggplot2::geom_point(
            ggplot2::aes(color = !!ggplot2::sym("color"), 
                size = !!ggplot2::sym("size")))
    }
    
    ## add theme
    g <- g + ggplot2::theme_classic()

    ## turn into interactive if TRUE, return the plots
    if (interactive) {
        g <- g + ggplot2::theme(legend.position = "none") 
        plotly::ggplotly(g, tooltip = tT, height = height, width = height)
    } else {
        g + ggplot2::theme(aspect.ratio = 1)
    }
}



#' @name explVar
#'
#' @title Retrieve the explained variance for each principal component (PCA) or
#' axis (PCoA)
#'
#' @description
#' The function \code{explVar} calculates the proportion of explained variance 
#' for each principal component (PC, \code{type = "PCA"}) and axis 
#' (\code{type = "PCoA"}). 
#' 
#' @details 
#' \code{explVar} uses the function \code{prcomp} from the \code{stats} package 
#' to retrieve the explained standard deviation per PC 
#' (\code{type = "PCA"}) and the function \code{cmdscale} from the \code{stats} 
#' package to retrieve the explained variation based on eigenvalues per 
#' Axis (\code{type = "PCoA"}).
#' 
#' @param d \code{prcomp} or \code{list} from \code{cmdscale}
#' @param type \code{character}, one of \code{"PCA"} or \code{"PCoA"}
#' 
#' @return \code{numeric} vector with the proportion of explained variance 
#' for each PC or Axis
#' 
#' @examples
#' x <- matrix(seq_len(100), nrow = 10, ncol = 10, 
#'     dimnames = list(seq_len(10), paste("sample", seq_len(10))))
#' set.seed(1)
#' x <- x + rnorm(100)
#'
#' ## run for PCA
#' pca <- dimensionReduction(x = x, 
#'     params = list(center = TRUE, scale = TRUE), type = "PCA")[[2]]
#' explVar(d = pca, type = "PCA")
#' 
#' ## run for PCoA
#' pcoa <- dimensionReduction(x = x, 
#'     params = list(method = "euclidean"), type = "PCoA")[[2]]
#' explVar(d = pcoa, type = "PCoA")
#' 
#' @author Thomas Naake
#'
#' @export
explVar <- function(d, type = c("PCA", "PCoA")) {

    type <- match.arg(type)

    if (type == "PCA") {
        ## PCA (by prcomp) and retrieve the exlained variance for each PC
        sdev_2 <- d[["sdev"]] ^ 2
        explVar <- sdev_2 / sum(sdev_2)
        names(explVar) <- paste("PC", seq_along(explVar), sep = "")    
    }

    if (type == "PCoA") {
        eig <- d[["eig"]]
        explVar <- eig / sum(eig)
        explVar <- explVar[-length(explVar)]
        names(explVar) <- paste("Axis.", seq_along(explVar), sep = "")
    }

    explVar
}

#' @name permuteExplVar
#' 
#' @title Permute the expression values and retrieve the explained variance
#' 
#' @description 
#' The function \code{permuteExplVar} determines the explained variance of the 
#' permuted expression matrix (\code{x}). It is used to determine the optimal 
#' number of PCs for tSNE. 
#' 
#' @details 
#' For the input of tSNE, typically, we want to reduce the initial number of 
#' dimensions linearly with PCA (used as the \code{initial_dims} arguments in 
#' the \code{Rtsne} funtion). The reduced data set is used for feeding 
#' into tSNE. By plotting the percentage of variance explained by the Princical
#' Components (PCs) we can estimate how many PCs we keep as input into tSNE.
#' However, if we select too many PCs, noise will be included as input to tSNE;
#' if we select too few PCs we might loose the important data structures. 
#' To get a better understanding how many PCs to include, randomization will
#' be employed and the observed variance will be compared to the permuted 
#' variance.
#' 
#' @param x \code{matrix} or \code{data.frame}, samples in columns and features 
#' in rows
#' @param n \code{numeric}, number of permutation rounds
#' @param center \code{logical}, passed to the function \code{explVar}
#' @param scale \code{logical}, passed to the function \code{explVar}
#' @param sample_n \code{numeric(1)}, number of features (subset) to be 
#' taken for calculation of permuted explained variance, the top 
#' \code{sample_n} varying values based on their standard deviation will be 
#' taken
#' 
#' @examples  
#' x <- matrix(seq_len(100), nrow = 10, ncol = 10,
#'     dimnames = list(seq_len(10), paste("sample", seq_len(10))))
#' permuteExplVar(x = x, n = 10, center = TRUE, scale = TRUE, sample_n = NULL)
#'
#' @return matrix with explained variance
#'
#' @author Thomas Naake
#'
#' @export
permuteExplVar <- function(x, n = 10, center = TRUE, scale = TRUE, 
    sample_n = NULL) {
    
    if (n < 1) stop("n has to be greater than 0")

    ## in case of large data sets the permutation might take a long time,
    ## limit if there are more features (nrow(x)) than sample_n features the 
    ## features to sample_n features
    if (!is.null(sample_n)) {
        if (sample_n < nrow(x)) {
            sds <- apply(x, 1, sd, na.rm = TRUE)
            sds_feat <- order(sds, decreasing = TRUE)[seq_len(sample_n)]
            x <- x[sds_feat, ] 
        }
    }

    var_perm <- lapply(seq_len(n), function(i) {
        ## permute features across the samples
        x_perm <- apply(x, 1, sample)
        
        ## PCA and retrieve the explained variance for each PC
        pca <- dimensionReduction(x = x_perm,  type = "PCA", 
            params = list(center = center, scale = scale))[[2]]
        explVar(d = pca, type = "PCA")
    })

    ## create a matrix (rbind the list elements)
    do.call(rbind, var_perm)
}


#' @name plotPCAVar
#' 
#' @title Plot of explained variance against the principal components
#' 
#' @description
#' The function \code{plotPCAVar} plots the explained variance (in %) on the 
#' y-axis against the principal components for the measured and permuted values.  
#' 
#' @details
#' The argument \code{var_perm} is optional and visualization of permuted values 
#' can be omitted by setting \code{var_perm = NULL}.
#' 
#' @param var_x \code{numeric} (named \code{numeric} vector)
#' @param var_perm \code{matrix} with the explained variance obtained by 
#' permutation (function \code{permuteExplVar})
#' 
#' @examples 
#' x <- matrix(seq_len(100), ncol = 10)
#' pca <- dimensionReduction(x = x, params = list(center = TRUE, scale = TRUE),
#'     type = "PCA")[[2]]
#' var_x <- explVar(d = pca, type = "PCA")
#' var_perm <- permuteExplVar(x = x, n = 100, center = TRUE, scale = TRUE)
#' plotPCAVar(var_x = var_x, var_perm = var_perm)
#'
#' @return 
#' \code{gg} object from \code{ggplot}
#' 
#' @author Thomas Naake
#' 
#' @importFrom ggplot2 ggplot aes sym geom_point geom_line theme_bw
#' @importFrom ggplot2 ylab xlab theme element_text element_blank
#'
#' @export
plotPCAVar <- function(var_x, var_perm = NULL) {
    
    df <- data.frame(PC = names(var_x), values = var_x, group = "measured")
    
    if (!is.null(var_perm)) {
        df_perm <- data.frame(PC = colnames(var_perm), 
            values = colMeans(var_perm), group = "permuted")
        df <- rbind(df, df_perm)
    }
    
    df[["PC"]] <- factor(df[["PC"]], levels = names(var_x))
    df[["values"]] <- df[["values"]] * 100
    
    ## plotting
    g <- ggplot2::ggplot(df, ggplot2::aes(x = !!ggplot2::sym("PC"), 
            y = !!ggplot2::sym("values")))  + 
        ggplot2::geom_point(ggplot2::aes(color = !!ggplot2::sym("group"))) + 
        ggplot2::geom_line(ggplot2::aes(color = !!ggplot2::sym("group"), 
            group = !!ggplot2::sym("group"))) +
        ggplot2::theme_bw() + ggplot2::ylab("explained variance (%)") + 
        ggplot2::xlab("principal components") +
        ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90))
    
    if (is.null(var_perm)) g <- g + 
        ggplot2::theme(legend.title = ggplot2::element_blank(), 
            legend.position = "none")
    
    g
}

#' @name plotPCAVarPvalue
#'
#' @title Plot p-values for the significance of principal components
#' 
#' @description 
#' The function \code{plotPCAVarPvalue} plots the p-values of significances of 
#' principal components. Using the visual output, the optimal number of 
#' principal components can be selected. 
#' 
#' @details
#' Internal usage in \code{shinyQC}.
#' 
#' @param var_x \code{numeric}, measured variances
#' @param var_perm \code{matrix}, variances obtained by permutation
#' 
#' @examples
#' x <- matrix(seq_len(100), ncol = 10)
#' pca <- dimensionReduction(x = x, params = list(center = TRUE, scale = TRUE), 
#'     type = "PCA")[[2]]
#' var_x <- explVar(d = pca, type = "PCA")
#' var_perm <- permuteExplVar(x = x, n = 100, center = TRUE, scale = TRUE)
#' plotPCAVarPvalue(var_x = var_x, var_perm = var_perm)
#' 
#' @return \code{gg} object from \code{ggplot}
#' 
#' @importFrom ggplot2 ggplot aes sym geom_point geom_line geom_hline aes
#' @importFrom ggplot2 ylab xlab theme_bw theme element_text
#'
#' @author Thomas Naake
#' 
#' @export
plotPCAVarPvalue <- function(var_x, var_perm) {
    p_val <- apply(t(var_perm) >= var_x, 1, sum) / nrow(var_perm)
    
    df <- data.frame(PC = names(p_val), values = p_val, group = "pvalue")
    df[["PC"]] <- factor(df[["PC"]], levels = df[["PC"]])
    
    ## plotting
    ggplot2::ggplot(df, ggplot2::aes(x = !!ggplot2::sym("PC"), 
            y = !!ggplot2::sym("values"))) + 
        ggplot2::geom_point() + 
        ggplot2::geom_line(ggplot2::aes(group = !!ggplot2::sym("group"))) + 
        ggplot2::geom_hline(ggplot2::aes(yintercept = 0.05), color = "red") +
        ggplot2::ylab("p-value") + ggplot2::xlab("principal components") + 
        ggplot2::theme_bw() + 
        ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90))
}

#' @name tblPCALoadings
#' 
#' @title Return tibble with PCA loadings for features
#' 
#' @description 
#' The function \code{tblPCALoadings} returns a \code{tibble} with loadings 
#' values for the features (row entries) in \code{x}.
#' 
#' @details 
#' The function \code{tblPCALoadings} acccesses the list entry \code{rotation} 
#' of the \code{prcomp} object. 
#' 
#' @param x \code{matrix}, containing no missing values
#' @param params \code{list}, arguments/parameters given to the function 
#' \code{stats::prcomp}
#' 
#' @examples 
#' set.seed(1)
#' x <- matrix(rnorm(seq_len(10000)), ncol = 100)
#' rownames(x) <- paste("feature", seq_len(nrow(x)))
#' colnames(x) <- paste("sample", seq_len(ncol(x)))
#' params <- list(method = "euclidean", ## dist
#'     initial_dims = 10, max_iter = 100, dims = 3, perplexity = 3, ## tSNE
#'     min_dist = 0.1, n_neighbors = 15, spread = 1) ## UMAP
#' tblPCALoadings(x, params)
#'
#' @return \code{tbl}
#' 
#' @author Thomas Naake
#' 
#' @export
tblPCALoadings <- function(x, params) {
    params <- append(params, list(x = t(x)))
    d <- do.call(what = stats::prcomp, params)$rotation
    tbl <- tibble::as_tibble(d) 
    tbl[["name"]] <- rownames(d)
    tbl
}

#' @name plotPCALoadings
#' 
#' @title Plot for PCA loadings of features
#' 
#' @description 
#' The function \code{plotPCALoadings} creates a loadings plot of the features.
#' 
#' @details 
#' The function takes as input the output of the function 
#' \code{tblPlotPCALoadings}. It uses the \code{ggplotly} function from 
#' \code{plotly} to create an interactive \code{plotly} plot.
#' 
#' 
#' @param tbl \code{tbl} as obtained by the function \code{dimensionReduction}
#' @param x_coord \code{character}, column name of \code{tbl} that stores x 
#' coordinates
#' @param y_coord \code{character}, column name of \code{tbl} that stores y 
#' coordinates
#' 
#' @examples 
#' x <- matrix(rnorm(seq_len(10000)), ncol = 100)
#' rownames(x) <- paste("feature", seq_len(nrow(x)))
#' colnames(x) <- paste("sample", seq_len(ncol(x)))
#' params <- list(method = "euclidean", ## dist
#'     initial_dims = 10, max_iter = 100, dims = 3, perplexity = 3, ## tSNE
#'     min_dist = 0.1, n_neighbors = 15, spread = 1) ## UMAP
#' tbl <- tblPCALoadings(x, params)
#' plotPCALoadings(tbl, x_coord = "PC1", y_coord = "PC2")
#'
#' @return \code{plotly}
#' 
#' @author Thomas Naake
#' 
#' @importFrom plotly ggplotly
#' @importFrom ggplot2 ggplot aes sym geom_point xlab ylab theme_classic
#' @importFrom ggplot2 theme
#' 
#' @export
plotPCALoadings <- function(tbl, x_coord, y_coord) {
    
    g <- ggplot2::ggplot(tbl, 
            ggplot2::aes(text = !!ggplot2::sym("name"))) +
        ggplot2::geom_point(ggplot2::aes(x = !!ggplot2::sym(x_coord), 
            y = !!ggplot2::sym(y_coord)), alpha = 0.4) +
        ggplot2::xlab(x_coord) + ggplot2::ylab(y_coord) +
        ggplot2::theme_classic() + ggplot2::theme(legend.position = "none")

    plotly::ggplotly(g, tooltip = "name")
}

#' @importFrom stats prcomp
#' @importFrom ape pcoa
#' @importFrom MASS isoMDS
#' @importFrom Rtsne Rtsne
#' @importFrom umap umap
#' @importFrom tibble as_tibble 
#' @importFrom SummarizedExperiment SummarizedExperiment

## function dimensionReduction
test_that("dimensionReduction", {
    set.seed(1)
    x <- matrix(rnorm(100000), nrow = 1000, ncol = 100, 
        dimnames = list(seq_len(1000), paste("sample", seq_len(100))))
    x[, seq(1, 25)] <- x[, seq(1, 25)] - 50
    x[, seq(26, 50)] <- x[, seq(26, 50)] - 25
    x[, seq(51, 75)] <- x[, seq(51, 75)] + 25
    x[, seq(76, 100)] <- x[, seq(76, 100)] + 50
    #x <- x + rnorm(10000)
    x_foo <- x
    x_foo[1, 3] <- NA
    
    parameters <- list(
        "center" = TRUE, "scale" = FALSE, ## PCA
        "method" = "euclidean", ## PCoA and NMDS
        "perplexity" = 3, "max_iter" = 1000, "initial_dims" = 2, ## tSNE
        "dims" = 2, "pca_center" = TRUE, "pca_scale" = FALSE, theta = 0, ## tSNE
        "min_dist" = 0.1, "n_neighbors" = 5, "spread" = 1) ## UMAP
    
    pca_o <- suppressWarnings(
        dimensionReduction(x, "PCA", params = parameters))
    pcoa_o <- dimensionReduction(x, type = "PCoA", params = parameters)
    suppressWarnings(
        nmds_o <- dimensionReduction(x, "NMDS", params = parameters))
    set.seed(1)
    tsne_o <- dimensionReduction(x, "tSNE", params = parameters)
    umap_o <- dimensionReduction(x, "UMAP", params = parameters)
    
    pca_r <- stats::prcomp(t(x), center = TRUE, scale = FALSE)$x 
    pca_r <- tibble::as_tibble(pca_r)
    pcoa_r <- cmdscale(dist(t(x), method = "euclidean"), k = ncol(x) - 1, 
        eig = FALSE)
    colnames(pcoa_r) <- paste("Axis.", seq_len(99), sep = "")
    pcoa_r <- tibble::as_tibble(pcoa_r)
    suppressWarnings(
        nmds_r <- MASS::isoMDS(dist(t(x), method = "euclidean"), k = 2)$points)
    nmds_r <- tibble::as_tibble(nmds_r)
    colnames(nmds_r) <- c("MDS1", "MDS2")
    tsne_r <- Rtsne::Rtsne(t(x), perplexity = 3, max_iter = 1000,
        initial_dims = 2, dims = 2, pca_center = TRUE, pca_scale = FALSE,
        theta = 0)$Y
    tsne_r <- tibble::as_tibble(tsne_r)
    colnames(tsne_r) <- c("X1", "X2")
    umap_r <- umap::umap(t(x), method = "naive", min_dist = 0.1, 
        n_neighbors = 5, spread = 1)$layout
    umap_r <- tibble::as_tibble(umap_r)
    colnames(umap_r) <- c("X1", "X2")
    
    expect_error(dimensionReduction(x, type = "foo", params = parameters), 
        "'arg' should be one of ")
    suppressWarnings(expect_error(
        dimensionReduction(x_foo, type = "PCA", params = parameters), 
        "infinite or missing values in 'x'"))
    expect_error(dimensionReduction(x_foo, type = "tSNE", params = parameters), 
        "missing values in object")
    expect_error(dimensionReduction(x_foo, type = "UMAP", params = parameters), 
        "missing value where TRUE/FALSE needed")
    expect_true(tibble::is_tibble(pca_o[[1]]))
    expect_true(tibble::is_tibble(pcoa_o[[1]]))
    expect_true(tibble::is_tibble(nmds_o[[1]]))
    expect_true(tibble::is_tibble(tsne_o[[1]]))
    expect_true(tibble::is_tibble(umap_o[[1]]))
    expect_true(is(pca_o[[2]], "prcomp"))
    expect_equal(names(pca_o[[2]]), 
        c("sdev", "rotation", "center", "scale", "x"))
    expect_true(is(pcoa_o[[2]], "list"))
    expect_equal(names(pcoa_o[[2]]), c("points", "eig", "x", "ac", "GOF"))
    expect_true(is(nmds_o[[2]], "list"))
    expect_equal(names(nmds_o[[2]]), c("points", "stress"))
    expect_true(is(tsne_o[[2]], "Rtsne"))
    expect_equal(names(tsne_o[[2]]), 
        c("N", "Y", "costs", "itercosts", "origD", "perplexity", "theta",
            "max_iter", "stop_lying_iter", "mom_switch_iter", "momentum",
            "final_momentum", "eta", "exaggeration_factor"))
    expect_true(is(umap_o[[2]], "umap"))
    expect_equal(names(umap_o[[2]]), c("layout", "data", "knn", "config"))
    expect_equal(dim(pca_o[[1]]), c(100, 101))
    expect_equal(dim(pcoa_o[[1]]), c(100, 100))
    expect_equal(dim(nmds_o[[1]]), c(100, 3))
    expect_equal(dim(tsne_o[[1]]), c(100, 3))
    expect_equal(dim(umap_o[[1]]), c(100, 3))
    
    ## the last column that is removed refers to the column "name"
    expect_equal(pca_o[[1]][, -101], pca_r, tolerance = 1e-07)
    expect_equal(pcoa_o[[1]][, -100], pcoa_r, tolerance = 1e-07)
    expect_equal(nmds_o[[1]][, -3], nmds_r, tolerance = 1e00)
    expect_equal(tsne_o[[1]][, -3], tsne_r, tolerance = 1e01)
    expect_equal(umap_o[[1]][, -3], umap_r, tolerance = 1e01)
    
    cols <- paste("sample", seq_len(100))
    expect_equal(pca_o[[1]][["name"]], cols)
    expect_equal(pcoa_o[[1]][["name"]], cols)
    expect_equal(nmds_o[[1]][["name"]], cols)
    expect_equal(tsne_o[[1]][["name"]], cols)
    expect_equal(umap_o[[1]][["name"]], cols)
})

## function dimensionReductionPlot
test_that("dimensionReductionPlot", {
     
    ## create se
    a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
                 dimnames = list(seq_len(10), paste("sample", seq_len(10))))
    set.seed(1)
    a <- a + rnorm(100)
    cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
    rD <- data.frame(spectra = rownames(a))
    se <- SummarizedExperiment::SummarizedExperiment(assay = a, 
        rowData = rD, colData = cD)
    se_error <- se
    colnames(se_error@colData)[1] <- "name"
    
    ## create the data.frame containing the transformed values
    parameters <- list("center" = TRUE, "scale" = FALSE)
    tbl <- dimensionReduction(SummarizedExperiment::assay(se), 
        type = "PCA", params = parameters)[[1]]
    g <- dimensionReductionPlot(tbl = tbl, se = se, color = "type", 
        size = "type", x_coord = "PC1", y_coord = "PC2")
    
    expect_error(dimensionReductionPlot(tbl = tbl), 'argument "se" is missing')
    expect_error(dimensionReductionPlot(tbl = tbl, se = se), 
        'argument "x_coord" is missing')
    expect_error(dimensionReductionPlot(tbl = tbl, se = se,
        color = "none"), 'argument "x_coord" is missing')
    expect_error(dimensionReductionPlot(tbl = tbl, se = se, color = "none", 
        x_coord = "PC1"), 'argument "y_coord" is missing')
    expect_error(dimensionReductionPlot(tbl = tbl, se = se, color = "none", 
        x_coord = "test", y_coord = "PC2"), 
        "object 'test' not found")
    expect_error(dimensionReductionPlot(tbl = tbl[, -11], se = se, color = "none", 
        x_coord = "PC1", y_coord = "PC2"), "must be present in the data")
    expect_error(dimensionReductionPlot(tbl = se, se = se), 
        "no applicable method for")
    expect_error(dimensionReductionPlot(tbl = tbl, se = "foo"), 
        "no applicable method for")
    expect_error(dimensionReductionPlot(tbl = tbl, se = se, color = "foo"), 
        "should be one of")
    expect_error(dimensionReductionPlot(tbl = tbl, se = se, color = "none", 
            size = "foo"), 
        "should be one of")
    expect_is(g, "plotly")
})

## function coordsUI
## requires reactive environment

## function explVar
test_that("explVar", {
    x <- matrix(seq_len(100), nrow = 10, ncol = 10, 
                dimnames = list(seq_len(10), paste("sample", seq_len(10))))
    set.seed(1)
    x <- x + rnorm(100)
    
    pca <- dimensionReduction(x = x, params = list(center = TRUE, scale = TRUE), 
        type = "PCA")[[2]]
    pcoa <- dimensionReduction(x = x, params = list(method = "euclidean"), 
        type = "PCoA")[[2]]
    
    varExpl_pca <- explVar(d = pca, type = "PCA")
    varExpl_pcoa <- explVar(d = pcoa, type = "PCoA")
    
    expect_error(explVar(d = NA, type = "PCA"), 
        "subscript out of bounds")
    expect_error(explVar(d = NA, type = "PCoA"), 
        "subscript out of bounds")
    suppressWarnings(expect_error(explVar(d = list(), type = "PCA"), 
        "must be the same length as the vector"))
    suppressWarnings(expect_error(explVar(d = list(), type = "PCoA"), 
        "must be the same length as the vector"))
    expect_equal(as.numeric(varExpl_pca), 
        c(9.992575e-01, 2.675309e-04, 2.275137e-04, 1.158747e-04, 5.881982e-05,
            4.652981e-05, 1.865835e-05, 6.885796e-06, 6.705589e-07,
            2.006033e-34),
        tolerance = 1e-07)
    expect_equal(as.numeric(varExpl_pcoa), 
        c(9.992597e-01, 2.673699e-04, 2.267327e-04, 1.145103e-04, 5.908631e-05,
            4.653893e-05, 1.855159e-05, 6.844296e-06, 6.848357e-07),
        tolerance = 1e-07)
    expect_equal(names(varExpl_pca), paste("PC", seq_len(10), sep = ""))
    expect_equal(names(varExpl_pcoa), paste("Axis.", seq_len(9), sep = ""))
})

## function permuteExplVar
test_that("permuteExplVar", {
    x <- matrix(seq_len(100), nrow = 10, ncol = 10, 
                dimnames = list(seq_len(10), paste("sample", seq_len(10))))
    set.seed(1)
    x <- x + rnorm(100)
    x_foo <- x
    x_foo[1, 3] <- NA
    
    varExplPerm <- permuteExplVar(x, n = 10, center = TRUE, scale = TRUE)
    expect_error(permuteExplVar(x_foo, n = 10, center = TRUE, scale = TRUE),
        "infinite or missing values in 'x'")
    expect_error(permuteExplVar(x, n = "", center = TRUE, scale = TRUE),
        "n has to be greater than 0")
    expect_error(permuteExplVar(x, n = 0, center = TRUE, scale = TRUE),
        "n has to be greater than 0")
    expect_error(permuteExplVar(x, n = 10, center = "", scale = TRUE),
        "length of 'center' must equal the number of columns of 'x'")
    expect_error(permuteExplVar(x, n = 10, center = TRUE, scale = ""),
        "length of 'scale' must equal the number of columns of 'x'")
    expect_equal(as.numeric(rowSums(varExplPerm)), rep(1, 10), tolerance = 1e-05)
    expect_equal(dim(varExplPerm), dim(x))
    expect_equal(colnames(varExplPerm), paste("PC", seq_len(10), sep = ""))
})

## function plotPCAVar
test_that("plotPCAVar", {
    x <- matrix(seq_len(100), nrow = 10, ncol = 10, 
        dimnames = list(seq_len(10), paste("sample", seq_len(10))))
    set.seed(1)
    x <- x + rnorm(100)
    pca <- dimensionReduction(x, params = list(center = TRUE, scale = TRUE), 
        type = "PCA")[[2]]
    var_x <- explVar(d = pca, type = "PCA")
    var_perm <- permuteExplVar(x, n = 100, center = TRUE, scale = TRUE)
    g <- plotPCAVar(var_x, var_perm)
    
    expect_error(plotPCAVar(NULL, NULL), 
        "arguments imply differing number of rows")
    expect_error(plotPCAVar(var_x, var_x),
        "'x' must be an array of at least two dimensions")
    expect_is(g, "gg")
})

## function plotPCAVarPvalue
test_that("plotPCAVarPvalue", {
    x <- matrix(seq_len(100), nrow = 10, ncol = 10, 
                dimnames = list(seq_len(10), paste("sample", seq_len(10))))
    set.seed(1)
    x <- x + rnorm(100)
    pca <- dimensionReduction(x, params = list(center = TRUE, scale = TRUE), 
        type = "PCA")[[2]]
    var_x <- explVar(d = pca, type = "PCA")
    var_perm <- permuteExplVar(x, n = 100, center = TRUE, scale = TRUE)
    g <- plotPCAVarPvalue(var_x, var_perm)
    
    expect_error(plotPCAVarPvalue(NULL, NULL), "argument is not a matrix")
    expect_error(plotPCAVarPvalue(var_x, var_x), 
        "arguments imply differing number of rows")
    expect_is(g, "gg")
})

## function tblPCALoadings
test_that("tblPCALoadings", {
    x <- matrix(seq_len(100), nrow = 10, ncol = 10, 
                dimnames = list(seq_len(10), paste("sample", seq_len(10))))
    params <- list(center = TRUE, scale = TRUE)
    tbl <- tblPCALoadings(x = x, params = params)
    expect_is(tbl, "tbl")
    expect_equal(dim(tbl), c(10, 11))
    expect_equal(tbl$name, as.character(seq_len(10)))
    expect_equal(colnames(tbl), c(paste0("PC", seq_len(10)), "name"))
    expect_equal(tbl$PC1, rep(0.316, 10), tolerance = 1e-3)
    expect_equal(tbl$PC2, c(-0.9486833, rep(0.1054093, 9)), tolerance = 1e-3)
    expect_error(tblPCALoadings(x = "foo", params = params), "must be numeric")
    expect_error(tblPCALoadings(x = x, params = "foo"), 
        "argument is not interpretable as logical")
})

## function plotPCALoadings
test_that("plotPCALoadings", {
    x <- matrix(seq_len(100), nrow = 10, ncol = 10, 
                dimnames = list(seq_len(10), paste("sample", seq_len(10))))
    params <- list(center = TRUE, scale = TRUE)
    tbl <- tblPCALoadings(x = x, params = params)
    expect_is(plotPCALoadings(tbl, "PC1", "PC2"), "plotly")
    expect_error(plotPCALoadings(NULL, "PC1", "PC2"), "object 'PC1' not found")
    expect_error(plotPCALoadings(tbl, "foo", "PC2"), "object 'foo' not found")
    expect_error(plotPCALoadings(tbl, "PC1", "foo"), "object 'foo' not found")
})

#' @name samplesMeasuredMissing
#'
#' @title Create tibble containing number of measured/missing features 
#' of samples
#'
#' @description \code{samplesMeasuredMissing} returns a \code{tbl} with 
#' the number of measured/missing
#' features of samples. The function will take as input a 
#' \code{SummarizedExperiment} object and will access its \code{assay()} slot
#'
#' @param se \code{SummarizedExperiment} object
#' 
#' @return \code{tbl} with number of measured/missing features per sample
#' 
#' @examples 
#' ## create se
#' a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
#'             dimnames = list(seq_len(10), paste("sample", seq_len(10))))
#' a[c(1, 5, 8), seq_len(5)] <- NA
#' set.seed(1)
#' a <- a + rnorm(100)
#' sample <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
#' featData <- data.frame(spectra = rownames(a))
#' se <- SummarizedExperiment::SummarizedExperiment(assay = a, 
#'     rowData = featData, colData = sample)
#' 
#' ## create the data.frame with information on number of measured/missing
#' ## values
#' samplesMeasuredMissing(se)
#' 
#' @importFrom SummarizedExperiment assay
#' 
#' @export
samplesMeasuredMissing <- function(se) {
    
    a <- SummarizedExperiment::assay(se)
    sum_na <- colSums(is.na(a))
    
    ## count per column the missing/measured values
    tibble::tibble(name = colnames(a),
        measured = nrow(a) - sum_na, missing = sum_na)
}

#' @name barplotSamplesMeasuredMissing
#'
#' @title Barplot of number of measured/missing features of samples
#'
#' @description \code{barplotSamplesMeasuredMissing} plots the number of 
#' measured/missing features of samples as a barplot. The function will 
#' take as input the returned \code{tbl} of \code{samplesMeasuredMissing}. 
#'
#' @param tbl \code{tbl} object
#' @param measured \code{logical}, should the number of measured or missing 
#' values be plotted
#' 
#' @return \code{gg} object from \code{ggplot2}
#' 
#' @examples 
#' ## create se
#' a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
#'             dimnames = list(seq_len(10), paste("sample", seq_len(10))))
#' a[c(1, 5, 8), seq_len(5)] <- NA
#' set.seed(1)
#' a <- a + rnorm(100)
#' cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
#' rD <- data.frame(spectra = rownames(a))
#' se <- SummarizedExperiment::SummarizedExperiment(assay = a, 
#'     rowData = rD, colData = cD)
#'
#' ## create the data.frame with information on number of measured/missing
#' ## values
#' tbl <- samplesMeasuredMissing(se) 
#'
#' ## plot number of measured values
#' barplotSamplesMeasuredMissing(tbl, measured = TRUE)
#'
#' ## plot number of missing values
#' barplotSamplesMeasuredMissing(tbl, measured = FALSE)
#'
#' @importFrom ggplot2 ggplot geom_bar aes sym ylab theme_classic xlab theme
#' @importFrom ggplot2 element_text
#' @importFrom plotly ggplotly
#' 
#' @export
barplotSamplesMeasuredMissing <- function(tbl, measured = TRUE) {
    
    ## create a barplot with the number of measured/missing features per sample
    g <- ggplot2::ggplot(tbl) 
    if (measured) 
        g <- g + ggplot2::geom_bar(
            ggplot2::aes(x = !!ggplot2::sym("name"), 
                y = !!ggplot2::sym("measured")), stat = "identity") +
            ggplot2::ylab("number of measured features")
    if (!measured) 
        g <- g + ggplot2::geom_bar(
            ggplot2::aes(x = !!ggplot2::sym("name"), 
                y = !!ggplot2::sym("missing")), stat = "identity") +
            ggplot2::ylab("number of missing features")
    g <- g + ggplot2::theme_classic() + ggplot2::xlab("sample") + 
        ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90))
    plotly::ggplotly(g)
} 

#' @name histFeature
#'
#' @title Histogram for measured value per feature
#'
#' @description 
#' The function \code{histFeature} creates a histogram with the number
#' of measured/missing values per feature.
#'
#' @param x \code{matrix} containing intensities. Missing values are encoded 
#' as \code{NA}.
#' @param measured \code{logical}, should the measured values 
#' (\code{measured = TRUE}) or missing values (\code{measured = FALSE}) be taken
#' @param ... additional parameters passed to \code{geom_histogram}, e.g. 
#' \code{binwidth}.
#'
#' @return \code{plotly} object from \code{ggplotly}
#' 
#' @examples
#' x <- matrix(c(c(1, 1, 1), c(1, NA, 1), c(1, NA, 1), 
#'     c(1, 1, 1), c(NA, 1, 1), c(NA, 1, 1)), byrow = FALSE, nrow = 3)
#' colnames(x) <- c("A_1", "A_2", "A_3", "B_1", "B_2", "B_3")
#' histFeature(x, binwidth = 1)
#' 
#' @importFrom tibble tibble
#' @importFrom ggplot2 ggplot geom_histogram xlab ylab ggtitle theme_classic
#' @importFrom plotly ggplotly
#' @export
histFeature <- function(x, measured = TRUE, ...) { 
    
    ## retrieve the measured values per compound and store the values in a 
    ## tibble
    if (measured) {
        val <- !is.na(x)   
        title <- "Measured values"
        x_lab <- "number of measured values per feature"
    } else { ## missing
        val <- is.na(x)
        title <- "Missing values"
        x_lab <- "number of missing values per feature"
    }
    val <- rowSums(val)
    val <- tibble::tibble(values = val)
    
    ## plotting
    g <- ggplot2::ggplot(val, aes(x = !!ggplot2::sym("values"))) + 
        ggplot2::geom_histogram(...) + 
        ggplot2::xlab(x_lab) + 
        ggplot2::ylab("number of features") + 
        ggplot2::ggtitle(title) + 
        ggplot2::theme_classic()
    plotly::ggplotly(g)
    
    
}


#' @name measuredCategory
#' 
#' @title Obtain the number of measured intensities per sample type
#' 
#' @description 
#' The function \code{measuredCategory} creates a \code{tbl} with
#' the number of measured values per feature. 0 means that there were only 
#' missing values (\code{NA}) for the feature and sample type. 
#' \code{measuredCategory} will return a \code{tbl} where columns are the 
#' unique sample types and rows are the features as in \code{assay(se)}.
#' 
#' @details 
#' \code{measuredCategory} is a helper function. 
#' 
#' @param se \code{SummarizedExperiment}
#' @param measured \code{logical}, should the measured values 
#' (\code{measured = TRUE}) or missing values (\code{measured = FALSE}) 
#' be taken
#' @param category \code{character}, corresponds to a column name in 
#' \code{colData(se)}
#' 
#' @return \code{matrix} with number of measured/missing features per 
#' \code{category} type
#' 
#' @examples
#' ## create se
#' set.seed(1)
#' a <- matrix(rnorm(100), nrow = 10, ncol = 10,
#'             dimnames = list(seq_len(10), paste("sample", seq_len(10))))
#' a[c(1, 5, 8), seq_len(5)] <- NA
#' cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
#' rD <- data.frame(spectra = rownames(a))
#' se <- SummarizedExperiment::SummarizedExperiment(assay = a,
#'     rowData = rD, colData = cD)
#'
#' measuredCategory(se, measured = TRUE, category = "type")
#'
#' @importFrom SummarizedExperiment assay
#' @importFrom tibble as_tibble
#'
#' @export
measuredCategory <- function(se, measured = TRUE, category = "type") {
    
    ## access the colData slot and add the rownames as a new column to cD
    ## (will add the column "rowname")
    cD <- se@colData
    category <- match.arg(category, choices = colnames(cD))
    colnames(cD) <- make.names(colnames(cD))
    category <- make.names(category)
    
    ## access the assay slot
    a <- SummarizedExperiment::assay(se)
    
    ## get the sample category levels and create a vector with the unique
    ## sample category levels
    samp <- cD[[category]]
    samp_u <- unique(samp)

    ## create the data.frame to store the values, the data.frame has the
    ## dimensions: nrow(a)/number of features as in a and number of 
    ## unique sample types
    mat_samp <- matrix(NA, nrow = nrow(a), ncol = length(samp_u),
        dimnames = list(rownames(a), samp_u))

    ## iterate through the columns and write to the respective column if 
    ## the feature was measured in (at least) one sample of this type
    for (i in samp_u) {
        a_samp_i <- a[, samp == i, drop = FALSE]
        if (measured) {
            mat_samp[, i] <- rowSums(!is.na(a_samp_i))    
        } else { ## missing
            mat_samp[, i] <- rowSums(is.na(a_samp_i))
        }
    }
    #data.frame(feature = rownames(mat_samp), mat_samp)
    mat_samp
}

## compounds per class
#' @name histFeatureCategory
#'
#' @title Histogram of features per sample type
#'
#' @description The function \code{histFeatureCategory} creates histogram
#' plots for each sample type in \code{se}.
#'
#' @param se \code{SummarizedExperiment}, the assay slot contains the intensity 
#' values per sample. Missing values are encoded as \code{NA}.
#' @param measured \code{logical}, should the measured values 
#' (\code{measured = TRUE}) or missing values (\code{measured = FALSE}) be taken 
#' @param category \code{character}, corresponding to a column in 
#' \code{colData(se)}
#' @param... additional parameters passed to \code{geom_histogram}, e.g. 
#' \code{binwidth}.
#' 
#' @return \code{plotly} object from \code{ggplotly}
#'
#' @examples
#' ## create se
#' a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
#'             dimnames = list(seq_len(10), paste("sample", seq_len(10))))
#' a[c(1, 5, 8), seq_len(5)] <- NA
#' set.seed(1)
#' a <- a + rnorm(100)
#' cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
#' rD <- data.frame(spectra = rownames(a))
#' se <- SummarizedExperiment::SummarizedExperiment(assay = a, 
#'     rowData = rD, colData = cD)
#' 
#' histFeatureCategory(se, measured = TRUE, category = "type")
#' 
#' @importFrom tidyr pivot_longer
#' @importFrom ggplot2 ggplot aes sym geom_histogram facet_grid ggtitle
#' @importFrom ggplot2 xlab ylab theme_classic theme
#' @importFrom plotly ggplotly
#'
#' @export
histFeatureCategory <- function(se, measured = TRUE, 
    category = "type", ...) {

    ## create data frame with columns as unique sample type
    mat_type <- measuredCategory(se, measured = measured, 
        category = category)

    ## create a tibble in long format and prepare for plotting (exclude column
    ## feature)
    tbl_type_l <- mat_type |> 
        as.data.frame() |> 
        tidyr::pivot_longer(cols = seq_len(ncol(mat_type)))
    
    if (measured) {
        title <- "Measured values"
        x_lab <- "number of measured values per feature"
    } else {
        title <- "Missing values"
        x_lab <- "number of missing values per feature"
    }

    p <- ggplot2::ggplot(tbl_type_l,
            ggplot2::aes(x = !!ggplot2::sym("value"))) + 
        ggplot2::geom_histogram(ggplot2::aes(fill = !!ggplot2::sym("name")), 
            ...) +
        ggplot2::facet_grid(. ~ name) + ggplot2::ggtitle(title) + 
        ggplot2::xlab(x_lab) + ggplot2::ylab("number of features") +
        ggplot2::theme_classic() + ggplot2::theme(legend.position = "none")
    plotly::ggplotly(p)
}

## frequencies of missing values per compound with respect to class, 
## sample type, study groups to assess differences in occurences
#' @name upsetCategory
#'
#' @title UpSet plot to display measures values across sample types
#'
#' @description 
#' The function \code{upsetCategory} displays the frequency of measured values 
#' per feature with respect to class/sample type to assess difference in
#' occurrences. Internally, the measured values per sample are obtained via
#' the \code{measuredCategory} function: this function will access the number
#' of measured/missing values per category and feature. From this, a binary 
#' \code{tbl} will be created specifying if the feature is present/missing, 
#' which will be given to the \code{upset} function from the \code{UpSetR} 
#' package.
#'
#' @details 
#' Presence is defined by a feature being measured in at least one 
#' sample of a set.
#' 
#' Absence is defined by a feature with only missing values (i.e. 
#' no measured values) of a set.
#' 
#' @param se \code{SummarizedExperiment},
#'  containing the intensity values in \code{assay(se)}, missing values are
#' encoded by \code{NA}
#' @param category \code{character}, corresponding to a column in 
#' \code{colData(se)}
#' @param measured \code{logical}, should the measured values 
#' (\code{measured = TRUE}) 
#' or missing values (\code{measured = FALSE}) be taken 
#'
#' @return \code{upset} plot
#' 
#' @examples 
#' ## create se
#' a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
#'             dimnames = list(seq_len(10), paste("sample", seq_len(10))))
#' a[c(1, 5, 8), seq_len(5)] <- NA
#' set.seed(1)
#' a <- a + rnorm(100)
#' cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
#' rD <- data.frame(spectra = rownames(a))
#' se <- SummarizedExperiment::SummarizedExperiment(assay = a, 
#'     rowData = rD, colData = cD)
#' 
#' upsetCategory(se, category = "type")
#' 
#' @importFrom UpSetR upset
#' 
#' @export
upsetCategory <- function(se, category = colnames(colData(se)), measured = TRUE) {
    
    category <- match.arg(category)
    ## create data frame with columns as unique sample type
    mat_type <- measuredCategory(se, category = category, measured = measured) 
    
    if (measured) 
        ## Presence is defined by a feature being measured in at least one 
        ## sample of a set
        mat_bin <- ifelse(mat_type > 0, 1, 0) 
    else {
        ## Absence is defined by a feature with only missing values (i.e. 
        ## no measured values) of a set. 
        cD <- se@colData
        category_tab <- table(cD[[category]])
        category_tab <- category_tab[colnames(mat_type)]
        mat_bin <- ifelse(mat_type == as.numeric(category_tab), 1, 0)
    }
    if (sum(colSums(mat_bin) > 0) > 1) {
        mat_bin <- as.data.frame(mat_bin)
        UpSetR::upset(mat_bin, order.by = "freq", nsets = ncol(mat_type))
    } else {
        NULL
    }
}

#' @name extractComb
#'
#' @title Obtain the features that are present in a specified set
#'
#' @description
#' The function \code{extractComb} extracts the features that match a
#' \code{combination} depending if the features was measured or missing. 
#' The function will return the sets that match the \code{combination}, 
#' thus, the function might be useful when answering questions about which 
#' features are measured/missing under certain combinations (e.g. sample 
#' types or experimental conditions).
#' 
#' @details 
#' The function \code{extractComb} uses the \code{make_comb_mat} function from 
#' \code{ComplexHeatmap} package.
#' 
#' Presence is defined by a feature being measured in at least one sample of a 
#' set.
#' 
#' Absence is defined by a feature with only missing values (i.e. no measured 
#' values) of a set. 
#'
#' @param se \code{SummarizedExperiment}
#' @param combination \code{character}, refers to factors in \code{category}
#' @param measured \code{logical}
#' @param category \code{character}, corresponding to a column name in 
#' \code{colData(se)}
#'
#' @return \code{character}
#' 
#' @examples
#' 
#' ## create se
#' a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
#'             dimnames = list(seq_len(10), paste("sample", seq_len(10))))
#' a[c(1, 5, 8), seq_len(5)] <- NA
#' set.seed(1)
#' a <- a + rnorm(100)
#' cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
#' rD <- data.frame(spectra = rownames(a))
#' se <- SummarizedExperiment::SummarizedExperiment(assay = a, rowData = rD, colData = cD)
#' 
#' extractComb(se, combination = "2", measured = TRUE, category = "type") 
#' 
#' @importFrom ComplexHeatmap make_comb_mat comb_name extract_comb
#' 
#' @export
extractComb <- function(se, combination, measured = TRUE, category = "type") {
    
    ## obtain the number of measured samples per type and create a binary matrix
    mat_type <- measuredCategory(se = se, measured = measured, category = category)
    feat <- rownames(mat_type)
    
    ## create the binary matrix
    if (measured) {
        ## Presence is defined by a feature being measured in at least one 
        ## sample of a set
        mat_bin <- ifelse(mat_type > 0, 1, 0) 
    } else {
        ## Absence is defined by a feature with only missing values (i.e. 
        ## no measured values) of a set. 
        cD <- se@colData
        category_tab <- table(cD[[category]])
        category_tab <- category_tab[colnames(mat_type)]
        mat_bin <- ifelse(mat_type == as.numeric(category_tab), 1, 0)
    }
    
    ## create the combination matrix object
    comb_mat <- ComplexHeatmap::make_comb_mat(mat_bin, mode = "distinct")
    
    ## create a character vector that contains the combination in a binary 
    ## format from the combination argument (character vector with types)
    combination_num <- ifelse(colnames(mat_bin) %in% combination, 1, 0)
    combination_num <- paste(combination_num, collapse = "")
    
    ## return the names of the features that match the combination
    if (combination_num %in% ComplexHeatmap::comb_name(comb_mat)) {
        res <- ComplexHeatmap::extract_comb(comb_mat, combination_num)
    } else {
        res <- "no features for this combination"
    }
    
    res
}

#' @importFrom SummarizedExperiment SummarizedExperiment
#' @importFrom dplyr pull
#' @importFrom tibble tibble is_tibble

## create se
a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
            dimnames = list(seq_len(10), paste("sample", seq_len(10))))
a[c(1, 5, 8), seq_len(5)] <- NA
set.seed(1)
a <- a + rnorm(100)
cD <- data.frame(sample = colnames(a), type = c(rep("1", 5), rep("2", 5)))
rD <- data.frame(spectra = rownames(a))
se <- SummarizedExperiment::SummarizedExperiment(assay = a, rowData = rD, 
    colData = cD)

## function samplesMeasuredMissing
test_that("samplesMeasuredMissing", {
    measured <- c(7, 7, 7, 7, 7, 10, 10, 10, 10, 10)
    missing <- c(3, 3, 3, 3, 3, 0, 0, 0, 0, 0)
    x <- samplesMeasuredMissing(se)
    expect_equal(dplyr::pull(x, "name"), 
        c("sample 1", "sample 2", "sample 3", "sample 4", "sample 5", 
          "sample 6", "sample 7", "sample 8", "sample 9", "sample 10"))
    expect_equal(as.numeric(dplyr::pull(x, "measured")), measured)
    expect_equal(as.numeric(dplyr::pull(x, "missing")), missing)
    expect_is(x, "tbl")
    expect_error(samplesMeasuredMissing(NULL), "unable to find an inherited")
    expect_error(samplesMeasuredMissing("foo"), "unable to find an inherited")
    expect_error(samplesMeasuredMissing(seq_len(10)), "unable to find an inherited")
})

## function barplotSamplesMeasuredMissing
test_that("barplotSamplesMeasuredMissing", {
    x <- samplesMeasuredMissing(se)
    expect_is(barplotSamplesMeasuredMissing(x, measured = TRUE), "plotly")
    expect_is(barplotSamplesMeasuredMissing(x, measured = FALSE), "plotly")
    ##expect_error(barplotSamplesMeasuredMissing(NULL, measured = FALSE), "not found")
    expect_error(barplotSamplesMeasuredMissing("foo", measured = FALSE), 
        "must be a ")
    expect_error(barplotSamplesMeasuredMissing(seq_len(10), measured = FALSE), 
        "must be a ")
    expect_error(barplotSamplesMeasuredMissing(x, measured = NULL), 
        "argument is of length zero")
    
})


## function histFeature
test_that("histFeature", {
    x <- data.frame(A_1 = c(1, 1, 1), A_2 = c(1, NA, 1), A_3 = c(1, NA, 1), 
        B_1 = c(1, 1, 1), B_2 = c(NA, 1, 1), B_3 = c(NA, 1, 1))
    g <- histFeature(x, binwidth = 1, measured = TRUE)
    
    expect_error(histFeature(x = NULL), 
        "must be an array of at least two dimensions")
    expect_error(histFeature(x = df, measured = ""), 
        "argument is not interpretable as logical")
    # expect_warning(histFeature(x = df, binwidth = ""), 
    #     "`width` must be a numeric scalar")
    #expect_warning(histFeature(x = df, binwidth = 0), 
    #     "`binwidth` must be positive")
    expect_is(g, "plotly")
})

## function measuredCategory
test_that("measuredCategory", {
    mc_t <- measuredCategory(se, measured = TRUE, category = "type")
    mc_f <- measuredCategory(se, measured = FALSE, category = "type")
    
    tbl_1 <- data.frame( 
        "1" = c(0, 5, 5, 5, 0, 5, 5, 0, 5, 5), 
        "2" = c(5, 5, 5, 5, 5, 5, 5, 5, 5, 5)) |> as.matrix()
    colnames(tbl_1) <- c(1, 2)
    tbl_2 <- data.frame(
        "1" = c(5, 0, 0, 0, 5, 0, 0, 5, 0, 0), 
        "2" = c(0, 0, 0, 0, 0, 0, 0, 0, 0, 0)) |> as.matrix()
    colnames(tbl_2) <- c(1, 2)
    
    expect_true(all(mc_t == tbl_1))
    expect_true(all(mc_f == tbl_2))
    expect_true(is.matrix(mc_t))
    expect_true(is.matrix(mc_f))
    expect_equal(dim(mc_t), c(10, 2))
    expect_equal(dim(mc_f), c(10, 2))
    expect_error(
        measuredCategory(se = se, measured = TRUE, category = "foo"), 
        "'arg' should be one of ")
    expect_error(
        measuredCategory(se = NULL, measured = TRUE, category = "type"),
        "no applicable method for")
    expect_error(
        measuredCategory(se = se, measured = "", category = "type"),
        "argument is not interpretable as logical")
})

## function histFeatureCategory
test_that("histFeatureCategory", { 
    g <- histFeatureCategory(se = se, measured = TRUE, 
        category = "type", binwidth = 2)
    expect_error(
        histFeatureCategory(NULL, measured = TRUE, category = "type", 
            binwidth = 2), "no applicable method for")
    expect_error(
        histFeatureCategory(se, measured = "", category = "type", 
            binwidth = 2), "argument is not interpretable as logical")
    expect_error(
        histFeatureCategory(se, measured = TRUE, category = "foo", 
            binwidth = 2), "'arg' should be one of ")
    expect_is(g, "plotly")
})

## function upset_category
test_that("upset_category", {
    g <- upsetCategory(se, category = "type")
    expect_error(upsetCategory(NULL, category = "type"), "unable to find an")
    expect_error(upsetCategory(se, category = "foo"), "should be one of ")
    expect_equal(upsetCategory(se, category = "type", measured = FALSE), NULL)
    expect_error(upsetCategory(se, category = "type", measured = ""),
        "argument is not interpretable as logical")
    expect_is(g, "upset")
    
    se_2 <- SummarizedExperiment(
        assays = list(counts = matrix(100 * runif(100 * 8), 100, 8)),
            colData = DataFrame(sample = paste0("S", seq_len(8)),
            type = sample(LETTERS[c(1, 2)], 8, replace = TRUE),
            name = paste0("S", seq_len(8)))
    )
    assay(se_2)[5, 1] <- NA
    g <- upsetCategory(se_2, category = "type", measured = FALSE)
    expect_equal(g, NULL)
    
})

## function extractComb
test_that("extractComb", {
    expect_equal(
        extractComb(se = se, combination = "1", measured = TRUE, 
            category = "type"), "no features for this combination")
    expect_equal(
        extractComb(se = se, combination = "2", measured = TRUE, 
            category = "type"), c("1", "5", "8"))
    expect_equal(
        extractComb(se = se, combination = c("1", "2"), measured = TRUE, 
            category = "type"), c("2", "3", "4", "6", "7", "9", "10"))
    expect_equal(
        extractComb(se = se, combination = "1", measured = FALSE, 
            category = "type"), c("1", "5", "8"))
    expect_equal(
        extractComb(se = se, combination = "2", measured = FALSE, 
            category = "type"), "no features for this combination")
    expect_equal(
        extractComb(se = se, combination = c("1", "2"), measured = FALSE, 
            category = "type"), "no features for this combination")
    expect_error(
        extractComb(se = se, combination = "1", measured = "", 
            category = "type"), "argument is not interpretable as logical")
    expect_error(
        extractComb(se = se, combination = "1", measured = TRUE, 
            category = "foo"), 
        "'arg' should be one of ")
    expect_error(
        extractComb(se = NULL, combination = "1", measured = TRUE, 
            category = "type"), "no applicable method for")
})

################################################################################
################################### Values #####################################
################################################################################

#' @name fR_boxplotUI
#'
#' @title Fluid row UI for tab panel 'Boxplot/Violin plot'
#'
#' @description
#' The module defines the UI for the tab panel 'Boxplot/Violin plot'.
#'
#' @details 
#' \code{fR_boxplotUI} returns the HTML code for the tab-pane 
#' 'Boxplot/Violin plot'. Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param name \code{character}
#' @param collapsed \code{logical}
#' 
#' @return 
#' \code{shiny.tag} with HTML content
#'
#' @author Thomas Naake
#' 
#' @examples
#' fR_boxplotUI("test", "name")
#' 
#' @importFrom shiny NS fluidRow downloadButton plotOutput
#' @importFrom shinydashboard box
#' 
#' @noRd
fR_boxplotUI <- function(id, name, collapsed) {
    ns <- shiny::NS(id)
    shiny::fluidRow(
        shinydashboard::box(title = name, width = 12, collapsible = TRUE, 
            collapsed = collapsed,
            shiny::plotOutput(outputId = ns("boxplot")),
            shiny::downloadButton(outputId = ns("downloadPlot"), ""))
    )
}

#' @name tP_boxplotUI
#' 
#' @title Tab panel UI for tab panel 'Boxplot/Violin plot'
#' 
#' @description 
#' The function defines the UI for the tab panel 'Boxplot/Violin plot'. It 
#' serves as a wrapper for the function \code{fR_boxplotUI}.
#' 
#' @details 
#' \code{tP_boxplotUI} returns the HTML code for the tab-pane 
#' 'Boxplot/Violin plot'. Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' 
#' @return 
#' \code{shiny.tag} with HTML content
#'
#' @author Thomas Naake
#' 
#' @examples
#' tP_boxplotUI("test")
#' 
#' @importFrom shiny NS tabPanel fluidRow column conditionalPanel
#' @importFrom shiny selectInput radioButtons HTML
#' @importFrom shinyhelper helper
#' @importFrom plotly plotlyOutput
#' 
#' @noRd
tP_boxplotUI <- function(id) {
    
    ns <- shiny::NS(id)
    shiny::tabPanel(title = "Boxplot/Violin plot",
        shiny::fluidRow(
            shiny::column(6, 
                shiny::radioButtons(inputId = "boxLog",
                    label = shiny::HTML("Display log values? <br>
                        (only for 'raw', 'normalized' and 'batch corrected')"),
                    choices = list("no log", "log"),
                    selected = "no log")),
            shiny::column(2, 
                shiny::radioButtons(inputId = "violinPlot",
                    label = "Type of display", 
                    choices = list("boxplot", "violin"), 
                        selected = "boxplot")),
            shiny::column(3, 
                shiny::selectInput(inputId = ns("orderCategory"), 
                    label = "Select variable to order samples", 
                    choices = "name")),
            shiny::column(1, 
                shiny::br() |> 
                    shinyhelper::helper(content = "tabPanel_boxplot"))
        ),
        fR_boxplotUI("boxRaw", "raw", collapsed = FALSE),
        fR_boxplotUI("boxNorm", "normalized", collapsed = TRUE),
        fR_boxplotUI("boxBatch", "batch corrected", collapsed = TRUE),
        fR_boxplotUI("boxTransf", "transformed", collapsed = TRUE),
        shiny::conditionalPanel("output.missingVals == 'TRUE'", 
            fR_boxplotUI("boxImp", "imputed", collapsed = TRUE))
    )
}

#' @name boxPlotUIServer
#' 
#' @title Module for server expressions for the UI of tab panel 
#' 'Boxplot/Violin plot' 
#' 
#' @description
#' The module defines the server expressions for parts of the UI for the tab 
#' panel 'Boxplot/Violin plot'. It will load different helper files depending
#' on \code{missingValue}
#' 
#' @details 
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param missingValue \code{logical} (will load different helper files)
#' 
#' @return
#' \code{shiny.render.function} expression
#' 
#' @importFrom shiny moduleServer observe updateSelectInput
#' @importFrom shinyhelper helper
#' @importFrom SummarizedExperiment SummarizedExperiment
#'
#' @author Thomas Naake
#' 
#' @noRd
boxPlotUIServer <- function(id, se) {

    shiny::moduleServer(
        id, 
        function(input, output, session) {
            
            shiny::observe({
                shiny::updateSelectInput(session = session, 
                    inputId = "orderCategory", choices = colnames(se@colData))
            })

        }
    )
}

#' @name boxPlotServer
#' 
#' @title Module for server expressions of tab panel 'Boxplot/Violin plot' 
#' 
#' @description
#' The module defines the server expressions for the tab panel 
#' 'Boxplot/Violin plot'.
#' 
#' @details 
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param se \code{SummarizedExperiment}
#' @param boxLog \code{reactive} expression and \code{logical}
#' @param violin \code{reactive} expression and \code{character}
#' @param type \code{character}
#' 
#' @return
#' \code{shiny.render.function} expression
#'
#' @author Thomas Naake
#' 
#' @importFrom shiny moduleServer reactive renderPlot downloadHandler req
#' @importFrom ggplot2 ggsave
#' @importFrom plotly plotlyOutput
#' 
#' @noRd
boxPlotServer <- function(id, se, orderCategory, boxLog, violin, type) {
    
    shiny::moduleServer(
        id, 
        function(input, output, session) {
            
            logValues <- shiny::reactive({
                if (boxLog() == "log") {
                    TRUE
                } else {
                    FALSE
                }
            })
            
            vP <- shiny::reactive({
                if (violin() == "violin") {
                    TRUE
                } else {
                    FALSE
                }
            })
            
            ## create the actual plot
            p_boxplot <- shiny::reactive({
                createBoxplot(se = se(), orderCategory = orderCategory(), 
                    title = "", log = logValues(), 
                    violin = vP())
            })
            output$boxplot <- shiny::renderPlot({
                p_boxplot()
            })
            
            output$downloadPlot <- shiny::downloadHandler(
                filename = function() {
                    paste("Boxplot_violinplot_", type, ".pdf", sep = "")
                },
                content = function(file) {
                    ggplot2::ggsave(file, p_boxplot(), device = "pdf",
                        limitsize = FALSE)
                }
            )
        }
    )
}

################################################################################
################################# drift/trend ##################################
################################################################################
#' @name tP_driftUI
#'
#' @title Tab panel UI for tab panel 'Trend/drift'
#'
#' @description
#' The module defines the UI for the tab panel 'Trend/drift'.
#'
#' @details 
#' \code{tP_driftUI} returns the HTML code for the tab-pane 
#' 'Trend/drift'. Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#'
#' @return 
#' \code{shiny.tag} with HTML content
#'
#' @author Thomas Naake
#'
#' @examples
#' tP_driftUI("test", se)
#' 
#' @importFrom shiny NS tabPanel fluidRow downloadButton column
#' @importFrom shiny selectInput
#' @importFrom shinydashboard box
#' @importFrom shinyhelper helper
#' @importFrom plotly plotlyOutput
#' 
#' @noRd
tP_driftUI <- function(id) {

    ns <- shiny::NS(id)
    shiny::tabPanel(title = "Trend/drift",
        shiny::fluidRow(
            shiny::column(width = 12,
                plotly::plotlyOutput(outputId = ns("plotDrift"),
                    width = "95%") |>
                    shinyhelper::helper(content = "tabPanel_drift"),
                shiny::downloadButton(outputId = ns("downloadPlot"), "")
            ),
            shinydashboard::box(width = 12, collapsible = TRUE, 
                collapsed = FALSE, title = "Parameters",
                shiny::column(6,
                    shiny::selectInput(
                        inputId = ns("category"),
                        label = "Select variable", choices = "name"),
                    shiny::selectInput(
                        inputId = ns("levelSel"), 
                        label = "Select level to highlight", 
                        choices = "all"),
                    shiny::selectInput(
                        inputId = ns("orderCategory"),
                        label = "Select variable to order samples",
                        choices = "name")),
                shiny::column(6,
                    shiny::selectInput(inputId = ns("aggregation"), 
                        label = "Select aggregation",
                        choices = list("sum", "median"), selected = "sum"),
                    shiny::selectInput(inputId = ns("method"),
                        label = "Select smoothing method",
                        choices = list("LOESS" = "loess", "linear model" = "lm"),
                        selected = "loess"),
                    shiny::selectInput(inputId = ns("data"),
                        label = "Select data input", choices = "raw"))
            ),
        )
    )
}

#' @name driftServer
#' 
#' @title Module for server expressions of tab panel 'Trend/drift' 
#' 
#' @description
#' The module defines the server expressions for the tab panel 
#' 'Trend/drift'.
#' 
#' @details 
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param se \code{SummarizedExperiment} and \code{reactive} value
#' @param se_n \code{SummarizedExperiment} and \code{reactive} value
#' @param se_b \code{SummarizedExperiment} and \code{reactive} value
#' @param se_t \code{SummarizedExperiment} and \code{reactive} value
#' @param se_i \code{SummarizedExperiment} and \code{reactive} value
#' @param missingValue \code{logical} (if \code{FALSE} do not show option for imputed)
#' 
#' @return
#' \code{shiny.render.function} expression
#'
#' @author Thomas Naake
#' 
#' @importFrom shiny moduleServer selectInput reactive req observe
#' @importFrom shiny updateSelectInput
#' @importFrom plotly renderPlotly
#' @importFrom htmlwidgets saveWidget
#' @importFrom SummarizedExperiment colData
#' @importFrom shinyhelper helper
#' 
#' @noRd
driftServer <- function(id, se, se_n, se_b, se_t, se_i, missingValue) {
    
    shiny::moduleServer(
        id, 
        function(input, output, session) {
            
            shiny::observe({
                if (missingValue) {
                    data_l <- list("raw", "normalized", "batch corrected",
                        "transformed", "imputed")
                } else {
                    data_l <- list("raw", "normalized", "batch corrected",
                        "transformed")
                }
                shiny::updateSelectInput(session = session, inputId = "data",
                    choices = data_l)
            })
            
            se_drift <- shiny::reactive({
                shiny::req(input$data)
                if (input$data == "raw") se <- se()
                if (input$data == "normalized") se <- se_n()
                if (input$data == "batch corrected") se <- se_b()
                if (input$data == "transformed") se <- se_t()
                if (input$data == "imputed") se <- se_i()
                se
            })
            
            cD <- shiny::reactive(se()@colData)
            
            shiny::observe({
                cols_cD <- colnames(cD())
                shiny::updateSelectInput(session = session, 
                    inputId = "category", 
                    choices = cols_cD)
                shiny::updateSelectInput(session = session,
                    inputId = "orderCategory", choices = cols_cD)
            })
            shiny::observe({
                shiny::updateSelectInput(session = session, 
                    inputId = "levelSel",
                    choices = c("all", unique(cD()[[input$category]])))
            })
            
            p_drift <- shiny::reactive({
                driftPlot(se = se_drift(), aggregation = input$aggregation, 
                    category = input$category, 
                    orderCategory = input$orderCategory,
                    level = input$levelSel, method = input$method)
            })
            
            output$plotDrift <- plotly::renderPlotly({
                p_drift()
            })
            
            output$downloadPlot <- shiny::downloadHandler(
                filename = function() {
                    paste("Drift_", input$aggregation, "_", 
                        input$category, "_", 
                        input$levelSel, "_", input$method, ".html", sep = "")
                },
                content = function(file) {
                    htmlwidgets::saveWidget(p_drift(), file)
                }
            )
        }
    )
}


################################################################################
########################### coefficient of variation ###########################
################################################################################

#' @name tP_cvUI
#'
#' @title Tab panel UI for tab panel 'Coefficient of Variation'
#'
#' @description
#' The module defines the UI for the tab panel 'Coefficient of Variation'.
#'
#' @details 
#' \code{fR_boxplotUI} returns the HTML code for the tab-pane 
#' 'Coefficient of Variation'. Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#'
#' @return 
#' \code{shiny.tag} with HTML content
#'
#' @author Thomas Naake
#'
#' @examples
#' fR_cvUI("test")
#' 
#' @importFrom shiny NS tabPanel fluidRow downloadButton selectInput column
#' 
#' @noRd
tP_cvUI <- function(id) {
    
    ns <- shiny::NS(id)
    shiny::tabPanel(title = "Coefficient of variation",
        shiny::fluidRow(
            shiny::column(12,
                shiny::plotOutput(outputId = ns("cv"), width = "95%") |>
                    shinyhelper::helper(content = "tabPanel_cv")),
            shiny::column(6, 
                shiny::selectInput(inputId = ns("data"),
                    label = "Data set", choices = "raw",
                    selected = "raw", multiple = TRUE)),
            shiny::column(6,
                shiny::downloadButton(outputId = ns("downloadPlot"), ""))
        )
    )
}

#' @name cvServer
#' 
#' @title Module for server expressions of tab panel 'Coefficient of variation' 
#' 
#' @description
#' The module defines the server expressions for the tab panel 
#' 'Coefficient of variation'.
#' 
#' @details 
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param a_r \code{matrix} and \code{reactive} value
#' @param a_n \code{matrix} and \code{reactive} value
#' @param a_b \code{matrix} and \code{reactive} value
#' @param a_t \code{matrix} and \code{reactive} value
#' @param a_i \code{matrix} and \code{reactive} value
#' @param missingValue \code{logical} (if \code{FALSE} do not use imputed values)
#' 
#' @return
#' \code{shiny.render.function} expression
#'
#' @author Thomas Naake
#' 
#' @importFrom shiny moduleServer reactive updateSelectInput renderPlot
#' @importFrom shiny downloadHandler 
#' @importFrom shinyhelper helper
#' @importFrom ggplot2 ggsave
#' @importFrom plotly plotlyOutput
#' 
#' @noRd
cvServer <- function(id, a_r, a_n, a_b, a_t, a_i, missingValue) {
    
    shiny::moduleServer(
        id, 
        function(input, output, session) {
            
            ## create the cv values
            cv_r <- shiny::reactive({
                cv(a_r(), name = "raw")
            })

            cv_n <- shiny::reactive({
                cv(a_n(), name = "normalized")
            })
            
            cv_b <- shiny::reactive({
                cv(a_b(), name = "batch corrected")
            })

            cv_t <- shiny::reactive({
                cv(a_t(), name = "transformed")
            })

            cv_i <- shiny::reactive({
                cv(a_i(), name = "imputed")
            })
            
            shiny::observe({
                a_r()
                if (missingValue) {
                    data_l <-  c("raw", "normalized", "batch corrected",
                                    "transformed", "imputed")
                } else {
                   data_l <- c("raw", "normalized", "batch corrected",
                                  "transformed")
                }
                shiny::updateSelectInput(session = session, inputId = "data",
                    choices = data_l, selected = "raw")
            })

            ## create a reactive data.frame containing the cv values
            df_cv <- shiny::reactive({
                df <- data.frame(row.names = colnames(a_r()))
                if ("raw" %in% input$data) df <- cbind(df, cv_r())
                if ("normalized" %in% input$data) df <- cbind(df, cv_n())
                if ("batch corrected" %in% input$data) df <- cbind(df, cv_b())
                if ("transformed" %in% input$data) df <- cbind(df, cv_t())
                if ("imputed" %in% input$data) df <- cbind(df, cv_i())
                df
            })

            p_cv <- shiny::reactive({
                plotCV(df = df_cv())
            })
            
            ## create the actual plot
            output$cv <- shiny::renderPlot({
                p_cv()
            })
            
            output$downloadPlot <- shiny::downloadHandler(
                filename = function() {
                    paste("CV.pdf", sep = "")
                },
                content = function(file) {
                    ggplot2::ggsave(file, p_cv(), device = "pdf",
                        limitsize = FALSE)
                }
            )
            
        }
    )
}

################################################################################
################################# mean-sd plot #################################
################################################################################
#' @name box_meanSdUI
#' 
#' @title Box UI for tab panel 'mean-sd plot'
#' 
#' @description 
#' The module defines the UI in the tab panel 'mean-sd plot'.
#' 
#' @details 
#' \code{box_meanSdUI} returns the HTML code for the tab-pane 'mean-sd plot'. 
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param name \code{character}, name/title for the box
#' 
#' @return 
#' \code{shiny.tag} with HTML content
#'
#' @author Thomas Naake
#' 
#' @examples
#' box_meanSdUI("test", "test")
#' 
#' @importFrom shiny NS plotOutput downloadButton
#' @importFrom shinydashboard box
#' 
#' @noRd
box_meanSdUI <- function(id, name) {
    ns <- shiny::NS(id)
    shinydashboard::box(title = name, width = 6, collapsible = TRUE,
        shiny::plotOutput(outputId = ns("meanSd")),
        shiny::downloadButton(outputId = ns("downloadPlot"), "")
    )
}

#' @name tP_meanSdUI
#' 
#' @title Tab panel UI for tab panel 'mean-sd plot'
#' 
#' @description 
#' The module defines the UI in the tab panel 'mean-sd plot'. It serves as a 
#' wrapper for the function \code{box_meanSdUI}.
#' 
#' @details 
#' \code{box_meanSdUI} returns the HTML code for the tab-pane 'mean-sd plot'. 
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#'
#' @return 
#' \code{shiny.tag} with HTML content
#'
#' @author Thomas Naake
#' 
#' @examples 
#' tP_meanSdUI("")
#' 
#' @importFrom shiny tabPanel fluidRow conditionalPanel br column
#' @importFrom shinyhelper helper
#' 
#' @noRd
tP_meanSdUI <- function(id) {

    ns <- shiny::NS(id)
    shiny::tabPanel(title = "mean-sd plot",
        ## call here the module UIs box_meanSdUI
        shiny::fluidRow(width = 12,
            shiny::column(12, 
                shiny::br() |> 
                    shinyhelper::helper(content = "tabPanel_meanSd")),
            box_meanSdUI("meanSdTransf", "transformed"), 
            shiny::conditionalPanel("output.missingVals == 'TRUE'",
                box_meanSdUI("meanSdImp", "imputed"))
        )
    )
}


#' @name meanSdServer
#' 
#' @title Module for server expressions of tab panel 'mean-sd plot'
#' 
#' @description 
#' The module defines the server expressions for the tab panel 'mean-sd plot'.
#' 
#' @details 
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param assay \code{matrix} and \code{reactive} expression, obtained from 
#' \code{assay(SummarizedExperiment)}
#' @param type \code{character}
#' 
#' @return
#' \code{shiny.render.function} expression
#'
#' @author Thomas Naake
#' 
#' @importFrom shiny moduleServer reactive renderPlot downloadHandler
#' @importFrom ggplot2 ggsave theme_classic
#' 
#' @noRd
#' 
#' @importFrom vsn meanSdPlot
meanSdServer <- function(id, assay, type) {
    
    shiny::moduleServer(
        id, 
        function(input, output, session) {

            p_meansd <- shiny::reactive({
                req(assay())
                vsn::meanSdPlot(assay(), ranks = TRUE)$gg +
                    ggplot2::theme_bw()
            })
            output$meanSd <- shiny::renderPlot({
                p_meansd()
            })
            
            output$downloadPlot <- shiny::downloadHandler(
                filename = function() {
                    paste("Meansd_", type, ".pdf", sep = "")
                },
                content = function(file) {
                    ggplot2::ggsave(file, p_meansd(), device = "pdf",
                        limitsize = FALSE)
                }
            )
        }
    )
}

################################################################################
#################################### MA plot ###################################
################################################################################
#' @name tP_maUI
#' 
#' @title Tab panel UI for tab panel 'MA plot'
#' 
#' @description 
#' The module defines the UI in the tab panel 'MA plot'.
#' 
#' @details 
#' \code{tP_maUI} returns the HTML code for the tab-pane 'MA plot'. 
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param missingValue \code{logical} (if \code{FALSE} do not show option 
#' for imputed)
#'
#' @return 
#' \code{shiny.tag} with HTML content
#'
#' @author Thomas Naake
#' 
#' @examples
#' tP_maUI("test")
#' 
#' @importFrom shiny NS tabPanel fluidRow downloadButton column
#' @importFrom shiny plotOutput checkboxInput
#' @importFrom shinydashboard box
#' @importFrom plotly plotlyOutput
#' 
#' @noRd
tP_maUI <- function(id) {
    
    ns <- shiny::NS(id)
    shiny::tabPanel(title = "MA plot", 
        shiny::fluidRow(
            shiny::column(6, 
                shiny::selectInput(
                    inputId = ns("groupMA"), label = "group",
                    choices = "all")),
            shiny::column(6, 
                shiny::selectInput(
                    inputId = ns("plotMA"), label = "plot", multiple = TRUE,
                    selected = "sample", choices = "all_samples"))
        ) |> 
            shinyhelper::helper(content = "tabPanel_MA"),
        shiny::fluidRow(
            shinydashboard::box(title = "MA plot per sample", width = 12, 
                collapsible = TRUE, 
                shiny::plotOutput(outputId = ns("MAplot"), height = "100%"),
                shiny::downloadButton(outputId = ns("downloadPlotMA"), ""),
                shiny::selectInput(
                    inputId = ns("MAtype"), label = "Data set for the MA plot",
                    choices = "raw")
            )
        ),
        shiny::fluidRow(
            shinydashboard::box(title = "Hoeffding's D statistic", width = 12, 
                collapsible = TRUE,
                plotly::plotlyOutput(outputId = ns("hoeffDPlot")),
                shiny::downloadButton(outputId = ns("downloadPlothD"), ""),
                shiny::checkboxInput(inputId = ns("hDLines"),
                    label = "lines", value = FALSE)
            )
        )
    )
}


#' @name maServer
#' 
#' @title Module for server expressions of tab panel 'MA plot'
#' 
#' @description 
#' The module defines the server expressions in the tab panel 'MA plot'.
#' 
#' @details 
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param se \code{SummarizedExperiment} object and \code{reactive} value, 
#' containing raw values
#' @param se_n \code{SummarizedExperiment} object and \code{reactive} value, 
#' containing normalized values
#' @param se_b \code{SummarizedExperiment} object and \code{reactive} value, 
#' containing batch corrected values
#' @param se_t \code{SummarizedExperiment} object and \code{reactive} value, 
#' containing transformed values
#' @param se_i \code{SummarizedExperiment} object and \code{reactive} value, 
#' containing imputed values
#' @param innerWidth \code{numeric} and \code{reactive} value, specifying 
#' the width of the window size
#' @param missingValue \code{logical} (if \code{FALSE} do not show values for 
#' imputed)
#' 
#' @return
#' \code{shiny.render.function} expression
#'
#' @author Thomas Naake
#' 
#' @importFrom shiny moduleServer fluidRow selectInput column req 
#' @importFrom shiny downloadHandler bindCache
#' @importFrom shinyhelper helper
#' @importFrom plotly renderPlotly
#' @importFrom htmlwidgets saveWidget
#' @importFrom SummarizedExperiment colData
#' 
#' @noRd
maServer <-  function(id, se, se_n, se_b, se_t, se_i, innerWidth, 
    missingValue) {
    
    shiny::moduleServer(
        id, 
        function(input, output, session) {
            
            ## create reactiveValues to store innerWidth, update if there are 
            ## changes to the parameters
            rv <- reactiveValues(
                innerWidth = "600px")
            
            observeEvent(innerWidth(), {
                rv$innerWidth <- innerWidth() * 2.5 / 5
            })
            
            ## access the colData slot and add the rownames as a new column to cD
            ## (will add the column "rowname")
            cD <- shiny::reactive({
                se()@colData |> as.data.frame()
            })
            
            cD_rn <- shiny::reactive({
                cD_rn <- cD()
                cD_rn[["rowname"]] <- rownames(cD_rn)
                cD_rn
            })
            
            selected_samples <- reactive({
                if (nrow(cD()) > 3) {
                    rownames(cD())[seq_len(3)]
                } else {
                    rownames(cD())
                }
            })
                
            shiny::observe({
                shiny::updateSelectInput(
                    inputId = "groupMA", choices = c("all", colnames(cD()))) 
            })
            
            shiny::observe({
                selected_samples <- selected_samples()
                
                shiny::updateSelectInput(
                    inputId = "plotMA", selected = selected_samples,
                    choices = cD_rn()[["rowname"]]) 
            })
            
            shiny::observe({
                if (missingValue) {
                    data_l <- list("raw", "normalized", "batch corrected", 
                        "transformed", "imputed")
                } else {
                    data_l <- list("raw", "normalized", "batch corrected", 
                        "transformed")
                }
                shiny::updateSelectInput(session = session, inputId = "MAtype",
                    choices = data_l)
            })
            
            ## create MA values: se, log2, group
            vals_r <- shiny::reactive({
                if (any(SummarizedExperiment::assay(se()) < 0, na.rm = TRUE)) {
                    log2_se <- FALSE 
                } else {
                    log2_se <- TRUE
                }
                MAvalues(se(), log2_se, input$groupMA)}) |>
                    shiny::bindCache(se(), input$groupMA, cache = "session")
            
            vals_n <- shiny::reactive({
                if (any(SummarizedExperiment::assay(se_n()) < 0, na.rm = TRUE)) {
                    log2_se <- FALSE
                } else {
                    log2_se <- TRUE
                }
                MAvalues(se_n(), log2_se, input$groupMA)}) |>
                shiny::bindCache(se_n(), input$groupMA, cache = "session")
            
            vals_b <- shiny::reactive({
                if (any(SummarizedExperiment::assay(se_b()) < 0, na.rm = TRUE)) {
                    log2_se <- FALSE 
                } else {
                    log2_se <- TRUE
                }
                MAvalues(se_b(), log2_se, input$groupMA)}) |>
                shiny::bindCache(se_b(), input$groupMA, cache = "session")

            
            vals_t <- shiny::reactive({
                MAvalues(se_t(), FALSE, input$groupMA)}) |>
                    shiny::bindCache(se_t(), input$groupMA, cache = "session")

            vals_i <- shiny::reactive({
                MAvalues(se_i(), FALSE, input$groupMA)}) |>
                    shiny::bindCache(se_i(), input$groupMA, cache = "session")

            ## MA plots: MA values, group
            p_ma <- shiny::reactive({
                if (length(input$plotMA) != 0) {
                    
                    if (input$MAtype == "raw") {
                        ma <- MAplot(vals_r(), group = input$groupMA, 
                            plot = input$plotMA)
                    }
                    if (input$MAtype == "normalized") {
                        ma <- MAplot(vals_n(), group = input$groupMA,
                            plot = input$plotMA)
                    }
                    if (input$MAtype == "batch corrected") {
                        ma <- MAplot(vals_b(), group = input$groupMA,
                            plot = input$plotMA)
                    }
                    if (input$MAtype == "transformed") {
                        ma <- MAplot(vals_t(), group = input$groupMA, 
                            plot = input$plotMA)
                    }
                    if (input$MAtype == "imputed") {
                        ma <- MAplot(vals_i(), group = input$groupMA,
                            plot = input$plotMA)
                    }
                    ma 
                } else 
                    NULL
            })
            
            output$MAplot <- shiny::renderPlot({
                if (!is.null(p_ma()))
                p_ma()
            }, height = reactive(rv$innerWidth), width = "auto")
            
            output$downloadPlotMA <- shiny::downloadHandler(
                filename = function() {
                    paste("MA_", input$MAtype, "_", input$groupMA, "_", 
                        input$plotMA,".pdf", sep = "")
                },
                content = function(file) {
                    ggplot2::ggsave(file, p_ma(), device = "pdf", 
                        height = rv$innerWidth, width = rv$innerWidth, 
                        units = "px", limitsize = FALSE)
                }
            )

            ## Hoeffding's D values: MA values, title for plot
            hD_r <- shiny::reactive({
                hoeffDValues(vals_r(), "raw", sample_n = 5000)
            }) |>
                shiny::bindCache(vals_r(), cache = "session")
            hD_n <- shiny::reactive({
                hoeffDValues(vals_n(),  "normalized", sample_n = 5000)
            }) |>
                shiny::bindCache(vals_n(), cache = "session")
            hD_b <- shiny::reactive({
                hoeffDValues(vals_b(), "batch corrected", sample_n = 5000)
            }) |>
                shiny::bindCache(vals_b(), cache = "session")
            hD_t <- shiny::reactive({
                hoeffDValues(vals_t(), "transformed", sample_n = 5000)
            }) |>
                shiny::bindCache(vals_t(), cache = "session")
            hD_i <- shiny::reactive({
                hoeffDValues(vals_i(), "imputed", sample_n = 5000)
            }) |>
                shiny::bindCache(vals_i(), cache = "session")

            ## create reactive data.frame for the hoeffDPlot function
            hoeffD_df <- shiny::reactive({
                if (missingValue) {
                    df <- data.frame(raw = hD_r(), normalized = hD_n(), 
                        `batch corrected` = hD_b(), transformed = hD_t(), 
                        imputed = hD_i())    
                } else {
                    df <- data.frame(raw = hD_r(), normalized = hD_n(), 
                        `batch corrected` = hD_b(), transformed = hD_t())
                }
                df
            })
            
            ## Hoeffding's D plots: lists (Hoeffding's D values), lines
            output$hoeffDPlot <- plotly::renderPlotly({
                hoeffDPlot(hoeffD_df(), lines = input$hDLines)  
            })
            
            output$downloadPlothD <- shiny::downloadHandler(
                filename = function() {
                    paste("Hoeffding_D_", input$groupMA, ".html")  
                },
                content = function(file) {
                    htmlwidgets::saveWidget(
                        hoeffDPlot(hoeffD_df(), lines = input$hDLines), file)
                }
            )
        }
    )
}

################################################################################
##################################### ECDF #####################################
################################################################################

#' @name tP_ECDFUI
#' 
#' @title Tab panel UI for tab panel 'ECDF'
#' 
#' @description 
#' The module defines the UI in the tab panel 'ECDF'
#'  
#' @details 
#' \code{tP_ECDFUI} returns the HTML code for the tab-pane 'ECDF'. 
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character} 
#'
#' @return
#' \code{shiny.tag} with HTML content
#'
#' @author Thomas Naake
#' 
#' @examples
#' tP_ECDFUI("test")
#' 
#' @importFrom shiny NS tabPanel plotOutput fluidRow column downloadButton
#' @importFrom shinyhelper helper
#' 
#' @noRd
tP_ECDFUI <- function(id) {
    
    ns <- shiny::NS(id)
    shiny::tabPanel(title = "ECDF",
        shiny::plotOutput(outputId = ns("ECDF")) |> 
            shinyhelper::helper(content = "tabPanel_ecdf"),
        shiny::downloadButton(outputId = ns("downloadPlot"), ""),
        shiny::fluidRow( 
            shiny::column(4, 
                shiny::selectInput(inputId = ns("typeECDF"),
                    label = "Data set for the ECDF plot", choices = "raw")),
            shiny::column(4, 
                shiny::selectInput(inputId = ns("sampleECDF"), 
                    label = "Sample", choices = "all_samples", 
                    selected = "sample")),
            shiny::column(4, 
                shiny::selectInput(inputId = ns("groupECDF"), 
                    label = "group", choices = "all"))
        )
    )

}

#' @name ECDFServer
#' 
#' @title Module for server expressions of tab panel 'ECDF'
#' 
#' @description 
#' The module defines the server expressions in the tab panel 'ECDF'.
#' 
#' @details 
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param se \code{SummarizedExperiment} object and \code{reactive} value, containing 
#' raw values
#' @param se_n \code{SummarizedExperiment} object and \code{reactive} value, containing 
#' normalized values
#' @param se_b \code{SummarizedExperiment} object and \code{reactive} value, containing
#' batch corrected values
#' @param se_t \code{SummarizedExperiment} object and \code{reactive} value, containing 
#' transformed values
#' @param se_i \code{SummarizedExperiment} object and \code{reactive} value, containing 
#' imputed values
#' @param missingValue \code{logical} (if \code{FALSE} do not show option for imputed)
#' 
#' @return
#' \code{shiny.render.function} expression
#' 
#' @importFrom shiny moduleServer updateSelectInput reactive
#' @importFrom shiny downloadHandler renderPlot
#' @importFrom ggplot2 ggsave
#' @importFrom SummarizedExperiment colData
#' @importFrom tibble rownames_to_column
#'
#' @author Thomas Naake
#' 
#' @noRd
ECDFServer <- function(id, se, se_n, se_b, se_t, se_i, missingValue) {
    
    shiny::moduleServer(
        id, 
        function(input, output, session) {
            
            shiny::observe({
                if (missingValue) {
                    data_l <- list("raw", "normalized", "batch corrected",
                                            "transformed", "imputed")
                } else {
                    data_l <- list("raw", "normalized", "batch corrected",
                                            "transformed")
                }
                shiny::updateSelectInput(session = session, 
                    inputId = "typeECDF", choices = data_l)
            })
            
            shiny::observe({
                cD_rn <- se() |> colnames()
                shiny::updateSelectInput(session = session,
                    inputId = "sampleECDF", choices = cD_rn)
            })
            
            shiny::observe({
                updateSelectInput(
                    inputId = "groupECDF", 
                    choices = c("all", colnames(se()@colData)))
            })
            
            ## ECDF plots: se, sample, group
            se_sel <- shiny::reactive({
                if (input$typeECDF == "raw") SE <- se()
                if (input$typeECDF == "normalized") SE <- se_n()
                if (input$typeECDF == "batch corrected") SE <- se_b()
                if (input$typeECDF == "transformed") SE <- se_t()
                if (input$typeECDF == "imputed") SE <- se_i()
                SE
            })
            
            p_ecdf <- shiny::reactive({
                ECDF(se = se_sel(), sample = input$sampleECDF, 
                    group = input$groupECDF)
            })
            
            output$ECDF <- shiny::renderPlot({
                p_ecdf()
            })
            
            output$downloadPlot <- shiny::downloadHandler(
                filename = function() {
                    paste("ECDF_", input$typeECDF, "_", input$groupECDF, "_", 
                        input$sampleECDF, ".pdf", sep = "")
                },
                content = function(file) {
                    ggplot2::ggsave(file, p_ecdf(), device = "pdf", 
                        limitsize = FALSE)
                }
            )
        }
    )
}


################################################################################
################################### distances ##################################
################################################################################

#' @name fR_distUI
#' 
#' @title Fluid row UI for tab panel 'Distance matrix'
#' 
#' @description
#' The module defines the UI in the tab panel 'Distance matrix'.
#' 
#' @details 
#' \code{fR_distUI} returns the HTML code for the tab-pane 'Distance Matrix'. 
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param title \code{character} name/title of the box
#' @param collapsed \code{logical}
#' 
#' @return 
#' \code{shiny.tag} with HTML content
#'
#' @author Thomas Naake
#' 
#' @examples
#' fR_distUI("test", "test")
#' 
#' @importFrom shiny NS fluidRow downloadButton column
#' @importFrom shinydashboard box
#' @importFrom plotly plotlyOutput
#' @importFrom shinyhelper helper
#' 
#' @noRd
fR_distUI <- function(id, title, collapsed = TRUE) {
    ns <- shiny::NS(id)
    shiny::fluidRow(
        shinydashboard::box(title = title, width = 12, 
            collapsible = TRUE, collapsed = collapsed, 
            shiny::column(6, 
                shiny::plotOutput(outputId = ns("distSample")),
                shiny::downloadButton(outputId = ns("downloadPlotDist"), "")),
            shiny::column(6, 
                plotly::plotlyOutput(outputId = ns("distSampleSum")),
                shiny::downloadButton(outputId = ns("downloadPlotSum"), ""))))  
    
}

#' @name tP_distUI
#' 
#' @title Tab panel UI for tab panel 'Distance matrix'
#' 
#' @description
#' The function defines the UI in the tab panel 'Distance matrix'. It serves
#' as a wrapper for \code{fR_distUI}.
#' 
#' @details 
#' \code{tP_distUI} returns the HTML code for the tab-pane 'Distance matrix'. 
#' Internal function for \code{shinyQC}.
#' 
#' @param missingValue \code{logical} (if \code{FALSE} do not show box for imputed)
#' 
#' @return 
#' \code{shiny.tag} with HTML content
#'
#' @author Thomas Naake
#' 
#' @examples 
#' tP_distUI()
#' 
#' @importFrom shiny tabPanel fluidRow column selectInput br
#' @importFrom shinydashboard box
#'
#' @noRd
tP_distUI <- function() {

    shiny::tabPanel(title = "Distance matrix",
        br() |> shinyhelper::helper(content = "tabPanel_distMat"),
        fR_distUI(id = "distRaw", title = "raw", collapsed = FALSE),
        fR_distUI(id = "distNorm", title = "normalized", collapsed = TRUE),
        fR_distUI(id = "distBatch", title = "batch corrected", 
            collapsed = TRUE),
        fR_distUI(id = "distTransf", title = "transformed", collapsed = TRUE),
        shiny::conditionalPanel("output.missingVals == 'TRUE'",
            fR_distUI(id = "distImp", title = "imputed", collapsed = TRUE)),
        shiny::fluidRow(
            shinydashboard::box(title = "Parameters", width = 6,
                collapsible = TRUE, collapsed = FALSE,
                shiny::column(12, 
                    shiny::selectInput(inputId = "groupDist", 
                        label = "annotation", choices = "name")),
                shiny::column(12, 
                shiny::selectInput(inputId = "methodDistMat", 
                    label = "distance method", 
                    choices = c("euclidean", "maximum", "canberra", 
                        "minkowski"), 
                    selected = "euclidean"))
            )
        )
    )
}

#' @name distServer
#' 
#' @title Module for server expressions of tab panel 'Distance matrix'
#' 
#' @description 
#' The module defines the server expressions in the tab panel 'Distance matrix'.
#' 
#' @details 
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param se \code{SummarizedExperiment} object and \code{reactive} value
#' @param assay \code{matrix} and \code{reactive} value
#' @param method \code{character} and \code{reactive} value, one of \code{"euclidean"}, 
#' \code{"mannhattan"}, \code{"canberra"}, or \code{"minkowski"}
#' @param label \code{character} and \code{reactive} value, specified the annotation of 
#' the \code{ComplexHeatmap}
#' @param type \code{character}
#' 
#' @return
#' \code{shiny.render.function} expression
#'
#' @author Thomas Naake
#' 
#' @importFrom shiny moduleServer reactive downloadHandler req
#' @importFrom plotly renderPlotly partial_bundle
#' @importFrom htmlwidgets saveWidget
#' @importFrom ComplexHeatmap draw
#' @importFrom grDevices pdf dev.off
#' 
#' 
#' @noRd
distServer <- function(id, se, assay, method, label, type) {
    
    shiny::moduleServer(
        id, 
        function(input, output, session) {

            d <- shiny::reactive({
                distShiny(assay(), method = method())
            })
            
            ## plot of distance matrix
            p_dist <- shiny::reactive({
                distSample(d(), se(), label = label(), title = "") 
            })
            
            output$distSample <- shiny::renderPlot({
                shiny::req(label())
                p_dist()  
            })
            
            output$downloadPlotDist <- shiny::downloadHandler(
                filename = function() {
                    paste("Distance_", type, "_", method(), ".pdf", sep = "")
                },
                content = function(file) {
                    grDevices::pdf(file)
                    p = p_dist()
                    ComplexHeatmap::draw(p)
                    grDevices::dev.off()
                    ##htmlwidgets::saveWidget(partial_bundle(p_dist()), file)
                }
            )
            
            ## plot of sum of distances
            p_sumDist <- shiny::reactive({
                sumDistSample(d(), title = "")
            })
            
            output$distSampleSum <- plotly::renderPlotly({
                p_sumDist()
            })

            output$downloadPlotSum <- shiny::downloadHandler(
                filename = function() {
                    paste("Sum_distance_", type, "_", 
                        method(), ".html", sep = "")
                },
                content = function(file) {
                    htmlwidgets::saveWidget(partial_bundle(p_sumDist()), file)
                }
            )
        }
    )
    
}

################################################################################
################################### Features ###################################
################################################################################

#' @name tP_featureUI
#' 
#' @title UI for tab panel 'Features'
#' 
#' @description
#' The module defines the UI in the tab panel 'Features'.
#' 
#' @details 
#' \code{tP_featureUI} returns the HTML code for the tab-pane 'Distance Matrix'. 
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param title \code{character} name/title of the box
#' @param collapsed \code{logical}
#' 
#' @return 
#' \code{shiny.tag} with HTML content
#'
#' @author Thomas Naake
#' 
#' @examples
#' fR_distUI("test", "test")
#' 
#' @importFrom shiny NS tabPanel plotOutput column radioButtons 
#' @importFrom shiny selectizeInput checkboxInput downloadButton
#' @importFrom shinydashboard box
#' @importFrom plotly plotlyOutput
#' @importFrom shinyhelper helper
#' 
#' @noRd
tP_featureUI <- function(id) {
    ns <- shiny::NS(id)
    shiny::tabPanel(title = "Features",
        br() |> shinyhelper::helper(content = "tabPanel_Features"),
        shinydashboard::box(title = "", width = 12, collapsible = TRUE, 
            collapsed = FALSE,
            shiny::plotOutput(outputId = ns("Features")),
            shiny::column(4, 
                shiny::downloadButton(outputId = ns("downloadPlot"), "")),
            shiny::column(4, 
                shiny::selectInput(inputId = ns("data"), 
                    label = "Data set", choices = "raw", multiple = TRUE, 
                    selected = "raw")),
            shiny::column(4, 
                shiny::selectizeInput(inputId = ns("selectFeature"), 
                    choices = NULL, label = "Select feature"))
        ),
        shinydashboard::box(title = "", width = 12, collapsible = TRUE, 
            collapsed = FALSE,
            plotly::plotlyOutput(outputId = ns("FeaturesCV")),
            shiny::column(6, 
                shiny::downloadButton(outputId = ns("downloadPlotCV"), "")),
            shiny::column(6, 
                shiny::checkboxInput(inputId = ns("FeatureLines"),
                label = "lines", value = FALSE))
        ),
        shiny::radioButtons(inputId = ns("mode"), label = "Select features",
            choices = list("all" = "all", "exclude" = "exclude", 
                                                        "select" = "select")),
        shiny::selectizeInput(inputId = ns("excludeFeature"), choices = NULL, 
            label = NULL, multiple = TRUE)
    ) 
}

#' @name featureServer
#' 
#' @title Module for server expressions of tab panel 'Features'
#' 
#' @description 
#' The module defines the server expressions in the tab panel 'Features'.
#' 
#' @details 
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param se \code{SummarizedExperiment} object
#' @param a \code{matrix} and \code{reactive} value, containing raw values
#' @param a_n \code{matrix} and \code{reactive} value, containing 
#' normalized values
#' @param a_b \code{matrix} and \code{reactive} value, containing 
#' batch corrected values
#' @param a_t \code{matrix} and \code{reactive} value, containing 
#' transformed values
#' @param a_i \code{matrix} and \code{reactive} value, containing 
#' imputed values
#' @param missingValue \code{logical} (if \code{FALSE} do not show option for 
#' imputed)
#' 
#' @return
#' \code{shiny.render.function} expression
#'
#' @author Thomas Naake
#' 
#' @importFrom shiny moduleServer observe updateSelectizeInput updateSelectInput  
#' @importFrom shiny reactive req renderPlot downloadHandler
#' @importFrom ggplot2 ggsave
#' @importFrom plotly renderPlotly
#' @importFrom htmlwidgets saveWidget 
#'
#' @noRd
featureServer <- function(id, se, a, a_n, a_b, a_t, a_i, missingValue) {
    
    shiny::moduleServer(
        id, 
        function(input, output, session) {

            shiny::observe({
                shiny::updateSelectizeInput(session = session, 
                    inputId = "selectFeature", 
                    choices = as.list(rownames(a())), server = TRUE)
            })

            shiny::observe({
                shiny::updateSelectizeInput(session = session, 
                    inputId = "excludeFeature", 
                    choices = rownames(se), server = TRUE)  
            })
            

            shiny::observe({
                if (missingValue) {
                    choices_l <-  c("raw", "normalized", "batch.corrected",
                        "transformed", "imputed")   
                } else {
                    choices_l <- c("raw", "normalized", "batch.corrected",
                        "transformed")
                }
                shiny::updateSelectInput(inputId = "data", 
                    label = "Data set", choices = choices_l,
                    selected = choices_l)
            })
            
            ## create a reactive data.frame containing the assay values
            l_assays <- shiny::reactive({
                shiny::req(a_i())
                if (missingValue) {
                    l <- list(raw = a(), normalized = a_n(),
                        `batch.corrected` = a_b(), transformed = a_t(), 
                        imputed = a_i())
                } else {
                    l <- list(raw = a(), normalized = a_n(),
                        `batch.corrected` = a_b(), transformed = a_t())
                }
                l
            })
            
            df_feature <- shiny::reactive({
                l <- l_assays()
                l <- l[names(l) %in% input$data]
                if (length(l) > 0) {
                    createDfFeature(l, feature = input$selectFeature)
                } else {
                    NULL
                }
            })
                
            p_feature <- shiny::reactive({
                if (!is.null(df_feature()))
                    featurePlot(df_feature())
            })
            
            output$Features <- shiny::renderPlot({
                p_feature()
            })
            
            output$downloadPlot <- shiny::downloadHandler(
                filename = function() {
                    paste("Features_", input$selectFeature, ".pdf", sep = "")
                },
                content = function(file) {
                    ggplot2::ggsave(file, p_feature(), device = "pdf",
                        limitsize = FALSE)
                }
            )
            
            output$FeaturesCV <- plotly::renderPlotly({
                cvFeaturePlot(l_assays(), lines = input$FeatureLines)
            })
            
            output$downloadPlotCV <- shiny::downloadHandler(
                filename = function() {
                    paste("Features_CV_lines_", input$FeatureLines, 
                                                            ".html", sep = "")
                },
                content = function(file) {
                    htmlwidgets::saveWidget(
                        cvFeaturePlot(l_assays(), lines = input$FeatureLines),
                        file)
                }
            )
        }
    )
}

#' @name tP_values_all
#' 
#' @title Tab panel UI for tab panel 'Values'
#' 
#' @description  
#' The module defines the UI for the tab panel 'Values'.
#' 
#' @details 
#' \code{tP_values_all} returns the HTML code for the tab-pane 'Values'. 
#' Internal function for \code{shinyQC}.
#' 
#' @return 
#' \code{shiny.tag} with HTML content
#'
#' @author Thomas Naake
#' 
#' @examples
#' tP_values_all()
#' 
#' @importFrom shiny tabPanel 
#' @importFrom shinydashboard tabBox
#' 
#' @noRd
tP_values_all <- function() {
    shiny::tabPanel("Values",
        shinydashboard::tabBox(title = "", width = 12,
            tP_boxplotUI(id = "boxUI"),
            tP_driftUI(id = "drift"),
            tP_cvUI(id = "cv"),
            tP_meanSdUI(id = "meanSd"),
            tP_maUI(id = "MA"),
            tP_ECDFUI(id = "ECDF"),
            tP_distUI(),
            tP_featureUI(id = "features")
        )
    )
}

#' @importFrom SummarizedExperiment SummarizedExperiment
#' @importFrom shiny testServer

## create se
a <- matrix(seq_len(1000), nrow = 100, ncol = 10, 
    dimnames = list(seq_len(100), paste("sample", seq_len(10))))
a[c(1, 5, 8), seq_len(5)] <- NA
set.seed(1)
a <- a + rnorm(1000)
cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
rD <- data.frame(spectra = rownames(a))
se <- SummarizedExperiment::SummarizedExperiment(assay = a, rowData = rD, 
                            colData = cD)

## function fR_boxplotUI
test_that("fR_boxplotUI", {
    expect_is(fR_boxplotUI("test", name = "test", collapsed = TRUE), "shiny.tag")
    expect_is(fR_boxplotUI("test", name = "test", collapsed = FALSE), "shiny.tag")
})

## tP_boxplotUI
test_that("tP_boxplotUI", {
    expect_is(tP_boxplotUI("test"), "shiny.tag")
})

## boxPlotUIServer
test_that("boxPlotUIServer", {
    shiny::testServer(boxPlotUIServer, {
        input <- new.env()
        output <- new.env()
        session <- new.env()
        se <- new.env()
        missingValue <- new.env()
        
        out <- boxPlotUIServer("", se = se)
        expect_is(out, "Observer")
        out <- boxPlotUIServer("", se = se)
        expect_is(out, "Observer")
    })
})

## boxPlotServer
test_that("boxPlotServer", {
    shiny::testServer(boxPlotServer, {
        input <- new.env()    
        output <- new.env()
        session <- new.env()
        se <- new.env()
        orderCategory <- new.env()
        boxLog <- new.env()
        violin <- new.env()
        
        out <- boxPlotServer("", se = se, orderCategory = orderCategory, 
            boxLog = boxLog, violin = violin, type = "test")
        expect_is(out, "shiny.render.function")
    })
})

## driftServer
test_that("driftServer", {
    shiny::testServer(driftServer, {
        input <- new.env()
        output <- new.env()
        session <- new.env()
        se <- new.env()
        se_n <- new.env()
        se_b <- new.env()
        se_t <- new.env()
        se_i <- new.env()
        dataType <- new.env()
        aggregation <- new.env()
        method <- new.env()
        
        out <- driftServer("", se = se, se_n = se_n, se_b = se_b, se_t = se_t, 
            se_i = se_i, missingValue = TRUE)
        expect_is(out, "shiny.render.function")
        out <- driftServer("", se = se, se_n = se_n, se_b = se_b, se_t = se_t, 
            se_i = se_i, missingValue = FALSE)
        expect_is(out, "shiny.render.function")
    })
})

## tP_driftUI
test_that("tP_driftUI", {
    expect_is(tP_driftUI("test"), "shiny.tag")
})


## tP_cvUI
test_that("tP_cvUI", {
    expect_is(tP_cvUI("test"), "shiny.tag")
})

## cvServer
test_that("cvServer", {
    shiny::testServer(cvServer, {
        input <- new.env()
        output <- new.env()
        session <- new.env()
        a_r <- new.env()
        a_n <- new.env()
        a_b <- new.env()
        a_t <- new.env()
        a_i <- new.env()
        
        out <- cvServer("", a_r = a_r, a_n = a_n, a_b = a_b, a_t = a_t,
            a_i = a_i, missingValue = TRUE)
        expect_is(out, "shiny.render.function")
        out <- cvServer("", a_r = a_r, a_n = a_n, a_b = a_b, a_t = a_t,
            a_i = a_i, missingValue = FALSE)
        expect_is(out, "shiny.render.function")
    })
})

## box_meanSdUI
test_that("box_meanSdUI", {
    expect_is(box_meanSdUI("test", name = "test"), "shiny.tag")
})

## tP_meanSdUI
test_that("tP_meanSdUI", {
    expect_is(tP_meanSdUI(""), "shiny.tag")
})

## meanSdServer
test_that("meanSdServer", {
    shiny::testServer(meanSdServer, {
        input <- new.env()    
        output <- new.env()
        session <- new.env()
        assay <- new.env()
        
        out <- meanSdServer("", assay = assay, type = "test")
        expect_is(out, "shiny.render.function")
    })
    
})

# tP_maUI
test_that("tP_maUI", {
    expect_is(tP_maUI("test"), "shiny.tag")
})

## maServer
test_that("maServer", {
    shiny::testServer(maServer, {
        input <- new.env()    
        output <- new.env()
        session <- new.env()
        se <- new.env()
        se_n <- new.env()
        se_b <- new.env()
        se_t <- new.env()
        se_i <- new.env()
        innerWidth <- new.env()
        
        out <- maServer("", se = se, se_n = se_n, se_b = se_b, se_t = se_t,
            se_i = se_i, innerWidth = innerWidth, missingValue = TRUE)
        expect_is(out, "shiny.render.function")
        out <- maServer("", se = se, se_n = se_n, se_b = se_b, se_t = se_t,
            se_i = se_i, innerWidth = innerWidth, missingValue = FALSE)
        expect_is(out, "shiny.render.function")
    })
})

## tP_ECDFUI
test_that("tP_ECDFUI", {
    expect_is(tP_ECDFUI("test"), "shiny.tag")
})

## ECDFServer
test_that("ECDFServer", {
    shiny::testServer(ECDFServer, {
        input <- new.env()    
        output <- new.env()
        session <- new.env()
        se <- new.env()
        se_n <- new.env()
        se_b <- new.env()
        se_t <- new.env()
        se_i <- new.env()
        
        out <- ECDFServer("", se = se, se_n = se_n, se_b = se_b, se_t = se_t,
            se_i = se_i, missingValue = TRUE)
        expect_is(out, "shiny.render.function")
        out <- ECDFServer("", se = se, se_n = se_n, se_b = se_b, se_t = se_t,
            se_i = se_i, missingValue = FALSE)
        expect_is(out, "shiny.render.function")
    })
})

## fR_distUI
test_that("fR_distUI", {
    expect_is(fR_distUI("test", title = "test", collapsed = TRUE), "shiny.tag")
    expect_is(fR_distUI("test", title = "test", collapsed = FALSE), "shiny.tag")
})

## distServer
test_that("distServer", {
    shiny::testServer(distServer, {
        input <- new.env()    
        output <- new.env()
        session <- new.env()
        se <- new.env()
        assay <- new.env()
        method <- new.env()
        label <- new.env()
        
        out <- distServer("", se = se, assay = assay, method = method, 
            label = label, type = "test")
        expect_is(out, "shiny.render.function")
    })
})

## tP_distUI
test_that("tP_distUI", {
    expect_is(tP_distUI(), "shiny.tag")
})

## featureServer
test_that("featureServer", {
    shiny::testServer(featureServer, {
        input <- new.env()    
        output <- new.env()
        session <- new.env()
        se <- reactive(se)
        a <- reactive(assay(se))
        a_n <- new.env()
        a_b <- new.env()
        a_t <- new.env()
        a_i <- new.env()
        
        out <- featureServer(id = "", se = se, a = a, a_n = a_n, a_b = a_b,
            a_t = a_t, a_i = a_i, missingValue = TRUE)
        expect_is(out, "shiny.render.function")
        out <- featureServer(id = "", se = se, a = a, a_n = a_n, a_b = a_b, 
            a_t = a_t, a_i = a_i, missingValue = FALSE)
        expect_is(out, "shiny.render.function")
    })
})

## tP_featureUI
test_that("tP_featureUI", {
    expect_is(tP_featureUI("test"), "shiny.tag")
})

## tP_values_all
test_that("tP_values_all", {
    expect_is(tP_values_all(), "shiny.tag")
})

#' @name createLandingPage
#' 
#' @title Create landing page in shiny qc when no \code{SummarizedExperiment} is 
#' supplied
#' 
#' @description
#' The function \code{createLandingPage} will load the UI when the \code{launch} 
#' button
#' is hit. It will pass the loaded \code{SummarizedExperiment} object to the 
#' function \code{FUN} and will load the tab panels (\code{show("tabPanelSE")}) and will
#' hide the upload interface \code{hide("uploadSE")}.
#' 
#' @details 
#' Internal usage in \code{shinyQC}. Modified from \code{iSEE} package. 
#' 
#' @param seUI \code{function} or \code{NULL}
#' @param seLoad \code{function} or \code{NULL}
#' @param requireButton \code{logical}
#' 
#' @examples
#' \dontrun{
#' createLandingPage(seUI = NULL, seLoad = NULL, requireButton = TRUE)
#' }
#' 
#' @author authors of \code{iSEE} package, adjusted by Thomas Naake
#' 
#' @importFrom shiny fileInput renderUI tagList actionButton observeEvent
#' @importFrom shiny showNotification insertTab
#' @importFrom shinyjs show hide
#' @importFrom methods is
#' 
#' @noRd
createLandingPage <- function(seUI = NULL, seLoad = NULL, 
    requireButton = TRUE) {
    
    if (is.null(seUI)) {
        seUI <- function(id) shiny::fileInput(id, 
            "SummarizedExperiment RDS file:", multiple = FALSE)
    }
    if (is.null(seLoad)) {
        seLoad <- function(x) readRDS(x$datapath)
    }

    force(requireButton)
    
    function (FUN, input, output, session, app_server) {
        
        output$allPanels <- shiny::renderUI({
            shiny::tagList(
                seUI("upload"),
                if (requireButton) shiny::actionButton("launch", 
                                                            label = "Launch")
            )
        })
        
        target <- if (requireButton) "launch" else "upload"
        
        shiny::observeEvent(input[[target]], {
            se2 <- try(seLoad(input[["upload"]]))
            if (is(se2, "try-error")) {
                shiny::showNotification("invalid SummarizedExperiment supplied", 
                                                                type = "error")
            } else {
                
                if (!is(se2, "SummarizedExperiment")) 
                    stop("se is not of class 'SummarizedExperiment'")
                if (is.null(rownames(se2))) 
                    stop("rownames(se) is NULL")
                if (is.null(colnames(se2)))
                    stop("colnames(se) is NULL")
                
                ## access the assay slot
                a <- SummarizedExperiment::assay(se2)
                
                ## access the colData slot and add the rownames as a new column to cD
                ## (will add the column "rowname")
                cD <- se2@colData |> as.data.frame()
                if (!all(colnames(se2) == rownames(cD)))
                    stop("colnames(se) do not match rownames(colData(se))")
                if (!all(colnames(a) == rownames(cD)))
                    stop("colnames(assay(se)) do not match rownames(colData(se))")
                
                ## if the launch button was pressed and the se is valid
                ## load the tabPanel and hide the upload button
                ## tabPanel for tab "Measured Values"
                missingValue2 <- missingValuesSE(se2)
                if (missingValue2) shiny::insertTab(inputId = "tabs",
                    tP_measuredValues_all(), target = "Samples", 
                    position = "after")
                ## tabPanel for tab "Missing Values"
                if (missingValue2) shiny::insertTab(inputId = "tabs", 
                    tP_missingValues_all(), target = "Measured Values", 
                    position = "after")
                shinyjs::show("tabPanelSE")
                shinyjs::show("sidebarPanelSE")
                shinyjs::hide("uploadSE")
                FUN(SE = se2, MISSINGVALUE = missingValue2)
            }
        }, ignoreNULL = TRUE, ignoreInit = TRUE)
        
        invisible(NULL)
    }
}

## function createLandingPage
test_that(".initialize_server", {
    expect_is(MatrixQCvis:::createLandingPage, "function")
    expect_is(MatrixQCvis:::createLandingPage(), "function")
    expect_is(MatrixQCvis:::createLandingPage(seUI = ""), "function")
    expect_is(MatrixQCvis:::createLandingPage(seLoad = ""), "function")
    expect_is(MatrixQCvis:::createLandingPage(requireButton = ""), "function")
})

#' @name hist_sample_num
#'
#' @title Return the number of a category
#'
#' @description \code{hist_sample_num} returns the number of a category 
#' (e.g. sample types) as a \code{tbl}.
#' The function will retrieve first the column \code{category} in \code{colData(se)}. 
#' The function will return a \code{tbl} containing the numerical 
#' values of the quantities.
#'
#' @param se \code{SummarizedExperiment} object
#' @param category \code{character}, corresponding to a column in \code{colData(se)}
#'
#' @return \code{tbl}
#' 
#' @examples 
#' ## create se
#' a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
#'     dimnames = list(seq_len(10), paste("sample", seq_len(10))))
#' a[c(1, 5, 8), seq_len(5)] <- NA
#' set.seed(1)
#' a <- a + rnorm(100)
#' cD <- data.frame(name = colnames(a), type = c(rep("1", 4), rep("2", 6)))
#' rD <- data.frame(spectra = rownames(a))
#' se <- SummarizedExperiment::SummarizedExperiment(assay = a, 
#'     rowData = rD, colData = cD)
#'
#' hist_sample_num(se, category = "type")
#'
#' @importFrom tibble tibble
#' @importFrom SummarizedExperiment colData
#'
#' @export
hist_sample_num <- function(se, category = "type") {

    cD <- SummarizedExperiment::colData(se)
    category <- match.arg(category, choices = colnames(cD)) |>
        make.names()
    colnames(cD) <- make.names(colnames(cD))
    
    ## retrieve the sample type
    df <- cD[[category]] |>
        as.character()
    df[is.na(df)] <- "NA"
    
    ## retrieve the number of samples per sample type
    tab <- table(df)
    tibble::tibble(names = names(tab), values = as.vector(tab))
}

#' @name hist_sample
#'
#' @title Plot a histogram of the number of a category
#'
#' @description \code{hist_sample} plots the number of a category (e.g. sample types)
#' as a histogram. It use the returned \code{tbl} from \code{hist_sample_num}.
#'
#' @param tbl \code{tbl} as returned by \code{hist_sample_num}
#' @param category \code{character}, x-axis label of the plot 
#'
#' @return \code{gg} object from \code{ggplot2}
#' 
#' @examples 
#' ## create se
#' a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
#'             dimnames = list(seq_len(10), paste("sample", seq_len(10))))
#' a[c(1, 5, 8), seq_len(5)] <- NA
#' set.seed(1)
#' a <- a + rnorm(100)
#' cD <- data.frame(name = colnames(a), type = c(rep("1", 4), rep("2", 6)))
#' rD <- data.frame(spectra = rownames(a))
#' se <- SummarizedExperiment::SummarizedExperiment(assay = a, 
#'     rowData = rD, colData = cD)
#' 
#' tbl <- hist_sample_num(se, category = "type")
#' hist_sample(tbl)
#' 
#' @importFrom ggplot2 ggplot aes sym geom_bar ggtitle ylab xlab theme_bw
#' @importFrom ggplot2 theme element_text
#' @importFrom plotly ggplotly
#' 
#' @export
hist_sample <- function(tbl, category = "type") {
    ## do the actual plotting
    p <- ggplot2::ggplot(tbl, ggplot2::aes(x = !!ggplot2::sym("names"), 
            y = !!ggplot2::sym("values"))) + 
        ggplot2::geom_bar(stat = "identity") + 
        ggplot2::ggtitle("Number of samples") + 
        ggplot2::ylab("number") + ggplot2::xlab(category) + 
        ggplot2::theme_classic() + 
        ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90))
    plotly::ggplotly(p = p, tooltip = c("x", "y"))
}

#' @name mosaic
#' 
#' @title Mosaic plot for two factors in colData(se)
#' 
#' @description 
#' The function \code{mosaic} creates a mosaic plot of two factors from
#' an \code{SummarizedExperiment} object. The columns \code{f1} and \code{f2} 
#' are taken from \code{colData(se)}.
#'
#' @details
#' Code partly taken from
#' https://stackoverflow.com/questions/21588096/pass-string-to-facet-grid-ggplot2
#'
#' @param se \code{SummarizedExperiment} object
#' @param f1 \code{character}, \code{f1} is one of the column names in \code{colData(se)}
#' @param f2 \code{character}, \code{f2} is one of the column names in \code{colData(se)}
#'
#' @return \code{gg} object from \code{ggplot2}
#'
#' @examples
#' ## create se
#' set.seed(1)
#' a <- matrix(rnorm(100), nrow = 10, ncol = 10,
#'             dimnames = list(seq_len(10), paste("sample", seq_len(10))))
#' a[c(1, 5, 8), seq_len(5)] <- NA
#' cD <- data.frame(name = colnames(a), 
#'     type = c(rep("1", 5), rep("2", 5)),
#'     cell_type = c("A", "B"))
#' rD <- data.frame(spectra = rownames(a))
#' se <- SummarizedExperiment::SummarizedExperiment(assay = a, 
#'     rowData = rD, colData = cD)
#' 
#' mosaic(se, "cell_type", "type")
#' 
#' @importFrom rlang := .data
#' @importFrom dplyr group_by summarise mutate ungroup n
#' @importFrom SummarizedExperiment colData
#' @importFrom ggplot2 ggplot aes sym geom_bar geom_text position_stack
#' @importFrom ggplot2 facet_grid scale_fill_brewer theme_bw ylab
#' @importFrom ggplot2 scale_y_continuous theme element_text
#' 
#' @export
mosaic <- function(se, f1, f2) {
    
    cD <- SummarizedExperiment::colData(se) |>
        as.data.frame()
    cols <- colnames(cD)
    f1 <- match.arg(f1, choices = cols)
    f2 <- match.arg(f2, choices = cols)
    colnames(cD) <- make.names(cols)
    f1 <- make.names(f1)
    f2 <- make.names(f2)
    
    ## create character for columns f1 and f2
    cD[[f1]] <- cD[[f1]] |>
        as.character()
    cD[[f2]] <- cD[[f2]] |>
        as.character()
    
    df <- cD |> 
        dplyr::group_by(!!f1 := get(f1), !!f2 := get(f2)) |>
        dplyr::summarise(count = dplyr::n()) |>
        dplyr::mutate(cut.count = sum(.data$count), 
            prop = (.data$count/sum(.data$count)))
    
    ## set prop to 1 when f1 == f2 (by default this will be the proportion
    ## of f1 on the total samples)
    if (f1 == f2) {
        df$prop <- 1
        df$cut.count <- df$count
    }
    
    df <- dplyr::mutate(df, 
            prop_percent = paste(round(.data[["prop"]]*100, 1), "%", sep = "")) |>
        dplyr::ungroup()
    
    ## create label for facet (contains the proportion of f1 on total samples)
    sample_percent <- round(df[["cut.count"]] / ncol(se) * 100, 1) 
    df$f1_labs <- paste0(df[[f1]], " (", sample_percent, "%)")
    
    ## plotting
    ggplot2::ggplot(df, ggplot2::aes(x = !!ggplot2::sym(f1), 
            y = !!ggplot2::sym("prop"), 
            width = !!ggplot2::sym("cut.count"), 
            fill = !!ggplot2::sym(f2))) +
        ggplot2::geom_bar(stat = "identity", position = "fill", 
            colour = "black") +
        ggplot2::geom_text(ggplot2::aes(label = !!ggplot2::sym("prop_percent")), 
            angle = 90, position = ggplot2::position_stack(vjust = 0.5)) +
        ggplot2::facet_grid(~ f1_labs, scales = "free_x", space = "free_x") +
        ggplot2::scale_fill_brewer() + ggplot2::theme_classic() + 
        ggplot2::ylab("proportion (%)") + 
        ggplot2::scale_y_continuous(labels = function(x) x * 100) +
        ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90))
}

#' @importFrom SummarizedExperiment SummarizedExperiment
#' @importFrom tibble tibble

## create se
a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
    dimnames = list(seq_len(10), paste("sample", seq_len(10))))
a[c(1, 5, 8), seq_len(5)] <- NA
set.seed(1)
a <- a + rnorm(100)
cD <- data.frame(sample = colnames(a), type = c(rep("1", 5), rep("2", 5)))
rD <- data.frame(spectra = rownames(a))
se <- SummarizedExperiment::SummarizedExperiment(assay = a, 
    rowData = rD, colData = cD)

## function hist_sample
test_that("hist_sample_num and hist_sample", {
    tbl <- hist_sample_num(se, category = "type")
    g <- hist_sample(tbl)
    
    
    expect_equal(tbl, 
        tibble::tibble(names = c("1", "2"), values = as.integer(c(5.0, 5.0))))
    expect_is(g, "plotly")
    # expect_error(hist_sample_num(se, category = "foo"), 
    #     "Input must be a vector")
    expect_error(hist_sample_num(NULL, category = "type"),
        "unable to find an inherited method for function")
})

## function mosaic
test_that("mosaic", {
    g <- mosaic(se, "sample", "type")
    
    expect_error(mosaic(NULL, "sample", "type"), 
        "unable to find an inherited method for function")
    expect_error(mosaic(se, "foo", "type"), "'arg' should be one of ")
    expect_error(mosaic(se, "sample", "foo"), "'arg' should be one of ")
    expect_is(g, "gg")
}) 

#' @name tag_loadMessage
#' 
#' @title Create a banner to indicate that the shiny session is busy
#' 
#' @description 
#' The function \code{tag_loadMessage} will display a banner within a shiny 
#' session in the case of shiny being busy. The function will display the 
#' loadmessage \code{Loading...} in the top of the page. 
#' 
#' @details 
#' Internal function for \code{shinyQC}
#' 
#' @return \code{shiny.tag.list} with HTML content
#' 
#' @author Thomas Naake
#' 
#' @examples
#' tag_loadMessage()
#' 
#' @importFrom shiny conditionalPanel tagList tags
#' 
#' @noRd
tag_loadMessage <- function() {
    shiny::tagList(
        shiny::tags$head(shiny::tags$script("
            $(document).on('shiny:connected', function(e) {
                Shiny.onInputChange('innerWidth', window.innerWidth);
            });
            $(window).resize(function(e) {
                Shiny.onInputChange('innerWidth', window.innerWidth);
            });
        "))
    )
}

#' @name tag_keepAlive
#' 
#' @title Send data back and forth through the websocket to keep the app busy
#' 
#' @description 
#' The function \code{tag_keepAlive} will send data back and forth through the 
#' websocket. When running the app via the server and the app is getting idle,
#' it will crash. Stop this behavior by exchanging data via the websocket.
#' 
#' @details 
#' Internal function for \code{shinyQC}
#' 
#' @return \code{shiny.tag.list} with HTML content
#' 
#' @author Thomas Naake
#' 
#' @examples
#' tag_keepAlive()
#' 
#' @importFrom shiny tagList HTML tags
#' 
#' @noRd
tag_keepAlive <- function() {
    
    shiny::tagList(
        shiny::tags$head(shiny::HTML(
            "
            <script>
            var socket_timeout_interval
            var n = 0
            $(document).on('shiny:connected', function(event) {
            socket_timeout_interval = setInterval(function(){
            Shiny.onInputChange('keepAlive', n++)
            }, 15000)
            });
            $(document).on('shiny:disconnected', function(event) {
            clearInterval(socket_timeout_interval)
            });
            </script>
            "
            )
        )
    )
}

#' @name sidebar_assayUI
#' 
#' @title Sidebar UI for normalization, transformation, and batch correction  
#' 
#' @description 
#' The module defines the UI in the sidebar for the data manipulation 
#' (normlization, transformation, and batch correction). 
#' 
#' @details 
#' \code{sidebar_assayUI} returns the HTML code for the sidebar in the tabs
#' \code{Values} and \code{Dimension Reduction}. Internal function for \code{shinyQC}.
#' 
#' @return \code{shiny.tag.list} with HTML content
#' 
#' @author Thomas Naake
#' 
#' @examples
#' sidebar_assayUI()
#' 
#' @importFrom shiny conditionalPanel selectInput uiOutput strong
#' 
#' @noRd
sidebar_assayUI <- function() {
    shiny::conditionalPanel(
        condition = "input.tabs == 'Dimension Reduction' | input.tabs == 'Values'",
        
        ## select type of normalization
        shiny::selectInput(inputId = "normalization",
            label = shiny::strong("Normalization method"),
            choices = c("none", "sum", "quantile division", "quantile"),
            selected = "none"),
        shiny::conditionalPanel(
            condition = "input.normalization == 'quantile division'",
            shiny::sliderInput("quantile", label = "Quantile",
                min = 0, max = 1, value = 0.75)),
        
        ## select type of batch correction
        shiny::selectInput(inputId = "batch",
            label = shiny::strong("Batch correction method"),
            choices = c("none", "removeBatchEffect (limma)", "ComBat"), 
            selected = "none"),
        ## create conditional panel to select batch variable, use observe to
        ## update the choices
        shiny::conditionalPanel(
            condition = "input.batch == 'removeBatchEffect (limma)' | input.batch == 'ComBat'",
                shiny::selectInput("batchCol",
                    label = "Select column containing batch information",
                    choices = "name")),
        
        ## select type of transformation
        shiny::selectInput(inputId = "transformation",
            label = shiny::strong("Transformation method"),
            choices = c("none", "log", "log2", "log10", "vsn"), 
            selected = "none")
        )
}

#' @name sidebar_imputationUI
#' 
#' @title Conditional sidebar UI for imputation
#' 
#' @description 
#' The module defines the UI in the sidebar for the data imputation. 
#' 
#' @details 
#' \code{sidebar_assayUI} returns the HTML code for the sidebar in the tabs
#' \code{Values} and \code{Dimension Reduction}. Internal function for 
#' \code{shinyQC}.
#' 
#' Method \code{"none"} is not available within the shiny application.
#' 
#' @return \code{shiny.tag.list} with HTML content
#' 
#' @param missingValue \code{logical} (if \code{FALSE} do not show 
#' \code{selectInput} for 
#' imputation)
#' 
#' @author Thomas Naake
#' 
#' @examples
#' sidebar_imputationUI()
#' 
#' @importFrom shiny conditionalPanel selectInput strong
#' 
#' @noRd
sidebar_imputationUI <- function() {
    ## select type of imputation
    shiny::conditionalPanel("output.missingVals == 'TRUE' & (input.tabs == 'Dimension Reduction' | input.tabs == 'Values')", 
        shiny::selectInput(inputId = "imputation",
            label = shiny::strong("Imputation method"),
            choices = c("BPCA", "kNN", "MLE", "Min", "MinDet", "MinProb"),
            selected = "MinDet"))
}

#' @name sidebar_DEUI
#' 
#' @title Sidebar UI for the tab 'DE'
#' 
#' @description 
#' The module defines the UI in the tab 'DE'. It allows for specifying the
#' formula for the model matrix and the contrasts. Furthermore, it provides 
#' the UI for selecting the type of test to perform (ttest or proDA). 
#' 
#' @details 
#' Internal function for \code{shinyQC}.
#' 
#' @return \code{shiny.tag.list} with HTML content
#' 
#' @author Thomas Naake
#' 
#' @examples
#' sidebar_DEUI()
#' 
#' @importFrom shiny conditionalPanel radioButtons textInput actionButton
#' 
#' @noRd
sidebar_DEUI <- function() {
    shiny::conditionalPanel(condition = "input.tabs == 'DE'",
        shiny::radioButtons(inputId = "DEtype",
            label = "Choose method/test for DE",
            choices = list("Moderated t-test (limma)" ="ttest",
                                "Wald test (proDA)" = "proDA")),
        shiny::textInput(inputId = "modelMat",
            label = "Select levels for Model Matrix", 
            value = "~", placeholder = "~ treatment"),
        shiny::actionButton(inputId = "actionModelMat",
            label = "Update formula for Model Matrix"),
        shiny::textInput(inputId = "contrastMat",
            label = "Select contrast(s)", 
            value = "", placeholder = "treatment"),
        shiny::actionButton(inputId = "actionContrasts",
            label = "Update contrasts"))
}

#' @name sidebar_excludeSampleUI
#' 
#' @title Sidebar UI for removing columns from \code{SummarizedExperiment} 
#' objects 
#' 
#' @description 
#' The module defines the UI in the sidebar for removing columns in the
#' \code{SummarizedExperiment} object. 
#' 
#' @details 
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' 
#' @return \code{shiny.tag.list} with HTML content
#' 
#' @author Thomas Naake
#' 
#' @examples
#'
#' ## create se
#' a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
#'             dimnames = list(seq_len(10), paste("sample", seq_len(10))))
#' a[c(1, 5, 8), seq_len(5)] <- NA
#' set.seed(1)
#' a <- a + rnorm(100)
#' cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
#' rD <- data.frame(spectra = rownames(a))
#' se <- SummarizedExperiment::SummarizedExperiment(assays = list(a, a+10), 
#'                                 rowData = rD, colData = cD)
#'
#' sidebar_excludeSampleUI("select")
#' 
#' @importFrom shiny NS conditionalPanel radioButtons selectizeInput
#' 
#' @noRd
sidebar_excludeSampleUI <- function(id) {
    ns <- shiny::NS(id)
    shiny::conditionalPanel(condition = "input.tabs != 'DE'",
        shiny::radioButtons(inputId = ns("mode"), label = "Select samples",
            choices = list("all" = "all", "exclude" = "exclude", 
                                                        "select" = "select")),
        shiny::selectizeInput(inputId = ns("excludeSamples"),
            label = NULL, choices = "samples", multiple = TRUE)
    )
}

#' @name sidebar_excludeSampleServer
#' 
#' @title Server for sidebar UI for removing columns from 
#' \code{SummarizedExperiment} objects 
#' 
#' @description 
#' The module defines the server for the 
#' UI in the sidebar for removing columns in the
#' \code{SummarizedExperiment} object.
#' 
#' @details 
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param se \code{SummarizedExperiment} object
#' 
#' @return \code{shiny.server.function} 
#' 
#' @author Thomas Naake
#' 
#' @importFrom shiny moduleServer updateSelectizeInput observe
#' 
#' @noRd
sidebar_excludeSampleServer <- function(id, se) {
    shiny::moduleServer(
        id,
        function(input, output, session) {
            
            shiny::observe({
                shiny::updateSelectizeInput(session = session, 
                    inputId = "excludeSamples",
                    choices = colnames(se), server = TRUE)
            })
        }
    )
}


#' @name sidebar_reportUI
#' 
#' @title Sidebar UI for creating a \code{knitr} report 
#' 
#' @description 
#' The module defines the UI in the sidebar for creating a \code{knitr} report.
#' 
#' @details 
#' Internal function for \code{shinyQC}
#' 
#' @return \code{shiny.tag.list} with HTML content
#' 
#' @author Thomas Naake
#' 
#' @examples
#' sidebar_reportUI()
#' 
#' @importFrom shiny downloadButton
#' 
#' @noRd
sidebar_reportUI <- function() {
    shiny::downloadButton("report", "Generate report")
}

#' @name sidebar_selectAssayUI
#' 
#' @title Sidebar UI for selecting the assay in multi-assay 
#' \code{SummarizedExperiment} objects
#' 
#' @description 
#' The module defines the UI in the sidebar for selecting the assay in 
#' multi-assay \code{SummarizedExperiment} objects. 
#' 
#' @details 
#' \code{sidebar_selectAssayUI} will only displayed if the 
#' \code{SummarizedExperiment} object contains more than one assay. This 
#' behavior will be governed by the condition 
#' \code{output.lengthAssays == 'TRUE'}; within the server
#' expression the module \code{selectAssayServer} (\code{id = "select"}) will 
#' return the \code{character} \code{"TRUE"} if there is more than one assay 
#' in \code{se}, otherwise it will return \code{"FALSE"} which will not 
#' display the \code{selectInput}. Internal function for \code{shinyQC}.
#' 
#' @param choicesAssaySE \code{character} or \code{numeric}
#'
#' @return \code{shiny.tag.list} with HTML content
#' 
#' @author Thomas Naake
#' 
#' @examples
#' choicesAssaySE <- c(1, 2)
#' sidebar_selectAssayUI(choicesAssaySE = choicesAssaySE)
#' 
#' @importFrom shiny conditionalPanel selectInput
#' @noRd
sidebar_selectAssayUI <- function(choicesAssaySE) {
    shiny::conditionalPanel(
        condition = "output.lengthAssays == 'TRUE'", 
        shiny::selectInput(inputId = "assaySelected",
            label = "Select data input", choices = choicesAssaySE, 
            selected = 1, multiple = FALSE))
}

#' @name choiceAssaySE
#' 
#' @title Return vector with names of assays of multi-assay 
#' \code{SummarizedExperiment}
#' 
#' @description 
#' The function \code{choiceAssaySE} will return a vector of length
#' \code{length(assays(se))}. It will contain either the assigned names to 
#' \code{assays(se)} (if any) or a vector with the seuence from 1 to 
#' \code{length(assays(se))}.
#'
#' @details 
#' The function returns the \code{choices} for the \code{selectInput} UI to 
#' select the assay. Internal usage in \code{shinyQC}.
#' 
#' @param se \code{SummarizedExperiment} object
#' 
#' @return 
#' \code{character} 
#' 
#' @author Thomas Naake
#' 
#' @examples 
#' ## create se
#' a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
#'     dimnames = list(seq_len(10), paste("sample", seq_len(10))))
#' a[c(1, 5, 8), seq_len(5)] <- NA
#' set.seed(1)
#' a <- a + rnorm(100)
#' cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
#' rD <- data.frame(spectra = rownames(a))
#' se <- SummarizedExperiment::SummarizedExperiment(assays = list(a, a+10), 
#'     rowData = rD, colData = cD)
#' 
#' choiceAssaySE(se = se)
#' 
#' @importFrom SummarizedExperiment assays
#' @noRd
choiceAssaySE <- function(se) {
    a <- SummarizedExperiment::assays(se)
    names_a <- names(a)
    
    if (NA %in% names_a) stop("names(assays(se)) contains NA")
    
    if (length(names_a) == length(a)) {
        choice <- names_a
    } else {
        choice <- seq_len(length(a))
    }
    
    return(choice)
}


#' @name selectAssaySE
#' 
#' @title Select assay from multi-assay \code{SummarizedExperiment} object
#' 
#' @description 
#' The function \code{selectAssaySE} will assign the \code{selected} assay to the 
#' \code{SummarizedExperiment}. \code{selectAssaySE} will return the \code{assay}, 
#' together with the \code{colData} and \code{rowData}, as a 
#' \code{SummarizedExperiment}. 
#' 
#' @details 
#' The function truncates multi-assay \code{SummarizedExperiment} objects to 
#' \code{assays(se)} with length 1. Internal usage in \code{shinyQC}.
#' 
#' @param se \code{SummarizedExperiment} object
#' @param selected \code{numeric} vector, index of the \code{assay} to be returned
#' 
#' @return 
#' \code{SummarizedExperiment} object
#' 
#' @author Thomas Naake
#' 
#' @examples
#' ## create se
#' a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
#'             dimnames = list(seq_len(10), paste("sample", seq_len(10))))
#' a[c(1, 5, 8), seq_len(5)] <- NA
#' set.seed(1)
#' a <- a + rnorm(100)
#' cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
#' rD <- data.frame(spectra = rownames(a))
#' se <- SummarizedExperiment::SummarizedExperiment(assays = list(a, a+10), 
#'     rowData = rD, colData = cD)
#' 
#' selectAssaySE(se = se, selected = 1)
#' selectAssaySE(se = se, selected = 2)
#' 
#' @importFrom SummarizedExperiment SummarizedExperiment
#' @importFrom SummarizedExperiment assay assays colData rowData assayNames
#' @noRd
selectAssaySE <- function(se, selected = 1) {
    
    if (length(SummarizedExperiment::assayNames(se)) > 1) {
        se <- SummarizedExperiment::SummarizedExperiment(
            assays = SummarizedExperiment::assay(se, i = selected), 
            rowData = SummarizedExperiment::rowData(se), 
            colData = SummarizedExperiment::colData(se))    
    }
    
    se
}



#' @name selectAssayServer
#' 
#' @title Module for server expressions for selecting assay in multi-assay
#' \code{SummarizedExperiment} objects 
#' 
#' @description
#' The module defines the server expressions for selecting the assay in 
#' multi-assay \code{SummarizedExperiment} objects.
#' 
#' @details 
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param se \code{SummarizedExperiment}
#' @param selected \code{reactive} expression and \code{character}/\code{numeric}
#' 
#' @return
#' \code{reactive} expression
#'
#' @author Thomas Naake
#' 
#' @importFrom shiny moduleServer reactive
#'
#' @noRd
selectAssayServer <- function(id, se, selected) {
    shiny::moduleServer(
        id,
        function(input, output, session) {

            se_sel <- shiny::reactive({
                selectAssaySE(se, selected = selected())
            })
            
            return(se_sel)
        }
    )
}

#' @name selectSampleSE
#' 
#' @title Select sample(s) from a \code{SummarizedExperiment} object
#' 
#' @description 
#' The function \code{selectSampleSE} removes/adds samples from a 
#' \code{SummarizedExperiment} as specified by the \code{selection} argument 
#' and the \code{mode} argument.
#' 
#' @details 
#' If the supplied vector (\code{selection}) is of length 0, the object 
#' \code{se} will be returned as is. 
#' 
#' @param se \code{SummarizedExperiment} object
#' @param selection \code{character} vector, containing the samples to 
#' exclude/add (\code{colnames(se)})
#' 
#' @return 
#' \code{SummarizedExperiment} object
#' 
#' @author Thomas Naake
#' 
#' @examples
#' ## create se
#' a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
#'             dimnames = list(seq_len(10), paste("sample", seq_len(10))))
#' a[c(1, 5, 8), seq_len(5)] <- NA
#' set.seed(1)
#' a <- a + rnorm(100)
#' cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
#' rD <- data.frame(spectra = rownames(a))
#' se <- SummarizedExperiment::SummarizedExperiment(assay = a, 
#'     rowData = rD, colData = cD)
#' 
#' samplesToExclude <- c("sample 1")
#' selectSampleSE(se = se, selection = samplesToExclude, mode = "exclude")
#' 
#' @noRd
selectSampleSE <- function(se, selection, 
                                    mode = c("all", "exclude", "select")) {
    
    mode <- match.arg(mode)
    
    if (mode == "exclude") {
        if (length(selection) > 0) {
            se <- se[, !(colnames(se) %in% selection)]  
        }    
    }
    
    if (mode == "select") {
        if (length(selection) >= 3) {
            se <- se[, colnames(se) %in% selection]    
        }
    } 
    
    return(se)
    
}

#' @name selectFeatureSE
#' 
#' @title Select feature(s) from a \code{SummarizedExperiment} object
#' 
#' @description 
#' The function \code{selectFeatureSE} removes/adds feature from a 
#' \code{SummarizedExperiment} as specified by the \code{selection} argument and the
#' \code{mode} argument.
#' 
#' @details 
#' If the supplied vector (\code{selection}) is of length 0, the object \code{se} will 
#' be returned as is (if \code{mode = "exclude"}). 
#' If the supplied vector (\code{selection}) is of length <3, the object \code{se} will 
#' be returned as is (if \code{mode = "select"}).
#' 
#' @param se \code{SummarizedExperiment} object
#' @param selection \code{character} vector, containing the samples to exclude/add 
#' (\code{colnames(se)})
#' 
#' @return 
#' \code{SummarizedExperiment} object
#' 
#' @author Thomas Naake
#' 
#' @examples
#' ## create se
#' a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
#'             dimnames = list(seq_len(10), paste("sample", seq_len(10))))
#' a[c(1, 5, 8), seq_len(5)] <- NA
#' set.seed(1)
#' a <- a + rnorm(100)
#' cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
#' rD <- data.frame(spectra = rownames(a))
#' se <- SummarizedExperiment::SummarizedExperiment(assay = a, 
#'     rowData = rD, colData = cD)
#' 
#' featuresToExclude <- c("1", "2")
#' selectFeatureSE(se = se, selection = featuresToExclude, mode = "exclude")
#' 
#' @noRd
selectFeatureSE <- function(se, selection, 
                                    mode = c("all", "exclude", "select")) {
    
    mode <- match.arg(mode)
    
    if (mode == "exclude") {
        if (length(selection) > 0) {
            se <- se[!(rownames(se) %in% selection), ]  
        }    
    }
    
    if (mode == "select") {
        if (length(selection) >= 3) {
            se <- se[rownames(se) %in% selection, ]    
        } 
    } 
    
    return(se)
}

#' @name updateSE
#' 
#' @title Update the \code{SummarizedExperiment} by the slot array
#' 
#' @description 
#' The function \code{updateSE} updates the \code{assay} slot of a \code{SummarizedExperiment}
#' object, \code{se}, with a supplied \code{assay} object. The function returns the 
#' updated object. 
#' 
#' @details 
#' Internal function in \code{shinyQC}.
#' 
#' @param se \code{SummarizedExperiment} object
#' @param assay \code{matrix} with same dimensions as \code{assay(se)}
#' @param ... further arguments passed to \code{SummarizedExperiment::assay}
#' 
#' @return
#' \code{SummarizedExperiment} object
#' 
#' @author Thomas Naake
#' 
#' @examples
#' assayOld <- SummarizedExperiment::assay(se)
#' assayNew <- assayOld + 1
#' updateSE(se, assayNew)
#' 
#' @importFrom SummarizedExperiment assay 'assay<-'
#' @importFrom shiny req
#'
#' @noRd
updateSE <- function(se, assay, ...) {
    shiny::req(assay)
    SummarizedExperiment::assay(se, withDimnames = FALSE, ...) <- assay
    
    return(se)
}


#' @name missingValuesSE
#' 
#' @title Check if there are missing values in the assay slot(s) of 
#' the \code{SummarizedExperiment}
#' 
#' @description 
#' The function \code{missingValuesSE} checks if the \code{assay} slot(s) of a 
#' \code{SummarizedExperiment} object, \code{se}, contains \code{NA} values.
#' 
#' @details 
#' Internal function in \code{shinyQC}.
#' 
#' @param se \code{SummarizedExperiment} object
#' 
#' @return
#' \code{logical}
#' 
#' @author Thomas Naake
#' 
#' @examples
#' missingValuesSE(se)
#' 
#' @importFrom SummarizedExperiment assay assays
#' 
#' @noRd
missingValuesSE <- function(se) {
    len <- length(SummarizedExperiment::assays(se))
    l_na <- lapply(seq_len(len), 
        function(i) any(is.na(SummarizedExperiment::assay(se, i))))
    any(unlist(l_na))
}

## create se
a <- matrix(seq_len(100), nrow = 10, ncol = 10,
    dimnames = list(seq_len(10), paste("sample", seq_len(10))))
a[c(1, 5, 8), seq_len(5)] <- NA
set.seed(1)
a <- a + rnorm(100)
cD <- data.frame(name = colnames(a),
    type = c(rep("1", 5), rep("2", 5)))
rD <- data.frame(spectra = rownames(a))
se <- SummarizedExperiment::SummarizedExperiment(assay = a, rowData = rD, 
                                                                colData = cD)

## function tag_loadMessage
test_that("tag_loadMessage", {
    expect_is(tag_loadMessage(), "shiny.tag.list")
})

## function tag_keepAlive
test_that("tag_keepAlive", {
    expect_is(tag_keepAlive(), "shiny.tag.list")
})

## function sidebar_assayUI
test_that("sidebar_assayUI", {
    expect_is(sidebar_assayUI(), "shiny.tag")
    expect_is(sidebar_assayUI(), "shiny.tag")
})

test_that("sidebar_imputationUI", {
    expect_is(sidebar_imputationUI(), "shiny.tag")
})

## function sidebar_DEUI
test_that("sidebar_DEUI", {
    expect_is(sidebar_DEUI(), "shiny.tag")
})

## function sidebar_excludeSampleUI
test_that("sidebar_excludeSampleUI", {
    expect_is(sidebar_excludeSampleUI(""), "shiny.tag")
})

## excludeSampleServer
test_that("sidebar_excludeSampleServer", {
    shiny::testServer(sidebar_excludeSampleServer, {
        input <- new.env()
        output <- new.env()
        session <- new.env()
        se <- new.env()

        out <- sidebar_excludeSampleServer("", se = se)
        expect_is(out, "Observer")
    })
})

## sidebar_reportUI
test_that("sidebar_reportUI", {
    expect_is(sidebar_reportUI(), "shiny.tag")
})

## function sidebar_selectAssayUI
test_that("sidebar_selectAssayUI", {
    expect_is(sidebar_selectAssayUI(choicesAssaySE = c(1, 2)), "shiny.tag")
})

## function choiceDataSE
test_that("choiceAssaySE", {
    se_2 <- se
    assays(se_2)[[2]] <- assay(se)
    names(SummarizedExperiment::assays(se_2)) <- c("abc", "def")
    expect_equal(choiceAssaySE(se_2), c("abc", "def"))
    names(SummarizedExperiment::assays(se_2)) <- c("abc", NA)
    expect_error(choiceAssaySE(se_2), "contains NA")
    names(SummarizedExperiment::assays(se_2)) <- NULL
    expect_equal(choiceAssaySE(se_2), c(1, 2))
})

## function selectAssaySE
test_that("selectAssaySE", {
    se_2 <- se
    assays(se_2)[[2]] <- assay(se)
    names(assays(se_2)) <- c("abc", "def")
    expect_equal(assay(selectAssaySE(se_2, "abc")), 
        SummarizedExperiment::assays(se_2)[[1]])
    expect_equal(colData(selectAssaySE(se_2, "abc")), 
        SummarizedExperiment::colData(se))
    expect_equal(rowData(selectAssaySE(se_2, "abc")), 
        SummarizedExperiment::rowData(se))
    expect_equal(assay(selectAssaySE(se_2, "def")), 
        SummarizedExperiment::assays(se_2)[[2]])
    expect_equal(colData(selectAssaySE(se_2, "def")), 
        SummarizedExperiment::colData(se))
    expect_equal(rowData(selectAssaySE(se_2, "def")), 
        SummarizedExperiment::rowData(se))
    names(assays(se_2)) <- c(1, 2)
    expect_equal(assay(selectAssaySE(se_2, 1)), 
        SummarizedExperiment::assays(se_2)[[1]])
    expect_equal(colData(selectAssaySE(se_2, 1)), 
        SummarizedExperiment::colData(se))
    expect_equal(rowData(selectAssaySE(se_2, 1)), 
        SummarizedExperiment::rowData(se))
    expect_equal(assay(selectAssaySE(se_2, 2)), 
        SummarizedExperiment::assays(se_2)[[2]])
    expect_equal(colData(selectAssaySE(se_2, 2)), 
        SummarizedExperiment::colData(se))
    expect_equal(rowData(selectAssaySE(se_2, 2)), 
        SummarizedExperiment::rowData(se))
    expect_error(selectAssaySE(se_2, "abc"), "not in names")
    expect_error(selectAssaySE(se_2, NULL), 
        "unable to find an inherited method")
})

## selectAssayServer
test_that("selectAssayServer", {
    shiny::testServer(selectAssayServer, {
        input <- new.env()
        output <- new.env()
        session <- new.env()
        se <- new.env()
        selected <- new.env()

        out <- selectAssayServer("", se = se, selected = selected)
        expect_is(out, "reactiveExpr")
    })
})

## function selectSampleSE
test_that("selectSampleSE", {
    expect_equal(selectSampleSE(NULL, NULL, "all"), NULL)
    expect_equal(selectSampleSE(NULL, NULL, "exclude"), NULL)
    expect_equal(selectSampleSE(NULL, NULL, "select"), NULL)
    expect_equal(selectSampleSE(NULL, "foo"), NULL)
    expect_equal(selectSampleSE(se, NULL, "all"), se)
    expect_equal(selectSampleSE(se, NULL, "exclude"), se)
    expect_equal(selectSampleSE(se, NULL, "select"), se)
    expect_equal(selectSampleSE(se, "foo", "all"), se)
    expect_equal(selectSampleSE(se, "sample 2", "all"), se)
    expect_equal(selectSampleSE(se, "sample 2", "exclude"), se[, -2])
    expect_equal(selectSampleSE(se, "sample 2", "select"), se)
    expect_equal(selectSampleSE(se, c("sample 2", "sample 3"), "exclude"), 
        se[, -c(2, 3)])
    expect_equal(selectSampleSE(se, c("sample 2", "sample 3"), "select"), se)
    expect_equal(
        selectSampleSE(se, c("sample 2", "sample 3", "sample 4"), "select"), 
        se[, c(2, 3, 4)])
    expect_error(selectSampleSE("foo", "sample 1", "exclude"),
        "incorrect number of dimensions")
    expect_error(selectSampleSE("foo", 
        c("sample 1", "sample 2", "sample 3"), "select"),
        "incorrect number of dimensions")
})

## function selectFeatureSE
test_that("selectFeatureSE", {
    expect_equal(selectFeatureSE(NULL, NULL, "all"), NULL)
    expect_equal(selectFeatureSE(NULL, NULL, "exclude"), NULL)
    expect_equal(selectFeatureSE(NULL, NULL, "select"), NULL)
    expect_equal(selectFeatureSE(NULL, "foo"), NULL)
    expect_equal(selectFeatureSE(se, NULL, "all"), se)
    expect_equal(selectFeatureSE(se, NULL, "exclude"), se)
    expect_equal(selectFeatureSE(se, NULL, "select"), se)
    expect_equal(selectFeatureSE(se, "foo", "all"), se)
    expect_equal(selectFeatureSE(se, "2", "all"), se)
    expect_equal(selectFeatureSE(se, "2", "exclude"), se[-2,])
    expect_equal(selectFeatureSE(se, "2", "select"), se)
    expect_equal(selectFeatureSE(se, c("1", "2"), "select"), se)
    expect_equal(selectFeatureSE(se, c("1", "2", "3"), "select"), se[c(1, 2, 3), ])
    expect_equal(selectFeatureSE(se, c("2", "3"), "exclude"), se[-c(2, 3), ])
    expect_error(selectFeatureSE("foo", "1", "exclude"),
        "incorrect number of dimensions")
})

## function updateSE
test_that("updateSE", {
    expect_equal(updateSE(se, SummarizedExperiment::assay(se)), se)
    expect_error(updateSE(se, NULL))
    expect_error(updateSE(se, "foo"),
        "must return a numeric vector")
    expect_error(updateSE(NULL, SummarizedExperiment::assay(se)),
        "unable to find an inherited method for function")
    expect_error(updateSE("", SummarizedExperiment::assay(se)),
        "unable to find an inherited method for function")
})

## ----style, echo = FALSE, results = 'asis'------------------------------------
BiocStyle::markdown()

## ----env, include=FALSE, echo=FALSE, cache=FALSE------------------------------
library("knitr")
opts_chunk$set(stop_on_error = 1L)
suppressPackageStartupMessages(library("MatrixQCvis"))

## ----install, eval=FALSE------------------------------------------------------
# if (!requireNamespace("BiocManager", quietly = TRUE))
#     install.packages("BiocManager")
# BiocManager::install("MatrixQCvis")

## ----load_MatrixQCvis, eval=TRUE----------------------------------------------
library(MatrixQCvis)

## ----eval = TRUE, echo = FALSE------------------------------------------------
## run under Linux only
if (grepl(tolower(Sys.info()[["sysname"]]), pattern = "linux")) {
    proxy_string <- Sys.getenv("http_proxy")
    if (nzchar(proxy_string)) {
        ExperimentHub::setExperimentHubOption("PROXY", proxy_string)
    }
}
    

## ----prepare_se, eval=TRUE, echo=TRUE-----------------------------------------
library(ExperimentHub)
eh <- ExperimentHub()

## the SummarizedExperiment object has the title "RNA-Sequencing and clinical  
## data for 741 normal samples from The Cancer Genome Atlas"
eh[eh$title == "RNA-Sequencing and clinical data for 741 normal samples from The Cancer Genome Atlas"]

## in a next step download the SummarizedExperiment object from ExperimentHub
se <- eh[["EH1044"]]

## here we will restrain the analysis on 40 samples and remove the features
## that have a standard deviation of 0
se <- se[, seq_len(40)]
se_sds <- apply(assay(se), 1, sd, na.rm = TRUE)
se <- se[!is.na(se_sds) & se_sds > 0, ]

## ----eval=FALSE---------------------------------------------------------------
# qc <- shinyQC(se)

## ----hist_sample, eval=TRUE, echo=FALSE, crop=NULL, out.width = "200px", dpi=65----
tbl <- hist_sample_num(se = se, category = "type")
partial_bundle(hist_sample(tbl, category = "type"))

## ----mosaic, eval=TRUE, echo=FALSE, crop=NULL, out.width = "200px", dpi=65----
se_tmp <- se
se_tmp$arbitrary_values <- c("A", "B")
mosaic(se = se_tmp, f1 = "type", f2 = "arbitrary_values")

## ----boxplot, eval=TRUE, echo=FALSE, warning=FALSE, crop=NULL, out.width = "200px", dpi=65----
createBoxplot(se, orderCategory = "sample", title = "raw", log = TRUE, 
               violin = TRUE)

## ----drift, eval=TRUE, echo=FALSE, message=FALSE, warning=FALSE, crop=NULL, out.width = "200px", dpi=65----
partial_bundle(driftPlot(se, aggregation = "median", category = "type",
          orderCategory = "type", level = "BRCA", method = "loess"))

## ----cv, eval=TRUE, echo=FALSE, warning=FALSE, message=FALSE, crop=NULL, out.width = "200px", dpi=65----
a <- assay(se)
a_n <- normalizeAssay(a, "sum")
se_n <- MatrixQCvis:::updateSE(se = se, assay = a_n)
a_b <- batchCorrectionAssay(se_n, method = "none")
a_t <- transformAssay(a_b, "vsn")
se_t <- MatrixQCvis:::updateSE(se = se, assay = a_t)

a_i <- imputeAssay(a_t, "MinDet")

## calculate cv values
cv_r <- cv(a, "raw")
cv_n <- cv(a_n, "normalized")
cv_b <- cv(a_b, "batch corrected")
cv_t <- cv(a_t, "transformed")
cv_i <- cv(a_i, "imputed")
 
df <- data.frame(cv_r, cv_n, cv_b, cv_t, cv_i)
plotCV(df)

## ----meansdplot, eval=TRUE, echo=FALSE, warning=FALSE, crop=NULL, out.width = "200px", dpi=65----
vsn::meanSdPlot(assay(se_t))

## ----maplot, eval=TRUE, echo = FALSE, show=FALSE, crop=NULL, out.width = "200px", dpi=65----
tbl <- MAvalues(se, group = "all")
MAplot(tbl, group = "all", plot = "TCGA-K4-A3WV-11A-21R-A22U-07")

## ----ecdf, eval=TRUE, echo=FALSE, crop=NULL, out.width = "200px", dpi=65------
ECDF(se, "TCGA-K4-A3WV-11A-21R-A22U-07", group = "all")

## ----distSampe, eval=TRUE, echo=FALSE, crop=NULL, warning=FALSE, message=FALSE, out.width = "200px", dpi=65----
a <- assay(se)
dist_mat <- distShiny(a)
distSample(dist_mat, se, "type", use_raster = TRUE, raster_device = "jpeg")
partial_bundle(sumDistSample(dist_mat, title = "raw"))

## ----featurePlot, eval=TRUE, echo=FALSE, crop=NULL, out.width = "200px", dpi=65----
l_assays <- list(raw = a, normalized = a_n, `batch.corrected` = a_b,
   transformed = a_t, imputed = a_i)
df_feature <- createDfFeature(l_assays, feature = rownames(se)[1])
featurePlot(df_feature)

## ----cvFeaturePlot, eval=TRUE, echo=FALSE, crop=NULL, out.width = "200px", dpi=65----
partial_bundle(cvFeaturePlot(l_assays, lines = FALSE))

## ----colData, echo=FALSE, eval=TRUE-------------------------------------------
colData(se) |>
    head(n = 10)

## ----modelMatrix, echo=FALSE, eval=TRUE---------------------------------------
mM <- model.matrix(formula("~ type + 0"), data = colData(se))
head(mM)

## ----contrasts, echo=FALSE, eval=TRUE, warning=FALSE, message=FALSE-----------
library(limma)
cM <- makeContrasts(contrasts = "typeBRCA-typeLUAD", levels = mM)
head(cM)

## ----topDE, echo=FALSE, eval=TRUE, warning=FALSE, message=FALSE---------------
a <- assay(se)
a_n <- a |>
    normalizeAssay(method = "none")
a_t <- a_n |>
    transformAssay(method = "vsn")
a_i <- a_t |>
    imputeAssay(method = "MinDet")

fit <- lmFit(a_i, design = mM)
fit <- contrasts.fit(fit, contrasts = cM)
fit <- eBayes(fit, trend = TRUE, robust = TRUE)
tT <- topTable(fit, number = Inf, adjust.method = "fdr", p.value = 0.05)
rmarkdown::paged_table(tT[seq_len(20), ])

## ----volcano, eval=TRUE, echo=FALSE, crop=NULL, out.width = "200px", dpi=65----
partial_bundle(volcanoPlot(tT, type = "ttest"))

## ----data_proteomics----------------------------------------------------------
eh[eh$title == "proteomic_20Q2"]
tbl <- eh[["EH3459"]]

## reduce the number of files to speed computations up (can be skipped)
cell_line_unique <- dplyr::pull(tbl, "cell_line") |>
    unique()
tbl <- tbl |> 
    filter(tbl[["cell_line"]] %in% cell_line_unique[seq_len(40)])

## using the information from protein_id/cell_line calculate the mean expression
## from the protein_expression values, 
tbl_mean <- tbl |>
    dplyr::group_by(protein_id, cell_line) |>
    dplyr::summarise(mean_expression = mean(protein_expression, na.rm = TRUE), 
        .groups = "drop") 

## create wide format from averaged expression data
tbl_mean <- tbl_mean |>
    tidyr::pivot_wider(names_from = cell_line, values_from = mean_expression,
        id_cols = protein_id, names_expand = TRUE)

## add additional information from tbl to tbl_mean, remove first columns 
## protein_expression and cell_line, remove the duplicated rows based on 
## protein_id, finally add the tbl_mean to tbl_info
tbl_info <- tbl |>
    dplyr::select(-protein_expression, -cell_line) |> 
    dplyr::distinct(protein_id, .keep_all = TRUE)
tbl_mean <- dplyr::right_join(tbl_info, tbl_mean,
    by = c("protein_id" = "protein_id")) 

## create assay object
cols_a_start <- which(colnames(tbl_mean) == "A2058_SKIN")
a <- tbl_mean[, cols_a_start:ncol(tbl_mean)] |>
    as.matrix()
rownames(a) <- dplyr::pull(tbl_mean, "protein_id")

## create rowData object
rD <- tbl_mean[, seq_len(cols_a_start - 1)] |>
    as.data.frame()
rownames(rD) <- dplyr::pull(tbl_mean, "protein_id")

## create colData object, for the tissue column split the strings in column 
## sample by "_", remove the first element (cell_line) and paste the remaining
## elements
cD <- data.frame(
    sample = colnames(tbl_mean)[cols_a_start:ncol(tbl_mean)]
) |> 
    mutate(tissue = unlist(lapply(strsplit(sample, split = "_"), function(sample_i) 
        paste0(sample_i[-1], collapse = "_"))))
rownames(cD) <- cD$sample

## create the SummarizedExperiment
se <- SummarizedExperiment(assay = a, rowData = rD, colData = cD)

## here we remove the features that have a standard deviation of 0
se_sds <- apply(assay(se), 1, sd, na.rm = TRUE)
se <- se[!is.na(se_sds) & se_sds > 0, ]

## ----shinyQC_proteomics, eval = FALSE-----------------------------------------
# shinyQC(se)

## ----samplesMeasuredMissing, eval=TRUE, echo=FALSE, crop=NULL, out.width = "200px", dpi=65----
tbl <- samplesMeasuredMissing(se)
partial_bundle(barplotSamplesMeasuredMissing(tbl, measured = TRUE))

## ----histFeature_measured, eval=TRUE, echo=FALSE, message=FALSE, warning=FALSE, crop=NULL, out.width = "200px", dpi=65----
partial_bundle(histFeature(assay(se), measured = TRUE))

## ----histFeature_missing, eval=FALSE, echo=FALSE, message=FALSE, warning=FALSE, crop=NULL, out.width = "200px", dpi=65----
# partial_bundle(histFeature(assay(se), measured = FALSE))

## ----histFeatureCategory, eval=TRUE, echo=FALSE, message=FALSE, warning=FALSE, crop=NULL, out.width = "200px", dpi=65----
partial_bundle(histFeatureCategory(se, measured = TRUE, category = "tissue"))

## ----upsetmeasured, eval=TRUE, echo=FALSE, crop=NULL, out.width = "200px", dpi=65----
upsetCategory(se, category = "tissue", measured = TRUE)

## ----upsetmissing, eval=FALSE, echo=FALSE, crop=NULL, out.width = "200px", dpi=65----
# upsetCategory(se, category = "tissue", measured = FALSE)

## ----session, eval=TRUE, echo=FALSE-------------------------------------------
sessionInfo()

#' @name createBoxplot
#'
#' @title Create a boxplot of (count/intensity) values per sample
#'
#' @description
#' The function \code{create_boxplot} creates a boxplot per sample for the 
#' intensity/count values.
#' 
#' @details
#' Internal usage in \code{shinyQC}.
#'
#' @param se \code{SummarizedExperiment} containing the (count/intensity) values 
#' in the \code{assay} slot
#' @param orderCategory \code{character}, one of \code{colnames(colData(se))}
#' @param title \code{character} or \code{numeric} of \code{length(1)}
#' @param log \code{logical}, if \code{TRUE} (count/intensity) values are 
#' displayed as log values
#' @param violin \code{logical}, if \code{FALSE} a boxplot is created, if 
#' \code{TRUE} a violin plot is created
#'
#' @examples
#' ## create se
#' a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
#'     dimnames = list(seq_len(10), paste("sample", seq_len(10))))
#' a[c(1, 5, 8), seq_len(5)] <- NA
#' set.seed(1)
#' a <- a + rnorm(100)
#' cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
#' rD <- data.frame(spectra = rownames(a))
#' se <- SummarizedExperiment::SummarizedExperiment(assay = a, 
#'     rowData = rD, colData = cD)
#' 
#' createBoxplot(se, orderCategory = "name", title = "", log = TRUE, 
#'     violin = FALSE)
#' 
#' @return \code{gg} object from \code{ggplot2}
#' 
#' @importFrom dplyr left_join
#' @importFrom tidyr pivot_longer 
#' @importFrom tibble tibble as_tibble
#' @importFrom SummarizedExperiment assay
#' @importFrom ggplot2 ggplot aes geom_boxplot geom_violin sym
#' @importFrom ggplot2 scale_x_discrete theme element_text ggtitle xlab
#' @importFrom ggplot2 theme_classic
#' 
#' @export
createBoxplot <- function(se, orderCategory = colnames(colData(se)), 
    title = "", log = TRUE, violin = FALSE) {

    ## match arguments for order
    orderCategory <- match.arg(orderCategory)

    ## access the assay slot
    a <- SummarizedExperiment::assay(se)
    
    ## take log values if log = TRUE
    if (log) 
        if (any(a == 0, na.rm = TRUE)) {
            a <- log(a + 1)
        } else {
            a <- log(a)
        }
    
    ## access the colData slot and add the rownames as a new column to cD
    ## (will add the column "x5at1t1g161asy")
    cD <- se@colData |> as.data.frame()
    if ("x5at1t1g161asy" %in% colnames(cD))
        stop("Column name `x5at1t1g161asy` must not be duplicated")
    cD[["x5at1t1g161asy"]] <- rownames(cD)
    cD <- cD[, c("x5at1t1g161asy", orderCategory)]

    
    if (!violin) {
        ## calculate the values for the box length (this will be 
        ## substantially faster than using geom_boxplot to do the job):
        ## 
        ## the upper whisker is located at the mininum of the maximum value or 
        ## Q_3 + 1.5 IQR ( min(max(x), Q_3 + 1.5 * IQR) )
        ## the lower whisker is located at the maximum of the smallest value or 
        ## Q_1 - 1.5 IQR ( max(min(x), Q_1 - 1.5 * IQR) ),
        ## where IQR = Q_3 - Q_1 is the box length.
        a_quantiles <- apply(a, 2, quantile, c(0, 0.25, 0.5, 0.75, 1), 
            na.rm = TRUE)
        a_iqr <- a_quantiles["75%", ] - a_quantiles["25%", ]
        a_upper_whisker <- apply(rbind(
            a_quantiles["100%", ], a_quantiles["75%", ] + 1.5 * a_iqr), 2, min)
        a_lower_whisker <- apply(rbind(
            a_quantiles["0%", ], a_quantiles["25%", ] - 1.5 * a_iqr), 2, max)
        
        ## combine all the information
        a_l <- tibble::tibble(name = colnames(a_quantiles), 
            ymin = as.numeric(a_lower_whisker),
            lower = as.numeric(a_quantiles["25%", ]), 
            middle = as.numeric(a_quantiles["50%", ]), 
            upper = as.numeric(a_quantiles["75%", ]), 
            ymax = as.numeric(a_upper_whisker))
        
        ## get a list of outliers for each column, these will be the values that 
        ## are located above the upper whisker or below the lower whisker
        a_out <- lapply(seq_len(ncol(a)), function(cols_i) {
            a_cols_i <- a[, cols_i]
            a_cols_i <- a_cols_i[a_cols_i > a_upper_whisker[cols_i] | 
                a_cols_i < a_lower_whisker[cols_i]]
            a_cols_i <- as.numeric(a_cols_i)
            if (length(a_cols_i) > 0)
                data.frame(name = colnames(a)[cols_i], value = a_cols_i)
            else 
                data.frame(name = NULL, value = NULL)
        })
        a_out <- do.call("rbind", a_out)
        a_out <- tibble::as_tibble(a_out)
        
    } else { ## if violin == TRUE
        ## pivot_longer will create the columns name (containing the colnames 
        ## of a) and value (containing the actual values)
        a <- tibble::as_tibble(a) 
        a_l <- tidyr::pivot_longer(data = a, cols = seq_len(ncol(a)))
    }

    ## add another column that gives the order of plotting (will be factor)
    ## order alphabetically: combine the levels of the orderCategory and add 
    ## the name (to secure that the levels are unique)
    ## add another column for the x_values
    a_l <- dplyr::left_join(x = a_l, y = cD, 
        by = c("name" = "x5at1t1g161asy"), copy = TRUE)
    a_o <- paste(a_l[[orderCategory]], a_l[["name"]])
    a_o_u <- unique(a_o)
    a_l[["x_ggplot_vals"]] <- factor(x = a_o, levels = sort(a_o_u))
    
    ## do the actual plotting
    if (!violin) { 
        
        g <- ggplot2::ggplot(a_l, 
                ggplot2::aes(x = !!ggplot2::sym("x_ggplot_vals"))) +
            ggplot2::geom_boxplot(ggplot2::aes(ymin = !!ggplot2::sym("ymin"), 
                lower = !!ggplot2::sym("lower"), 
                middle = !!ggplot2::sym("middle"), 
                upper = !!ggplot2::sym("upper"), 
                ymax = !!ggplot2::sym("ymax")), stat = "identity") 
        
        if (nrow(a_out) > 0) {
            ## add x-axis order to outliers data set
            a_out <- dplyr::left_join(x = a_out, y = cD, 
                by = c("name" = "x5at1t1g161asy"), copy = TRUE)
            a_out_o <- paste(a_out[[orderCategory]], a_out[["name"]])
            a_out[["x_ggplot_vals"]] <- factor(x = a_out_o, 
                levels = sort(a_o_u))
            g <- g + geom_point(
                ggplot2::aes(x = !!ggplot2::sym("x_ggplot_vals"), 
                    y = !!ggplot2::sym("value")), 
                data = a_out)    
        }
        
    } else { ## violin == TRUE
        g <- ggplot2::ggplot(a_l, 
            ggplot2::aes(y = !!ggplot2::sym("value"), 
                x = !!ggplot2::sym("x_ggplot_vals"))) +
            ggplot2::geom_violin()
    }
    
    g + ggplot2::scale_x_discrete(
            labels = unique(a_l[["name"]])[order(a_o_u)]) +
        ggplot2::theme_classic() +
        ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90)) + 
        ggplot2::ggtitle(title) + ggplot2::xlab("samples")   
}

#' @name driftPlot
#' 
#' @title Plot the trend line for aggregated values
#' 
#' @description 
#' The function \code{driftPlot} aggregates the (count/intensity) values from 
#' the \code{assay()} slot of a \code{SummarizedExperiment} by the \code{median} 
#' or \code{sum} of the (count/intensity) values. \code{driftPlot} then 
#' visualizes these aggregated values and adds a trend line (using either 
#' LOESS or a linear model) from (a subset of) the aggregated values. The 
#' subset is specified by the arguments \code{category} and \code{level}.
#' 
#' @details 
#' The x-values are sorted according to the \code{orderCategory} argument: The 
#' levels of the corresponding column in \code{colData(se)} are pasted with the 
#' sample names (in the column \code{name}) and factorized.
#' Internal usage in \code{shinyQC}.
#' 
#' @param se \code{SummarizedExperiment}
#' @param aggregation \code{character}, type of aggregation of (count/intensity) 
#' values
#' @param category \code{character}, column of \code{colData(se)}
#' @param orderCategory \code{character}, column of \code{colData(se)}
#' @param level \code{character}, from which samples should the LOESS curve be
#' calculated, either \code{"all"} or one of the levels of the selected columns
#' of \code{colData(se)} (\code{"category"}) 
#' @param method \code{character}, either \code{"loess"} or \code{"lm"}
#' 
#' @return \code{gg} object from \code{ggplot2}
#' 
#' @examples 
#' #' ## create se
#' set.seed(1)
#' a <- matrix(rnorm(1000), nrow = 10, ncol = 100, 
#'     dimnames = list(seq_len(10), paste("sample", seq_len(100))))
#' a[c(1, 5, 8), seq_len(5)] <- NA
#' cD <- data.frame(name = colnames(a), type = c(rep("1", 50), rep("2", 50)))
#' rD <- data.frame(spectra = rownames(a))
#' se <- SummarizedExperiment::SummarizedExperiment(assay = a, 
#'     rowData = rD, colData = cD)
#' 
#' driftPlot(se, aggregation = "sum", category = "type", 
#'     orderCategory = "type", level = "1", method = "loess")
#' 
#' @importFrom dplyr across left_join summarise starts_with
#' @importFrom tidyr pivot_longer 
#' @importFrom stats median
#' @importFrom SummarizedExperiment assay
#' @importFrom ggplot2 ggplot aes geom_point geom_smooth theme_classic sym
#' @importFrom ggplot2 scale_color_manual scale_x_discrete xlab ylab theme
#' @importFrom ggplot2 element_text
#' @importFrom plotly ggplotly style 
#' @importFrom rlang .data
#' 
#' @export
driftPlot <- function(se, aggregation = c("median", "sum"), 
        category = colnames(colData(se)), orderCategory = colnames(colData(se)), 
        level = c("all", unique(colData(se)[, category])),
        method = c("loess", "lm")) {

    aggregation <- match.arg(aggregation)
    category <- match.arg(category)
    category <- make.names(category)
    orderCategory <- match.arg(orderCategory)
    orderCategory <- make.names(orderCategory)
    level <- match.arg(level, 
        choices = c("all", unique(as.character(colData(se)[, category]))))
    method <- match.arg(method)
    
    ## access the assay slot
    a <- SummarizedExperiment::assay(se)
    
    ## access the colData slot and add the rownames as a new column to cD
    ## (will add the column "x5at1t1g161asy")
    cD <- se@colData |> as.data.frame()
    colnames(cD) <- make.names(colnames(cD))
    if ("x5at1t1g161asy" %in% colnames(cD))
        stop("Column name `x5at1t1g161asy` must not be duplicated")
    cD[["x5at1t1g161asy"]] <- rownames(cD)

    a_l <- a |>
        as.data.frame() |>
        tidyr::pivot_longer(cols = seq_len(ncol(a)))

    if (aggregation == "median") FUN <- median
    if (aggregation == "sum") FUN <- sum

    ## aggregate the values across the samples
    a_l <- dplyr::group_by(.data = a_l, .data$name)
    a_l <- dplyr::summarise(a_l, 
        dplyr::across(dplyr::starts_with("value"), FUN, na.rm = TRUE))

    ## join with cD
    tbl <- dplyr::left_join(a_l, cD, 
        by = c("name" = "x5at1t1g161asy"), copy = TRUE)
    tbl[["col_ggplot_points"]] <- "all"
    tbl[["name"]] <- factor(tbl[["name"]], sort(tbl[["name"]]))
    tbl_c <- tbl[[category]]

    ## add another column that gives the order of plotting (will be factor)
    ## order alphabetically: combine the levels of the orderCategory and add 
    ## the name (to secure that the levels are unique)
    ## add another column for the x_values
    tbl_o <- tbl[[orderCategory]]
    tbl_o_n <- paste(tbl_o, tbl[["name"]])
    tbl[["x_ggplot_vals"]] <- factor(tbl_o_n, sort(tbl_o_n))

    ## create a separate data.frame which only contains the level or "all"
    if (level == "all") {
        tbl_subset <- tbl
    } else {
        tbl_subset <- tbl[tbl_c == level, ]
    }
    tbl_subset[["col_ggplot_points"]] <- "subset"

    ## create another column which converts factors into numeric (needed for 
    ## geom_smooth)
    tbl_subset[["x_ggplot_vals_num"]] <- as.numeric(
        tbl_subset[["x_ggplot_vals"]])

    g <- ggplot2::ggplot(tbl,
            ggplot2::aes(x = !!ggplot2::sym("x_ggplot_vals"), 
                y = !!ggplot2::sym("value"), 
                col = !!ggplot2::sym("col_ggplot_points"))) + 
        suppressWarnings(
            ggplot2::geom_point(ggplot2::aes(text = !!ggplot2::sym("name")))) + 
        ggplot2::geom_point(data = tbl_subset, 
            ggplot2::aes(x = !!ggplot2::sym("x_ggplot_vals"), 
                y = !!ggplot2::sym("value"), 
                col = !!ggplot2::sym("col_ggplot_points"))) + 
        ggplot2::geom_smooth(data = tbl_subset, 
            ggplot2::aes(x = !!ggplot2::sym("x_ggplot_vals_num"), 
                y = !!ggplot2::sym("value")), 
            method = method) +
        ggplot2::theme_classic() + 
        ggplot2::scale_color_manual(values = c("#000000", "#2A6CEF")) +
        ggplot2::scale_x_discrete(
            labels = tbl[["name"]][order(tbl[["x_ggplot_vals"]])]) +
        ggplot2::xlab("samples") + 
        ggplot2::ylab(paste(aggregation, "of values")) +
        ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90), 
            legend.position = "none")
    g <- plotly::ggplotly(g, tooltip = c("text"))
    g |> plotly::style(hoveron = "fills", traces = 2)
}


#' @name cv 
#' 
#' @title Calculate coefficient of variation
#' 
#' @description 
#' The function \code{cv} calculates the coefficient of variation from columns  
#' of a matrix. The coefficients of variation are calculated according to the 
#' formula \code{sd(y) / mean(y) * 100} with \code{y} the column values, thus,
#' the function returns the coefficient of variation in percentage.
#' 
#' @details
#' The function returned a named \code{list} (the name is specified by the 
#' \code{name} argument) containing the coefficient of variation of the 
#' columns of \code{x}.
#' 
#' @param x \code{matrix}
#' @param name \code{character}, the name of the returned list
#' 
#' @return \code{list}
#' 
#' @examples
#' x <- matrix(seq_len(10), ncol = 2)
#' cv(x)
#' 
#' @importFrom stats sd
#' 
#' @export
cv <- function(x, name = "raw") {
    
    sd_v <- apply(x, 2, stats::sd, na.rm = TRUE)
    mean_v <- apply(x, 2, mean, na.rm = TRUE)
    cv_v <- sd_v / mean_v * 100
    
    ## create a named list and return the list
    cv_v <- list(cv_v)
    names(cv_v) <- name
    cv_v
}

#' @name plotCV
#' 
#' @title Plot CV values
#' 
#' @description 
#' The function \code{plotCV} displays the coefficient of variation values of 
#' set of values supplied in a \code{data.frame} object. The function will 
#' create a plot using the \code{ggplot2} package and will print the values 
#' in the different columns in different colors.
#' 
#' @details 
#' Internal usage in \code{shinyQC}.
#' 
#' @param df \code{data.frame} containing one or multiple columns containing 
#' the coefficients of variation
#' 
#' @examples
#' x1 <- matrix(seq_len(10), ncol = 2)
#' x2 <- matrix(seq(11, 20), ncol = 2)
#' x3 <- matrix(seq(21, 30), ncol = 2)
#' x4 <- matrix(seq(31, 40), ncol = 2)
#' 
#' ## calculate cv values
#' cv1 <- cv(x1, "x1")
#' cv2 <- cv(x2, "x2")
#' cv3 <- cv(x3, "x3")
#' cv4 <- cv(x4, "x4")
#' 
#' df <- data.frame(cv1, cv2, cv3, cv4)
#' plotCV(df)
#' 
#' @return \code{gg} object from \code{ggplot2}
#' 
#' @importFrom tidyr pivot_longer
#' @importFrom ggplot2 ggplot aes geom_point geom_line xlab ylab sym
#' @importFrom ggplot2 theme_bw theme element_text
#' @export
plotCV <- function(df) {
    
    ## add a sample column
    if (!is.data.frame(df)) stop("df is not a data.frame")
    df[["sample"]] <- rownames(df)
    df[["sample"]] <- factor(x = df[["sample"]], levels = df[["sample"]])
    df <- tidyr::pivot_longer(df, cols = seq_len((ncol(df) - 1)))
    
    ggplot2::ggplot(df, ggplot2::aes(x = !!ggplot2::sym("sample"), 
            y = !!ggplot2::sym("value"))) + 
        ggplot2::geom_point(ggplot2::aes(color = !!ggplot2::sym("name"))) + 
        ggplot2::geom_line(ggplot2::aes(group = !!ggplot2::sym("name"), 
            color = !!ggplot2::sym("name"))) + 
        ggplot2::xlab("sample") + 
        ggplot2::ylab("coefficient of variation (in %)") + 
        ggplot2::theme_bw() + 
        ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90))
}

#' @name ECDF
#'
#' @title Create ECDF plot of a sample against a reference
#'
#' @description
#' The function \code{ECDF} creates a plot of the empirical cumulative 
#' distribution function of a specified sample and an outgroup (reference). 
#' The reference is specified by the \code{group} argument. The row-wise 
#' (feature) mean values of the reference are calculated after excluding 
#' the specified \code{sample}.
#'
#' @details 
#' Internal use in \code{shinyQC}. 
#' 
#' The function \code{ECDF} uses the \code{ks.test} function from \code{stats} 
#' to perform a two-sample Kolmogorov-Smirnov test. The Kolmogorov-Smirnov 
#' test is run with the alternative \code{"two.sided"}
#' (null hypothesis is that the true distribution function of the 
#' \code{sample} is equal to the hypothesized distribution function of the 
#' \code{group}).
#' 
#' The \code{exact} argument in \code{ks.test} is set to \code{NULL}, meaning 
#' that an exact p-value is computed if the product of the sample sizes is 
#' less than 10000 of \code{sample} and \code{group}. Otherwise, asymptotic 
#' distributions are used whose approximations might be inaccurate in low 
#' sample sizes.
#' 
#' @param se \code{SummarizedExperiment} object
#' @param sample \code{character}, name of the sample to compare against the 
#' group
#' @param group \code{character}, either \code{"all"} or one of 
#' \code{colnames(colData(se))}
#' 
#' @examples
#' ## create se
#' set.seed(1)
#' a <- matrix(rnorm(1000), nrow = 100, ncol = 10, 
#'     dimnames = list(seq_len(100), paste("sample", seq_len(10))))
#' a[c(1, 5, 8), seq_len(5)] <- NA
#' cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
#' rD <- data.frame(spectra = rownames(a))
#' se <- SummarizedExperiment(assay = a, rowData = rD, colData = cD)
#' 
#' ECDF(se, sample = "sample 1", group = "all")
#' 
#' @importFrom SummarizedExperiment assay
#' @importFrom stats ks.test
#' @importFrom ggplot2 ggplot aes sym stat_ecdf theme_bw xlab ylab
#' @importFrom ggplot2 ggtitle theme element_blank
#' 
#' @return \code{gg} object from \code{ggplot2}
#' 
#' @export
ECDF <- function(se, sample = colnames(se), 
    group = c("all", colnames(colData(se)))) {

    ## match arguments
    sample <- match.arg(sample)
    group <- match.arg(group)
    group <- make.names(group)
    
    ## access the assay slot
    a <- SummarizedExperiment::assay(se)
    
    ## access the colData slot and add the rownames as a new column to cD
    ## (will add the column "x5at1t1g161asy")
    cD <- se@colData |> as.data.frame()
    colnames(cD) <- make.names(colnames(cD))
    if ("x5at1t1g161asy" %in% colnames(cD))
        stop("Column name `x5at1t1g161asy` must not be duplicated")
    cD[["x5at1t1g161asy"]] <- rownames(cD)
    
    df <- data.frame(value = a[, sample], type = sample)
    
    ## calculate sample-wise the values
    ## get indices 
    inds_l <- colnames(a) == sample
    inds_nl <- !inds_l
    
    ## truncate the indices based on the group (only use the group for the 
    ## comparison and the "outgroup")
    if (group != "all") {
        g <- cD[cD[, "x5at1t1g161asy"] == sample, group]
        inds_nl <- inds_nl & cD[, group] == g
    }
    
    rM <- rowMeans(a[, inds_nl], na.rm = TRUE)
    df_group <- data.frame(value = rM, type = "group")
    
    ## remove from df that contains the sample values and from df_group the 
    ## features that have in any of df/df_group NA values
    inds <- !(is.na(df_group$value) |  is.na(df$value))
    df <- df[inds, ]
    df_group <- df_group[inds, ]
    
    ## calculate KS statistic of data
    value_s <- df[["value"]]
    value_g <- df_group[["value"]]
    ks_test <- stats::ks.test(x = value_s, y = value_g, exact = NULL, 
        alternative = "two.sided")
    
    ## bind together
    df <- rbind(df, df_group)

    ggplot2::ggplot(df, 
        ggplot2::aes(x = !!ggplot2::sym("value"), 
            color = !!ggplot2::sym("type"), group = !!ggplot2::sym("type"))) + 
        ggplot2::stat_ecdf(linewidth = 1) + ggplot2::theme_bw() + 
        ggplot2::xlab(sample) + ggplot2::ylab("ECDF") +
        ggplot2::ggtitle(sprintf("K-S Test: D: %s, p-value: %s", 
            signif(ks_test$statistic, 3), 
            signif(ks_test$p.value, 3))) + 
        ggplot2::theme(legend.title = ggplot2::element_blank(), 
            legend.position ="top")
}

#' @name distShiny
#'
#' @title Create distance matrix from numerical matrix
#'
#' @description
#' The function \code{distShiny} takes as an input a numerical \code{matrix} or
#' \code{data.frame} and returns the distances between the rows and columns
#' based on the defined \code{method} (e.g. euclidean distance). 
#' 
#' @details 
#' Internal use in \code{shinyQC}.
#'
#' @param x \code{matrix} or \code{data.frame} with samples in columns and 
#' features in rows
#' @param method \code{character}, method for distance calculation
#'
#' @examples
#' x <- matrix(seq_len(100), nrow = 10, ncol = 10, 
#'         dimnames = list(seq_len(10), paste("sample", seq_len(10))))
#' distShiny(x = x)
#' 
#' @return \code{matrix}
#' 
#' @importFrom stats dist
#'
#' @export
distShiny <- function(x, method = "euclidean") {
    ## calculate the distance matrix
    d <- stats::dist(t(x), method = method, diag = TRUE)
    data.matrix(d)
}

#' @name distSample
#'
#' @title  Create a heatmap using distance information between samples
#' 
#' @description 
#' The function \code{distSample} creates a heatmap from a distance matrix 
#' created by the function \code{distShiny}. The heatmap is annotated by the 
#' column specified by the \code{label} column in \code{colData(se)}.
#' 
#' @details 
#' Internal use in \code{shinyQC}
#'
#' @param d \code{matrix} containing distances, obtained from \code{distShiny}
#' @param se \code{SummarizedExperiment}
#' @param label \code{character}, refers to a column in \code{colData(se)}
#' @param title \code{character}
#' @param ... further arguments passed to \code{ComplexHeatmap::Heatmap}
#'
#' @examples
#' ## create se
#' a <- matrix(seq_len(100), nrow = 10, ncol = 10,
#'             dimnames = list(seq_len(10), paste("sample", seq_len(10))))
#' a[c(1, 5, 8), seq_len(5)] <- NA
#' set.seed(1)
#' a <- a + rnorm(100)
#' a_i <- imputeAssay(a, method = "MinDet")
#' cD <- data.frame(name = colnames(a_i),
#'     type = c(rep("1", 5), rep("2", 5)))
#' rD <- data.frame(spectra = rownames(a_i))
#' se <- SummarizedExperiment::SummarizedExperiment(assay = a_i, rowData = rD,
#'     colData = cD)
#' 
#' dist <- distShiny(a_i)
#' distSample(dist, se, label = "type", title = "imputed", 
#'     show_row_names = TRUE)
#'
#' @return \code{Heatmap} object from \code{ComplexHeatmap}
#'
#' @importFrom ComplexHeatmap HeatmapAnnotation Heatmap
#' @importFrom grDevices hcl.colors
#' @importFrom stats setNames as.dist
#'
#' @export
distSample <- function(d, se, label = "name", title = "raw", ...) {
    
    ## create the annotation, use here the colData, get the column label in 
    ## colData
    val <- se@colData[[label]]
    val_u <- unique(val)
    df <- data.frame(x = val)
    colnames(df) <- label
    l <- list(stats::setNames(grDevices::hcl.colors(n = length(val_u)), val_u))
    names(l) <- label
    
    ## set default arguments for ComplexHeatmap::Heatmap
    top_annotation <- ComplexHeatmap::HeatmapAnnotation(df = df, col = l)
    show_column_names <- FALSE
    args_default <- list(matrix = d, 
        clustering_distance_rows = function(x) stats::as.dist(x),
        clustering_distance_columns = function(x) stats::as.dist(x),
        top_annotation = top_annotation,
        name = "distances", column_title = title,
        show_column_names = show_column_names)

    ## write the ellipsis to args
    args <- list(...)
    args_default[names(args)] <- args

    ## call the ComplexHeatmap::Heatmap function
    do.call(what = ComplexHeatmap::Heatmap, args = args_default)
}

#' @name sumDistSample
#'
#' @title Plot the sum of distances to other samples
#'
#' @description 
#' The function \code{sumDistSample} creates a plot showing the sum of distance 
#' of a sample to other samples. 
#'
#' @param d \code{matrix} containing distances, obtained from \code{distShiny}
#' @param title \code{character} specifying the title to be added to the plot
#' 
#' @examples
#' a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
#'             dimnames = list(seq_len(10), paste("sample", seq_len(10))))
#' dist <- distShiny(a)
#' 
#' sumDistSample(dist, title = "raw")
#'
#' @return \code{gg} object from \code{ggplot2}
#'
#' @importFrom ggplot2 ggplot aes sym geom_point geom_segment ggtitle
#' @importFrom ggplot2 xlab ylab theme_classic theme element_blank
#' @importFrom tibble tibble
#' @importFrom plotly ggplotly
#'
#' @export
sumDistSample <- function(d, title = "raw") {
    d_sum <- rowSums(d) 
    tbl <- tibble::tibble(name = names(d_sum), distance = d_sum)
    g <- ggplot2::ggplot(tbl, ggplot2::aes(x = !!ggplot2::sym("distance"), 
            y = !!ggplot2::sym("name"))) + 
        ggplot2::geom_point(size = 0.5) + 
        ggplot2::geom_segment(ggplot2::aes(xend = 0, 
            yend = !!ggplot2::sym("name")), 
            linewidth = 0.1) + 
        ggplot2::ggtitle(title) +
        ggplot2::xlab("sum of distances") + ggplot2::ylab("") + 
        ggplot2::theme_classic()
    
    plotly::ggplotly(g, tooltip = c("x", "y"))
}

#' @name MAvalues
#'
#' @title Create values (M and A) for MA plot
#'
#' @description 
#' The function \code{MAvalues} will create MA values as input for the function 
#' \code{MAplot} and \code{hoeffDValues}. 
#' \code{M} and \code{A} are specified relative to specified samples which 
#' is determined by the \code{group} argument. In case of \code{group == "all"}, 
#' all samples (expect the specified one) are taken for the reference 
#' calculation. In case of \code{group != "all"} will use the samples belonging 
#' to the same group given in \code{colnames(colData(se))} expect the 
#' specified one. 
#'
#' @param se \code{SummarizedExperiment}
#' @param log2 \code{logical}, specifies if values are 
#' \code{log2}-transformed prior to calculating M and A values. 
#' If the values are already transformed, \code{log2} should be set to 
#' \code{FALSE}. If \code{log2 = TRUE} and if there are values in 
#' \code{assay(se)} that are 0, the \code{log2} values are calculated by
#' \code{log2(assay(se) + 1)}
#' @param group \code{character}, either \code{"all"} or one of 
#' \code{colnames(colData(se))}
#'
#' @return \code{tbl} with columns \code{Feature}, \code{name} (sample name), 
#' \code{A}, \code{M} and additional columns of \code{colData(se)}
#' 
#' @examples
#' ## create se
#' set.seed(1)
#' a <- matrix(rnorm(10000), nrow = 1000, ncol = 10, 
#'             dimnames = list(seq_len(1000), paste("sample", seq_len(10))))
#' a[c(1, 5, 8), seq_len(5)] <- NA
#' cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
#' rD <- data.frame(spectra = rownames(a))
#' se <- SummarizedExperiment(assay = a, rowData = rD, colData = cD)
#' 
#' MAvalues(se, log = FALSE, group = "all")
#' 
#' @importFrom dplyr left_join
#' @importFrom SummarizedExperiment assay colData
#' @importFrom tibble as_tibble add_column tibble rownames_to_column
#' @importFrom tidyr pivot_longer
#' 
#' @export
MAvalues <- function(se, log2 = TRUE, group = c("all", colnames(colData(se)))) {
    
    ## check arguments group
    group <- match.arg(group)
    
    ## access the assay slot
    a <- SummarizedExperiment::assay(se)
    
    ## access the colData slot and add the rownames as a new column to cD
    ## (will add the column "x5at1t1g161asy")
    cD <- se@colData |> as.data.frame()
    if ("x5at1t1g161asy" %in% colnames(cD))
        stop("Column name `x5at1t1g161asy` must not be duplicated")
    cD[["x5at1t1g161asy"]] <- rownames(cD)
    
    if (ncol(a) < 2)
        stop("MAplot needs more than one samples")
    
    ## take logarithm of assay values if the values are not transformed yet
    if (log2) {
        if (any(a == 0, na.rm = TRUE)) {
            a <- log2(a + 1)
        } else {
            a <- log2(a)   
        }
    }
    
    ## calculate sample-wise the M and A values (iterate through the columns)
    A <- M <- matrix(NA, nrow = nrow(a), ncol = ncol(a),
        dimnames = list(rownames(a), colnames(a)))
    
    ## calculate sample-wise the values (iterate through the columns)
    for (sample_i in colnames(a)) {
        
        ## get indices
        inds_nl <- colnames(a) != sample_i
        
        ## truncate the indices based on the group (only use the group for the 
        ## comparison and the "outgroup")
        if (group != "all") {
            g <- cD[cD[["x5at1t1g161asy"]] == sample_i, group]
            inds_nl <- inds_nl & cD[, group] == g
        }
        rM <- rowMeans(a[, inds_nl], na.rm = TRUE)
        M[, sample_i] <- a[, sample_i] - rM
        A[, sample_i] <- 0.5 * (a[, sample_i] + rM)
    }
    
    ## combine the data and add additional information from colData
    M <- M |> 
        tibble::as_tibble(M, rownames = "Feature") |>
        tidyr::pivot_longer(cols = 2:(ncol(a) + 1), values_to = "M")
    A <- A |>
        tibble::as_tibble(A, rownames = "Feature") |>
        tidyr::pivot_longer(cols = 2:(ncol(a) + 1), values_to = "A")
    
    ## combine A and M
    tibble::tibble(A, M = M$M) |>
        dplyr::left_join(y = cD, by = c("name" = "x5at1t1g161asy"))
}

#' @name hoeffDValues
#' 
#' @title Create values of Hoeffding's D statistics from M and A values
#' 
#' @description 
#' The function creates and returns Hoeffding's D statistics values 
#' from MA values. 
#' 
#' In case \code{sample_n} is set to a numerical value (e.g. 10000), a 
#' random subset containing \code{sample_n} is taken to calculate Hoeffding's D 
#' values to speed up the calculation. In case there are less features
#' than \code{sample_n}, all features are taken.
#'
#' @details 
#' The function uses the function \code{hoeffd} from the \code{Hmisc} package to 
#' calculate the values.
#'
#' @param tbl \code{tibble}, as obtained from the function \code{MAvalues}
#' @param name \code{character(1)}, name of the returned list
#' @param sample_n \code{numeric(1)}, number of features (subset) to be 
#' taken for calculation of Hoeffding's D values 
#' 
#' @examples
#' ## create se
#' a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
#'             dimnames = list(seq_len(10), paste("sample", seq_len(10))))
#' a[c(1, 5, 8), seq_len(5)] <- NA
#' set.seed(1)
#' a <- a + rnorm(100)
#' cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
#' rD <- data.frame(spectra = rownames(a))
#' se <- SummarizedExperiment::SummarizedExperiment(assay = a, 
#'     rowData = rD, colData = cD)
#' 
#' tbl <- MAvalues(se)
#' hoeffDValues(tbl, "raw")
#' 
#' ## normalized values
#' se_n <- se
#' assay(se_n) <- normalizeAssay(a, "sum")
#' tbl_n <- MAvalues(se_n, group = "all")
#' hoeffDValues(tbl_n, "normalized")
#'
#' ## transformed values
#' se_t <- se
#' assay(se_t) <- transformAssay(a, "log")
#' tbl_t <- MAvalues(se_t, group = "all")
#' hoeffDValues(tbl_t, "transformed")
#'
#' @importFrom Hmisc hoeffd
#' @importFrom tidyr pivot_wider
#' @importFrom dplyr mutate group_by summarise pull
#'
#' @return named list with Hoeffding's D values per sample
#' 
#' @export
hoeffDValues <- function(tbl, name = "raw", sample_n = NULL) {
    
    ## for bigger datasets the calculaton of Hoeffding's values is not
    ## efficient, create a random subset of the features to calculate 
    ## Hoeffding's D values (e.g. 10000 features)
    ## in case there are less features than sample_n, all features are taken
    unique_features <- unique(tbl$Feature)
    if (!is.numeric(sample_n)) sample_n <- length(unique_features)
    min_features <- min(length(unique_features), sample_n)
    features <- sample(unique_features, size = min_features, replace = FALSE)
    tbl <- tbl[tbl$Feature %in% features, ]
         
    ## create a wide tibble with the samples as columns and features as rows 
    ## for A and M values
    A <- tidyr::pivot_wider(tbl, id_cols = "Feature", values_from = "A", 
        names_from = "name")
    M <- tidyr::pivot_wider(tbl, id_cols = "Feature", values_from = "M", 
        names_from = "name")
    
    ## create the D statistic between M and A values, 
    ## only return these comparisons (not A vs. A and M vs. M, i.e. index 
    ## by [2, 1])
    hd_l <- dplyr::mutate(tbl, name = factor(name, levels = unique(name))) |>
        dplyr::group_by(name) |>
        dplyr::summarise(hd_l = Hmisc::hoeffd(A, M)$D[2, 1]) 
    hd_l <- hd_l$hd_l
    
    ## assign the names (do not use the first column since it contains the 
    ## Feature names)
    names(hd_l) <- colnames(A)[-1]
    
    ## create a list containing the named numeric and return the named list of
    ## these values
    l <- list(hd_l)
    names(l) <- name
    
    l
}

#' @name hoeffDPlot
#' 
#' @title Create a plot from a list of Hoeffding's D values
#' 
#' @description 
#' The function \code{hoeffDPlot} creates via \code{ggplot} a violin plot per 
#' factor, a jitter plot of the data points and (optionally) connects the points
#' via lines. \code{hoeffDPlot} uses the \code{plotly} package to make the 
#' figure interactive.
#' 
#' @details 
#' The function \code{hoeffDPlot} will create the violin plot and jitter plot 
#' according to the specified order given by the colnames of \code{df}. 
#' \code{hoeffDPlot} will thus internally refactor the \code{colnames} of the 
#' supplied \code{data.frame} according to the order of the \code{colnames}. 
#' 
#' @param df \code{data.frame} containing one or multiple columns containing the 
#' Hoeffding's D statistics
#' @param lines \code{logical}, should points belonging to the same sample be 
#' connected
#'
#' @examples
#' ## create se
#' set.seed(1)
#' a <- matrix(rnorm(10000), nrow = 1000, ncol = 10, 
#'             dimnames = list(seq_len(1000), paste("sample", seq_len(10))))
#' a[c(1, 5, 8), seq_len(5)] <- NA
#' cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
#' rD <- data.frame(spectra = rownames(a))
#' se <- SummarizedExperiment::SummarizedExperiment(assay = a, 
#'     rowData = rD, colData = cD)
#' 
#' tbl <- MAvalues(se, log = FALSE, group = "all")
#' hd_r <- hoeffDValues(tbl, "raw")
#' 
#' ## normalized values
#' se_n <- se
#' assay(se_n) <- normalizeAssay(a, "sum")
#' tbl_n <- MAvalues(se_n, log = FALSE, group = "all")
#' hd_n <- hoeffDValues(tbl_n, "normalized")
#' 
#' df <- data.frame(raw = hd_r, normalized = hd_n)
#' hoeffDPlot(df, lines = TRUE)
#' hoeffDPlot(df, lines = FALSE)
#' 
#' @return \code{gg} object from \code{ggplot2}
#' 
#' @importFrom tidyr pivot_longer
#' @importFrom dplyr mutate
#' @importFrom ggplot2 ggplot geom_violin geom_point aes sym geom_line
#' @importFrom ggplot2 ylab theme_classic theme
#' @importFrom plotly ggplotly
#' 
#' @export
hoeffDPlot <- function(df, lines = TRUE) {
    
    ## set lines to FALSE if only one list is supplied
    if (ncol(df) == 1) lines <- FALSE
    
    ## obtain the supplied order
    cols <- colnames(df)
    
    ## add the sample names as a column and create a long format of the df
    df <- data.frame(sample = rownames(df), df)
    df <- tidyr::pivot_longer(df, cols = 2:ncol(df), 
        names_to = "processing_step")
    
    ## refactor the names according to the supplied order (cols)
    names_f <- factor(dplyr::pull(df,"processing_step"), cols)
    df <- dplyr::mutate(df, processing_step = names_f, x = as.numeric(names_f))

    df$x_jitter <- jitter(df$x)
    # ## do the actual plotting
    g <- ggplot2::ggplot(df) + 
        ggplot2::geom_violin(
            ggplot2::aes(x = !!ggplot2::sym("processing_step"), 
                y = !!ggplot2::sym("value")), 
            na.rm = TRUE) + 
        suppressWarnings(
            ggplot2::geom_point(
                ggplot2::aes(x = !!ggplot2::sym("x_jitter"), 
                    y = !!ggplot2::sym("value"), 
                    color = !!ggplot2::sym("processing_step"), 
                    text = !!ggplot2::sym("sample"))))
    if (lines) g <- g + ggplot2::geom_line(
        ggplot2::aes(x = !!ggplot2::sym("x_jitter"), 
            y = !!ggplot2::sym("value"), group = !!ggplot2::sym("sample")))
    g <- g + ggplot2::ylab("Hoeffding's D statistic") + 
        ggplot2::xlab("processing step") + ggplot2::theme_classic() +
        ggplot2::theme(legend.position = "none")
    plotly::ggplotly(g, tooltip = c("text", "y"))
}

#' @name MAplot
#'
#' @title Create a MA plot
#'
#' @description 
#' The function creates a 2D histogram of M and A values.
#' 
#' @details 
#' \code{MAplot} returns a 2D hex histogram instead of a classical scatterplot 
#' due to computational reasons and better visualization of overlaying points.
#' The argument \code{plot} specifies the sample (refering to 
#' \code{colData(se)$name}) to be plotted. If \code{plot = "all"}, MA values 
#' for all samples will be plotted (samples will be plotted in facets). 
#' If the number of features (\code{tbl$Features}) is below 1000, points will be 
#' plotted (via \code{geom_points}), otherwise hexagons will be plotted
#' (via \code{geom_hex}).
#'
#' @param tbl \code{tibble} containing the M and A values, as obtained from the 
#' \code{MAvalues} function
#' @param group \code{character}, one of \code{colnames(colData(se))} 
#' (\code{se} used in \code{MAvalues}) or \code{"all"}
#' @param plot \code{character}, one of \code{colData(se)$name} (\code{se} 
#' used in \code{MAvalues}) or \code{"all"}
#'
#' @return \code{gg} object from \code{ggplot2}
#'
#' @examples
#' ## create se
#' set.seed(1)
#' a <- matrix(rnorm(10000), nrow = 1000, ncol = 10,
#'             dimnames = list(seq_len(1000), paste("sample", seq_len(10))))
#' a[c(1, 5, 8), seq_len(5)] <- NA
#' cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
#' rD <- data.frame(spectra = rownames(a))
#' se <- SummarizedExperiment::SummarizedExperiment(assay = a,
#'     rowData = rD, colData = cD)
#'
#' tbl <- MAvalues(se, log = FALSE, group = "all")
#' MAplot(tbl, group = "all", plot = "all")
#'
#' @importFrom dplyr pull filter
#' @importFrom ggplot2 ggplot aes geom_hex geom_point facet_wrap sym
#' @importFrom ggplot2 theme coord_fixed xlim ylim theme_bw
#' @importFrom stats formula
#' 
#' @export
MAplot <- function(tbl, group = c("all", colnames(tbl)), 
    plot = c("all", unique(tbl[["name"]]))) {
    
    group <- match.arg(group)
    
    if (!all(plot %in% c("all", unique(tbl$name)))) {
        stop("plot not in 'all' or 'unique(tbl$name)'")
    }
    
    ## get the number of features (this will govern if points will be plotted
    ## or hexagons)
    n <- tbl[["Feature"]]
    n <- unique(n)
    n <- length(n)

    A <- tbl[["A"]]
    M <- tbl[["M"]]
    x_lim <- c(min(A, na.rm = TRUE), max(A, na.rm = TRUE))
    x_lim <- ifelse(is.infinite(x_lim), NA, x_lim)
    y_lim <- c(min(M, na.rm = TRUE), max(M, na.rm = TRUE))
    y_lim <- ifelse(is.infinite(y_lim), NA, y_lim)
    
    if (!("all" %in% plot)) {
        tbl <- tbl[tbl[["name"]] %in% plot, ]
    }
    
    ## create a formula depending on the group argument for facet_wrap 
    if (group == "all" | group == "name") {
        fm <- stats::formula(paste("~", quote(name))) 
    } else {
        fm <- stats::formula(paste("~", group, "+", quote(name)))
    }
    
    ## do the actual plotting
    g <- ggplot2::ggplot(tbl, 
        ggplot2::aes(x = !!ggplot2::sym("A"), y = !!ggplot2::sym("M")))
    if (n >= 1000) {
        g <- g + ggplot2::geom_hex()
    } else {
        g <- g + ggplot2::geom_point()
    }
    
    if (group != "name") {
        g <- g + ggplot2::facet_wrap(fm, scales = "free")
    } else {
        g <- g + ggplot2::coord_fixed()
    }
    
    if (!any(is.na(x_lim))) g <- g + ggplot2::xlim(x_lim)
    if (!any(is.na(y_lim))) g <- g + ggplot2::ylim(y_lim)
    g <- g + ggplot2::theme_bw()
    g + ggplot2::theme(aspect.ratio = 1) 
        #plot.margin = grid::unit(c(0,0,0,0), "mm"))
}

#' @name createDfFeature
#' 
#' @title Create data frame of (count/intensity) values for a selected feature
#' along data processing steps
#' 
#' @description 
#' The function \code{createDfFeature} takes as input a list of matrices and 
#' returns the row \code{Feature} of each matrix as a column of a 
#' \code{data.frame}. The function \code{createDfFeature} provides the input 
#' for the function \code{featurePlot}. 
#' 
#' @details 
#' Internal usage in \code{shinyQC}
#' 
#' @param l \code{list} containing matrices at different processing steps
#' @param feature \code{character}, element of \code{rownames} of the matrices 
#' in \code{l}
#' 
#' @return \code{data.frame}
#' 
#' @examples 
#' set.seed(1)
#' x1 <- matrix(rnorm(100), ncol = 10, nrow = 10, 
#'     dimnames = list(paste("feature", seq_len(10)), 
#'         paste("sample", seq_len(10))))
#' x2 <- x1 + 5
#' x3 <- x2 + 10
#' 
#' l <- list(x1 = x1, x2 = x2, x3 = x3)
#' createDfFeature(l, "feature 1")
#' 
#' @export
createDfFeature <- function(l, feature) {
    l_slice <- lapply(seq_along(l), function(i) as.numeric(l[[i]][feature, ]))
    names(l_slice) <- names(l)
    df <- data.frame(l_slice)
    rownames(df) <- colnames(l[[1]])
    df
}

#' @name featurePlot
#'
#' @title Create a plot of (count/intensity) values over the samples
#'
#' @description
#' The function \code{featurePlot} creates a plot of (count/intensity) values 
#' for different data processing steps (referring to columns in the 
#' \code{data.frame}) over the different samples (referring to rows in 
#' the \code{data.frame}).
#' 
#' @details
#' Internal usage in \code{shinyQC}.
#' 
#' @param df \code{data.frame}
#' 
#' @return \code{gg} object from \code{ggplot2}
#' 
#' @examples 
#' set.seed(1)
#' x1 <- matrix(rnorm(100), ncol = 10, nrow = 10, 
#'     dimnames = list(paste("feature", seq_len(10)), 
#'         paste("sample", seq_len(10))))
#' x2 <- x1 + 5
#' x3 <- x2 + 10
#' l <- list(x1 = x1, x2 = x2, x3 = x3)
#' df <- createDfFeature(l, "feature 1")
#' featurePlot(df)
#' 
#' @importFrom tidyr pivot_longer
#' @importFrom tibble tibble
#' @importFrom ggplot2 ggplot aes sym geom_point geom_line xlab ylab
#' @importFrom ggplot2 theme_bw theme element_text
#' 
#' @export
featurePlot <- function(df) {
    
    ## add a sample column
    if (!is.data.frame(df)) stop("df is not a data.frame")
    df[["sample"]] <- factor(x = rownames(df), levels = rownames(df))
    df <- tidyr::pivot_longer(df, cols = seq_len((ncol(df) - 1)))
    
    ggplot2::ggplot(df, 
            ggplot2::aes(x = !!ggplot2::sym("sample"), 
                y = !!ggplot2::sym("value"))) + 
        ggplot2::geom_point(ggplot2::aes(color = !!ggplot2::sym("name"))) + 
        ggplot2::geom_line(ggplot2::aes(group = !!ggplot2::sym("name"), 
            color = !!ggplot2::sym("name"))) + 
        ggplot2::xlab("sample") + ggplot2::ylab("value") + 
        ggplot2::theme_bw() + 
        ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90))
}

#' @name cvFeaturePlot
#' 
#' @title Plot of feature-wise coefficient of variation values
#' 
#' @description 
#' The function \code{cvFeaturePlot} returns a \code{plotly} plot of coefficient 
#' of variation values. It will create a violin plot and superseded points
#' of coefficient of variation values per list entry of \code{l}.
#' 
#' @details 
#' \code{lines = TRUE} will connect the points belonging to the same feature 
#' with a line. If there are less than two features, the violin plot will not be
#' plotted. The violin plots will be ordered according to the order in \code{l}
#'  
#' @param l \code{list} containing matrices
#' @param lines \code{logical}
#' 
#' @return \code{plotly}
#' 
#' @examples
#' x1 <- matrix(seq_len(100), ncol = 10, nrow = 10, 
#'     dimnames = list(paste("feature", seq_len(10)), 
#'         paste("sample", seq_len(10))))
#' x2 <- x1 + 5
#' x3 <- x2 + 10
#' l <- list(x1 = x1, x2 = x2, x3 = x3)
#' cvFeaturePlot(l, lines = FALSE)
#' 
#' @importFrom tidyr pivot_longer
#' @importFrom dplyr mutate
#' @importFrom ggplot2 ggplot geom_violin aes sym geom_point geom_line
#' @importFrom ggplot2 ylab xlab theme_classic theme
#' @importFrom plotly ggplotly
#' @export
cvFeaturePlot <- function(l, lines = FALSE) {
    
    names_l <- names(l)
    df <- lapply(seq_along(l), function(x) cv(t(l[[x]]), name = names_l[x])) |>
        as.data.frame()
    
    ## create df containing cv values
    df[["feature"]] <- rownames(l[[1]])
    df <- tidyr::pivot_longer(df, cols = seq_len((ncol(df) - 1)))
    df[["name"]] <- factor(df[["name"]], levels = names(l))
    df[["x_jitter"]] <- as.numeric(df$name) |>
        jitter()
    
    # ## do the actual plotting
    g <- ggplot2::ggplot(df) 
    if (nrow(df) > 2) g <- g + 
        ggplot2::geom_violin(
            ggplot2::aes(x = !!ggplot2::sym("name"), 
                y = !!ggplot2::sym("value")), 
            na.rm = TRUE)
    g <- g + suppressWarnings(
        ggplot2::geom_point(
            ggplot2::aes(x = !!ggplot2::sym("x_jitter"), 
                y = !!ggplot2::sym("value"), color = !!ggplot2::sym("name"),
                text = !!ggplot2::sym("feature"))))
    if (lines) g <- g + ggplot2::geom_line(
        ggplot2::aes(x = !!ggplot2::sym("x_jitter"), 
            y = !!ggplot2::sym("value"), group = !!ggplot2::sym("feature")))
    g <- g + ggplot2::ylab("coefficient of variation") + 
        ggplot2::xlab("processing step") +
        ggplot2::theme_classic() + ggplot2::theme(legend.position = "none") 
    plotly::ggplotly(g, tooltip = c("text", "y"))
}

## normalization allows general-purpose adjustment for differences among your 
## sample; data transformation and scaling are two different approaches to make 
## individual features more comparable. You can use one or combine them to 
## achieve better results. 
## Sample Normalization: sample-specific normalization (weight, volumne),
## normalization by sum/median/reference sample or feature/pooled sample 
## from group, quantile normalization
## data transformation: log transformation, cube root transformation
## data scaling: mean scaling (mean-centered only), auto scaling 
## (mean-centered and divided by sd), pareto scaling (mean-centered and divided
## by square root of sd), range scaling (mean-centered and diveded by range of 
## each variable)


#' @name normalizeAssay
#'
#' @title Normalize a data sets (reduce technical sample effects)
#'
#' @description
#' The function \code{normalizeAssay} performs normalization by sum of the 
#' (count/intensity) values per sample (\code{method = "sum"}), quantile 
#' division per sample (\code{method = "quantile division"}), 
#' or by quantile normalization (adjusting the value distributions that they 
#' become identical in statistical properties, \code{method = "quantile"}). 
#' The value for quantile division (e.g., the 75% quantile per sample) can be 
#' specified by the \code{probs} argument. Quantile normalization is 
#' performed by using the \code{normalizeQuantiles} function from \code{limma}.
#' 
#' For the methods \code{"sum"} and \code{"quantile division"}, normalization
#' will be done depending on the \code{multiplyByNormalizationValue} parameter.
#' If set to \code{TRUE}, normalization values (e.g. sum or quantile) will be
#' calculated per sample. In a next step, adjusted normalization values will 
#' be calculated for each sample in relation to the median normalization 
#' values across all samples. Finally, the values in \code{a} are 
#' multiplied by these adjusted normalization values.
#' If \code{multiplyByNormalizationValue} is set to \code{FALSE}, 
#' normalization values (e.g. sum or quantile) will be
#' calculated per sample. The values in \code{a} are sample-wise divided by
#' the normalization values. 
#' 
#' @details
#' Internal usage in \code{shinyQC}. If \code{method} is set to \code{"none"}, 
#' the object \code{x} is returned as is (pass-through).
#' 
#' If \code{probs} is NULL, \code{probs} is internally set to 0.75 if 
#' \code{method = "quantile division"}.
#' 
#' Depending on the values in \code{a}, if \code{multiplyByNormalizationValue}
#' is set to \code{TRUE} the returned normalized values will be in the same 
#' order of magnitude than the original values, while if \code{FALSE}, the 
#' returned values will be in a smaller order of magnitude.
#' 
#' @param a \code{matrix} with samples in columns and features in rows
#' @param method \code{character}, one of \code{"none"}, \code{"sum"}, 
#' \code{"quantile division"}, \code{"quantile"}
#' @param probs \code{numeric}, ranging between \code{[0, 1)}. \code{probs} 
#' is used as the divisor for quantile division in 
#' \code{method = "quantile division"}
#' @param multiplyByNormalizationValue \code{logical}, if TRUE, normalization 
#' values will be calculated and the values in \code{a} will be multiplied by 
#' the values The parameter is only relavant for \code{method = "sum"} and 
#' \code{method = "quantile division"}
#'
#' @examples
#' a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
#'         dimnames = list(seq_len(10), paste("sample", seq_len(10))))
#' normalizeAssay(a, "sum")
#' 
#' @return \code{matrix}
#'
#' @importFrom limma normalizeQuantiles
#' @importFrom stats quantile
#'  
#' @export
normalizeAssay <- function(a, 
    method = c("none", "sum", "quantile division", "quantile"), probs = 0.75,
    multiplyByNormalizationValue = FALSE) {
    
    if (!is.matrix(a)) stop ("a is not a matrix")
    method <- match.arg(method)
    
    a_n <- a

    if (method == "sum") {
        contains_negative <- a < 0
        contains_negative[is.na(contains_negative)] <- FALSE
        if (any(contains_negative))
            print("'a' contains negative values. Normalization may lead to undesired results.")
        
        if (multiplyByNormalizationValue) {
            normFactors <- apply(a_n, 2, sum, na.rm = TRUE)
            adjustedNormFactors <- median(normFactors, na.rm = TRUE) / normFactors
            a_n <- apply(a_n, 1, function(rows_i) 
                rows_i * adjustedNormFactors)
            
            ## transpose the matrix if the a_n was transposed by apply
            if (!all(colnames(a) %in% colnames(a_n)))
                a_n <- t(a_n)
        } else {
            a_n <- apply(a_n, 2, 
                function(cols_i) cols_i / sum(cols_i, na.rm = TRUE))    
        }
    }
    if (method == "quantile division") {
        contains_negative <- a < 0
        contains_negative[is.na(contains_negative)] <- FALSE
        if (any(contains_negative))
            print("'a' contains negative values. Normalization may lead to undesired results.")
        if (is.null(probs)) 
            probs <- 0.75
        
        if (multiplyByNormalizationValue) {
            normFactors <- apply(a_n, 2, function(cols_i) 
                stats::quantile(cols_i, probs = probs, na.rm = TRUE))
            adjustedNormFactors <- median(normFactors, na.rm = TRUE) / normFactors
            a_n <- apply(a_n, 1, function(rows_i) 
                rows_i * adjustedNormFactors)
            
            ## transpose the matrix if the a_n was transposed by apply
            if (!all(colnames(a) %in% colnames(a_n)))
                a_n <- t(a_n)
        } else {
            a_n <- apply(a_n, 2,
                function(cols_i) cols_i / stats::quantile(cols_i, 
                    probs = probs, na.rm = TRUE)) 
        }
        
    }
    if (method == "quantile") {
        cols_nona <- apply(a_n, 2, function(cols_i) !all(is.na(cols_i)))
        cols_nona <- names(cols_nona[cols_nona])
        a_n[, cols_nona] <- limma::normalizeQuantiles(a_n[, cols_nona], 
            ties = TRUE)
    }
    
    rownames(a_n) <- rownames(a)
    colnames(a_n) <- colnames(a)
    a_n
}

#' @name batchCorrectionAssay
#'
#' @title Remove batch effects from (count/intensity) values of a 
#' \code{SummarizedExperiment}
#'
#' @description
#' The function \code{batchCorrectionAssay} removes the batch effect of 
#' (count/intensity) values of a \code{SummarizedExperiment}. 
#' It uses either the \code{removeBatchEffect} or \code{ComBat} functions 
#' or no batch effect correction method (pass-through, 
#' \code{none}).
#'
#' @details 
#' The column \code{batch} in \code{colData(se)} contains the information 
#' on the batch identity. For \code{method = "removeBatchEffect (limma)"},
#' \code{batch2} may indicate a second series of batches. 
#' Internal use in \code{shinyQC}.
#' 
#' If \code{batch} is NULL and \code{method} is set to 
#' \code{method = "removeBatchEffect (limma)"} or \code{method = "ComBat"},
#' no batch correction will be performed (equivalent to 
#' \code{method = "none"}).
#' 
#' The method \code{ComBat} will only perform batch correction on valid 
#' features: (1) more or equal than two observations (no \code{NA}) per level 
#' and per feature, (2) variance greater than 0 per feature, and (3) more than
#' two valid features as given by (1) and (2). For non-valid features, values
#' are taken from \code{assay(se)}.
#'
#' @param se \code{SummarizedExperiment}
#' @param method \code{character}, one of \code{"none"} or 
#' \code{"removeBatchEffect"}
#' @param batch \code{character}, \code{NULL} or one of 
#' \code{colnames(colData(se))}
#' @param batch2 \code{character}, \code{NULL} or one of
#' \code{colnames(colData(se))}
#' @param ... further arguments passed to \code{removeBatchEffect} or 
#' \code{ComBat} 
#'
#' @examples
#' ## create se
#' a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
#'     dimnames = list(seq_len(10), paste("sample", seq_len(10))))
#' a[c(1, 5, 8), seq_len(5)] <- NA
#' set.seed(1)
#' a <- a + rnorm(100)
#' cD <- data.frame(name = colnames(a), 
#'     type = c(rep("1", 5), rep("2", 5)), batch = rep(c(1, 2), 5))
#' rD <- data.frame(spectra = rownames(a))
#' se <- SummarizedExperiment::SummarizedExperiment(assay = a, 
#'     rowData = rD, colData = cD)
#' 
#' ## method = "removeBatchEffect (limma)"
#' batchCorrectionAssay(se, method = "removeBatchEffect (limma)", 
#'     batch = "batch", batch2 = NULL)
#' 
#' ## method = "ComBat"
#' batchCorrectionAssay(se, method = "ComBat", 
#'     batch = "batch", batch2 = NULL)
#' 
#' @return \code{matrix}
#' 
#' @importFrom limma removeBatchEffect
#' @importFrom SummarizedExperiment assay
#' @importFrom sva ComBat
#' @importFrom stats var
#' 
#' @export
batchCorrectionAssay <- function(se, 
        method = c("none", "removeBatchEffect (limma)", "ComBat"), 
        batch = NULL, batch2 = NULL, ...) {
    
    method <- match.arg(method)
    ##batch <- match.arg(batch)
    ##batch2 <- match.arg(batch2)
    a <- SummarizedExperiment::assay(se)
    a_b <- as.matrix(a)
    
    if (method == "removeBatchEffect (limma)") {
        
        cD <- se@colData
        
        ## check, when batch and batch2 are not NULL, that they match
        ## with the colnames of colData, assign the values of colData
        if (!is.null(batch)) {
            batch <- match.arg(batch, choices = colnames(cD))
            batch <- cD[[batch]]
        }
        
        if (!is.null(batch2)) {
            batch2 <- match.arg(batch2, choices = colnames(cD))
            batch2 <- cD[[batch2]]
        }

        ## perform batch correction
        a_b <- limma::removeBatchEffect(a_b, batch = batch, batch2 = batch2, 
            ...)
    }
    
    if (method == "ComBat") {
        
        cD <- se@colData
        
        ## check, when batch is not NULL, that it matches with the colnames
        ## of colData, assign the values of colData
        if (!is.null(batch)) {
            batch <- match.arg(batch, choices = colnames(cD))
            batch <- cD[[batch]]
            
            ## require at least 2 observations per feature and level
            batch_u <- unique(batch)
            keep_rows <- rep(TRUE, nrow(se))
            for (i in batch_u) {
                sum_nas <- apply(a_b[, batch == i, drop = FALSE], 1, 
                    FUN = function(row) sum(!is.na(row)))
                keep_rows[sum_nas < 2] <- FALSE
            }
            
            ## now check the variance, set keep_rows to FALSE if variance == 0
            keep_rows[apply(a_b, 1, stats::var, na.rm = TRUE) == 0] <- FALSE
            
            ## perform batch correction for the valid features (if there are
            ## more or equal than 2), use default values
            if (sum(keep_rows) >= 2) {
                print(paste("Perform batch correction using", sum(keep_rows), 
                    "features."))
                a_b[keep_rows, ] <- sva::ComBat(a_b[keep_rows, ], batch = batch,
                    ...)
            } else {
                print("No batch correction performed.")
            }
        }
    }
    
    ## assign rownames and colnames
    rownames(a_b) <- rownames(a)
    colnames(a_b) <- colnames(a)
    
    ## return
    a_b
}

#' @name transformAssay
#'
#' @title Transform the (count/intensity) values of a \code{data.frame}, 
#' \code{tbl} or \code{matrix} 
#' 
#' @description
#' The function \code{transformAssay} transforms the (count/intensity) values 
#' of a  \code{matrix}. It uses either \code{log}, \code{log2}, \code{log10},  
#' variance stabilizing normalisation (\code{vsn}) or no transformation method 
#' (pass-through, \code{none}). The object
#' \code{x} has the samples in the columns and the features in the rows.
#'
#' @details 
#' Internal use in \code{shinyQC}.
#' 
#' @param a \code{matrix} with samples in columns and features in rows
#' @param method \code{character}, one of \code{"none"}, \code{"log"}, 
#' \code{"log2"}, \code{"log10"}, or \code{"vsn"}
#' @param .offset \code{numeric(1)}, offset to add when \code{method} set to
#' \code{"log"}, \code{"log2"}, or \code{"log10"} and 
#' \code{a} contains values of 0, default to 1 
#'
#' @examples
#' a <- matrix(seq_len(1000), nrow = 100, ncol = 10, 
#'         dimnames = list(seq_len(100), paste("sample", seq_len(10))))
#' transformAssay(a, "none")
#' transformAssay(a, "log")
#' transformAssay(a, "log2")
#' transformAssay(a, "vsn")
#'
#' @return \code{matrix}
#' 
#' @importFrom vsn vsn2
#' 
#' @export
transformAssay <- function(a, method = c("none", "log", "log2", "log10", "vsn"),
    .offset = 1) {
    
    if (!is.matrix(a)) stop("a is not a matrix")
    method <- match.arg(method)
    
    if (length(.offset) != 1)
        stop("'.offset' has to be of length 1")

    a_t <- a

    if (method == "log") {
        if (any(a_t == 0, na.rm = TRUE)) {
            a_t <- log(a_t + .offset)
        } else {
            a_t <- log(a_t)
        }
    }
    if (method == "log2") {
        if (any(a == 0, na.rm = TRUE)) {
            a_t <- log2(a_t + .offset)
        } else {
            a_t <- log2(a_t)
        }
    }
    if (method == "log10") {
        if (any(a == 0, na.rm = TRUE)) {
            a_t <- log10(a_t + .offset)
        } else {
            a_t <- log10(a_t)
        }
    }
    if (method == "vsn") {
        a_t <- vsn2(a_t)
        a_t <- a_t@hx
    }
    
    rownames(a_t) <- rownames(a) 
    colnames(a_t) <- colnames(a)
    a_t
}

#' @name imputeAssay
#' 
#' @title Impute missing values in a \code{matrix}
#' 
#' @description 
#' The function \code{impute} imputes missing values based on one of the 
#' following principles: Bayesian missing value imputation (\code{BPCA}), 
#' k-nearest neighbor averaging (\code{kNN}), Malimum likelihood-based 
#' imputation method using the EM algorithm (\code{MLE}), replacement by 
#' the smallest non-missing value
#' in the data (\code{Min}), replacement by the minimal value observed as
#' the q-th quantile (\code{MinDet}, default \code{q = 0.01}), and replacement
#' by random draws from a Gaussian distribution centred to a minimal value 
#' (\code{MinProb}).
#'
#' @details
#' \code{BPCA} wrapper for \code{pcaMethods::pca} with \code{methods = "bpca"}. 
#' \code{BPCA} is a missing at random (MAR) imputation method. 
#' 
#' \code{kNN} wrapper for \code{impute::impute.knn} with \code{k = 10}, 
#' \code{rowmax = 0.5}, \code{colmax = 0.5}, \code{maxp = 1500}. \code{kNN} 
#' is a MAR imputation method.
#' 
#' \code{MLE} wrapper for \code{imputeLCMD::impute.MAR} with 
#' \code{method = "MLE"}, 
#' \code{model.selector = 1}/\code{imputeLCMD::impute.wrapper.MLE}. 
#' \code{MLE} is a MAR imputation method.
#' 
#' \code{Min} imputes the missing values by the observed minimal value of 
#' \code{x}. \code{Min} is a missing not at random (MNAR) imputation method.
#' 
#' \code{MinDet} is a wrapper for \code{imputeLCMD::impute.MinDet} with 
#' \code{q = 0.01}. \code{MinDet} performs the imputation using a 
#' deterministic minimal value approach. The missing entries are
#' replaced with a minimal value, estimated from the \code{q}-th quantile 
#' from each sample. \code{MinDet} is a MNAR imputation method.
#' 
#' \code{MinProb} is a wrapper for \code{imputeLCMD::impute.MinProb} with 
#' \code{q = 0.01} and \code{tune.sigma = 1}. \code{MinProb} performs the 
#' imputation based on random draws from a Gaussion distribution with the 
#' mean set to the minimal value of a sample. \code{MinProb} is a 
#' MNAR imputation method.
#' 
#' \code{MinProb} does not impute values (not available within shiny 
#' application).  
#' 
#' @param a \code{matrix} with samples in columns and features in rows
#' @param method \code{character}, one of \code{"BPCA"}, \code{"kNN"}, 
#' \code{"MLE"}, \code{"Min"}, 
#' \code{"MinDet"}, \code{"MinProb"}, or \code{"none"}
#'
#' @examples
#' a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
#'     dimnames = list(seq_len(10), paste("sample", seq_len(10))))
#' a[c(1, 5, 8), seq_len(5)] <- NA
#' 
#' imputeAssay(a, method = "kNN")
#' imputeAssay(a, method = "Min")
#' imputeAssay(a, method = "MinDet")
#' imputeAssay(a, method = "MinProb")
#' 
#' @return \code{matrix}
#' 
#' @importFrom imputeLCMD impute.MinDet impute.MinProb
#' @importFrom impute impute.knn
#' @importFrom pcaMethods pca completeObs
#' 
#' @export
imputeAssay <- function(a,
    method = c("BPCA", "kNN", "MLE", "Min", "MinDet", "MinProb", "none")) {

    if (!is.matrix(a)) stop("a is not a matrix")
    method <- match.arg(method)

    ## convert the data.frame into matrix and transpose, this will impute
    ## the per row (feature-wise)
    a_i <- as.matrix(a) |>
        t()

    if (method == "BPCA") {
        n_samp <- nrow(a_i)
        ## expects a matrix with features in columns, samples in rows
        res <- pcaMethods::pca(a_i, method = "bpca", nPcs = (n_samp - 1),
            verbose = FALSE, maxSteps = 200, center = TRUE, scale = "uv")
        a_i <- pcaMethods::completeObs(res)
    }

    if (method == "kNN") {
        ## expects a matrix with features in rows, samples in columns
        a_i <- impute::impute.knn(data = t(a_i))$data |>
            t()
    }

    if (method == "MLE") {
        ## expects a matrix with features in columns, samples in rows
        a_i <- imputeLCMD::impute.wrapper.MLE(dataSet.mvs = a_i)
    }
        
    if (method == "Min") {
        min_val <- min(a_i, na.rm = TRUE)
        a_i[is.na(a_i)] <- min_val
    }
        
    if (method == "MinDet") {
        ## expects a matrix with features in columns, samples in rows
        a_i <- imputeLCMD::impute.MinDet(dataSet.mvs = a_i, q = 0.01)
    }
        
    if (method == "MinProb") {
        ## expects a matrix with features in columns, samples in rows
        a_i <- imputeLCMD::impute.MinProb(dataSet.mvs = a_i, q = 0.01, 
            tune.sigma = 1)
    }

    t(a_i)
}

#' @importFrom SummarizedExperiment SummarizedExperiment assay
#' @importFrom tibble tibble

## create se
a <- matrix(seq_len(1000), nrow = 100, ncol = 10,
    dimnames = list(seq_len(100), paste("sample", seq_len(10))))
a[c(1, 5, 8), seq_len(5)] <- NA
set.seed(1)
a <- a + rnorm(1000)
cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
rD <- data.frame(spectra = rownames(a))
se <- SummarizedExperiment::SummarizedExperiment(assay = a, rowData = rD,
    colData = cD)
se_error <- se
colnames(colData(se_error)) <- c("x5at1t1g161asy", "type")

## function createBoxplot
test_that("createBoxplot", {
    g <- createBoxplot(se)

    expect_error(createBoxplot(SummarizedExperiment::assay(se)),
        "unable to find an inherited method for function")
    expect_error(createBoxplot(se = se, orderCategory = "name",
        title =  "test", log = "", violin = TRUE), "not interpretable as logical")
    expect_error(createBoxplot(se = se, orderCategory = "name",
        title = "test", log = TRUE, violin = ""), "invalid argument type")
    expect_error(createBoxplot(se = se, orderCategory = "foo", title = "",
          log = TRUE, violin = TRUE),
        "should be one of")
    expect_error(createBoxplot(se = se_error, orderCategory = "x5at1t1g161asy"),
        "Column name `x5at1t1g161asy` must not be duplicated")
    expect_is(g, "gg")
})

## function driftPlot
test_that("driftPlot", {
    expect_is(
        driftPlot(se = se, aggregation = "median", category = "type",
            orderCategory = "type", level = "all", method = "loess"), "plotly")
  expect_error(driftPlot(se = se, aggregation = "", category = "type",
      orderCategory = "type", level = "all", method = "loess"),
      "should be one of")
  expect_error(driftPlot(se = se, aggregation = "median", category = "foo",
      orderCategory = "type", level = "all", method = "loess"),
      "should be one of")
  expect_error(driftPlot(se = se, aggregation = "median", category = "type",
      orderCategory = "foo", level = "all", method = "loess"),
      "should be one of")
  expect_error(driftPlot(se = se, aggregation = "median", category = "type",
      orderCategory = "type", level = "foo", method = "loess"),
      "should be one of")
  expect_error(driftPlot(se = se, aggregation = "median", category = "type",
      orderCategory = "type", level = "all", method = "foo"),
      "should be one of")
  expect_error(driftPlot(se = se_error, aggregation = "median",
            category = "type", orderCategory = "type", level = "all",
            method = "loess"),
      "Column name `x5at1t1g161asy` must not be duplicated")
})

## function cv
test_that("cv", {
    x <- matrix(seq_len(100), ncol = 5)
    expect_equal(cv(x)$raw,
        c(56.343617, 19.396983, 11.715009,  8.391603,  6.537105))
    expect_equal(names(cv(x)), "raw")
    expect_equal(names(cv(x, NULL)), NULL)
    expect_true(is.numeric(cv(x)$raw))
    expect_error(cv("foo"), "must have a positive length")
    expect_error(cv(seq_len(100)), "must have a positive length")
})

## function plotCV
test_that("plotCV", {
    x1 <- matrix(seq_len(100), ncol = 5)
    x2 <- matrix(seq(101, 200), ncol = 5)
    df <- data.frame(cv(x1, "raw"), cv(x2, "normalized"))
    g <- plotCV(df)
    expect_error(plotCV(NULL), "df is not a data.frame")
    expect_error(plotCV(NA), "df is not a data.frame")
    expect_error(plotCV(x1), "df is not a data.frame")
    expect_is(g, "gg")
})

## function ECDF
test_that("ECDF", {

    sample_1 <- colnames(se)[1]
    x <- SummarizedExperiment::assay(se)
    g <- ECDF(se, sample_1, "all")

    expect_error(ECDF(x, sample_1, "all"), "unable to find an inherited method")
    expect_error(ECDF(se, "", "all"), "'arg' should be one of")
    expect_error(ECDF(se, sample_1, "test"), "'arg' should be one of")
    expect_error(ECDF(se_error, sample_1, "all"),
        "Column name `x5at1t1g161asy` must not be duplicated")
    expect_is(g, "gg")
})

## function distShiny
test_that("distShiny", {
    x <- SummarizedExperiment::assay(se)

    matTest <- matrix(
        c(0,        173.0173, 349.8123,
          173.0173, 0,        176.7957,
          349.8123, 176.7957, 0), byrow = TRUE, ncol = 3, nrow = 3,
        dimnames = list(c(colnames(x)[seq_len(3)]), c(colnames(x)[seq_len(3)])))

    expect_error(distShiny(x, "test"), "invalid distance method")
    expect_equal(distShiny(x[seq_len(3), seq_len(3)], method = "euclidean"), matTest,
                 tolerance = 1e-02)
    expect_true(is.matrix(distShiny(x)))
})

## function distSample
test_that("distSample", {
    x <- SummarizedExperiment::assay(se)
    d <- distShiny(x, method = "euclidean")
    g <- distSample(d, se, label = "type")

    expect_error(distSample(d[seq_len(3), seq_len(3)], se = se, label = "type"),
        "number of observations in top annotation")
    expect_error(distSample(d, se = se[, seq_len(3)], label = "type"),
        "number of observations in top annotation")
    expect_is(g, "Heatmap")
})

## function sumDistSample
test_that("sumDistSample", {
    x <- SummarizedExperiment::assay(se)
    d <- distShiny(x, method = "euclidean")
    g <- sumDistSample(d)

    ##expect_error(sumDistSample(d, se), "no method for coercing this S4 class")
    ##expect_error(sumDistSample(matrix(seq_len(3))), "requires the following aesthetics")
    expect_error(sumDistSample(se),
        "must be an array of at least two dimensions")
    expect_is(g, "plotly")
})

## function MAvalues
test_that("MAvalues", {
    tbl_test <- tibble::tibble(Feature = as.character(c(rep(2, 3), rep(3, 3))),
        name = rep(colnames(se)[seq_len(3)], 2),
        A = c(4.149180, 5.535751, 5.785051, 4.144537, 5.534471, 5.785192),
        M = c( -6.044885, 2.274541, 3.770344, -6.061178, 2.278427, 3.782751),
        name.y = rep(colnames(se)[seq_len(3)], 2),
        type = "1")
    ma <- MAvalues(se = se, group = "all")

    expect_error(MAvalues(assay(se), log2 = TRUE, "all"),
        "unable to find an inherited method for function")
    expect_error(MAvalues(se, log2 = TRUE, group = ""), "'arg' should be one of")
    expect_error(MAvalues(se, log2 = "", group = "all"),
        "argument is not interpretable as logical")
    expect_error(MAvalues(se_error, log2 = TRUE, group = "all"),
        "Column name `x5at1t1g161asy` must not be duplicated")
    expect_true(is.data.frame(ma))
    expect_equal(dim(ma), c(1000, 6))
    expect_true(is.character(ma$Feature))
    expect_true(is.character(ma$name))
    expect_true(is.numeric(ma$A))
    expect_true(is.numeric(ma$M))
    expect_true(is.character(ma$type))
    expect_equal(MAvalues(se[c(2, 3), seq_len(3)], group = "all"), tbl_test,
          tolerance = 1e-07)
})

## function hoeffDvalues
test_that("hoeffDValues", {
    tbl <- MAvalues(se)
    l_test <- list(raw = c(0.9901381, 0.7174001, 0.2431791, 0.8799139,
        0.9270406, 0.9566922, 0.9671259, 0.9773905, 0.9788422, 0.9766581))
    l_test_subset <- list(raw = c(0.9924323, 0.6885165, 0.2892747, 0.8822307,
        0.9255351, 0.9562963, 0.9635617, 0.9784907, 0.9765922, 0.9765521))
    names(l_test$raw) <- colnames(se)
    names(l_test_subset$raw) <- colnames(se)


    hD <- hoeffDValues(tbl, name = "raw", sample_n = NULL)
    set.seed(2022)
    hD_subset <- hoeffDValues(tbl, name = "raw", sample_n = 90)

    expect_error(hoeffDValues(tbl[, !colnames(tbl) %in% "A"]),
        "Column `A` doesn't exist")
    expect_error(hoeffDValues(tbl[, !colnames(tbl) %in% "M"]),
        "Column `M` doesn't exist")
    expect_equal(hD, l_test, tolerance = 1e-07)
    expect_equal(hD_subset, l_test_subset, tolerance = 1e-07)
    expect_true(is.list(hD))
    expect_equal(length(hD), 1)
    expect_equal(length(unlist(hD)), length(unique(tbl$name)))
})

## function hoeffDPlot
test_that("hoeffDPlot", {
    l_1 <- list(raw = seq_len(10))
    l_2 <- list(normalized = seq_len(10))
    l_3 <- list(transformed = seq_len(10))
    l_4 <- list("batch corrected" = seq_len(10))
    l_5 <- list(imputed = seq_len(10))
    l_6 <- list(foo = seq_len(9))
    df <- data.frame(l_1, l_2)
    g <- hoeffDPlot(df)

    df <- data.frame(l_1, l_2, l_3, l_4, l_5)
    expect_error(hoeffDPlot(df, lines = ""),
        "argument is not interpretable as logical")
    expect_error({data.frame(l_1, l_6); hoeffDPlot(df)},
        "arguments imply differing number of rows")
    expect_is(g, "plotly")
})

## function MAplot
test_that("MAplot", {
    tbl <- MAvalues(se, group = "all")
    g <- MAplot(tbl, group = "all", plot = "all")

    expect_error(suppressWarnings(MAplot(se, "all")),
        "must be a ")
    expect_error(MAplot(tbl, group = "foo", plot = "all"), "should be one of ")
    expect_error(MAplot(tbl, group = "all", plot = "foo"),
        "plot not in ")
    expect_error(MAplot(tbl, group = "all", plot = c("sample 1", "foo")),
        "plot not in ")
    expect_is(g, "gg")
})

## function createDfFeature
test_that("createDfFeature", {

    x1 <- matrix(seq_len(100), ncol = 10, nrow = 10,
         dimnames = list(paste("feature", seq_len(10)), paste("sample", seq_len(10))))
    x2 <- x1 + 5
    x3 <- x2 + 10

    l <- list(x1 = x1, x2 = x2, x3 = x3)
    df <- createDfFeature(l, "feature 1")
    expect_equal(df$x1, seq(1, 91, 10))
    expect_equal(df$x2, seq(6, 96, 10))
    expect_equal(df$x3, seq(16, 106, 10))
    expect_is(df, "data.frame")
    expect_identical(rownames(df), paste("sample", seq_len(10)))
    expect_error(createDfFeature(l, "foo"), "subscript out of bounds")
    expect_error(createDfFeature("foo", "feature 1"),
        "incorrect number of dimensions")
})

## function featurePlot
test_that("featurePlot", {
    x1 <- matrix(seq_len(100), ncol = 10, nrow = 10,
      dimnames = list(paste("feature", seq_len(10)), paste("sample", seq_len(10))))
    x2 <- x1 + 5
    x3 <- x2 + 10

    l <- list(x1 = x1, x2 = x2, x3 = x3)
    df <- createDfFeature(l, "feature 1")
    expect_is(featurePlot(df), "gg")
    expect_error(featurePlot(NULL), "df is not a data.frame")
})

## function cvFeaturePlot
test_that("cvFeaturePlot", {
    x1 <- matrix(seq_len(100), ncol = 10, nrow = 10,
        dimnames = list(paste("feature", seq_len(10)), paste("sample", seq_len(10))))
    x2 <- x1 + 5
    x3 <- x2 + 10

    l <- list(x1 = x1, x2 = x2, x3 = x3)

    expect_is(cvFeaturePlot(l = l, lines = FALSE), "plotly")
    expect_is(cvFeaturePlot(l = l, lines = TRUE), "plotly")
    expect_error(cvFeaturePlot(l = NULL, lines = TRUE))
    expect_error(cvFeaturePlot(l = l, lines = "foo"),
        "argument is not interpretable as logical")
})

## function normalizeAssay
test_that("normalizeAssay", {
    a <- SummarizedExperiment::assay(se)
    a_n <- normalizeAssay(a, method = "none",
        multiplyByNormalizationValue = FALSE)
    a_n_multiply <- normalizeAssay(a, method = "none",
        multiplyByNormalizationValue = TRUE)
    a_s <- normalizeAssay(a, method = "sum",
        multiplyByNormalizationValue = FALSE)
    a_s_multiply <- normalizeAssay(a, method = "sum",
        multiplyByNormalizationValue = TRUE)
    a_qd <- normalizeAssay(a, method = "quantile division", probs = 0.75,
        multiplyByNormalizationValue = FALSE)
    a_qd_multiply <- normalizeAssay(a, method = "quantile division",
        probs = 0.75, multiplyByNormalizationValue = TRUE)
    a_q <- normalizeAssay(a, method = "quantile", multiplyByNormalizationValue = FALSE)
    a_q_multiply <- normalizeAssay(a, method = "quantile", multiplyByNormalizationValue = TRUE)
    expect_error(normalizeAssay(se), "a is not a matrix")
    expect_error(normalizeAssay(a, "foo"), "'arg' should be one of ")

    expect_equal(a_n, a)
    expect_equal(a_n_multiply, a)
    expect_equal(a_n_multiply, a_n)
    expect_equal(a_q, a_q_multiply)

    expect_true(is.matrix(a_n))
    expect_true(is.matrix(a_n_multiply))
    expect_true(is.matrix(a_s))
    expect_true(is.matrix(a_s_multiply))
    expect_true(is.matrix(a_qd))
    expect_true(is.matrix(a_qd_multiply))
    expect_true(is.matrix(a_q))
    expect_true(is.matrix(a_q_multiply))

    expect_equal(dim(a_n), dim(a))
    expect_equal(dim(a_n_multiply), dim(a))
    expect_equal(dim(a_s), dim(a))
    expect_equal(dim(a_s_multiply), dim(a))
    expect_equal(dim(a_qd), dim(a))
    expect_equal(dim(a_qd_multiply), dim(a))
    expect_equal(dim(a_q), dim(a))
    expect_equal(dim(a_q_multiply), dim(a))

    expect_equal(rownames(a_n), rownames(a))
    expect_equal(rownames(a_n_multiply), rownames(a))
    expect_equal(rownames(a_s), rownames(a))
    expect_equal(rownames(a_s_multiply), rownames(a))
    expect_equal(rownames(a_qd), rownames(a))
    expect_equal(rownames(a_qd_multiply), rownames(a))
    expect_equal(rownames(a_q), rownames(a))
    expect_equal(rownames(a_q_multiply), rownames(a))

    expect_equal(colnames(a_n), colnames(a))
    expect_equal(colnames(a_n_multiply), colnames(a))
    expect_equal(colnames(a_s), colnames(a))
    expect_equal(colnames(a_s_multiply), colnames(a))
    expect_equal(colnames(a_qd), colnames(a))
    expect_equal(colnames(a_qd_multiply), colnames(a))
    expect_equal(colnames(a_q), colnames(a))
    expect_equal(colnames(a_q_multiply), colnames(a))
})

## function transformAssay
test_that("transformAssay", {
    a <- SummarizedExperiment::assay(se)
    a_n <- transformAssay(a, method = "none")
    a_l <- transformAssay(a, method = "log")
    a_l2 <- transformAssay(a, method = "log2")
    a_l10 <- transformAssay(a, method = "log10")
    a_v <- transformAssay(a, method = "vsn")

    expect_error(transformAssay(se), "a is not a matrix")
    expect_error(transformAssay(a, "foo"), "'arg' should be one of ")
    expect_equal(a_n, a)
    expect_true(is.matrix(a_n))
    expect_true(is.matrix(a_l))
    expect_true(is.matrix(a_l2))
    expect_true(is.matrix(a_v))
    expect_equal(a_l, log(a))
    expect_equal(a_l2, log2(a))
    expect_equal(a_l10, log10(a))
    expect_equal(dim(a_n), dim(a))
    expect_equal(dim(a_l), dim(a))
    expect_equal(dim(a_l2), dim(a))
    expect_equal(dim(a_l10), dim(a))
    expect_equal(dim(a_v), dim(a))
    expect_equal(rownames(a_n), rownames(a))
    expect_equal(rownames(a_l), rownames(a))
    expect_equal(rownames(a_l2), rownames(a))
    expect_equal(rownames(a_l10), rownames(a))
    expect_equal(rownames(a_v), rownames(a))
    expect_equal(colnames(a_n), colnames(a))
    expect_equal(colnames(a_l), colnames(a))
    expect_equal(colnames(a_l2), colnames(a))
    expect_equal(colnames(a_l10), colnames(a))
    expect_equal(colnames(a_v), colnames(a))
})

## function batchCorrectionAssay
test_that("batchCorrectionAssay", {
    a <- matrix(seq_len(1000), nrow = 100, ncol = 10,
        dimnames = list(seq_len(100), paste("sample", seq_len(10))))
    se_b <- se
    SummarizedExperiment::assay(se_b) <- a
    a_n <- batchCorrectionAssay(se_b, method = "none")
    a_l <- batchCorrectionAssay(se_b, method = "removeBatchEffect (limma)",
        batch = "type", batch2 = NULL)
    a_c <- batchCorrectionAssay(se_b, method = "ComBat",
        batch = "type", batch2 = NULL, par.prior = FALSE)

    ## removeBatchEffect (limma)
    expect_error(batchCorrectionAssay(a, "removeBatchEffect (limma)"),
        "unable to find an inherited method for function")
    expect_error(batchCorrectionAssay(se_b, "foo"), "'arg' should be one of ")
    expect_error(batchCorrectionAssay(se_b, "removeBatchEffect (limma)", 
        batch = "foo", batch2 = NULL),
        "should be one of")
    expect_error(batchCorrectionAssay(se_b, "removeBatchEffect (limma)", 
        batch = "type", batch2 = "foo"),
        "should be one of")
    expect_error(batchCorrectionAssay(se_b, "removeBatchEffect (limma)", 
        batch = "foo", batch2 = "foo"),
        "should be one of")
    expect_error(batchCorrectionAssay(se_b, "removeBatchEffect (limma)", 
        batch = NULL, batch2 = "foo"),
        "should be one of")
    expect_equal(batchCorrectionAssay(se_b, "removeBatchEffect (limma)", 
        batch = NULL, batch2 = NULL), a)
    
    ## ComBat
    expect_error(batchCorrectionAssay(a, "ComBat"),
        "unable to find an inherited method for function")
    expect_error(batchCorrectionAssay(se_b, "ComBat", 
        batch = "foo", batch2 = NULL),
        "should be one of")
    expect_error(batchCorrectionAssay(se_b, "ComBat", 
        batch = "foo", batch2 = "foo"),
        "should be one of")
    expect_equal(batchCorrectionAssay(se_b, "ComBat", 
        batch = NULL, batch2 = NULL), a)
    
    expect_equal(a_n, a)
    expect_true(is.matrix(a_n))
    expect_true(is.matrix(a_l))
    expect_true(is.matrix(a_c))
    expect_equal(dim(a_n), dim(a))
    expect_equal(dim(a_l), dim(a))
    expect_equal(dim(a_c), dim(a))
    expect_equal(rownames(a_n), rownames(a))
    expect_equal(rownames(a_l), rownames(a))
    expect_equal(rownames(a_c), rownames(a))
    expect_equal(colnames(a_n), colnames(a))
    expect_equal(colnames(a_l), colnames(a))
    expect_equal(colnames(a_c), colnames(a))
})

## function imputeAssay
test_that("imputeAssay", {
    a <- SummarizedExperiment::assay(se)
    a_bpca <- imputeAssay(a, "BPCA")
    a_knn <- imputeAssay(a, "kNN")
    a_min <- imputeAssay(a, "Min")
    a_mindet <- imputeAssay(a, "MinDet")
    a_minprob <- imputeAssay(a, "MinProb")
    a_none <- imputeAssay(a, "none")

    expect_error(imputeAssay(se), "a is not a matrix")
    expect_error(imputeAssay(se, "foo"), "a is not a matrix")
    expect_true(is.matrix(a_bpca))
    expect_true(is.matrix(a_knn))
    expect_true(is.matrix(a_min))
    expect_true(is.matrix(a_mindet))
    expect_true(is.matrix(a_minprob))
    expect_true(is.matrix(a_none))
    expect_equal(dim(a_bpca), dim(a))
    expect_equal(dim(a_knn), dim(a))
    expect_equal(dim(a_min), dim(a))
    expect_equal(dim(a_mindet), dim(a))
    expect_equal(dim(a_minprob), dim(a))
    expect_equal(dim(a_none), dim(a))
    expect_equal(rownames(a_bpca), rownames(a))
    expect_equal(rownames(a_knn), rownames(a))
    expect_equal(rownames(a_min), rownames(a))
    expect_equal(rownames(a_mindet), rownames(a))
    expect_equal(rownames(a_minprob), rownames(a))
    expect_equal(rownames(a_none), rownames(a))
    expect_equal(colnames(a_bpca), colnames(a))
    expect_equal(colnames(a_knn), colnames(a))
    expect_equal(colnames(a_min), colnames(a))
    expect_equal(colnames(a_mindet), colnames(a))
    expect_equal(colnames(a_minprob), colnames(a))
    expect_equal(colnames(a_none), colnames(a))
    expect_equal(as.vector(a[1, seq_len(6)]), c(NA, NA, NA, NA, NA, 501.0773),
        tolerance = 1e-04)
    expect_equal(as.vector(a[5, seq_len(6)]), c(NA, NA, NA, NA, NA, 505.9916),
        tolerance = 1e-04)
    expect_equal(as.vector(a_bpca[1, seq_len(6)]),
        c(700.2801, 700.2800, 700.2800, 700.2801, 700.2801, 501.0773),
        tolerance = 5e-01)
    expect_equal(as.vector(a_bpca[5, seq_len(6)]),
        c(704.9565, 704.9565, 704.9565, 704.9566, 704.9566, 505.9916),
        tolerance = 5e-01)
    expect_equal(as.vector(a_knn[1, seq_len(6)]),
        c(6.799054, 106.900480, 207.305202, 306.809707, 406.564452, 501.077303),
        tolerance = 1e-04)
    expect_equal(as.vector(a_knn[5, seq_len(6)]),
        c(6.799054, 106.900480, 207.305202, 306.809707, 406.564452, 505.991601),
        tolerance = 1e-04)
    expect_equal(as.vector(a_min[1, seq_len(6)]),
        c(2.164371, 2.164371, 2.164371, 2.164371, 2.164371, 501.077303),
        tolerance = 1e-04)
    expect_equal(as.vector(a_min[5, seq_len(6)]),
        c(2.164371, 2.164371, 2.164371, 2.164371, 2.164371, 505.991601),
        tolerance = 1e-04)
    expect_equal(as.vector(a_mindet[1, seq_len(6)]),
        c(505.0606, 505.0606, 505.0606, 505.0606, 505.0606, 501.0773),
        tolerance = 1e-04)
    expect_equal(as.vector(a_mindet[5, seq_len(6)]),
        c(509.9465, 509.9465, 509.9465, 509.9465, 509.9465, 505.9916),
        tolerance = 1e-04)
    expect_equal(as.vector(a_minprob[1, seq_len(6)]),
        c(485.9080, 507.6398, 495.5805, 490.3416, 479.0684, 501.0773),
        tolerance = 1e-04)
    expect_equal(as.vector(a_minprob[5, seq_len(6)]),
        c(550.3846, 479.6420, 547.0334, 449.2677, 429.0399, 505.9916),
        tolerance = 1e-04)
    expect_equal(a_none, a)
})

#' @name tP_histSampleUI
#' 
#' @title Tab panel UI for tab panel 'Histogram'
#' 
#' @description 
#' The module defines the UI for the tab panel 'Histogram': a \code{plotOutput} 
#' and a \code{selectInput} for the selection of the categorical variable. 
#' 
#' @details 
#' \code{tP_histSampleUI} returns the HTML code for the tab-pane 'Histogram'. 
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param se \code{SummarizedExperiment} object
#' 
#' @return \code{shiny.tag} with HTML content
#' 
#' @author Thomas Naake
#' 
#' @examples
#' tP_histSampleUI("test")
#' 
#' @importFrom shiny NS tabPanel downloadButton uiOutput
#' @importFrom plotly plotlyOutput
#' 
#' @noRd
tP_histSampleUI <- function(id) {
    ns <- shiny::NS(id)
    shiny::tabPanel(title = "Histogram", 
        plotly::plotlyOutput(outputId = ns("histSample")),
        shiny::downloadButton(outputId = ns("downloadPlot"), ""),
        shiny::selectInput(inputId = ns("typeHist"), 
            label = "Categorical variable", choices = NULL)
    )
}


#' @name histSampleServer
#' 
#' @title Module for server expressions of tab panel 'Histogram'
#' 
#' @description 
#' The function defines the server output for the tab panel 'Histogram': the
#' hitogram plot.
#' 
#' @details 
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param se \code{SummarizedExperiment} object and \code{reactive} value
#' 
#' @return 
#' \code{shiny.render.function} expression
#' 
#' @author Thomas Naake
#'
#' @importFrom shiny moduleServer updateSelectInput reactive 
#' @importFrom shiny downloadHandler
#' @importFrom htmlwidgets saveWidget
#' @importFrom plotly renderPlotly
#'
#' @noRd
histSampleServer <- function(id, se) {
    shiny::moduleServer(
        id, 
        function(input, output, session) {
            
            shiny::observe({
                shiny::updateSelectInput(session = session, 
                    inputId = "typeHist", choices = colnames(se()@colData))
            })
            
            p_hist <- shiny::reactive({
                shiny::req(input$typeHist)
                histTbl <- hist_sample_num(se(), category = input$typeHist)
                hist_sample(histTbl, category = input$typeHist)
            })
            
            output$histSample <- plotly::renderPlotly({
                p_hist()
            })
            
            output$downloadPlot <- shiny::downloadHandler(
                filename = function() {
                    paste("Histogram_", input$typeHist, ".html", sep = "")
                },
                content = function(file) {
                    htmlwidgets::saveWidget(p_hist(), file)
                }
            )
        }
    )
}


#' @name tP_mosaicSampleUI
#' 
#' @title Tab panel UI for tab panel 'Mosaic'
#' 
#' @description 
#' The module defines the UI for the tab panel 'Mosaic': a \code{plotOutput} 
#' and two \code{selectInput} elements, one for \code{'Categorical variable 1'} and 
#' one for \code{'Categorical variable 2'}
#' 
#' @details 
#' \code{tP_mosaicSampleUI} returns the HTML code for the tab-pane 'Mosaic'. 
#' Internal function for \code{shinyQC}. 
#' 
#' @param id \code{character}
#' 
#' @return 
#' \code{shiny.tag} with HTML content
#' 
#' @author Thomas Naake
#' 
#' @examples
#' tP_mosaicSampleUI("test")
#' 
#' @importFrom shiny NS tabPanel plotOutput downloadButton selectInput
#' @importFrom shinyhelper helper
#' 
#' @noRd
tP_mosaicSampleUI <- function(id) {
    ns <- shiny::NS(id)
    shiny::tabPanel(title = "Mosaic", 
        shiny::plotOutput(outputId = ns("mosaicSample")) |>
            shinyhelper::helper(content = "tabPanel_mosaicSample"),
        shiny::downloadButton(outputId = ns("downloadPlot"), ""),
        shiny::tagList(
            shiny::selectInput(inputId = ns("mosaicf1"), 
                label = "Categorical variable 1", 
                choices = "type"),
            shiny::selectInput(inputId = ns("mosaicf2"),
                label = "Categorical variable 2", 
                choices = "type")
        )
    )
}

#' @name mosaicSampleServer
#' 
#' @title Module for server expressions of tab panel 'Mosaic'
#' 
#' @description 
#' The module defines the output for the tab panel 'Mosaic'.
#' 
#' @details 
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param se \code{SummarizedExperiment} object and a \code{reactive} value
#' 
#' @return 
#' \code{shiny.render.function} expression
#'
#' @author Thomas Naake
#' 
#' @importFrom shiny moduleServer tagList updateSelectInput reactive
#' @importFrom shiny renderPlot downloadHandler observe
#' @importFrom ggplot2 ggsave
#' 
#' @noRd
mosaicSampleServer <- function(id, se) {
    shiny::moduleServer(
        id, 
        function(input, output, session) {

            shiny::observe({
                cn <- colnames(se()@colData)
                shiny::updateSelectInput(inputId = "mosaicf1", 
                    choices = cn)
                shiny::updateSelectInput(inputId = "mosaicf2",
                    choices = cn)
            })
            
            p_mosaic <- shiny::reactive({
                mosaic(se(), f1 = input$mosaicf1, f2 = input$mosaicf2)
            })
            
            output$mosaicSample <- shiny::renderPlot({
                p_mosaic()
            })
            
            output$downloadPlot <- shiny::downloadHandler(
                filename = function() {
                    paste("Mosaic_", input$mosaicf1, "_", input$mosaicf2, 
                        ".pdf", sep = "")
                },
                content = function(file) {
                    ggplot2::ggsave(file, p_mosaic(), device = "pdf",
                        limitsize = FALSE)
                }
            )
        }
    )
}

#' @name tP_samples_all
#' 
#' @title Tab panel UI for tab panel 'Samples'
#' 
#' @description 
#' The module defines the UI for the tab panel 'Samples'.
#' 
#' @details 
#' \code{tP_samples_all} returns the HTML code for the tab-pane 'Samples'. 
#' Internal function for \code{shinyQC}.
#' 
#' @return 
#' \code{shiny.tag} with HTML content
#'
#' @author Thomas Naake
#' 
#' @examples
#' library(SummarizedExperiment)
#' 
#' ## create se
#' a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
#'     dimnames = list(seq_len(10), paste("sample", seq_len(10))))
#' a[c(1, 5, 8), seq_len(5)] <- NA
#' set.seed(1)
#' a <- a + rnorm(100)
#' cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
#' rD <- data.frame(spectra = rownames(a))
#' se <- SummarizedExperiment(assay = a, rowData = rD, colData = cD)
#' 
#' tP_samples_all()
#' 
#' @importFrom shiny tabPanel 
#' @importFrom shinydashboard tabBox
#' @noRd
tP_samples_all <- function() {
    shiny::tabPanel("Samples",
        shinydashboard::tabBox(title = "", width = 12,
            tP_histSampleUI(id = "Sample_hist"),
            tP_mosaicSampleUI(id = "Sample_mosaic")
        )
    )
}

#' @importFrom SummarizedExperiment SummarizedExperiment
#' @importFrom shiny testServer

## create se
a <- matrix(seq_len(1000), nrow = 100, ncol = 10, 
            dimnames = list(seq_len(100), paste("sample", seq_len(10))))
a[c(1, 5, 8), seq_len(5)] <- NA
set.seed(1)
a <- a + rnorm(1000)
sample <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
featData <- data.frame(spectra = rownames(a))
se <- SummarizedExperiment::SummarizedExperiment(assay = a, rowData = featData, 
    colData = sample)

## tP_histSampleUI
test_that("tP_histSampleUI", {
    expect_is(tP_histSampleUI("test"), "shiny.tag")
})


## histSampleServer
test_that("histSampleServer", {
    shiny::testServer(histSampleServer, {
        input <- new.env()    
        output <- new.env()
        session <- new.env()
        se <- new.env()
        
        out <- histSampleServer("", se = se)
        expect_is(out, "shiny.render.function")
    })
})

## tP_mosaicSampleUI
test_that("tP_mosaicSampleUI", {
    expect_is(tP_mosaicSampleUI("test"), "shiny.tag")
})

## mosaicSampleServer
test_that("mosaicSampleServer", {
    shiny::testServer(mosaicSampleServer, {
        input <- new.env()    
        output <- new.env()
        session <- new.env()
        se <- new.env()
        
        out <- mosaicSampleServer("", se = se)
        expect_is(out, "shiny.render.function")
    })
})

## tP_samples_all
test_that("tP_samples_all", {
    expect_is(tP_samples_all(), "shiny.tag")
})

#' @importFrom ExperimentHub ExperimentHub
NULL

#' @name shinyQC
#'
#' @title Shiny application for initial QC exploration of -omics data sets
#'
#' @description
#' The shiny application allows to explore -omics
#' data sets especially with a focus on quality control. \code{shinyQC} gives
#' information on the type of samples included (if this was previously
#' specified within the \code{SummarizedExperiment} object). It gives 
#' information on the number of missing and measured values across features 
#' and across sets (e.g. quality control samples, control, and treatment 
#' groups, only displayed for \code{SummarizedExperiment} objects that 
#' contain missing values).
#'
#' \code{shinyQC} includes functionality to display (count/intensity) values 
#' across samples (to detect drifts in intensity values during the 
#' measurement), to display
#' mean-sd plots, MA plots, ECDF plots, and distance plots between samples.
#' \code{shinyQC} includes functionality to perform dimensionality reduction
#' (currently limited to PCA, PCoA, NMDS, tSNE, and UMAP). Additionally,
#' it includes functionality to perform differential expression analysis
#' (currently limited to moderated t-tests and the Wald test).
#'
#' @details 
#' \code{rownames(se)} should be set to the corresponding name of features, 
#' while \code{colnames(se)} should be set to the sample IDs. 
#' \code{rownames(se)} and \code{colnames(se)} are not allowed to be NULL.
#' \code{colnames(se)}, \code{colnames(assay(se))} and 
#' \code{rownames(colData(se))} all have to be identical.
#' 
#' \code{shinyQC} allows to subset the supplied \code{SummarizedExperiment} object. 
#' 
#' On exit of the shiny application, the (subsetted) \code{SummarizedExperiment} 
#' object is returned with information on the processing steps (normalization, 
#' transformation, batch correction and imputation). The object will 
#' only returned if \code{app_server = FALSE} and if the function call is assigned
#' to an object, e.g. \code{tmp <- shinyQC(se)}. 
#' 
#' If the \code{se} argument is omitted the app will load an interface that allows 
#' for data upload.
#'
#' @param se \code{SummarizedExperiment} object (can be omitted)
#' @param app_server \code{logical} (set to \code{TRUE} if run under a server 
#' environment)
#'
#' @importFrom shiny div fluidRow uiOutput insertTab runApp shinyUI tabsetPanel
#' @importFrom shinydashboard dashboardPage dashboardHeader dashboardSidebar
#' @importFrom shiny tags
#' @importFrom shinyjs useShinyjs hidden show
#' @importFrom SummarizedExperiment assay colData SummarizedExperiment
#' @importFrom methods is 
#'
#' @examples 
#' library(dplyr)
#' library(SummarizedExperiment)
#' 
#' ## create se
#' set.seed(1)
#' a <- matrix(rnorm(100, mean = 10, sd = 2), nrow = 10, ncol = 10, 
#'             dimnames = list(seq_len(10), paste("sample", seq_len(10))))
#' a[c(1, 5, 8), seq_len(5)] <- NA
#' cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
#' rD <- data.frame(spectra = rownames(a))
#' se <- SummarizedExperiment(assay = a, rowData = rD, colData = cD)
#' 
#' \donttest{shinyQC(se)}
#' 
#' @author Thomas Naake
#' 
#' @return \code{shiny} application, 
#' \code{SummarizedExperiment} upon exiting the \code{shiny} application
#'
#' @export
shinyQC <- function(se, app_server = FALSE) {

    has_se <- !missing(se)
    if (has_se) {
        if (!is(se, "SummarizedExperiment")) 
            stop("se is not of class 'SummarizedExperiment'")
        if (is.null(rownames(se))) 
            stop("rownames(se) is NULL")
        if (is.null(colnames(se)))
            stop("colnames(se) is NULL")

        ## access the assay slot
        a <- SummarizedExperiment::assay(se)

        ## access the colData slot and check for integrity of colnames/rownames
        cD <- se@colData |> as.data.frame()
        if (!all(colnames(se) == rownames(cD)))
            stop("colnames(se) do not match rownames(colData(se))")
        if (!all(colnames(a) == rownames(cD)))
            stop("colnames(assay(se)) do not match rownames(colData(se))")

        ## retrieve the names of assays(se) and return a character for 
        ## choices in the selectInput UI that allows for switching between 
        ## the different assays
        choicesAssaySE <- choiceAssaySE(se)
    } else {
        choicesAssaySE <- NULL
        se <- NULL
    }

    ## create environment to store the modified SummarizedExperiment object 
    ## into, on exiting the shiny application return the object stored in
    ## env_se$se_return (this will be NULL in case there was no 
    ## SummarizedExperiment loaded yet or a modified version of the 
    ## SummarizedExperiment depending on the user input in the shiny 
    ## environment)
    env_se <- new.env(parent = emptyenv())
    env_se$se_return <- NULL
    
    on.exit(expr = if (!app_server) {
        return(invisible(env_se$se_return))
    })
    
    ## define the values of the host, set to 0.0.0.0 in the server mode, that 
    ## other clients can connect to the host, otherwise set to localhost 
    if (app_server) {
        host <- getOption("shiny.host", "0.0.0.0")
    } else {
        host <- getOption("shiny.host", "127.0.0.1")
    }

    ## assign function for landing page
    landingPage = createLandingPage()
    
    ## define UI
    ui <- shiny::shinyUI(shinydashboard::dashboardPage(skin = "black",
        shinydashboard::dashboardHeader(title = "MatrixQCvis"),
        shinydashboard::dashboardSidebar(
            #fileInput("upload", "Upload...")
            ## Sidebar with a slider input
            shinyjs::useShinyjs(debug = TRUE),
            shinyjs::hidden(
                shiny::div(id = "sidebarPanelSE",
                    tag_loadMessage(),
                    tag_keepAlive(),
                    ## sidebar for tabs 'Values' and 'Dimension Reduction'
                    ## for normalizing, transforming, batch correcting and 
                    ## imputing data
                    sidebar_assayUI(),
                    sidebar_imputationUI(),
                    ## create sidebar for tab 'DE' (input for model 
                    ## matrix/contrasts) sidebar_UI()
                    sidebar_DEUI(), 
                    ## sidebar for excluding samples from se_r and generating 
                    ## report
                    sidebar_excludeSampleUI(id = "select"), 
                    sidebar_reportUI(),
                    ## sidebar for selecting assay in multi-assay 
                    ## SummarizedExperiment
                    sidebar_selectAssayUI(choicesAssaySE = choicesAssaySE)
            ))
        ),

        shinydashboard::dashboardBody(shiny::fluidRow(
            shiny::tags$head( 
                shiny::tags$script(
                    type="text/javascript",'$(document).ready(function(){
                    $(".main-sidebar").css("height","100%");
                    $(".main-sidebar .sidebar").css({"position":"relative","max-height": "100%","overflow": "auto"})
                    })')),
            shinyjs::useShinyjs(debug = TRUE),
            shinyjs::hidden(
                shiny::div(id = "tabPanelSE",
                    shiny::tabsetPanel(type = "tabs",
                        ## tabPanel for tab "Samples"
                        tP_samples_all(),
                        ## tabPanel for tab "Values"
                        tP_values_all(),
                        ## tabPanel for tab "Dimension Reduction"
                        tP_dimensionReduction_all(),
                        ## tabPanel for tab "DE"
                        tP_DE_all(),
                    id = "tabs") ## end tabsetPanel
                )
            )
        ),
        shiny::div(id = "uploadSE", 
            shiny::uiOutput("allPanels")
        )
    )))

    ## define server function
    server <- function(input, output, session) {

        if (!has_se) {
            FUN <- function(SE, MISSINGVALUE) {
                .initialize_server(se = SE, input = input, output = output, 
                    session = session, missingValue = MISSINGVALUE, 
                    envir = env_se)
            }
            landingPage(FUN, input = input, output = output, session = session, 
                app_server = app_server)
        } else {
            missingValue <- missingValuesSE(se)
            ## tabPanel for tab "Measured Values"
            if (missingValue) shiny::insertTab(inputId = "tabs", 
                tP_measuredValues_all(), target = "Samples", position = "after")
            ## tabPanel for tab "Missing Values"
            if (missingValue) shiny::insertTab(inputId = "tabs", 
                tP_missingValues_all(), target = "Measured Values", 
                position = "after")
            shinyjs::show("tabPanelSE")
            shinyjs::show("sidebarPanelSE")
            .initialize_server(se = se, input = input, output = output, 
                session = session, missingValue = missingValue,
                envir = env_se)
        }
        
    } ## end of server

    
    ## run the app
    app <- list(ui = ui, server = server)
    
    shiny::runApp(app, host = host, launch.browser = !app_server, port = 3838)
}

#' @name .initialize_server
#' 
#' @title Server initialization of \code{shinyQC}
#' 
#' @description 
#' The function \code{.initialize_server} defines most of the server function in 
#' \code{shinyQC}. Within the server function of \code{shinyQC}, 
#' \code{.initialize_server} is called in different context depending if 
#' the \code{se} was assigned or not. 
#' 
#' @param se \code{SummarizedExperiment}
#' @param input \code{shiny} input object
#' @param output \code{shiny} output object
#' @param session \code{shiny} session object
#' @param missingValue \code{logical}, specifying if the 
#' \code{SummarizedExperiment} 
#' object contains missing values in the assay slot
#' @param envir \code{environment}, \code{environment} to store the modified 
#' \code{SummarizedExperiment} object into
#'
#' @return 
#' Observers and reactive server expressions for all app elements
#' 
#' @importFrom SummarizedExperiment assays `metadata<-`
#' @importFrom rmarkdown render
#' @importFrom shinyhelper observe_helpers
#' @importFrom shiny renderText req outputOptions reactive observe sliderInput
#' @importFrom shiny updateCheckboxInput updateSelectInput observeEvent 
#' @importFrom shiny showModal modalDialog withProgress downloadHandler
#' @importFrom shiny reactiveValues bindCache
#' 
#' @author Thomas Naake
#' 
#' @noRd
.initialize_server <- function(se, input, output, session, 
                                    missingValue = TRUE, envir = new.env()) {
    
    if (!is.logical(missingValue)) stop("missingValue has to be logical")
    if (!is(envir, "environment")) stop("envir has to be of class environment")

    output$keepAlive <- shiny::renderText({
        shiny::req(input$keepAlive)
        paste("keep alive", input$keepAlive)
    })

    output$missingVals <- shiny::renderText({missingValue})
    shiny::outputOptions(output, "missingVals", suspendWhenHidden = FALSE)

    ## create server to select assay in multi-assay se
    output$lengthAssays <- shiny::renderText({
        if (length(SummarizedExperiment::assays(se)) > 1) {
            "TRUE"
        } else {
            "FALSE"
        }
    })
    
    ## set suspendWhenHidden to FALSE to retrieve lengthAssays
    ## even if it is not called explicitly (e.g. by renderText)
    shiny::outputOptions(output, "lengthAssays", suspendWhenHidden = FALSE)
    
    se_sel <- selectAssayServer("select", se = se, 
        selected = shiny::reactive(input$assaySelected))
    
    se_feat <- shiny::reactive({
        selectFeatureSE(se_sel(), 
            selection = input[["features-excludeFeature"]], 
            mode = input[["features-mode"]])
    })
    
    sidebar_excludeSampleServer("select", se = se)
    
    ## uses 'helpfiles' directory by default
    ## we use the withMathJax parameter to render formulae
    shinyhelper::observe_helpers(withMathJax = TRUE,
        help_dir = paste(find.package("MatrixQCvis"), "helpfiles", sep = "/"))
    
    ## create reactive SummarizedExperiment objects for raw, normalized, 
    ## transformed and imputed data
    se_r <- shiny::reactive({selectSampleSE(se = se_feat(), 
        selection = input[["select-excludeSamples"]], 
        mode = input[["select-mode"]])})
    
    ## TAB: Samples
    ## barplot about number for sample type
    histSampleServer("Sample_hist", se = se_r)
    mosaicSampleServer("Sample_mosaic", se = se_r)
    
    ## TAB: Measured values and Missing values
    ## barplot number of measured/missing features per sample
    samplesMeasuredMissingTbl <- sampleMeasuredMissingServer("MeMiTbl", 
                                                            se = se_r)
    barplotMeasuredMissingSampleServer(id = "MeV_number", 
        samplesMeasuredMissing = samplesMeasuredMissingTbl, measured = TRUE)
    barplotMeasuredMissingSampleServer(id = "MiV_number", 
        samplesMeasuredMissing = samplesMeasuredMissingTbl, measured = FALSE)
    
    ## sync input[["MeV-categoryHist"]] with input[["MeV-categoryUpSet"]]
    shiny::observe({
        input[["MeV-categoryHist"]]
        ## update upon change of MeV-categoryHist MeV-categoryUpSet to the
        ## value of MeV-categoryHist
        shiny::updateCheckboxInput(session, "MeV-categoryUpSet", NULL, 
            input[["MeV-categoryHist"]])
    })
    shiny::observe({
        input[["MeV-categoryUpSet"]]
        ## update upon change of MeV-categoryUpSet MeV-categoryHist to the
        ## value of MeV-categoryUpSet
        shiny::updateCheckboxInput(session, "MeV-categoryHist", NULL, 
            input[["MeV-categoryUpSet"]])
    })
    
    ## sync input[["MiV-categoryHist"]] with input[["MiV-categoryUpSet"]]
    shiny::observe({
        input[["MiV-categoryHist"]]
        ## update upon change of MiV-categoryHist MiV-categoryUpSet to the
        ## value of MiV-categoryHist
        shiny::updateCheckboxInput(session, "MiV-categoryUpSet", NULL, 
            input[["MiV-categoryHist"]])
    })
    shiny::observe({
        input[["MiV-categoryUpSet"]]
        ## update upon change of MiV-categoryUpSet MiV-categoryHist to the
        ## value of MiV-categoryUpSet
        shiny::updateCheckboxInput(session, "MiV-categoryHist", NULL, 
            input[["MiV-categoryUpSet"]])
    })
    
    ## tab: Histogram Features
    ## histogram for measured values across samples per feature
    histFeatServer("MeV", se = se_r, assay = a, measured = TRUE)
    histFeatServer("MiV", se = se_r, assay = a, measured = FALSE)
    
    ## tab: Histogram Features along variable (e.g. sample type)
    histFeatCategoryServer("MeV", se = se_r, measured = TRUE)
    histFeatCategoryServer("MiV", se = se_r, measured = FALSE)
    
    ## tab: UpSet (UpSet plot with set of measured features)
    upSetServer("MeV", se = se_r, measured = TRUE)
    upSetServer("MiV", se = se_r, measured = FALSE)
    
    ## tab: Sets
    setsServer("MeV", se = se_r, measured = TRUE)
    setsServer("MiV", se = se_r, measured = FALSE)
    
    ## TAB: Values and Dimension reduction plots
    
    ## observe expression: update UI on loading the app
    shiny::observe({
        ## update the batchCol selectInput menu to select the variable for
        ## batch correction
        cols_cD <- colnames(se@colData)
        shiny::updateSelectInput(session = session, inputId = "batchCol", 
            choices = cols_cD)
        shiny::updateSelectInput(session = session, inputId = "groupDist", 
            choices = cols_cD)
    })
    
    ## create reactive for assay slot
    a <- shiny::reactive({
        se_r() |>
            assay() |>
            as.matrix()
    })
    
    ## reactive expression for data transformation, returns a matrix with
    ## normalized values
    a_n <- shiny::reactive({
        #shiny::req(a(), input$normalization)
        ## input$normalization is either "none", "sum", "quantile division",
        ## "quantile"
        normalizeAssay(a(), method = input$normalization, 
            probs = input$quantile, multiplyByNormalizationValue = TRUE)
    })
    
    ## create SummarizedExperiment objects with updated assays
    se_r_n <- shiny::reactive({updateSE(se = se_r(), assay = a_n())})
    
    ## reactive expression for data batch correction, returns a matrix with
    ## batch-corrected values
    a_b <- shiny::reactive({
        batchCorrectionAssay(se_r_n(), method = input$batch, 
            batch = input$batchCol)
    })
    
    shiny::observeEvent({shiny::req(input$batch); input$batch}, {
        if (input$tabs == "Values" & input$batch != "none") {
            shiny::showModal(shiny::modalDialog(
                "It seems you have applied a batch correction method in the 'Values' tab.",
                "Please make sure to assess the existence and strength of the batch effect before and after applying the batch correction method.",
                "The most informative plots are the dimension reduction plots.",
                title = "Attention!", easyClose = TRUE))
        }
    })
    
    ## reactive expression for data transformation, returns a matrix with
    ## transformed values
    a_t <- shiny::reactive({
        ## input$transformation is either "none", "log", "log2", "log10",
        ## or "vsn"
        transformAssay(a_b(), method = input$transformation)
    })
    
    ## reactive expression for data imputation, returns a matrix with
    ## imputed values
    a_i <- shiny::reactive({
        if (missingValue) {
            ## impute missing values of the data.frame with transformed values
            imputeAssay(a_t(), input$imputation)    
        } else {
            a_t()
        }
    })
    
    ## create SummarizedExperiment objects with updated assays
    ##se_r_n <- shiny::reactive({updateSE(se = se_r(), assay = a_n())})
    se_r_b <- shiny::reactive({updateSE(se = se_r(), assay = a_b())})
    se_r_t <- shiny::reactive({updateSE(se = se_r(), assay = a_t())})
    se_r_i <- shiny::reactive({updateSE(se = se_r(), assay = a_i())})
    
    ## TAB: Values
    ## boxplots
    boxPlotUIServer("boxUI", se = se)
    boxPlotServer("boxRaw", se = se_r,
        orderCategory = shiny::reactive(input[["boxUI-orderCategory"]]),
        boxLog = shiny::reactive(input$boxLog),
        violin = shiny::reactive(input$violinPlot), type = "raw")
    boxPlotServer("boxNorm", se = se_r_n,
        orderCategory = shiny::reactive(input[["boxUI-orderCategory"]]),
        boxLog = shiny::reactive(input$boxLog),
        violin = shiny::reactive(input$violinPlot), type = "normalized")
    boxPlotServer("boxBatch", se = se_r_b,
        orderCategory = shiny::reactive(input[["boxUI-orderCategory"]]),
        boxLog = shiny::reactive(input$boxLog),
        violin = shiny::reactive(input$violinPlot), type = "batch corrected")
    boxPlotServer("boxTransf", se = se_r_t,
        orderCategory = shiny::reactive(input[["boxUI-orderCategory"]]),
        boxLog = function() FALSE,
        violin = shiny::reactive(input$violinPlot), type = "transformed")
    boxPlotServer("boxImp", se = se_r_i,
        orderCategory = shiny::reactive(input[["boxUI-orderCategory"]]),
        boxLog = function() FALSE,
        violin = shiny::reactive(input$violinPlot), type = "imputed")
        
    ## drift
    driftServer("drift", se = se_r, se_n = se_r_n, se_b = se_r_b,
        se_t = se_r_t, se_i = se_r_i, missingValue = missingValue)
    
    ## coefficient of variation
    cvServer(id = "cv", a_r = a, a_n = a_n, a_b = a_b, a_t = a_t, a_i = a_i,
        missingValue = missingValue)
    
    ## mean-sd plot
    meanSdServer(id = "meanSdTransf", assay = a_t, type = "transformed")
    meanSdServer(id = "meanSdImp", assay = a_i, type = "imputed")
    
    ## MA plot
    maServer(id = "MA", se = se_r, se_n = se_r_n, se_b = se_r_b, se_t = se_r_t,
        se_i = se_r_i, innerWidth = shiny::reactive(input$innerWidth),
        missingValue = missingValue)
    
    ## ECDF
    ECDFServer("ECDF", se = se_r, se_n = se_r_n, se_b = se_r_b, 
        se_t = se_r_t, se_i = se_r_i, missingValue = missingValue)
    
    ## distances
    distServer("distRaw", se = se_r, assay = a,
        method = shiny::reactive(input$methodDistMat), 
        label = shiny::reactive(input$groupDist), type = "raw")
    distServer("distNorm", se = se_r, assay = a_n,
        method = shiny::reactive(input$methodDistMat), 
        label = shiny::reactive(input$groupDist), type = "normalized")
    distServer("distBatch", se = se_r, assay = a_b,
        method = shiny::reactive(input$methodDistMat), 
        label = shiny::reactive(input$groupDist), type = "batch corrected")
    distServer("distTransf", se = se_r, assay = a_t, 
        method = shiny::reactive(input$methodDistMat),
        label = shiny::reactive(input$groupDist), type = "transformed")
    distServer("distImp", se = se_r, assay = a_i,
        method = shiny::reactive(input$methodDistMat),
        label = shiny::reactive(input$groupDist), type = "imputed")
    
    ## Features
    featureServer("features", se = se, a = a, a_n = a_n, a_b = a_b, a_t = a_t,
        a_i = a_i, missingValue = missingValue)
    
    ## TAB: Dimension reduction
    ## observe handlers to sync "scale" and "center" between the 'PCA' and
    ## 'tSNE' tab within the 'Dimension reduction' tab
    shiny::observe({
        input[["PCA-scale"]]
        ## update upon change of PCA-scale tSNE-scale to the value of
        ## PCA-scale
        shiny::updateCheckboxInput(session, "tSNE-scale", NULL,
                                                        input[["PCA-scale"]])
    })
    shiny::observe({
        input[["tSNE-scale"]]
        ## update upon change of tSNE-scale PCA-scale to the value of
        ## tSNE-scale
        shiny::updateCheckboxInput(session, "PCA-scale", NULL,
                                                        input[["tSNE-scale"]])
    })
    observe({
        input[["PCA-center"]]
        ## update upon change of PCA-center tSNE-center to the value of
        ## PCA-center
        shiny::updateCheckboxInput(session, "tSNE-center", NULL,
                                                        input[["PCA-center"]])
    })
    shiny::observe({
        input[["tSNE-center"]]
        ## update upon change of tSNE-center PCA-center to the value of
        ## tSNE-center
        shiny::updateCheckboxInput(session, "PCA-center", NULL,
                                                        input[["tSNE-center"]])
    })

    ## observe handlers to sync "distance" method between the 'PCoA' and
    ## 'NMDS' tab within the 'Dimension reduction' tab
    shiny::observe({
        input[["PCoA-dist"]]
        ## update upon change of PCoA-dist NMDS-dist to the value of
        ## PCoA-dist
        shiny::updateCheckboxInput(session, "NMDS-dist", NULL,
                                                        input[["PCoA-dist"]])
    })
    shiny::observe({
        input[["NMDS-dist"]]
        ## update upon change of NMDS-dist PCoA-dist to the value of NMDS-dist
        shiny::updateCheckboxInput(session, "PCoA-dist", NULL,
                                                        input[["NMDS-dist"]])
    })

    ## create reactive values that stores the parameters for the dimension
    ## reduction plots
    params <- shiny::reactiveValues(
        "center" = TRUE, "scale" = FALSE, ## for PCA
        "method" = "euclidean", ## for PCoA and NMDS
        "perplexity" = 1, "max_iter" = 1000, "initial_dims" = 10, ## for tSNE
        "dims" = 3, "pca_center" = TRUE, "pca_scale" = FALSE, ## for tSNE
        "min_dist" = 0.1, "n_neighbors" = 15, "spread" = 1) ## for UMAP

    ## change the reactive values upon the user input changes
    shiny::observe({
        params$center <- input[["PCA-center"]]
        params$scale <- input[["PCA-scale"]]
        params$method <- input[["PCoA-dist"]]
        params$perplexity <- input[["tSNE-perplexity"]]
        params$max_iter <- input[["tSNE-maxIter"]]
        params$initial_dims <- input[["tSNE-initialDims"]]
        params$dims <- input[["tSNE-dims"]]
        params$pca_center <- input[["PCA-center"]]
        params$pca_scale <- input[["PCA-scale"]]
        params$min_dist <- input[["UMAP-minDist"]]
        params$n_neighbors <- input[["UMAP-nNeighbors"]]
        params$spread <- input[["UMAP-spread"]]
    })

    ## server modules for the dimensional reduction plots
    sample_n <- reactive({ncol(se_r())})

    dimRedServer(id = "PCA", se = se_r, assay = a_i, type = "PCA",
        label = "PC", params = shiny::reactive(params),
        innerWidth = shiny::reactive(input$innerWidth), 
        selectedTab = shiny::reactive(input$dimensionReductionTab))
    dimRedServer(id = "PCoA", se = se_r, assay = a_i, type = "PCoA",
        label = "axis", params = shiny::reactive(params),
        innerWidth = shiny::reactive(input$innerWidth), 
        selectedTab = shiny::reactive(input$dimensionReductionTab))
    dimRedServer(id = "NMDS", se = se_r, assay = a_i, type = "NMDS",
        label = "MDS", params = shiny::reactive(params),
        innerWidth = shiny::reactive(input$innerWidth), 
        selectedTab = shiny::reactive(input$dimensionReductionTab))
    dimRedServer(id = "tSNE", se = se_r, assay = a_i, type = "tSNE",
        label = "dimension", params = shiny::reactive(params),
        innerWidth = shiny::reactive(input$innerWidth),
        selectedTab = shiny::reactive(input$dimensionReductionTab))
    tSNEUIServer(id = "tSNE", sample_n = sample_n)
    dimRedServer(id = "UMAP", se = se_r, assay = a_i, type = "UMAP",
        label = "axis", params = shiny::reactive(params),
        innerWidth = shiny::reactive(input$innerWidth),
        selectedTab = shiny::reactive(input$dimensionReductionTab))
    umapUIServer(id = "UMAP", sample_n = sample_n)
 
    ## run additional server modules for the scree plots (only for the
    ## tabs 'PCA' and 'tSNE') and loading plot
    screePlotServer("PCA", assay = a_i,
        center = shiny::reactive(input[["PCA-center"]]),
        scale = shiny::reactive(input[["PCA-scale"]]))
    loadingsPlotServer("PCA", assay = a_i, params = shiny::reactive(params))
    screePlotServer("tSNE", assay = a_i,
        center = shiny::reactive(input[["tSNE-center"]]),
        scale = shiny::reactive(input[["tSNE-scale"]]))

    ## TAB: Differential Expression (DE)
    ## create data.frame with colData of the supplied se
    colDataServer("colData", se = se_r)
    
    ## check if the supplied formula (input$modelMat) is valid and return
    ## NULL if otherwise
    validFormulaMM <- validFormulaMMServer("modelMatrix", 
        expr = shiny::reactive(input$modelMat), 
        action = shiny::reactive(input$actionModelMat), se = se_r)
    
    ## create the matrix of the Model Matrix using the validFormulaMM
    modelMatrix <- modelMatrixServer("modelMatrix", se = se_r, 
        validFormulaMM = validFormulaMM)
    
    ## create the data.frame of the Model Matrix to display
    modelMatrixUIServer("modelMatrix", modelMatrix = modelMatrix, 
        validFormulaMM = validFormulaMM)
    
    ## check if the supplied formula/expr (input$contrastMat) is vald and 
    ## return NULL if otherwise
    validExprContrast <- validExprContrastServer("contrast", 
        expr = shiny::reactive(input$contrastMat), 
        action = shiny::reactive(input$actionContrasts), modelMatrix = modelMatrix)
    
    ## create the matrix of the Contrast Matrix using the validExprContrast
    contrastMatrix <- contrastMatrixServer("contrast", 
        validExprContrast = validExprContrast, modelMatrix = modelMatrix)
    
    ## create the data.frame of the Contrast Matrix to display
    contrastMatrixUIServer("contrast", validFormulaMM = validFormulaMM, 
        validExprContrast = validExprContrast, contrastMatrix = contrastMatrix)
    
    ## calculate the fit and test results with eBayes (ttest) and 
    ## proDA, cache the results for proDA since it is computationally
    ## expensive
    fit_ttest <- fitServer("ttest", assay = a_i, 
        modelMatrix = modelMatrix,
        contrastMatrix = contrastMatrix)
    
    fit_proDA <- fitServer("proDA", assay = a_t,
            modelMatrix = modelMatrix,
            contrastMatrix = contrastMatrix) |>
        shiny::bindCache(a_t(), modelMatrix(), contrastMatrix(), 
                                                            cache = "session")
    
    ## create data.frame with the test results
    testResult <- testResultServer("testServer", 
        type = shiny::reactive(input$DEtype), fit_ttest = fit_ttest, 
        fit_proDA = fit_proDA, validFormulaMM = validFormulaMM, 
        validExprContrast = validExprContrast)
    
    
    ## display the test results
    topDEUIServer("topDE", type = shiny::reactive(input$DEtype),
        validFormulaMM = validFormulaMM, 
        validExprContrast = validExprContrast, testResult = testResult)
    
    ## create Volcano plot
    volcanoUIServer("volcano", type = shiny::reactive(input$DEtype),
        validFormulaMM = validFormulaMM,
        validExprContrast = validExprContrast, testResult = testResult)
    
    ## observer for creating the report
    output$report <- shiny::downloadHandler(
        filename = "report_qc.html",
        content = function(file) {
            shiny::withProgress(message = "Rendering, please wait!", {
                rep_tmp <- paste(find.package("MatrixQCvis"), 
                    "report/report_qc.Rmd", sep = "/")

                params_l = list(
                    missingValue = missingValue,
                    se_r = se_r(), se_n = se_r_n(), se_b = se_r_b(), 
                    se_t = se_r_t(), se_i = se_r_i(),
                    sample_hist = input[["Sample_hist-typeHist"]],
                    sample_mosaic_f1 = input[["Sample_mosaic-mosaicf1"]],
                    sample_mosaic_f2 = input[["Sample_mosaic-mosaicf2"]])
                
                if (missingValue) {
                    params_l <- append(params_l, 
                        list(mev_binwidth = input[["MeV-binwidth"]],
                            mev_binwidthC = input[["MeV-binwidthC"]],
                            mev_hist_category = input[["MeV-categoryHist"]],
                            mev_upset_category = input[["MeV-categoryUpset"]],
                            miv_binwidth = input[["MiV-binwidth"]],
                            miv_binwidthC = input[["MiV-binwidthC"]],
                            miv_hist_category = input[["MiV-categoryHist"]],
                            miv_upset_category = input[["MiV-categoryUpSet"]]))
                } else {
                    params_l <- append(params_l, 
                        list(mev_binwidth = 1, mev_binwidthC = 1,
                            mev_hist_category = NULL, mev_upset_category = NULL,
                            miv_binwidth = 1, miv_binwidthC = 1,
                            miv_hist_category = NULL, 
                            miv_upset_category = NULL))
                }
                params_l <- append(params_l,
                    list(int_log = input[["boxLog"]], 
                        int_violin = input[["violinPlot"]],
                        int_violin_orderCategory = input[["boxUI-orderCategory"]],
                        int_drift_data = input[["drift-data"]],
                        int_drift_aggregation = input[["drift-aggregation"]],
                        int_drift_category = input[["drift-category"]],
                        int_drift_orderCategory = input[["drift-orderCategory"]],
                        int_drift_level = input[["drift-levelSel"]],
                        int_drift_method = input[["drift-method"]],
                        int_ma_data = input[["MA-MAtype"]],
                        int_ma_group = input[["MA-groupMA"]],
                        int_ma_plot = input[["MA-plotMA"]],
                        int_hD_lines = input[["hDLines"]],
                        int_ecdf_data = input[["ECDF-ECDFtype"]],
                        int_ecdf_sample = input[["ECDF-sampleECDF"]],
                        int_ecdf_group = input[["ECDF-groupECDF"]],
                        int_dist_method = input[["methodDistMat"]],
                        int_dist_label = input[["groupDist"]],
                        int_feat_selectFeat = input[["features-selectFeature"]],
                        int_feat_featLine = input[["features-FeatureLines"]],
                        dr_pca_center = params$center,
                        dr_pca_scale = params$scale,
                        dr_pca_color = input[["PCA-color"]],
                        dr_pca_x = input[["PCA-x"]], 
                        dr_pca_y = input[["PCA-y"]],
                        dr_pcoa_method = params$method,
                        dr_pcoa_color = input[["PCoA-color"]],
                        dr_pcoa_x = input[["PCoA-x"]], 
                        dr_pcoa_y = input[["PCoA-y"]],
                        dr_nmds_color = input[["NMDS-color"]],
                        dr_nmds_x = input[["NMDS-x"]], 
                        dr_nmds_y = input[["NMDS-y"]],
                        dr_tsne_perplexity = params$perplexity,
                        dr_tsne_max_iter = params$max_iter,
                        dr_tsne_initial_dims = params$initial_dims,
                        dr_tsne_dims = params$dims,
                        dr_tsne_pca_center = params$pca_center,
                        dr_tsne_pca_scale = params$pca_scale,
                        dr_tsne_color = input[["tSNE-color"]],
                        dr_tsne_x = input[["tSNE-x"]], 
                        dr_tsne_y = input[["tSNE-y"]],
                        dr_umap_min_dist = params$min_dist,
                        dr_umap_n_neighbors = params$n_neighbors,
                        dr_umap_spread = params$spread,
                        dr_umap_color = input[["UMAP-color"]],
                        dr_umap_x = input[["UMAP-x"]], 
                        dr_umap_y = input[["UMAP-y"]],
                        de_m_formula = validFormulaMM(),
                        de_c_formula = validExprContrast,
                        de_method = input[["DEtype"]],
                        de_fit_ttest = fit_ttest(),
                        de_fit_proDA = fit_proDA()
                    )
                )
                
                rmarkdown::render(input = rep_tmp, output_file = file, 
                    params = params_l, envir = new.env(parent=globalenv()))
            })
        }
    )

    ## assign the se_r_i SummarizedExperiment to the environment envir
    ## (this object will be returned when exiting shinyQC)
    observe({
        se <- se_r_i()
        se@metadata <- list(
            "normalized" = input$normalization,
            "batch corrected" = input$batch,
            "transformation" = input$transformation)

        if (missingValue) {
            se@metadata[["imputation"]] <- input$imputation
        }
        assign("se_return", se, envir = envir)
        
    })
}

#' @importFrom SummarizedExperiment SummarizedExperiment 


## function shinyQC
test_that("shinyQC", {
    ## create SummarizedExperiment that doesn't comply with the expectations
    se <- SummarizedExperiment::SummarizedExperiment(
        assays = list(counts = matrix(100 * runif(100 * 8), 100, 8)),
        colData = data.frame(sample = paste0("S", seq_len(8)),
            group = sample(LETTERS[c(1, 2)], 8, replace = TRUE),
            name = paste0("S", seq_len(8)))
    )
    expect_error(shinyQC(se), "rownames[(]se[)] is NULL")
    rownames(se) <- seq_len(100)
    expect_error(shinyQC(se), "colnames[(]se[)] is NULL")
    colnames(se) <- seq_len(8)
    tmp <- 1
    expect_error(shinyQC(tmp), "se is not of class 'SummarizedExperiment'")
})

## function .initialize_server
test_that(".initialize_server", {
    se <- SummarizedExperiment::SummarizedExperiment(
        assays = list(counts = matrix(100 * runif(100 * 8), 100, 8)),
        colData = data.frame(sample = paste0("S", seq_len(8)),
            group = sample(LETTERS[c(1, 2)], 8, replace = TRUE),
            name = paste0("S", seq_len(8)))
    )
    expect_error(MatrixQCvis:::.initialize_server(se = se, input = new.env(),
        output = new.env, session = new.env(), missingValue = NULL,
        envir = new.env()), "missingValue has to be logical")
    expect_error(MatrixQCvis:::.initialize_server(se = se, input = new.env(),
        output = new.env, session = new.env(), missingValue = TRUE,
        envir = NULL), "envir has to be of class environment")
    expect_is(MatrixQCvis:::.initialize_server, "function")
})

#' @name tP_barplotMeasuredMissingSampleUI
#' 
#' @title Tab panel UI for tab panel 'Number of Features'
#' 
#' @description 
#' The module defines the UI for the tab panel 'Number of Features'.
#' 
#' @details
#' \code{tP_histFeatUI} returns the HTML code for the tab-pane 'Number of Features'.
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param title \code{character}
#' 
#' @return 
#' \code{shiny.tag} with HTML content
#'
#' @author Thomas Naake
#' 
#' @examples
#' tP_barplotMeasuredMissingSampleUI("test")
#' 
#' @importFrom shiny NS tabPanel downloadButton
#' @importFrom shinyhelper helper
#' @importFrom plotly plotlyOutput
#' 
#' @noRd
tP_barplotMeasuredMissingSampleUI <- function(id, title = "Number of measured features") {
    ns <- shiny::NS(id)
    
    if (id == "MeV_number") {
        helper_file <- "tabPanel_barNumberFeature_measured"
    }
    if (id == "MiV_number") {
        helper_file <- "tabPanel_barNumberFeature_missing"
    }
    
    shiny::tabPanel(title = title,
        plotly::plotlyOutput(ns("barplotNumber")) |>
            shinyhelper::helper(content = helper_file),
        shiny::downloadButton(outputId = ns("downloadPlot"), "")
    )
}

#' @name sampleMeasuredMissingServer
#' 
#' @title Module for server expressions of tab panel 'Number of features'
#' 
#' @description 
#' The module defines the server expressions for the tab panel 
#' 'Number of features'.
#' 
#' @details 
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param se \code{SummarizedExperiment} and \code{reactive} value
#' 
#' @return
#' \code{shiny.render.function} expression
#'
#' @author Thomas Naake
#' 
#' @importFrom shiny moduleServer reactive
#' 
#' @noRd
sampleMeasuredMissingServer <- function(id, se) {
    
    shiny::moduleServer(
        id, 
        function(input, output, session) {
            
            shiny::reactive({
                samplesMeasuredMissing(se())
            })
            
        }
    )
}


#' @name barplotMeasuredMissinSampleServer
#' 
#' @title Module for server expressions of tab panel 'Number of features'
#' 
#' @description 
#' The module defines the server expressions for the tab panel 
#' 'Number of features'.
#' 
#' @details 
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param samplesMeasuredMissing \code{tibble} and \code{reactive} value
#' @param measured \code{logical}
#' 
#' @return
#' \code{shiny.render.function} expression
#'
#' @author Thomas Naake
#' 
#' @importFrom shiny moduleServer reactive downloadHandler
#' @importFrom plotly renderPlotly
#' @importFrom htmlwidgets saveWidget
#' 
#' @noRd
barplotMeasuredMissingSampleServer <- function(id, samplesMeasuredMissing,
    measured = TRUE) {
    
    shiny::moduleServer(
        id, 
        function(input, output, session) {
            
            p_barplotNumber <- shiny::reactive({
                barplotSamplesMeasuredMissing(samplesMeasuredMissing(), 
                    measured = measured)
            })
            
            output$barplotNumber <- plotly::renderPlotly({
                p_barplotNumber()
            })
            
            output$downloadPlot <- shiny::downloadHandler(
                filename = function() {
                    paste("Number_of_features_measured_", 
                                            measured, ".html", sep = "")
                },
                content = function(file) {
                    htmlwidgets::saveWidget(p_barplotNumber(), file)
                }
            )
        }
    )
}



#' @name tP_histFeatUI
#' 
#' @title Tab panel UI for tab panel 'Histogram Features'
#' 
#' @description 
#' The module defines the UI for the tab panel 'Histogram Features'.
#' 
#' @details
#' \code{tP_histFeatUI} returns the HTML code for the tab-pane 'Histogram Features'. 
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param se \code{SummarizedExperiment} object
#' 
#' @return 
#' \code{shiny.tag} with HTML content
#'
#' @author Thomas Naake
#' 
#' @examples
#' tP_histFeatUI("test")
#' 
#' @importFrom shiny NS tabPanel downloadButton uiOutput
#' @importFrom shinyhelper helper
#' @importFrom plotly plotlyOutput
#' 
#' @noRd
tP_histFeatUI <- function(id) {
    ns <- shiny::NS(id)
    
    if (id == "MeV") {
        helper_file <-  "tabPanel_histFeature_measured"
    } 
    if (id == "MiV") {
        helper_file <- "tabPanel_histFeature_missing"
    }
    
    shiny::tabPanel(title = "Histogram Features",
        plotly::plotlyOutput(ns("histFeature")) |>
            shinyhelper::helper(content = helper_file),
        shiny::downloadButton(outputId = ns("downloadPlot_hist"), ""),
        shiny::sliderInput(inputId = ns("binwidth"), label = "Binwidth: ", 
            min = 1, max = 1, value = 1, step = 1)
    )
    
}


#' @name histFeatServer
#' 
#' @title Module for server expressions of tab panel 'Histogram Features'
#' 
#' @description 
#' The module defines the server expressions for the tab panel 
#' 'Histogram Features'
#' 
#' @details 
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param assay \code{matrix} and \code{reactive} value, obtained from 
#' \code{assay(se)}
#' @param measured \code{logical}
#' 
#' @return
#' \code{shiny.render.function} expression
#'
#' @author Thomas Naake
#' 
#' @importFrom shiny moduleServer reactive updateSliderInput
#' @importFrom shiny downloadHandler 
#' @importFrom htmlwidgets saveWidget
#' 
#' @noRd
histFeatServer <- function(id, se, assay, measured = TRUE) {
    
    shiny::moduleServer(
        id, 
        function(input, output, session) {
            
            shiny::observe({
                shiny::updateSliderInput(session = session, 
                    inputId = "binwidth", max = ncol(se()))
            })
            
            p_histFeature <- shiny::reactive({
                histFeature(assay(), binwidth = input$binwidth, 
                    measured = measured)
            })
            
            output$histFeature <- plotly::renderPlotly({
                p_histFeature()
            })
            
            output$downloadPlot_hist <- shiny::downloadHandler(
                filename = function() {
                    paste("Histogram_features_measured_", 
                                                measured, ".html", sep = "")
                },
                content = function(file) {
                    htmlwidgets::saveWidget(p_histFeature(), file)
                }
            )
        }
    )
}
    
    
    
#' @name tP_histFeatCategoryUI
#' 
#' @title Tab panel UI for tab panel 'Histogram Features along variable'
#' 
#' @description 
#' The function defines the UI for the tab panel 
#' 'Histogram Features along variable'.
#' 
#' @details 
#' \code{tP_histFeatCategoryUI} returns the HTML code for the tab-pane
#' 'Histogram Features along variable'. Internal function for \code{shinyQC}.
#'
#' @param id \code{character}
#' @param se \code{SummarizedExperiment} object
#' 
#' @return 
#' \code{shiny.tag} with HTML content
#'
#' @author Thomas Naake
#' 
#' @examples
#' tP_histFeatCategoryUI("test")
#' 
#' @importFrom shiny NS tabPanel downloadButton uiOutput
#' @importFrom plotly plotlyOutput
#' @importFrom shinyhelper helper
#' 
#' @noRd
tP_histFeatCategoryUI <- function(id) {
    ns <- shiny::NS(id)
    
    if (id == "MeV") {
        helper_file <- "tabPanel_histFeatureSample_measured"
    }
    if (id == "MiV") {
        helper_file <- "tabPanel_histFeatureSample_missing"
    }
    
    shiny::tabPanel(title = "Histogram Features along variable",
        plotly::plotlyOutput(ns("histFeatureCategory")) |>
            shinyhelper::helper(content = helper_file),
        shiny::downloadButton(outputId = ns("downloadPlot_histFeat"), ""),
        sliderInput(inputId = ns("numberFeatures"),
            label = "Binwidth (# features per sample type): ", 
            step = 1, min = 1, value = 1, max = 2),
        shiny::selectInput(inputId = ns("categoryHist"), 
            label = "Variable for stratification", choices = "name")
    )
}

#' @name histFeatCategoryServer
#' 
#' @title Module for server expressions of tab panel
#' 'Histogram Features along variable'
#' 
#' @description 
#' The function defines the output for the tab panel 
#' 'Histogram Features along variable'
#' 
#' @details
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param se \code{SummarizedExperiment} object and \code{reactive} values
#' @param measured \code{logical}
#' 
#' @return
#' \code{shiny.render.function} expression
#'
#' @author Thomas Naake
#' 
#' @importFrom shiny moduleServer updateSelectInput updateSliderInput reactive
#' @importFrom shiny req downloadHandler
#' @importFrom htmlwidgets saveWidget
#' @importFrom plotly renderPlotly
#' 
#' @noRd
histFeatCategoryServer <- function(id, se, measured = TRUE) {
    
    shiny::moduleServer(
        id,
        function(input, output, session) {
            
            cD <- shiny::reactive(se()@colData)
            
            shiny::observe({
                shiny::updateSelectInput(session = session,
                    inputId = "categoryHist",
                    choices = colnames(cD()))
            })
            
            shiny::observe({
                req(input$categoryHist)
                updateSliderInput(session = session,
                    inputId = "numberFeatures",
                    max = max(as.vector(table(cD()[[input$categoryHist]]))))
            })
            
            p_histFeatureCategory <- shiny::reactive({
                histFeatureCategory(se(), binwidth = input$numberFeatures, 
                    measured = measured, category = input$categoryHist)
            })
            
            output$histFeatureCategory <- plotly::renderPlotly({
                p_histFeatureCategory()
            })
            
            output$downloadPlot_histFeat <- shiny::downloadHandler(
                filename = function() {
                    paste("Histogram_features_along_variable_measured_", 
                        measured, ".html", sep = "")
                },
                content = function(file) {
                    htmlwidgets::saveWidget(p_histFeatureCategory(), file)
                }
            )
        }
    )
}

#' @name tP_upSetUI
#' 
#' @title Tab panel UI for tab panel ''UpSet'
#' 
#' @description 
#' The module defines the UI for the tab panel 'UpSet'.
#' 
#' @details
#' \code{tP_upSetUI} returns the HTML code for the tab-pane 'UpSet'. 
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' 
#' @return 
#' \code{shiny.tag} with HTML content
#'
#' @author Thomas Naake
#' 
#' @examples
#' tP_upSetUI("test")
#' 
#' @importFrom shiny tabPanel plotOutput downloadButton uiOutput
#' @importFrom shinyhelper helper
#' 
#' @noRd
#' 
tP_upSetUI <- function(id) {
    ns <- shiny::NS(id)
    
    if (id == "MeV") {
        helper_file <- "tabPanel_upSet_measured"
    } 
    if (id == "MiV") {
        helper_file <- "tabPanel_upSet_missing"
    }
    
    tabPanel(title = "UpSet", 
        shiny::plotOutput(ns("upsetSample")) |>
            shinyhelper::helper(content = helper_file),
        shiny::downloadButton(outputId = ns("downloadPlot"), ""),
        shiny::selectInput(inputId = ns("categoryUpSet"), 
            label = "Variable for stratification", choices = "type")
    )
}

#' @name upSetServer
#' 
#' @title Module for server expressions of tab panel 'UpSet'
#' 
#' @description 
#' The function defines the server expressions for the tab panel 'UpSet'.
#' 
#' @details
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param se \code{SummarizedExperiment} object and \code{reactive} values
#' @param measured \code{logical}
#' 
#' @return
#' \code{shiny.render.function} expression
#'
#' @author Thomas Naake
#' 
#' @importFrom shiny moduleServer updateSelectInput req reactive
#' @importFrom shiny downloadHandler renderPlot
#' @importFrom ggplot2 ggsave
#' 
#' @noRd
upSetServer <- function(id, se, measured = TRUE) {
    
    shiny::moduleServer(
        id, 
        function(input, output, session) {
            
            shiny::observe({
                shiny::updateSelectInput(session = session,
                    inputId = "categoryUpSet", 
                    choices = colnames(se()@colData))
            })
            
            p_upset <- shiny::reactive({
                upsetCategory(se(), category = input$categoryUpSet, 
                    measured = measured)
            })
            
            output$upsetSample <- shiny::renderPlot({
                p_upset()
            })
            
            output$downloadPlot <- shiny::downloadHandler(
                filename = function() {
                    paste("upSet_measured_", measured, ".pdf", sep = "")
                },
                content = function(file) {
                    ggplot2::ggsave(file, p_upset(), device = "pdf",
                        limitsize = FALSE)
                }
            )
        }
    )
}

#' @name tP_setsUI
#' 
#' @title Tab panel UI for tab panel 'Sets'
#' 
#' @description 
#' The module defines the UI for the tab panel 'Sets'.
#' 
#' @details 
#' \code{tP_setsUI} returns the HTML code for the tab-pane 'Sets'. 
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' 
#' @return 
#' \code{shiny.tag} with HTML content
#'
#' @author Thomas Naake
#' 
#' @examples
#' tP_setUI("test")
#' 
#' @importFrom shiny NS uiOutput textOutput tabPanel
#' @importFrom shinyhelper helper
#' @noRd 
tP_setsUI <- function(id) {
    ns <- shiny::NS(id)
    
    if (id == "MeV") {
        helper_file <- "tabPanel_sets_measured"
    } 
    if (id == "MiV") {
        helper_file <- "tabPanel_sets_missing"
    }
    
    shiny::tabPanel(title = "Sets", 
        shiny::checkboxGroupInput(inputId = ns("checkboxCategory"), 
            label = "Select sets", choices = "setA") |> 
            shinyhelper::helper(content = helper_file),
        shiny::textOutput(ns("combinationText"))
    )
}

#' @name setsServer
#' 
#' @title Module for server expressions of tab panel 'Sets'
#' 
#' @description 
#' The module defines the server expressions for the tab panel 'Sets'.
#' 
#' @details
#' Internal function for \code{shinyQC}.
#' 
#' @param id \code{character}
#' @param se \code{SummarizedExperiment} object and \code{reactive} values
#' @param measured \code{logical}
#' 
#' @return
#' \code{shiny.render.function} expression
#'
#' @author Thomas Naake
#' 
#' @importFrom shiny moduleServer updateCheckboxGroupInput renderText 
#' @importFrom shiny req
#' 
#' @noRd
setsServer <- function(id, se, measured = TRUE) {
    
    shiny::moduleServer(
        id, 
        function(input, output, session) {
            
            shiny::observe({
                shiny::req(input$categoryUpSet)
                shiny::updateCheckboxGroupInput(session = session,
                    inputId = "checkboxCategory", 
                    choices = unique(se()@colData[[input$categoryUpSet]])) 
            })
            
            output$combinationText <- shiny::renderText({
                extractComb(se(), combination = input$checkboxCategory, 
                    category = input$categoryUpSet, measured = measured)
            })
        }
    )
}


#' @name tP_measuredValues_all
#' 
#' @title Tab panel UI for tab panel 'Measured Values'
#' 
#' @description 
#' The module defines the UI for the tab panel 'Measured Values'.
#' 
#' @details 
#' \code{tP_measuredValues_all} returns the HTML code for the tab-pane 
#' 'Measured Values'. Internal function for \code{shinyQC}.
#' 
#' @return 
#' \code{shiny.tag} with HTML content
#'
#' @author Thomas Naake
#' 
#' @examples
#' tP_measuredValues_all()
#' 
#' @importFrom shiny tabPanel 
#' @importFrom shinydashboard tabBox
#' 
#' @noRd 
tP_measuredValues_all <- function() {
    shiny::tabPanel("Measured Values",
        shinydashboard::tabBox(title = "", width = 12,
            tP_barplotMeasuredMissingSampleUI(id = "MeV_number", 
                title = "Number of features"),
            tP_histFeatUI(id = "MeV"),
            tP_histFeatCategoryUI(id = "MeV"),
            tP_upSetUI(id = "MeV"),
            tP_setsUI(id = "MeV")
        )
    )    
}

#' @name tP_missingValues_all
#' 
#' @title Tab panel UI for tab panel 'Missing Values'
#' 
#' @description 
#' The module defines the UI for the tab panel 'Missing Values'.
#' 
#' @details 
#' \code{tP_missingValues_all} returns the HTML code for the tab-pane 
#' 'Missing Values'. Internal function for \code{shinyQC}.
#' 
#' @return 
#' \code{shiny.tag} with HTML content
#'
#' @author Thomas Naake
#' 
#' @examples
#' tP_missingValues_all()
#' 
#' @importFrom shiny tabPanel 
#' @importFrom shinydashboard tabBox
#' 
#' @noRd
tP_missingValues_all <- function() {
        shiny::tabPanel("Missing Values",
            shinydashboard::tabBox(title = "", width = 12,
                tP_barplotMeasuredMissingSampleUI(id = "MiV_number",
                    title = "Number of features"),
                tP_histFeatUI(id = "MiV"),
                tP_histFeatCategoryUI(id = "MiV"),
                tP_upSetUI(id = "MiV"),
                tP_setsUI(id = "MiV")
            )
        )
}

## create se
a <- matrix(seq_len(1000), nrow = 100, ncol = 10,
            dimnames = list(seq_len(100), paste("sample", seq_len(10))))
a[c(1, 5, 8), seq_len(5)] <- NA
set.seed(1)
a <- a + rnorm(1000)
cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
rD <- data.frame(spectra = rownames(a))
se <- SummarizedExperiment::SummarizedExperiment(assay = a, rowData = rD, 
    colData = cD)


## tP_barplotMeasuredMissingSampleUI
test_that("tP_barplotMeasuredMissingSampleUI", {
    expect_is(tP_barplotMeasuredMissingSampleUI("MeV_number", 
        title = "test"), "shiny.tag")
    expect_is(tP_barplotMeasuredMissingSampleUI("MiV_number", 
        title = "test"), "shiny.tag")
})

## sampleMeasuredMissingServer
test_that("sampleMeasuredMissingServer", {
    shiny::testServer(sampleMeasuredMissingServer, {
        input <- new.env()
        output <- new.env()
        session <- new.env()
        se <- new.env()

        out <- sampleMeasuredMissingServer("", se = se)
        expect_is(out, "reactive")
    })
})

## barplotMeasuredMissingSampleServer
test_that("barplotMeasuredMissingSampleServer", {
    shiny::testServer(barplotMeasuredMissingSampleServer, {

        input <- new.env()
        output <- new.env()
        session <- new.env()
        samplesMeasuredMissing <- new.env()

        out <- barplotMeasuredMissingSampleServer("", 
            samplesMeasuredMissing = samplesMeasuredMissing,
            measured = TRUE)
        expect_is(out, "shiny.render.function")
    })
})

## tP_histFeatUI
test_that("tP_histFeatUI", {
    expect_is(tP_histFeatUI("MeV"), "shiny.tag")
    expect_is(tP_histFeatUI("MiV"), "shiny.tag")
})

## histFeatServer
test_that("histFeatServer", {
    shiny::testServer(histFeatServer, {
        input <- new.env()
        output <- new.env()
        session <- new.env()
        id <- new.env()
        se <- new.env()
        assay <- new.env()

        out <- histFeatServer("", se = se, assay = assay, measured = TRUE)
        expect_is(out, "shiny.render.function")
    })
})

## tP_histFeatCategoryUI
test_that("tP_histFeatCategoryUI", {
    expect_is(tP_histFeatCategoryUI("MeV"), "shiny.tag")
    expect_is(tP_histFeatCategoryUI("MiV"), "shiny.tag")
})

## histFeatCategoryServer
test_that("histFeatCategoryServer", {
    shiny::testServer(histFeatCategoryServer, {
        input <- new.env()
        output <- new.env()
        session <- new.env()
        id <- new.env()
        se <- new.env()

        out <- histFeatCategoryServer("", se = se, measured = TRUE)
        expect_is(out, "shiny.render.function")
    })
})

## tP_upSetUI
test_that("tP_upSetUI", {
    expect_is(tP_upSetUI("MeV"), "shiny.tag")
    expect_is(tP_upSetUI("MiV"), "shiny.tag")
})

## upSetServer
test_that("upSetServer", {
    shiny::testServer(upSetServer, {
        input <- new.env()
        output <- new.env()
        session <- new.env()
        id <- new.env()
        se <- new.env()

        out <- upSetServer("", se = se, measured = TRUE)
        expect_is(out, "shiny.render.function")
    })
})

## tP_setsUI
test_that("tP_setsUI", {
    expect_is(tP_setsUI("MeV"), "shiny.tag")
    expect_is(tP_setsUI("MiV"), "shiny.tag")
})

## setsServer
test_that("setsServer", {
    shiny::testServer(setsServer, {
        input <- new.env()
        output <- new.env()
        session <- new.env()
        id <- new.env()
        se <- new.env()

        out <- setsServer("", se = se, measured = TRUE)
        expect_is(out, "shiny.render.function")
    })
})

## tP_measuredValues_all
test_that("tP_measuredValues_all", {
    expect_is(tP_measuredValues_all(), "shiny.tag")
})

## tP_missingValues_all
test_that("tP_missingValues_all", {
    expect_is(tP_missingValues_all(), "shiny.tag")
})

### Barplot for number of features

The plot shows the number of missing features 
along the samples. Missing values are defined as `NA` values in `assay(se)`.
The plot will help to identify samples that 
have a high number of missing values that can be excluded from further analysis.

### Coefficient of variation among the samples

This panel shows the coefficient of variation values for 

 - raw (**raw**), 
 - normalized (**normalized**), 
 - normalized+batch corrected (**batch corrected**),
 - normalized+batch corrected+transformed (**transformed**), and
 - normalized+batch corrected+transformed+imputed (**imputed**) 
 
assay values. The **imputed** values are only displayed if there are 
missing values (`NA`s) in the **raw** data set. The different methods for 
normalization, transformation, batch correction and imputation are 
specified in the side panel. 

The panel displays the coefficient of variation values from the samples of the
 `SummarizedExperiment` object (in percent). The coefficients of variation are 
 calculated according to the formula `sd(x) / mean(x) * 100` with `x` 
 the sample values and `sd` the standard deviation.
 

### MA plot and Hoeffding's D statistic

In the first part of the panel the `A` vs. `M` plots per sample are depicted.

The values are defined as follows
- $A = 1/2 \cdot (I_i + I_j)$ and
- $M = I_i- I_j$,
where $I_i$ and $I_j$ are transformed values. In the case of **raw** or
**normalized** the values are `log2`-transformed prior to 
calculating `A` and `M`. In case of **transformed** or
**batch corrected**
the values are taken as they are (N.B. when the transformation
method is set to **none** the values are not `log2`-transformed).

The values for $I_i$ are taken from the sample $i$. For $I_j$, the feature-wise 
means are calculated from the values of the **group** $j$ of samples specified 
by the drop-down menu **group**. The sample for calculating $I_i$ is
excluded from the group $j$. The group can be set to `"all"`
(i.e. all samples except sample $i$ are used to calculate
$I_j$) or any other column in `colData(se)`. For any group except `"all"` the
group is taken to which the sample $i$ belongs to and the sample $i$ is 
excluded from the feature-wise calculation. 

The MA values for all samples are by default displayed facet-wise. The MA plot 
can be set to specific samples by changing the selected value in the 
input menu **plot**.

The underlying data set can be selected by the drop-down menu 
(**Data set for the MA plot**). 


In the second part of the tab, the Hoeffding's D statistic values are 
visualized for the different data sets **raw**, **normalized**, 
**transformed**, and **batch corrected**. 

`D` is a measure of the distance between `F(A, M)` and `G(A)H(M)`, where
`F(A, M)` is the joint cumulative distribution function (CDF) of 
`A` and `M`, and `G` and `H` are marginal CDFs. 
The higher the value of `D`, the more dependent are `A` and `M`. 

### Boxplot or violin plots of assay values among the samples

This tab shows the assay values for 

 - raw (**raw**), 
 - normalized (**normalized**),
 - normalized+batch corrected (**batch corrected**), 
 - normalized+batch corrected+transformed (**transformed**), 
 - normalized+batch corrected+transformed+imputed (**imputed**) 
 
assay values. The **imputed** values are only displayed if there are missing 
values (`NA`s) in the **raw** data set. The different methods for 
normalization, transformation, batch correction and imputation are specified 
in the side panel. 

For visualization purposes only, the assay values for the raw and normalized 
data sets can be `log` transformed 
(**Display log values? (only for 'raw' and 'normalized')**).

The type of visualization (boplot or violin plot) can be specified 
by selecting `boxplot` or `violin` in the radio button panel. 

### Distance matrices between samples

On the left, the panel depicts heatmaps of distances between samples for 
the data sets of
raw (**raw**), normalized (**normalized**), normalized+transformed 
(**transformed**), normalized+transformed+batch corrected 
(**batch corrected**), and normalized+transformed+imputed (**imputed**).
The annotation of the heatmaps can be adjusted by the drop-down
menu **annotation**.

On the right panel the sum of distances to other samples is depicted. 

### Distance matrices between samples

On the left, the panel depicts heatmaps of distances between samples for 
the data sets of

 - raw (**raw**), 
 - normalized (**normalized**), 
 - normalized+batch corrected (**batch corrected**),
 - normalized+batch corrected+transformed (**transformed**), and 
 - normalized+batch corrected+transformed+imputed (**imputed**).
 
The **imputed** data set is only displayed if there are 
missing values (`NA`s) in the **raw** data set. 
The annotation of the heatmaps can be adjusted by the drop-down
menu **annotation**.

On the right panel the sum of distances to other samples is depicted. 

### Mosaic plot
The plot displays information from two categorical/qualitative variables. 
Use the select inputs (**Categorical 1** and 
**Categorical variable 2**) to specify the variables on the x-axis and
y-axis. The area of the files is proportional to the number 
of observations within that category (also displayed in %).

---
title: "MatrixQCvis report"
output:   
    BiocStyle::html_document:
        toc_float: true
        mathjax: null
        self_contained: true
params:
    missingValue: TRUE
    se_r: NULL
    se_n: NULL
    se_b: NULL
    se_t: NULL
    se_i: NULL
    sample_hist: "name"
    sample_mosaic_f1: "name"
    sample_mosaic_f2: "name"
    mev_binwidth: 1
    mev_binwidthC: 1
    miv_binwidth: 1
    miv_binwidthC: 1
    mev_hist_category: NULL
    mev_upset_category: NULL
    miv_hist_category: NULL
    miv_upset_category: NULL
    int_log: TRUE
    int_violin: TRUE
    int_violin_orderCategory: NULL
    int_drift_data: "raw"
    int_drift_aggregation: "median"
    int_drift_category: "name"
    int_drift_orderCategory: NULL
    int_drift_level: NULL
    int_drift_method: "loess"
    int_ma_data: "raw"
    int_ma_group: NULL
    int_ma_plot: NULL
    int_hD_lines: FALSE
    int_ecdf_data: "raw"
    int_ecdf_sample: NULL
    int_ecdf_group: "all"
    int_dist_method: "euclidean"
    int_dist_label: "name"
    int_feat_selectFeat: NULL,
    int_feat_featLine: FALSE,
    dr_pca_center: TRUE
    dr_pca_scale: TRUE
    dr_pca_color: "none"
    dr_pca_x: "PC1"
    dr_pca_y: "PC1"
    dr_pcoa_method: "euclidean"
    dr_pcoa_color: "none" 
    dr_pcoa_x: "Axis.1"
    dr_pcoa_y: "Axis.2"
    dr_nmds_color: "none"
    dr_nmds_x: "MDS1"
    dr_nmds_y: "MDS2"
    dr_tsne_perplexity: 1
    dr_tsne_max_iter: 1000
    dr_tsne_initial_dims: 10
    dr_tsne_dims: 3
    dr_tsne_pca_center: TRUE
    dr_tsne_pca_scale: TRUE
    dr_tsne_color: "none"
    dr_tsne_x: "X1"
    dr_tsne_y: "X2"
    dr_umap_min_dist: 0.1
    dr_umap_n_neighbors: 15
    dr_umap_spread: 1
    dr_umap_color: "none"
    dr_umap_x: "X1"
    dr_umap_y: "X2"
    de_m_formula: NULL
    de_c_formula: NULL
    de_method: "ttest"
    de_fit_ttest: NULL
    de_fit_proDA: NULL
---


```{r style, echo = FALSE, results = 'asis'}
BiocStyle::markdown()
```

```{r env, include=FALSE, echo=FALSE, cache=FALSE}
library("knitr")
opts_chunk$set(stop_on_error = 1L)
suppressPackageStartupMessages(library("MatrixQCvis"))
```

```{r prepare_se, eval=TRUE, echo=FALSE}
se_r <- params$se_r
se_n <- params$se_n
se_b <- params$se_b
se_t <- params$se_t
se_i <- params$se_i
missingValue <- params$missingValue
```

This is an automatically-produced report from `shinyQC`. The analyzed data
contains `r nrow(se_r)` features and `r ncol(se_r)` samples. 

# Tab: Samples

## Histogram

Use the settings

- *Categorical variable = * `r params$sample_hist`.

```{r hist_sample, eval=TRUE, echo=FALSE}
tbl <- hist_sample_num(se = se_r, category = params$sample_hist)
hist_sample(tbl, category = params$category_hist)
```


## Mosaic
```{r mosaic_prepare, eval=TRUE, echo=FALSE}
if (!is.null(params$sample_mosaic_f1)) {
    called <- TRUE
    sample_mosaic_f1 <- params$sample_mosaic_f1
} else {
    called <- FALSE
    sample_mosaic_f1 <- colnames(SummarizedExperiment::colData(se_r))[1]
}
if (!is.null(params$sample_mosaic_f2)) {
    sample_mosaic_f2 <- params$sample_mosaic_f2
} else {
    sample_mosaic_f2 <- colnames(SummarizedExperiment::colData(se_r))[1]
}

```

`r if (!called) {"The mosaic plot was not called within the shiny application. Use default settings."}`

Use the settings 

- *Categorical variable 1 =* `r sample_mosaic_f1` and 
- *Categorical variable 2 =* `r sample_mosaic_f2`. 

```{r mosaic, eval=TRUE, echo=FALSE, message=FALSE, warning=FALSE}
mosaic(se = params$se_r, f1 = sample_mosaic_f1, f2 = sample_mosaic_f2)
```

```{r, eval=TRUE, echo=FALSE}
if (shiny::isRunning())
  shiny::setProgress(0.1)
```


`r if (missingValue) {"# Tab: Measured Values\n"}`

`r if (missingValue) {"## Barplot for samples\n"}`



```{r samples_memi_mev, eval=params$missingValue, echo=FALSE, message=FALSE, warning=FALSE}
tbl <- samples_memi(se_r)
barplot_samples_memi(tbl, measured = TRUE)  
```


`r if (missingValue) {"## Histogram Features\n"}`

```{r hist_feature_mev_prepare, eval=TRUE, echo=FALSE,message=FALSE, warning=FALSE}
if (!is.null(params$mev_binwidth)) {
    called <- TRUE
    binwidth <- params$mev_binwidth
} else {
    called <- FALSE
    binwidth <- 1
}
```


`r if (missingValue & !called) {"The 'Histogram Features' plot was not called within the shiny application. Use default settings."}`

`r if (missingValue) {"Use the settings"}`

`r if (missingValue) {"- *Binwidth =*"}`  `r if (missingValue) paste(binwidth, ".", sep = "")`
```{r hist_feature_mev, eval=params$missingValue, echo=FALSE, message=FALSE, warning=FALSE}
hist_feature(SummarizedExperiment::assay(se_r), measured = TRUE, 
    binwidth = binwidth)  
```

`r if (missingValue) {"## Histogram Features along variable\n"}`

```{r hist_feature_category_mev_prepare, eval=TRUE, echo=FALSE, message=FALSE, warning=FALSE}
if (!is.null(params$mev_binwidthC)) {
    called <- TRUE
    binwidth <- params$mev_binwidthC
    mev_hist_category <- params$mev_hist_category
} else {
    called <- FALSE
    binwidth <- 1
    mev_hist_category <- colnames(SummarizedExperiment::colData(se_r))[1]
}
```

`r if (missingValue & !called) {"The 'Histogram Features along variable' plot was not called within the shiny application. Use default settings."}`

`r if (missingValue) {"Use the settings"}`

`r if (missingValue) {paste("- *Variable for stratification =*", mev_hist_category, "and")}`
`r if (missingValue) {paste("- *Binwidth =* ", binwidth, ".", sep = "")}`


```{r hist_feature_category_mev, eval=params$missingValue, echo=FALSE, message=FALSE, warning=FALSE}
hist_feature_category(se_r, measured = TRUE, category = mev_hist_category,
    binwidth = binwidth)
```

`r if (missingValue) {"## Upset\n"}`

```{r upset_mev_prepare, eval=TRUE, echo=FALSE, message=FALSE, warning=FALSE}
if (!is.null(params$mev_upset_category)) {
    called <- TRUE
    mev_upset_category <- params$mev_upset_category
} else {
    called <- FALSE
    mev_upset_category <- colnames(SummarizedExperiment::colData(se_r))[1]
}

```

`r if (missingValue & !called) {"The 'Upset' plot was not called within the shiny application. Use default settings."}`

`r if (missingValue) {"Use the settings"}`

`r if (missingValue) {paste("- *Variable for stratification =* ", mev_upset_category, ".", sep = "")}`


```{r upset_mev, eval=params$missingValue, echo=FALSE}
upset_category(se_r, category = mev_upset_category, measured = TRUE)
```


```{r, eval=TRUE, echo=FALSE}
if (shiny::isRunning())
  shiny::setProgress(0.2)
```

`r if (missingValue) {"# Tab: Missing Values\n"}`

`r if (missingValue) {"## Barplot for samples\n"}`

```{r samples_memi_miv, eval=params$missingValue, echo=FALSE, message=FALSE, warning=FALSE}
tbl <- samples_memi(se_r)
barplot_samples_memi(tbl, measured = FALSE)
```

`r if (missingValue) {"## Histogram Features\n"}`

```{r hist_feature_miv_prepare, eval=TRUE, echo=FALSE, message=FALSE, warning=FALSE}
if (!is.null(params$miv_binwidth)) {
    called <- TRUE
    binwidth <- params$miv_binwidth
} else {
    called <- FALSE
    binwidth <- 1
}
```

`r if (missingValue & !called) {"The 'Histogram Features' plot was not called within the shiny application. Use default settings."}`

`r if (missingValue) {"Use the settings"}`

`r if (missingValue) {paste("- *Binwidth =* ", binwidth, ".", sep = "")}`
```{r hist_feature_miv, eval=params$missingValue, echo=FALSE, message=FALSE, warning=FALSE}
hist_feature(SummarizedExperiment::assay(se_r), measured = FALSE, 
    binwidth = binwidth)
```

`r if (missingValue) {"## Histogram Features along variable\n"}`

```{r hist_feature_category_miv_prepare, eval=TRUE, echo=FALSE, message=FALSE, warning=FALSE}
if (!is.null(params$miv_binwidthC)) {
    called <- TRUE
    binwidth <- params$miv_binwidthC
    miv_hist_category <- params$miv_hist_category
} else {
    called <- FALSE
    binwidth <- 1
    miv_hist_category <- colnames(SummarizedExperiment::colData(se_r))[1]
}
```

`r if (missingValue & !called) {"The 'Histogram Features along variable' plot was not called within the shiny application. Use default settings."}`

`r if (missingValue) {"Use the settings"}`

`r if (missingValue) {paste("- *Variable for stratification =*", miv_hist_category, "and")}`
`r if (missingValue) {paste("- *Binwidth =* ", binwidth, ".", sep = " ")}`

```{r hist_feature_category_miv, eval=params$missingValue, echo=FALSE, message=FALSE, warning=FALSE}
hist_feature_category(se_r, measured = FALSE, category = miv_hist_category,
    binwidth = binwidth)
```

`r if (missingValue) {"## Upset\n"}`

```{r upset_miv_prepare, eval=TRUE, echo=FALSE, message=FALSE, warning=FALSE}
if (!is.null(params$miv_upset_category)) {
    called <- TRUE
    miv_upset_category <- params$miv_upset_category
} else {
    called <- FALSE
    miv_upset_category <- colnames(SummarizedExperiment::colData(se_r))[1]
}
```

`r if (missingValue & !called) {"The 'Upset' plot was not called within the shiny application. Use default settings."}`

`r if (missingValue) {"Use the settings"}`

`r if (missingValue) {paste("- *Variable for stratification =* ", mev_upset_category, ".", sep = " ")}`

```{r upset_miv, eval=missingValue, echo=FALSE}
upset_category(se_r, category = miv_upset_category, measured = FALSE)
```

```{r, eval=TRUE, echo=FALSE}
if (shiny::isRunning())
  shiny::setProgress(0.25)
```

# Tab: Values

## Boxplot/Violin plot

```{r boxplot_prepare, eval=TRUE,echo=FALSE, message=FALSE, warning=FALSE}
if (!is.null(params$int_violin_orderCategory)) {
    called <- TRUE
    int_box_type <- int_violin <- params$int_violin
    int_violin_orderCategory <- params$int_violin_orderCategory
    int_log <- params$int_log
    int_violin <- if (int_violin == "violin") TRUE else FALSE
    int_log <- if (int_log == "log2") TRUE else FALSE
} else {
    called <- FALSE
    int_violin <- TRUE
    int_violin_orderCategory <- colnames(SummarizedExperiment::colData(se_r))[1]
    int_log <- FALSE
    int_box_type <- "violin"
}
```

`r if (!called) {"The 'Boxplot/Violin plot' was not called within the shiny application. Use default settings."}`

Use the settings 

- *Display log2 values? = * `r int_log`, 
- *Type of display = * `r int_box_type`, and
- *Select variable to order samples* = `r int_violin_orderCategory`.

```{r boxplot, eval=TRUE, echo=FALSE, warning=FALSE}
createBoxplot(se_r, orderCategory = int_violin_orderCategory, 
    title = "raw", log2 = int_log, violin = int_violin)
createBoxplot(se_n, orderCategory = int_violin_orderCategory, 
    title = "normalized", log2 = int_log, violin = int_violin)
createBoxplot(se_b, orderCategory = int_violin_orderCategory,
    title = "batch corrected", log2 = FALSE, violin = int_violin)
createBoxplot(se_t, orderCategory = int_violin_orderCategory,
    title = "transformed", log2 = FALSE, violin = int_violin)
createBoxplot(se_i, orderCategory = int_violin_orderCategory, 
    title = "imputed", log2 = FALSE, violin = int_violin)
```

```{r, eval=TRUE, echo=FALSE}
if (shiny::isRunning())
  shiny::setProgress(0.32)
```

## Trend/drift
```{r drift_prepare, eval=TRUE,echo=FALSE, message=FALSE, warning=FALSE}
if (!is.null(params$int_drift_data)) {
    called <- TRUE
    int_drift_data <- params$int_drift_data
    int_drift_aggregation <- params$int_drift_aggregation
    int_drift_category <- params$int_drift_category
    int_drift_orderCategory <- params$int_drift_orderCategory
    int_drift_level <- params$int_drift_level
    int_drift_method <- params$int_drift_method
    
    if (int_drift_data == "raw") {
       se_tmp <- se_r
    }
    if (int_drift_data == "normalized") {
        se_tmp <- se_n
    }
    if (int_drift_data == "batch corrected") {
        se_tmp <- se_b
    }
    if (int_drift_data == "transformed") {
        se_tmp <- se_t
    }
    if (int_drift_data == "imputed") {
        se_tmp <- se_i
    }
    
} else {
    called <- FALSE
    int_drift_data <- "raw"
    se_tmp <- se_r
    int_drift_aggregation <- "sum"
    int_drift_category <- colnames(SummarizedExperiment::colData(se_r))[1]
    int_drift_orderCategory <- colnames(SummarizedExperiment::colData(se_r))[1]
    int_drift_level <- "all"
    int_drift_method <- "loess"
}
```

`r if (!called) {"The 'Trend/drift' plot was not called within the shiny application. Use default settings."}`

Use the settings 

- *Select variable = * `r int_drift_category`,  
- *Select level to highlight = * `r int_drift_level`, 
- *Select data input = * `r int_drift_data`, 
- *Select aggregation = * `r int_drift_aggregation`,
- *Select smoothing method = * `r int_drift_method`, and 
- *Select variable to order samples = * `r int_drift_orderCategory`.

```{r drift, eval=TRUE, echo=FALSE, message=FALSE, warning=FALSE}
driftPlot(se_tmp, aggregation = int_drift_aggregation,
    category = int_drift_category,
    orderCategory = int_drift_orderCategory,
    level = int_drift_level,
    method = params$int_drift_method)
```

## Coefficient of variation

```{r cv, eval=TRUE, echo=FALSE, warning=FALSE, message=FALSE}
a_r <- SummarizedExperiment::assay(se_r)
a_n <- SummarizedExperiment::assay(se_n)
a_b <- SummarizedExperiment::assay(se_b)
a_t <- SummarizedExperiment::assay(se_t)
a_i <- SummarizedExperiment::assay(se_i)

## calculate cv values
cv_r <- cv(a_r, "raw")
cv_n <- cv(a_n, "normalized")
cv_b <- cv(a_b, "batch corrected")
cv_t <- cv(a_t, "transformed")
cv_i <- cv(a_i, "imputed")

df <- data.frame(cv_r, cv_n, cv_b, cv_t, cv_i)
plotCV(df)
```


## Mean-sd plot

```{r meansdplot, eval=TRUE, echo=FALSE, warning=FALSE, message=FALSE}
vsn::meanSdPlot(a_t)
vsn::meanSdPlot(a_i)
```

```{r, eval=TRUE, echo=FALSE}
if (shiny::isRunning())
  shiny::setProgress(0.4)
```

## MA plot
```{r maplot_prepare, eval=TRUE, echo=FALSE, warning=FALSE, message=FALSE}
if (!is.null(params$int_ma_group)) {
    called <- TRUE
    int_ma_group <- params$int_ma_group
    int_ma_data <- params$int_ma_data
    int_ma_plot <- params$int_ma_plot
    int_hD_lines <- params$int_hD_lines
} else {
    called <- FALSE
    int_ma_group <- "all"
    int_ma_data <- "raw"
    int_ma_plot <- "all"
    int_hD_lines <- FALSE
}
```

`r if (!called) {"The 'MA plot' was not called within the shiny application. Use default settings."}`

Use the settings 

- *group = * `r int_ma_group`,  
- *plot = * `r int_ma_plot`, 
- *Data set for the MA plot = * `r int_ma_data`, and
- *lines = * `r int_hD_lines`.

```{r maplot, eval=TRUE, echo=FALSE, warning=FALSE, message=FALSE}
tbl_r <- MAvalues(se_r, log2 = TRUE, group = int_ma_group)
tbl_n <- MAvalues(se_n, log2 = TRUE, group = int_ma_group)
tbl_b <- MAvalues(se_b, log2 = TRUE, group = int_ma_group)
tbl_t <- MAvalues(se_t, log2 = FALSE, group = int_ma_group)

if (shiny::isRunning())
  shiny::setProgress(0.5)

tbl_i <- MAvalues(se_i, log2 = FALSE, group = int_ma_group)
 
if (int_ma_data == "raw") {
    tbl <- tbl_r
}
if (int_ma_data == "normalized") {
    tbl <- tbl_n
}
if (int_ma_data == "batch corrected") {
    tbl <- tbl_b
}
if (int_ma_data == "transformed") {
    tbl <- tbl_t
}
if (int_ma_data == "imputed") {
    tbl <- tbl_i
}
 
MAplot(tbl, group = int_ma_group,
    plot = int_ma_plot)

d_r <- hoeffDValues(tbl_r, name = "raw")
d_n <- hoeffDValues(tbl_n, name = "normalized")
d_b <- hoeffDValues(tbl_b, name = "batch corrected")
d_t <- hoeffDValues(tbl_t, name = "transformed")

if (missingValue) {
    d_i <- hoeffDValues(tbl_i, name = "imputed")
    df <- data.frame(d_r, d_n, d_b, d_t, d_i)  
} else {
    df <- data.frame(d_r, d_n, d_b, d_t)
}

hoeffDPlot(df, lines = int_hD_lines)
```

```{r, eval=TRUE, echo=FALSE}
if (shiny::isRunning())
  shiny::setProgress(0.55)
```

## ECDF
```{r ecdf_prepare, eval=TRUE, echo=FALSE, warning=FALSE, message=FALSE}
if (!is.null(params$int_ecdf_sample)) {
    called <- TRUE
    int_ecdf_data <- params$int_ecdf_data
    int_ecdf_sample <- params$int_ecdf_sample
    int_ecdf_group <- params$int_ecdf_group
    
    if (int_ecdf_data == "raw") {
        se_tmp <- se_r
    }
    if (int_ecdf_data == "normalized") {
        se_tmp <- se_n
    }
    if (int_ecdf_data == "batch corrected") {
        se_tmp <- se_b
    }
    if (int_ecdf_data == "transformed") {
        se_tmp <- se_t
    }
    if (int_ecdf_data == "imputed") {
        se_tmp <- se_i
    }

} else {
    called <- FALSE
    int_ecdf_data <- "raw"
    int_ecdf_sample <- colnames(se_r)[1]
    int_ecdf_group <- "all"
    se_tmp <- se_r
}
```

`r if (!called) {"The 'ECDF' plot was not called within the shiny application. Use default settings."}`

Use the settings

- *Data set for the ECDF plot = * `r int_ecdf_data`,  
- *Sample = * `r int_ecdf_sample`, and
- *group = * `r int_ecdf_group`.

```{r ecdf, eval=TRUE, echo=FALSE, warning=FALSE}
ECDF(se_tmp, sample = int_ecdf_sample,
    group = int_ecdf_group)
```


## Distance matrix
```{r distSample_prepare, eval=TRUE, echo=FALSE, warning=FALSE, message=FALSE}
if (!is.null(params$int_ecdf_label)) {
    called <- TRUE
    int_dist_label <- params$int_dist_label
    int_dist_method <- params$int_dist_method
} else {
    called <- FALSE
    int_dist_label <- colnames(SummarizedExperiment::colData(se_r))[1]
    int_dist_method <- "euclidean"
}
```

`r if (!called) {"The 'Distance matrix' plots were not called within the shiny application. Use default settings."}`

Use the settings

- *annotation = * `r int_dist_label` and 
- *distance method = * `r int_dist_method`.

```{r distSample, eval=TRUE, echo=FALSE}
dist_mat_r <- distShiny(a_r, method = int_dist_method)
dist_mat_n <- distShiny(a_n, method = int_dist_method)
dist_mat_b <- distShiny(a_b, method = int_dist_method)
dist_mat_t <- distShiny(a_t, method = int_dist_method)

## plotting
distSample(d = dist_mat_r, se = se_r,
    label = int_dist_label, title = "raw")
sumDistSample(dist_mat_r, title = "raw")

distSample(d = dist_mat_n, se = se_n,
    label = int_dist_label, title = "normalized")
sumDistSample(dist_mat_n, title = "normalized")

distSample(d = dist_mat_b, se = se_b,
    label = int_dist_label, title = "batch corrected")
sumDistSample(dist_mat_b, title = "batch corrected")

distSample(d = dist_mat_t, se = se_t,
    label = int_dist_label, title = "transformed")
sumDistSample(dist_mat_t, title = "transformed")

if (missingValue) {
    dist_mat_i <- distShiny(a_i, method = int_dist_method)
    distSample(d = dist_mat_i, se = se_i,
        label = int_dist_label, title = "imputed")
    sumDistSample(dist_mat_i, title = "imputed")  
}

```

## Features

```{r features_prepare, eval=TRUE, echo=FALSE, warning=FALSE, message=FALSE}
if (!is.null(params$int_feat_selectFeat)) {
    called <- TRUE
    int_feat_selectFeat <- params$int_feat_selectFeat
    int_feat_featLine <- params$int_feat_featLine
} else {
    called <- FALSE
    int_feat_selectFeat <- rownames(se_r)[1]
    int_feat_featLine <- FALSE
}
```

`r if (!called) {"The 'Features' plots were not called within the shiny application. Use default settings."}`

Use the settings

- *Select feature = * `r int_feat_selectFeat` and 
- *lines = * `r int_feat_featLine`.

```{r features, eval=TRUE, echo=FALSE}
if (missingValue) {
    l_assays <- list(raw = a_r, normalized = a_n, batch.corrected = a_b,
      transformed = a_t, imputed = a_i)
} else {
    l_assays <- list(raw = a_r, normalized = a_n, batch.corrected = a_b,
      transformed = a_t)
}

df_feature <- createDfFeature(l_assays, feature = int_feat_selectFeat)

## plotting
featurePlot(df_feature)
cvFeaturePlot(l_assays, lines = int_feat_featLine)
```

```{r, eval=TRUE, echo=FALSE}
if (shiny::isRunning())
  shiny::setProgress(0.6)
```

# Tab: Dimension Reduction

## PCA
```{r PCA_prepare, eval=TRUE, echo=FALSE, warning=FALSE, message=FALSE}
if (!is.null(params$dr_pca_color)) {
    called <- TRUE
    dr_pca_center <- params$dr_pca_center
    dr_pca_scale <- params$dr_pca_scale
    dr_pca_color <- params$dr_pca_color
    dr_pca_x <- params$dr_pca_x
    dr_pca_y <- params$dr_pca_y
} else {
    called <- FALSE
    dr_pca_center <- TRUE
    dr_pca_scale <- TRUE
    dr_pca_color <- "none"
    dr_pca_x <- "PC1"
    dr_pca_y <- "PC2"
}
```

`r if (!called) {"The 'PCA' plot was not called within the shiny application. Use default settings."}`

Use the settings 

- *x-axis = * `r dr_pca_x`, 
- *y-axis = * `r dr_pca_y`, 
- *scale = * `r dr_pca_scale`,
- *center = * `r dr_pca_center`, and 
- *Color = * `r dr_pca_color`. 

```{r PCA, eval=TRUE, echo=FALSE}
tbl <- dimensionReduction(a_i, type = "PCA",
    params = list(center = dr_pca_center, scale = dr_pca_scale))
explainedVar <- explVar(x = a_i, 
    params = list(center = dr_pca_center, scale = dr_pca_scale))
dimensionReductionPlot(tbl = tbl, se = se_r, color = dr_pca_color,
    explainedVar = explainedVar, x_coord = dr_pca_x, y_coord = dr_pca_y)
```


## PCoA
```{r PCoA_prepare, eval=TRUE, echo=FALSE, warning=FALSE, message=FALSE}
if (!is.null(params$dr_pcoa_color)) {
    called <- TRUE
    dr_pcoa_method <- params$dr_pcoa_method
    dr_pcoa_color <- params$dr_pcoa_color
    dr_pcoa_x <- params$dr_pcoa_x
    dr_pcoa_y <- params$dr_pcoa_y
} else {
    called <- FALSE
    dr_pcoa_method <- "euclidean"
    dr_pcoa_color <- "none"
    dr_pcoa_x <- "Axis.1"
    dr_pcoa_y <- "Axis.2"
}
```

`r if (!called) {"The 'PCoA' plot was not called within the shiny application. Use default settings."}`

Use the settings 

- *x-axis = * `r dr_pcoa_x`, 
- *y-axis = * `r dr_pcoa_y`, 
- *Distance measure = * `r dr_pcoa_method`, and 
- *Color = * `r dr_pcoa_color`. 

```{r PCoA, eval=TRUE, echo=FALSE}
tbl <- dimensionReduction(a_i, type = "PCoA",
    params = list(method = dr_pcoa_method))
dimensionReductionPlot(tbl = tbl, se = se_r, color = dr_pcoa_color,
    explainedVar = NULL, x_coord = dr_pcoa_x, y_coord = dr_pcoa_y)
```

```{r, eval=TRUE, echo=FALSE}
if (shiny::isRunning())
  shiny::setProgress(0.65)
```

## NMDS
```{r NMDS_prepare, eval=TRUE, echo=FALSE, warning=FALSE, message=FALSE, results='hide'}
if (!is.null(params$dr_nmds_color)) {
    called <- TRUE
    dr_nmds_method <- params$dr_pcoa_method
    dr_nmds_color <- params$dr_nmds_color
    dr_nmds_x <- params$dr_nmds_x
    dr_nmds_y <- params$dr_nmds_y
} else {
    called <- FALSE
    dr_nmds_method <- "euclidean"
    dr_nmds_color <- "none"
    dr_nmds_x <- "MDS1"
    dr_nmds_y <- "MDS2"
}
```

`r if (!called) {"The 'NMDS' plot was not called within the shiny application. Use default settings."}`

Use the settings

- *x-axis = * `r dr_nmds_x`, 
- *y-axis = * `r dr_nmds_y`, 
- *Distance measure = * `r dr_nmds_method`, and 
- *Color = * `r dr_nmds_color`. 

```{r NMDS, eval=TRUE, echo=FALSE, warning=FALSE, message=FALSE, results='hide'}
tbl <- dimensionReduction(a_i, type = "NMDS", 
    params = list(method = dr_nmds_method))
```
```{r NMDS_plot, eval=TRUE, echo=FALSE, warning=FALSE, message=FALSE}
dimensionReductionPlot(tbl = tbl, se = se_r, color = dr_nmds_color,
    explainedVar = NULL, x_coord = dr_nmds_x, y_coord = dr_nmds_y)
```

## tSNE
```{r tSNE_prepare, eval=TRUE, echo=FALSE, warning=FALSE, message=FALSE}
if (!is.null(params$dr_tsne_color)) {
    called <- TRUE
    dr_tsne_perplexity <- params$dr_tsne_perplexity
    dr_tsne_max_iter <- params$dr_tsne_max_iter
    dr_tsne_initial_dims <- params$dr_tsne_initial_dims
    dr_tsne_dims <- params$dr_tsne_dims
    dr_tsne_pca_center <- params$dr_tsne_pca_center
    dr_tsne_pca_scale <- params$dr_tsne_pca_scale
    dr_tsne_color <- params$dr_tsne_color
    dr_tsne_x <- params$dr_tsne_x
    dr_tsne_y <- params$dr_tsne_y
} else {
    called <- FALSE
    dr_tsne_perplexity <- 1
    dr_tsne_max_iter <- 1000
    dr_tsne_initial_dims <- 10
    dr_tsne_dims <- 3
    dr_tsne_pca_center <- TRUE
    dr_tsne_pca_scale <- TRUE
    dr_tsne_color <- "none"
    dr_tsne_x <- "X1"
    dr_tsne_y <- "X2"
}
```

```{r, eval=TRUE, echo=FALSE}
if (shiny::isRunning())
  shiny::setProgress(0.73)
```

`r if (!called) {"The 'tSNE' plot was not called within the shiny application. Use default settings."}`

Use the settings 

- *x-axis = * `r dr_tsne_x`, 
- *y-axis = * `r dr_tsne_y`, 
- *Perplexity = * `r dr_tsne_perplexity`, 
- *Number of iterations = * `r dr_tsne_max_iter`, 
- *Number of retained dimensions in intial PCA = * `r dr_tsne_initial_dims`,
- *Output dimensionality = * `r dr_tsne_dims`, `scale =` `r dr_tsne_pca_scale`,
- *center = * `r dr_tsne_pca_center`, and 
- *Color = * `r dr_tsne_color`.

```{r tSNE, eval=TRUE, echo=FALSE}
tbl <- dimensionReduction(a_i, type = "tSNE", 
    params = list(perplexity = dr_tsne_perplexity, 
    max_iter = dr_tsne_max_iter, initial_dims = dr_tsne_initial_dims,
    dims = dr_tsne_dims, pca_center = dr_tsne_pca_center,
    pca_scale = dr_tsne_pca_scale))
dimensionReductionPlot(tbl = tbl, se = se_r, color = dr_tsne_color,
    explainedVar = NULL, x_coord = dr_tsne_x, y_coord = dr_tsne_y)
```


## UMAP
```{r UMAP_prepare, eval=TRUE, echo=FALSE, warning=FALSE, message=FALSE}
if (!is.null(params$dr_umap_color)) {
    called <- TRUE
    dr_umap_min_dist = params$dr_umap_min_dist
    dr_umap_n_neighbors = params$dr_umap_n_neighbors
    dr_umap_spread = params$dr_umap_spread
    dr_umap_color = params$dr_umap_color
    dr_umap_x = params$dr_umap_x
    dr_umap_y = params$dr_umap_y
} else {
    called <- FALSE
    dr_umap_min_dist = 0.1
    dr_umap_n_neighbors = min(15, ncol(se_r))
    dr_umap_spread = 1
    dr_umap_color = "none"
    dr_umap_x = "X1"
    dr_umap_y = "X2"
}
```

`r if (!called) {"The 'UMAP' plot was not called within the shiny application. Use default settings."}`

Use the settings 

- *x-axis = * `r dr_umap_x`, 
- *y-axis = * `r dr_umap_y`, 
- *Minimum distance =* `r dr_umap_min_dist`, 
- *Number of neighbors =* `r dr_umap_n_neighbors`, 
- *Spread = * `r dr_umap_spread`, and
- *Color = * `r dr_umap_color`. 

```{r UMAP, eval=TRUE, echo=FALSE}
tbl <- dimensionReduction(a_i, type = "UMAP", 
    params = list(min_dist = dr_umap_min_dist, n_neighbors = dr_umap_n_neighbors,
        spread = dr_umap_spread))
dimensionReductionPlot(tbl = tbl, se = se_r, color = dr_umap_color,
    explainedVar = NULL, x_coord = dr_umap_x, y_coord = dr_umap_y)
```


```{r, eval=TRUE, echo=FALSE}
if (shiny::isRunning())
  shiny::setProgress(0.87)
```



```{r DE_prepare,echo=FALSE, eval=TRUE}
m_formula <- params$de_m_formula
valid_m <- if (!is.null(m_formula)) TRUE else FALSE

c_formula <- params$de_c_formula
valid_c <- if (!is.null(c_formula)) TRUE else FALSE
```

`r if (valid_m | (valid_m & valid_c)) {"# Tab: DE\n~\n"}`
`r if (valid_m) {"The differential expression analysis was called with the model matrix formula:"}`
`r if (valid_m) {c_formula}`

`r if (valid_m & valid_c) {"The differential expression analysis was called with the contrast expression:"}`
`r if (valid_m) {c_formula}`


```{r DE, echo=FALSE, eval=TRUE}
if (valid_m & valid_c) {
    mM <- stats::model.matrix(m_formula, data = colData(se_r))
    cM <- limma::makeContrasts(contrasts = c_formula, levels = mM)

    if (params$de_method == "limma") {
        tT <- limma::topTable(params$de_fit_ttest, number = Inf, 
            adjust.method = "fdr", p.value = 0.05)
        tT <- cbind(name = rownames(tT), tT)
        volcanoPlot(tT, type = "ttest")
    }
    if (params$de_method == "proDA") {
        tT <- proDA::test_diff(fit = params$de_fit_proDA, 
            contrast = params$de_c_formula,
            sort_by = "adj_pval")
        volcanoPlot(tT, type = "proDA")
    }
}
```

```{r, eval=TRUE, echo=FALSE}
if (shiny::isRunning())
  shiny::setProgress(0.98)
```

### t-distributed stochastic neighbor embedding (tSNE)

The panel depicts a plot of tSNE. The parameters **Perplexity**, 
**Number of iterations**, **Number of retained dimensions in initial PCA**,
and **Output dimensionality** required for the tSNE algorithm can be
set with the sliders. For the parameter
**Number of retained dimensions in initial PCA** the panel 
*Principal components* can be employed that shows on the left panel a 
Scree plot of the data set and permuted values and corresponding p-values
from the permutation. For computational reasons, the data set will
be restricted to the top 5000 varying features based on their 
standard variation (only if there are more than 5000 features 
in the data set, otherwise all features are taken). 

The different dimensions of the transformed data can be displayed by changing 
the values in the drop-down menus for the x-axis and y-axis (either two or 
three dimensions according to the **Output dimensionality**).  

---
title: "MatrixQCvis: shiny-based interactive data quality exploration of omics data"
author:
 - name: Thomas Naake and Wolfgang Huber
   mail: thomas.naake@embl.de, thomasnaake@googlemail.com, wolfgang.huber@embl.de
   affiliation: European Molecular Biology Laboratory, Meyerhofstrasse 1, 69117 Heidelberg
package: MatrixQCvis
      
output:  
    BiocStyle::html_document:
        toc_float: true
bibliography: MatrixQCvis-citations.bib
vignette: >
    %\VignetteIndexEntry{Shiny-based interactive data quality exploration of omics data}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteKeywords{Mass Spectrometry, MS, Metabolomics, Proteomics, Transcriptomics, Visualization, QC}
    %\VignettePackage{MatrixQCvis-vignette}
    %\VignetteEncoding{UTF-8}
---

```{r style, echo = FALSE, results = 'asis'}
BiocStyle::markdown()
```

```{r env, include=FALSE, echo=FALSE, cache=FALSE}
library("knitr")
opts_chunk$set(stop_on_error = 1L)
suppressPackageStartupMessages(library("MatrixQCvis"))
```

# Introduction {#sec-intro}

Data quality assessment is an integral part of preparatory data analysis 
to ensure sound biological information retrieval. 
We present here the `MatrixQCvis` package, which provides shiny-based 
interactive visualization of data quality metrics at the per-sample and 
per-feature level. It is broadly applicable to quantitative omics data types 
that come in matrix-like format (features x samples). It enables the detection 
of low-quality samples, drifts, outliers and batch effects in data sets.
Visualizations include amongst others bar- and violin plots of the 
(count/intensity) values, mean vs standard deviation plots, MA plots, 
empirical cumulative distribution function (ECDF) plots, visualizations 
of the distances between samples, and multiple types of dimension reduction
plots. 
`MatrixQCvis` builds upon the Bioconductor `SummarizedExperiment` S4 
class and enables thus the facile integration into existing workflows.

`MatrixQCvis` is especially addressed to analyze the quality of proteomics and 
metabolomics data sets that are characterized by missing values as it 
allows the user for imputation of missing values and differential expression analysis 
using the `proDA` package [@Ahlmann2019]. Besides this, `MatrixQCvis` is 
extensible to other type of data(e.g. transcriptomics count data) that can be 
represented as a `SummarizedExperiment` object. 
Furthermore, the `shiny` application facilitates simple differential 
expression analysis using either moderated t-tests (from the `limma` package,
@Ritchie2015) or Wald tests (from the `proDA` package, @Ahlmann2019).

Within this vignette, the term feature will refer to a probed molecular entity,
e.g. gene, transcript, protein, peptide, or metabolite. 

In the following, we will describe the major setup of `MatrixQCvis` and the 
navigation through the shiny application, `shinyQC`.

# Questions and bugs {-}

`MatrixQCvis` is currently under active development. If you
discover any bugs, typos or develop ideas of improving
`MatrixQCvis` feel free to raise an issue via
[GitHub](https://github.com/tnaake/MatrixQCvis) or
send a mail to the developer.

# Prepare the environment {#sec-prepare}
To install `MatrixQCvis` enter the following to the `R` console

```{r install, eval=FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")
BiocManager::install("MatrixQCvis")
```

Before starting with the analysis, load the `MatrixQCvis` package. This 
will also load the required packages `Biobase`, `BiocGenerics`, `GenomeInfoDb`,
`GenomicRanges`, `ggplot2`, `IRanges`, `MatrixGenerics`,
`parallel`, `matrixStats`, `plotly`, `shiny`, `SummarizedExperiment`, and 
`stats4`.

```{r load_MatrixQCvis, eval=TRUE}
library(MatrixQCvis)
``` 

# Appearance of user interface depends on the data input
Please note: Depending on the supplied `SummarizedExperiment` object the user
interface of `shinyQC` will differ:

- for a `SummarizedExperiment` object containing missing values
    - the tabs `Samples`, `Measured Values`, `Missing Values`, `Values`,
    `Dimension Reduction` and `DE` will be displayed,
    - within the tabs `Values` and `Dimension Reduction` the 
    `imputed` data set **will be** visualized,
    - the sidebar panel **includes** a drop-down menu for the imputation method.
- for a `SummarizedExperiment` object containing no missing values (i.e.
 with complete observations)
    - the tabs `Samples`, `Values`, `Dimension Reduction` and `DE` 
    will be displayed,
    - within the tabs `Values` and `DE` the `imputed` data set 
    **will not** be visualized,
    - the sidebar panel **does not includes** a drop-down menu for the 
    imputation method.

In the following, the vignette will be (mainly) described from the point of view
of a `SummarizedExperiment` containing no missing values (RNA-seq dataset)
and missing values (proteomics dataset). 


# QC analysis of TCGA RNA-seq data

Here, we will retrieve a `SummarizedExperiment`, `se`, object  
from the `ExperimentHub`package. The dataset (GEO accession GSE62944) contains
741 normal samples across 24 cancer types from the TCGA re-processed RNA-seq
data. We will use the dataset obtained by `ExperimentHub` to showcase the 
functionality of `shinyQC`. 

```{r eval = TRUE, echo = FALSE}
## run under Linux only
if (grepl(tolower(Sys.info()[["sysname"]]), pattern = "linux")) {
    proxy_string <- Sys.getenv("http_proxy")
    if (nzchar(proxy_string)) {
        ExperimentHub::setExperimentHubOption("PROXY", proxy_string)
    }
}
    
```

```{r, prepare_se, eval=TRUE, echo=TRUE}
library(ExperimentHub)
eh <- ExperimentHub()

## the SummarizedExperiment object has the title "RNA-Sequencing and clinical  
## data for 741 normal samples from The Cancer Genome Atlas"
eh[eh$title == "RNA-Sequencing and clinical data for 741 normal samples from The Cancer Genome Atlas"]

## in a next step download the SummarizedExperiment object from ExperimentHub
se <- eh[["EH1044"]]

## here we will restrain the analysis on 40 samples and remove the features
## that have a standard deviation of 0
se <- se[, seq_len(40)]
se_sds <- apply(assay(se), 1, sd, na.rm = TRUE)
se <- se[!is.na(se_sds) & se_sds > 0, ]
```


The most important function to assess the data quality is the `shinyQC` function
and its most important argument is `se`. `shinyQC` expects a `SummarizedExperiment` 
object. 

The `shinyQC` function sets the following requirements to the 
`SummarizedExperiment` object `se`:
 - `rownames(se)` are not allowed to be `NULL` and have to be set to the 
   feature names,
 - `colnames(se)` are not allowed to be `NULL` and have to be set to the 
   sample names,
 - `colnames(se)`, `colnames(assay(se))` and `rownames(colData(se))` all have 
    to be identical.
 
 If these requirements are not met, `shinyQC` will stop and throw an error.

Alternatively, a `SummarizedExperiment` object can also be loaded from within 
`shinyQC` (when no `se` object is supplied to `shinyQC`).

Objects belonging to the `SummarizedExperiment` class are containers for one 
or more assays, 
which are (numerical) matrices containing the quantitative, measured information
of the experiment. The rows represent features of interest (e.g. 
transcripts, peptides, proteins, or metabolites) and the columns represent the 
samples. The 
`SummarizedExperiment` object stores also information on the features of 
interest (accessible by `rowData`) and information on the samples
(accessible by `colData`). The name of samples and features will be accessed
from `colnames(se)` and `rownames(se)`, respectively.

If there is more than one experimental data set (`assay`)
stored in the `SummarizedExperiment` object, a select option will appear in the 
sidebar allowing the user to select the `assay`. 


The actual shiny application can then be started by entering the following 
to the `R` console:

```{r, eval=FALSE}
qc <- shinyQC(se)
```

The assignment to `qc` or any other object is not mandatory. Upon exiting the
shiny application, `shinyQC` will return a 
`SummarizedExperiment` object containing the imputed dataset
that can be in the following further analyzed. The object will only be 
returned if the function call was assigned to an object, e.g. 
`qc <- shinyQC(se)`.

Now, we will have a closer look on the user interface of the Shiny 
application. 


## Sidebar

The sidebar enables the user to exclude (e.g. in the case of identified outliers)
and select samples (e.g. in the case if there is interest for a specific 
sample type). Samples are excluded/selected by entering the sample name 
in the input field and pressing `Enter` on the keyboard or by clicking 
on the name of the samples in the drop-down menu and activating the 
relevant option (`"all"` for all samples; `"exclude"`, `"select"`). If the 
option is set to `"select"` at least three samples have to be selected for 
the selection to take place. 

In addition, in the tabs `Values`, 
`Dimension Reduction`, and `DE`, the sidebars allows the user for 

 - normalization: currently the methods `sum`, `quantile divion`, `quantile`
   and `none`, i.e. no normalization, are supported;
 - batch correction: currently the methods `removeBatchEffect` from the `limma`
   package [@Ritchie2015], `ComBat` from the `sva` package, and 
   `none`, i.e. no batch correction, are supported.
   It is highly advised to consult the dimension reduction plots before 
   performing any batch correction. Batch correction should not be done based 
   solely on (count/intensity) value distributions (boxplots/violin plots);
 - transformation: currently the methods `log`, `log2`, `log10`, `vsn` 
   (variance stabilizing normalization/transformation, @Huber2002), and `none`, i.e.
   no transformation, are supported;
 - imputation (only for `SummarizedExperiment` containing missing values): 
   currently the methods `BPCA`, `KNN`, `MLE`, `Min`, `MinDet`, 
   and `MinProb` are supported (see also @Lazar2016 for a review on 
   imputation methods for label-free quantitative proteomics data sets).
   
By clicking on `Generate report` a markdown report will be created 
(the progress of rendering is displayed in the bottom right corner). After 
rendering there is the possibility to open or to save the report. The 
report will take all values as set in the `shinyQC` application - if the 
plot was not called yet, default values will be taken for the rendering. 
   
By exiting the shiny application, a `SummarizedExperiment` object 
is returned to the `qc` object.
If the supplied `SummarizedExperiment` contains missing values, the 
`SummarizedExperiment` with imputed values is returned, otherwise the
`SummarizedExperiment` with batch corrected values is returned.

The `metadata` slot contains information about the method of 
 - the normalization,
 - the batch correction,
 - the transformation, and
 - the imputation of (count/intensity) values (if the supplied 
   `SummarizedExperiment` contains missing values).

The sidebar in the last tab (`DE`) is different from the other tabs and will
be explained in the section `Tab: DE`. 
  

## Tab: Samples

The tab `Samples` gives general information on the number of samples in the 
`se` object. 

### Histogram
The first panel shows a barplot and displays the number of 
samples per sample type, treatment, etc. As an example, if we want to display
how many samples are in `se` for the different `type`s (`type` is a 
column name in `colData(se)` and any column in `colData(se)` can be selected), 
this panel will show the following output:
```{r hist_sample, eval=TRUE, echo=FALSE, crop=NULL, out.width = "200px", dpi=65}
tbl <- hist_sample_num(se = se, category = "type")
partial_bundle(hist_sample(tbl, category = "type"))
```

### Mosaic plot

The figure in this panel displays the relative proportions of the numbers, 
e.g. how many samples (in %) are there for `type` against `arbitrary_values`.
As the dataset was only shipped with a `type` and `sample` column, for 
demonstration, we manually added the column `arbitrary_levels` to the `se` 
object. This column is filled with the the values `"A"` and `"B"`.

Again, `type` and `arbitrary_values` are columns in `colData(se)` and any 
column in `colData(se)` can be selected to create the Mosaic plot.

The figure will tell us to what extent the `se` contains the different types 
in a balanced manner depending on `arbitrary_values`:

```{r mosaic, eval=TRUE, echo=FALSE, crop=NULL, out.width = "200px", dpi=65}
se_tmp <- se
se_tmp$arbitrary_values <- c("A", "B")
mosaic(se = se_tmp, f1 = "type", f2 = "arbitrary_values")
```

 

## Tab: Values
The tab `Values` will take a closer look on the `assay` slot of the 
`SummarizedExperiment`. 

### Boxplot/Violin plot

This panel shows the (count/intensity) values for raw (`raw`), 
batch corrected (`normalized`), normalized+batch corrected (`batch corrected`), 
normalized+batch corrected+transformed (`transformed`), and
normalized+batch corrected+transformed+imputed (`imputed`) (count/intensity) 
values (imputation of missing values, `imputed` will only be shown if there are 
missing values in the `SummarizedExperiment`). As already mentioned, the 
different methods for normalization, batch correction, transformation (and 
imputation) are specified in the side panel.

For visualization purposes only, the (count/intensity) values for the raw,
normalized and batch corrected data sets can be `log2` transformed (see the 
radio buttons in
`Display log2 values? (only for 'raw', 'normalized' and 'batch corrected')`).

The type of visualization (boxplot or violin plot) can be specified by 
selecting `boxplot` or `violin` in the radio button panel (`Type of display`).

The figure (violin plot) using the raw values will look like (log set to `TRUE`)
```{r boxplot, eval=TRUE, echo=FALSE, warning=FALSE, crop=NULL, out.width = "200px", dpi=65}
createBoxplot(se, orderCategory = "sample", title = "raw", log = TRUE, 
               violin = TRUE)
```

### Trend/drift 
This panel shows a trend line for aggregated values to 
indicate drifts/trends in data acquisition. It
shows the sum- or median-aggregated values (specified in
`Select aggregation`). The plot displays trends in data
acquisition that originate e.g. from differences in instrument 
sensitivity. The panel displays aggregated values for 
raw (`raw`), batch corrected (`batch corrected`), batch corrected+normalized 
(`normalized`), batch corrected+normalized+transformed (`transformed`), and
batch corrected+normalized+transformed+imputed (`imputed`) (count/intensity) values 
(imputation of missing values, `imputed` will only be shown if there are missing
values in the `SummarizedExperiment`). 
The different methods for normalization, batch correction, transformation (and 
imputation) are specified in the sidebar panel. 

The smoothing is calculated from the 
selection of samples that are specified by the drop-down menus
`Select variable` and `Select level to highlight`. 
The menu `Select variable` corresponds to the `colnames` in 
`colData(se)`. Here, we can select for the higher-order variable, e.g.
the type (containing for example `BLCA`, `BRCA`, etc.). 
The drop-down menu `Select level to highlight` will specify the actual selection 
from which
the trend line will be calculated (e.g. `BLCA`, `BRCA`, etc.). Also,
the menu will always include the level `all`, which will use all points to 
calculate the trend line. If we want to calculate the trend line of 
aggregated values of all samples belonging to the type `QC`, we select
`QC` in the drop-down menu. 

The panel allows the users for further customization after expanding the collapsed box.
The data input is selected in the drop-down menu under `Select data input`.
The smoothing method (either LOESS or linear model) is selected in the drop-down
menu under `Select smoothing method`. The aggregation method is selected 
in the drop-down menu `Select smoothing method`.

With the drop-down menu `Select categorical variable to order samples`, 
the samples (x-axis) will be ordered alphanumerically according to the 
selected level (and the sample name). 


Here, we are interested in observing if there is a trend/drift for 
samples of `type` `BRCA`. We select `LOESS` as the method for the trend line 
and `median` as the aggregation method. The figure will then look as follows:

```{r drift, eval=TRUE, echo=FALSE, message=FALSE, warning=FALSE, crop=NULL, out.width = "200px", dpi=65}
partial_bundle(driftPlot(se, aggregation = "median", category = "type",
          orderCategory = "type", level = "BRCA", method = "loess"))
```


### Coefficient of variation

This panel shows the coefficient of variation values for raw (`raw`),
normalized (`normalized`), normalized+batch corrected (`batch corrected`), 
normalized+batch corrected+transformed (`transformed`), and 
normalized+batch corrected+transformed+imputed (`imputed`) 
(count/intensity) values (imputation of missing values, `imputed` will only be shown 
if there are missing values in the `SummarizedExperiment`) among the samples. 
The different methods for normalization, batch corrected, transformation,
(and imputation) are specified in the sidebar panel. 

The panel displays the coefficient of variation values from the samples of the
`SummarizedExperiment` object. The coefficients of variation are calculated 
according to the formula `sd(x) / mean(x) * 100` with `x` the sample values 
and `sd` the standard deviation. The plot might be useful when looking at the
coefficient of variation values of a specific sample type (e.g. QCs) and trying
to identify outliers. 
 
Here, we shows the plot of coefficient of variation values from the 
raw values (as obtained by `assay(se)`), normalized values (using `sum` 
normalization), transformed values (using `vsn`), batch corrected values
(using `none`) and imputed values (using the `MinDet` algorithm, @Lazar2016).

```{r cv, eval=TRUE, echo=FALSE, warning=FALSE, message=FALSE, crop=NULL, out.width = "200px", dpi=65}
a <- assay(se)
a_n <- normalizeAssay(a, "sum")
se_n <- MatrixQCvis:::updateSE(se = se, assay = a_n)
a_b <- batchCorrectionAssay(se_n, method = "none")
a_t <- transformAssay(a_b, "vsn")
se_t <- MatrixQCvis:::updateSE(se = se, assay = a_t)

a_i <- imputeAssay(a_t, "MinDet")

## calculate cv values
cv_r <- cv(a, "raw")
cv_n <- cv(a_n, "normalized")
cv_b <- cv(a_b, "batch corrected")
cv_t <- cv(a_t, "transformed")
cv_i <- cv(a_i, "imputed")
 
df <- data.frame(cv_r, cv_n, cv_b, cv_t, cv_i)
plotCV(df)
```

 
### Mean-sd plot

The panel shows the three mean-sd (standard deviation) plots for
normalized+batch corrected+transformed (`transformed`)
and normalized+batch corrected+transformed+imputed (`imputed`) values
(`imputed` will only be shown if there are missing
values in the `SummarizedExperiment`). 
The sd and mean are calculated feature-wise from the values of the respective 
data set. The plot allows the user to visualize if there is a dependence of the sd on 
the mean. The red line depicts the running median estimator (window-width 10%). 
In case of sd-mean independence, the running median should be approximately 
horizontal.

For the transformed values, the mean-sd plot will look like
```{r meansdplot, eval=TRUE, echo=FALSE, warning=FALSE, crop=NULL, out.width = "200px", dpi=65}
vsn::meanSdPlot(assay(se_t))
```

### MA plot

The panel displays MA plots and Hoeffding's D statistic. 

In the first part of the panel the `A` vs. `M` plots per sample are depicted.

The values are defined as follows

 - $A = \frac{1}{2} \cdot (I_i + I_j)$ and 
 - $M =  I_i−I_j$ ,
 
where $I_i$ and $I_j$  are per definition `log2`-transformed values. 
In the case of `raw`, `normalized`, or `batch corrected` the values are
`log2`-transformed prior to calculating `A` and `M`. In case of `transformed`
or `imputed` the values are taken as they are 
(N.B. when the transformation method is set to `none` the values are not 
`log2`-transformed).
   
The values for $I_i$ are taken from the sample $i$. For $I_j$, the 
feature-wise means are calculated from the values of the `group` $j$ of 
samples specified by the drop-down menu `group`. The sample for calculating 
$I_i$ is excluded from the group $j$. The group can be set to 
`"all"` (i.e. all samples except sample $i$ are used to calculate $I_j$) or 
any other column in `colData(se)`. For any group except `"all"` the group is 
taken to which the sample $i$ belongs to and the sample $i$ is excluded from 
the feature-wise calculation.

The MA values for all samples are by default displayed facet-wise. The MA plot 
can be set to a specific sample by changing the selected value in the 
drop-down menu `plot`.

The underlying data set can be selected by the drop-down menu 
(`Data set for the MA plot`).

In the second part of the panel, the Hoeffding's D statistic values are 
visualized for the different data sets `raw`, `normalized`, `batch corrected`,
`transformed`, and `imputed` (`imputed` will only be shown if there are
missing values in the `SummarizedExperiment`).

`D` is a measure of the distance between `F(A, M)` and `G(A)H(M)`, where 
`F(A, M)` is the joint cumulative distribution function (CDF) of `A` and `M`, 
and `G` and `H` are marginal CDFs. The higher the value of `D`, the more 
dependent are `A` and `M`. The `D` values are connected for the same 
samples along the different data sets (when `lines` is selected), enabling the
user to track the influence of normalization, batch correction,
transformation (and imputation) methods on the `D` values. 

The MA plot using the raw values and `group = "all"` will look like the 
following (`plot` = "Sample_1-1"`):

```{r maplot, eval=TRUE, echo = FALSE, show=FALSE, crop=NULL, out.width = "200px", dpi=65}
tbl <- MAvalues(se, group = "all")
MAplot(tbl, group = "all", plot = "TCGA-K4-A3WV-11A-21R-A22U-07")
```

### ECDF
The plot shows the ECDF of the values of the sample 
$i$ and the feature-wise mean values of a group $j$ of samples specified 
by the drop-down menu `Group`. The sample for calculating $I_i$ is
excluded from the group $j$. The group can be set to `"all"`
(i.e. all samples except sample $i$ are used to calculate
$I_j$) or any other column in `colData(se)`. For any group except `"all"` the
group is taken to which the sample $i$ belongs to and the sample $i$ is 
excluded from the feature-wise calculation.

The underlying data set can be selected by the drop-down menu 
`Data set for the MA plot`. The sample $i$ can be selected by
the drop-down menu `Sample`. The group can be selected by 
the drop-down menu `Group`.

The ECDF plot for the sample `"TCGA-K4-A3WV-11A-21R-A22U-07"`, 
`group = "all"`, and the 
raw values (as obtained by `assay(se)`) will look like:

```{r ecdf, eval=TRUE, echo=FALSE, crop=NULL, out.width = "200px", dpi=65}
ECDF(se, "TCGA-K4-A3WV-11A-21R-A22U-07", group = "all")
```


### Distance matrix

On the left, the panel depicts heatmaps of distances between samples for 
the data sets of
raw (`raw`), normalized (`normalized`),
normalized+batch corrected (`batch corrected`), 
normalized+batch corrected+transformed (`transformed`), and 
normalized+batch corrected+transformed+imputed (`imputed`, 
`imputed` will only be shown if there are missing values in the 
`SummarizedExperiment`). The annotation of the heatmaps can be adjusted by 
the drop-down menu `annotation`.

On the right panel the sum of distances to other samples is depicted.

The distance matrix and sum of distances (for raw values, as obtained by
`assay(se)`) will look like:

```{r distSampe, eval=TRUE, echo=FALSE, crop=NULL, warning=FALSE, message=FALSE, out.width = "200px", dpi=65}
a <- assay(se)
dist_mat <- distShiny(a)
distSample(dist_mat, se, "type", use_raster = TRUE, raster_device = "jpeg")
partial_bundle(sumDistSample(dist_mat, title = "raw"))
```

### Features

The first plot shows the values for each samples along the data 
processing steps.
The feature to be displayed is selected via the drop-down menu 
**Select feature**. 

```{r featurePlot, eval=TRUE, echo=FALSE, crop=NULL, out.width = "200px", dpi=65}
l_assays <- list(raw = a, normalized = a_n, `batch.corrected` = a_b,
   transformed = a_t, imputed = a_i)
df_feature <- createDfFeature(l_assays, feature = rownames(se)[1])
featurePlot(df_feature)
```

The second plot shows the coefficient of variation of the values for all features
in the data set along the data processing steps. The features of same 
identity can be connected by lines by clicking on `lines`. 

```{r cvFeaturePlot, eval=TRUE, echo=FALSE, crop=NULL, out.width = "200px", dpi=65}
partial_bundle(cvFeaturePlot(l_assays, lines = FALSE))
```

The element in the bottom of the tab panel (`Select features`) will specify 
the selection of features in the data set (the selection will be propagated through 
all tabs):

- `all`: when selected, all features in the uploaded `SummarizedExperiment` 
object will used,
- `exclude`: when selected, the features specified in the text input field
will be excluded from the uploaded `SummarizedExperiment`,
- `select`: when selected, the features specified in the text input field 
will be selected from the uploaded `SummarizedExperiment` 
(note: a minimum of three features needs to be selected in order for the 
selection to take place).


## Tab: Dimension Reduction

Within this tab several dimension reduction plots are displayed to visualize
the level of similarity of samples of a data set: 
principal component analysis (PCA), principal coordinates analysis 
(PCoA, also known as multidimensional scaling, MDS), 
non-metric multidimensional scaling (NMDS), 
t-distributed stochastic neighbor embedding (tSNE, @vanderMaaten2008), and 
uniform manifold approximation and projection (UMAP, @McInnes2018). 
Data input for the dimension reduction plots is the `imputed` data set. 

### PCA

The panel depicts a plot of PCA. The data input can be `scale`d and 
`center`ed prior to calculating the principal components by adjusting the
respective tick marks. The different PCs can be displayed by changing the
values in the drop-down menus for the x-axis and y-axis. 

A scree plot, showing the explained variance per PC, is displayed in the 
right panel.

### PCoA

The panel depicts a plot of PCoA (= multidimensional scaling). Different distance 
measures can be used to calculate the distances between the samples 
(euclidean, maximum, manhattan, canberra, minkowski). 
The different axes of the transformed data can be displayed by changing the
values in the drop-down menus for the x-axis and y-axis. 

### NMDS

The panel depicts a plot of NMDS. Different distance 
measures can be used to calculate the distances between the samples 
(euclidean, maximum, manhattan, canberra, minkowski). 
The different axes of the transformed data can be displayed by changing the
values in the drop-down menus for the x-axis and y-axis. 

### tSNE

The panel depicts a plot of tSNE. The parameters `Perplexity`, 
`Number of iterations`, `Number of retained dimensions in initial PCA`,
and `Output dimensionality` required for the tSNE algorithm can be
set with the sliders. For the parameter
`Number of retained dimensions in initial PCA` the panel 
`Principal components` can be employed that shows on the left panel a 
Scree plot of the data set and permuted values and corresponding p-values
from the permutation (set the number of principal components where the 
explained variance is above the permuted data set/where p-values are below
0.05).

The different dimensions of the transformed data can be displayed by changing 
the values in the drop-down menus for the x-axis and y-axis (either two or 
three dimensions according to the `Output dimensionality`).  

### UMAP

The panel depicts a plot of UMAP. The parameters `Minimum distance`, 
`Number of neighbors`, and `Spread`, required for the UMAP algorithm can be
set with the sliders. 

The different dimensions of the transformed data can be displayed by changing 
the values in the drop-down menus for the x-axis and y-axis.  

## Tab: DE

This tab enables the user to test for differential expression between conditions. 

Currently, two methods/tests are implemented for calculating differential 
expression between conditions: moderated t-tests from `limma` and the
Wald test from `proDA`. The approach of `proDA` does not require imputed 
values and will take the normalized+transformed+batch corrected 
(`batch corrected`) data set as input.

The moderated t-statistic is the ratio of the M-value to its standard error, 
where the M-value is the log2-fold change for the feature of interest. 
The moderated t-statistic has the same interpretation as
an ordinary t-statistic except that the standard errors have been moderated
across features, borrowing information from the ensemble of features to aid
with inference about each individual feature [@Kammers2015]. We use the 
`eBayes` function from `limma` to compute the moderated t-statistics
 (`trend` and `robust` are set by default to `TRUE`, see `?eBayes` for 
 further information).

`proDA` [@Ahlmann2019] was developed for the differential abundance analysis
in label-free proteomics data sets. `proDA` models missing values in an 
intensity-dependent probabilistic manner based on a dropout curve 
(for further details see @Ahlmann2019). 

In the input field for levels, the formula for the levels is entered.
The formula has to start with a `~` (tilde) and the `R`-specific symbolic form:

- `+` to add terms,
- `:` to denote an interaction term, 
- `*` to denote factor crossing (`a*b` is interpreted as `a+b+a:b`), `a` and `b`
   are columns in `colData(se)`,
- `-` to remove the specified term, e.g. `~ a - 1` to specify no intercept, and
   `a` a column in `colData(se)`,
- `+ 0` to alternatively specify a model without intercept.

The `colnames` of `colData` can be added as terms.  

The `colnames` of the model matrix can be used to calculate contrasts, e.g. 
`a - b` to specify the contrast between `a` and `b`. The contrasts can be 
specified in the input field in the sidebar panel.

The panels `Model matrix` and `Contrast matrix` will show the model and contrast
matrix upon correct specification of the levels and contrasts. 
The panel `Top DE` will show the differential features in a tabular format, 
while the panel `Volcano plot` will display the information of 
log fold change (for `limma`) or difference (for `proDA`) against the 
p-values (displayed as `-log10(p-value)`. 

In the following, we will look at the different panels with the
`se` input as specified above.

### Sample meta-data

The panel `Sample meta-data` will show the column data of the `se` object. The 
output will help to specify the levels for the model matrix.

The output will look like the following (only the first few rows are shown 
here)
```{r colData, echo=FALSE, eval=TRUE}
colData(se) |>
    head(n = 10)
```

### Model matrix

When entering `~ type + 0` into the input field 
`Select levels for Model Matrix`, the `Model matrix` panel will look like
(only the first few rows are shown here):

```{r modelMatrix, echo=FALSE, eval=TRUE}
mM <- model.matrix(formula("~ type + 0"), data = colData(se))
head(mM)
```

### Contrast matrix

As an example, we are interested in the differential expression between 
the samples of typ `BRCA` and `LUAD`. We enter `typeBRCA-typeLUAD` in the input
field `Select contast(s)`. The contrast matrix (only the first few rows 
are shown here) will then look like:

```{r contrasts, echo=FALSE, eval=TRUE, warning=FALSE, message=FALSE}
library(limma)
cM <- makeContrasts(contrasts = "typeBRCA-typeLUAD", levels = mM)
head(cM)
```


### Top DE

Switching to the panel `Top DE`, we will obtain a table with the differentially
expressed features (normalization method is set to `none`, 
transformation method to `vsn` and imputation method to `MinDet`). 
Here, differential expression is tested via moderated 
t-tests (from the `limma` package): 

The output will be (only the first 20 rows will be shown here):

```{r topDE, echo=FALSE, eval=TRUE, warning=FALSE, message=FALSE}
a <- assay(se)
a_n <- a |>
    normalizeAssay(method = "none")
a_t <- a_n |>
    transformAssay(method = "vsn")
a_i <- a_t |>
    imputeAssay(method = "MinDet")

fit <- lmFit(a_i, design = mM)
fit <- contrasts.fit(fit, contrasts = cM)
fit <- eBayes(fit, trend = TRUE, robust = TRUE)
tT <- topTable(fit, number = Inf, adjust.method = "fdr", p.value = 0.05)
rmarkdown::paged_table(tT[seq_len(20), ])
```


### Volcano plot

The last panel of the tab `DE` displays the information from the differential
expression analysis. In the case of moderated t-tests, the plot shows the
log fold changes between the specified contrasts against the p-values. 
Using the afore-mentioned specification for the model matrix and the 
contrast matrix, the plot will look like:

```{r volcano, eval=TRUE, echo=FALSE, crop=NULL, out.width = "200px", dpi=65}
partial_bundle(volcanoPlot(tT, type = "ttest"))
```



# QC analysis of proteomics data

We will retrieve a proteomics dataset from the `ExperimentHub` package. The 
dataset contains quantitative profiling information of about 12000 proteins
in 375 cell lines spanning 24 primary diseases and 27 lineages. The 
dataset was obtained by the Gygilab at Harvard University.
Within the `ExperimentHub`, the dataset is stored as a `tibble` in long
format. We will convert it here to a `SummarizedExperiment` class object.

```{r data_proteomics}
eh[eh$title == "proteomic_20Q2"]
tbl <- eh[["EH3459"]]

## reduce the number of files to speed computations up (can be skipped)
cell_line_unique <- dplyr::pull(tbl, "cell_line") |>
    unique()
tbl <- tbl |> 
    filter(tbl[["cell_line"]] %in% cell_line_unique[seq_len(40)])

## using the information from protein_id/cell_line calculate the mean expression
## from the protein_expression values, 
tbl_mean <- tbl |>
    dplyr::group_by(protein_id, cell_line) |>
    dplyr::summarise(mean_expression = mean(protein_expression, na.rm = TRUE), 
        .groups = "drop") 

## create wide format from averaged expression data
tbl_mean <- tbl_mean |>
    tidyr::pivot_wider(names_from = cell_line, values_from = mean_expression,
        id_cols = protein_id, names_expand = TRUE)

## add additional information from tbl to tbl_mean, remove first columns 
## protein_expression and cell_line, remove the duplicated rows based on 
## protein_id, finally add the tbl_mean to tbl_info
tbl_info <- tbl |>
    dplyr::select(-protein_expression, -cell_line) |> 
    dplyr::distinct(protein_id, .keep_all = TRUE)
tbl_mean <- dplyr::right_join(tbl_info, tbl_mean,
    by = c("protein_id" = "protein_id")) 

## create assay object
cols_a_start <- which(colnames(tbl_mean) == "A2058_SKIN")
a <- tbl_mean[, cols_a_start:ncol(tbl_mean)] |>
    as.matrix()
rownames(a) <- dplyr::pull(tbl_mean, "protein_id")

## create rowData object
rD <- tbl_mean[, seq_len(cols_a_start - 1)] |>
    as.data.frame()
rownames(rD) <- dplyr::pull(tbl_mean, "protein_id")

## create colData object, for the tissue column split the strings in column 
## sample by "_", remove the first element (cell_line) and paste the remaining
## elements
cD <- data.frame(
    sample = colnames(tbl_mean)[cols_a_start:ncol(tbl_mean)]
) |> 
    mutate(tissue = unlist(lapply(strsplit(sample, split = "_"), function(sample_i) 
        paste0(sample_i[-1], collapse = "_"))))
rownames(cD) <- cD$sample

## create the SummarizedExperiment
se <- SummarizedExperiment(assay = a, rowData = rD, colData = cD)

## here we remove the features that have a standard deviation of 0
se_sds <- apply(assay(se), 1, sd, na.rm = TRUE)
se <- se[!is.na(se_sds) & se_sds > 0, ]
```

Again, the shiny application can be started via

```{r shinyQC_proteomics, eval = FALSE}
shinyQC(se)
```

A description of the tabs `Samples`, `Values`, `Dimension Reduction`, and 
`DE` can be found above under the section `QC analysis of TCGA RNA-seq data`.
We will focus here on the two tabs that are shown only for data sets that 
contain missing values, `Measured Values` and `Missing Values`.
  
## Tab: Measured Values and Missing Values

The tabs `Measured Values` and `Missing Values` are only displayed if the 
`SummarizedExperiment` object contains missing values as in the case 
of this proteomics dataset. 

The layout in the tabs `Measured Values` and `Missing Values` is similar. 
Therefore, the two tabs are described here simultaneously and the differences
are pointed out where necessary. 

### Barplot for samples
The plot shows the number of measured or missing values per sample 
in the data set (depending on the selected tab). For example for the tab
`Measured Values`, the plot will look like

```{r samplesMeasuredMissing, eval=TRUE, echo=FALSE, crop=NULL, out.width = "200px", dpi=65}
tbl <- samplesMeasuredMissing(se)
partial_bundle(barplotSamplesMeasuredMissing(tbl, measured = TRUE))
```

In this case, the samples show approximately the same number of measured features,
i.e. there is no indication to remove any sample based on this measure. 

### Histogram Features

The plot shows different data depending on which tab 
(`Measured Values` or `Missing Values`) is selected. The binwidth will be 
determined by the slider input (`Binwidth (Measured Values)` or 
`Binwidth (Missing Values)`).

#### Measured Variables

The plot shows how often a feature was measured in a certain number of 
samples.

Examples:

1. in the case of one sample (x-axis), the y-axis will denote the number of 
features for which only one feature was measured.

2. in the case of the number of total samples (x-axis), the y-axis will 
denote the number of features with complete observations (i.e. the number 
of features for which the feature was quantified in all samples).

```{r histFeature_measured, eval=TRUE, echo=FALSE, message=FALSE, warning=FALSE, crop=NULL, out.width = "200px", dpi=65}
partial_bundle(histFeature(assay(se), measured = TRUE))
```

#### Missing Variables
The plot shows how often a feature was missing in a certain number of samples.

Examples:

1. in the case of one sample (x-axis), the y-axis will denote the number of 
features for which only one feature was missing.

2. in the case of the number of total samples (x-axis), the y-axis will 
denote the number of features with completely missing observations 
(i.e. the number of features for which no feature was quantified in all 
samples).

```{r histFeature_missing, eval=FALSE, echo=FALSE, message=FALSE, warning=FALSE, crop=NULL, out.width = "200px", dpi=65}
partial_bundle(histFeature(assay(se), measured = FALSE))
```

### Histogram Features along variable

The plot in this panel can be read accordingly to the one in the panel 
`Histogram Features`, but, it is segregated for the specified variable 
(e.g. it shows the distribution of measured/missing values among the sample 
types).

```{r histFeatureCategory, eval=TRUE, echo=FALSE, message=FALSE, warning=FALSE, crop=NULL, out.width = "200px", dpi=65}
partial_bundle(histFeatureCategory(se, measured = TRUE, category = "tissue"))
```

### UpSet
The plot shows the interaction of sets between different variables 
depending on their presence or absence. The dots in the UpSet plot specify 
if the criteria for presence/absence are fulfilled (see below for the 
definition). In each column the intersections are displayed together with 
the number of features regarding the type of intersection. The boxplots in 
the rows display the number of present/absent features per set.

All sets present in the data set are displayed. Depending on the data set, 
however, not all intersections sets are displayed (see the help page for 
the `upset` function from the `UpSetR` package).

#### Measured Values
Presence is defined by a feature being measured in at least one sample of a 
set.

```{r upsetmeasured, eval=TRUE, echo=FALSE, crop=NULL, out.width = "200px", dpi=65}
upsetCategory(se, category = "tissue", measured = TRUE)
```

#### Missing Values
Absence is defined by a feature with only missing values (i.e. no measured 
values) of a set.

```{r upsetmissing, eval=FALSE, echo=FALSE, crop=NULL, out.width = "200px", dpi=65}
upsetCategory(se, category = "tissue", measured = FALSE)
```

### Sets

This panel will retrieve the features specified by intersection of sets. 

This panel builds upon the `Upset` panel. By selecting the check boxes, 
the names of the features (taken from the `rownames` of the features) are 
printed as text that fulfill the defined intersection of sets.

Example: Four sets (`Type_1`, `Type_2`, `Type_3`, and `Type_4`) are found for 
a specified variable (here: `type`). When selecting the boxes for `Type_1` and 
`Type_2` (while not selecting the boxes for `Type_3` and `Type_4`) the 
features that are present/absent for `Type_1` and `Type_2` 
(but not in the sets `Type_3` and `Type_4`) are returned.

For the tab `Measured Values`, presence is defined by a feature being 
measured in at least one sample of a set.

For the tab `Missing Values`, absence is defined by a feature with only 
missing values (i.e. no measured values) of a set.



# Appendix {-}

## Session information {-}

All software and respective versions to build this vignette are listed here:

```{r session, eval=TRUE, echo=FALSE}
sessionInfo()
```

## References

### Principal coordinates analysis (PCoA)

The panel depicts a plot of PCoA (= multidimensional scaling). Different distance 
measures can be used to calculate the distances between the samples 
(euclidean, maximum, manhattan, canberra, minkowski). 
The different axes of the transformed data can be displayed by changing the
values in the drop-down menus for the x-axis and y-axis. 

### Features

The first plot shows the values for each samples along the data 
processing steps.
The feature to be displayed is selected via the drop-down menu 
**Select feature**. 

The second plot shows the coefficient of variation values for all features
in the data set along the data processing steps. The features of same 
identity can be connected by lines by clicking on **lines**. 

The element in the bottom of the tab panel (**Select features**) will specify 
the selection of features in the data set (that will be propagated through 
all tabs):

- `all`: when selected, all features in the uploaded `SummarizedExperiment` 
object will used,
- `exclude`: when selected, the features specified in the text input field
will be excluded from the uploaded `SummarizedExperiment`,
- `select`: when selected, the features specified in the text input field 
will be selected from the uploaded `SummarizedExperiment` 
(note: a minimum of three features needs to be selected in order for the 
selection to take place).

### Barplot for number of features

The plot shows the number of measued features along the samples. Measured 
values are defined as non-`NA` values in `assay(se)`.
The plot will help to identify samples that 
have a high number of missing values that can be excluded from further analysis.

### Histogram for number of features along a variable
The plot can be read accordingly to the one in the tab *Histogram features*, 
but, it is segregated for the stratified variable (e.g. it shows the 
distribution of missing values among the sample types). 

The variable for stratification can be specified by the drop-down menu
**Variable for stratification**.

### Coefficient of variation among the samples

This panel shows the coefficient of variation values for raw (**raw**), 
normalized (**normalized**), normalized+transformed (**transformed**),
normalized+transformed+batch corrected (**batch corrected**), and
normalized+transformed+batch corrected+imputed (**imputed**) 
assay values (imputation of missing values). 
The different methods for normalization, transformation, batch 
correction and imputation are specified in the side panel. 

The panel displays the coefficient of variation values from the samples of the
 `SummarizedExperiment` object. The coefficients of variation are calculated 
 according to the formula `sd(x) / mean(x) * 100` with `x` the sample values 
 and `sd` the standard deviation.
 

### Boxplot or violin plots of values among the samples

This tab shows the assay values for raw (**raw**), normalized 
(**normalized**), normalized+transformed (**transformed**), and
normalized+transformed+batch corrected (**batch corrected**)
assay values. 
The different methods for normalization, transformation, and batch 
correction are specified in the side panel. 

For visualization purposes only, the assay
values for the raw and normalized data sets can be `log2` transformed
(**Display log2 values? (only for 'raw' and 'normalized')**).

The type of visualization (boplot or violin plot) can be specified 
by selecting `boxplot` or `violin` in the radio button panel. 

### Boxplot or violin plots of assay values among the samples

This tab shows the assay values for raw (**raw**), normalized 
(**normalized**), normalized+transformed (**transformed**), 
normalized+transformed+batch corrected (**batch corrected**)
and normalized+transformed+batch corrected+imputed (**imputed**) 
assay values (imputation of missing values). 
The different methods for normalization, transformation, batch 
correction and imputation are specified in the side panel. 

For visualization purposes only, the assay
values for the raw and normalized data sets can be `log2` transformed
(**Display log2 values? (only for 'raw' and 'normalized')**).

The type of visualization (boplot or violin plot) can be specified 
by selecting `boxplot` or `violin` in the radio button panel. 

### Trend line for aggregated values to indicate drifts/trends in data acquisition

This panel shows the sum- or median-aggregated values (specified in
**Select aggregation**). The plot allows to display trends in data
acquisition that originate e.g. from differences in instrument 
sensitivity. The panel allows to display aggregated values for 
raw (**raw**), normalized 
(**normalized**), normalized+transformed (**transformed**), 
normalized+transformed+batch corrected (**batch corrected**), and
normalized+transformed+batch corrected+imputed (**imputed**) assay values 
(imputation of missing values). 
The different methods for normalization, transformation, batch correction 
and imputation are
specified in the side panel. 

The smoothing is calculated from a 
selection of samples that are specified by the drop-down menus
**Select variable** and **Select level to highlight**. 
The menu **Select variable** corresponds to the `colnames` in 
`colData(se)`. Here, we can select for the higher-order variable, e.g.
the sample type (containing for example `Type_1`, `Type_2`, ..., `QC`). 
The drop-down menu **Select level to highlight** will specify the actual 
selection from which
the trend line will be calculated (e.g. `Type_1`, `Type_2`, ..., `QC`). Also,
the menu will always include the level `all`, which will use all points to 
calculate the trend line. As an example, if we want to calculate the trend line of 
aggregated values of all samples belonging to the type `QC`, we select
`QC` in the drop-down menu. 

The panel allows for further customization after expanding the collapsed box.
The data input is selected in the drop-down menu under **Select data input**.
The smoothing method (either LOESS or linear model) is selected in the drop-down
menu under **Select smoothing method**. The aggregation method is selected
in the drop-down menu **Select smoothing method**.

With the drop-down menu **Select categorical variable to order samples**, 
the samples (x-axis) will be ordered alphanumerically according to the 
selected level (and the sample name). 

### Mean-sd plots

The panel shows the three mean-sd (standard deviation) plots for  
normalized+transformed (**transformed**), 
normalized+transformed+batch corrected (**batch corrected**), and 
normalized+transformed+batch corrected+imputed (**imputed**) assay values.
The sd and mean are calculated feature-wise from the values of the
respective data set. The plot allows to visualize if there is a dependence
of the sd on the mean. The red line depicts the running median estimator 
(window-width 10%). In case of sd-mean independence, the running median
should be approximately horizontal. 

### Empirical distribution function

The plot shows the empirical distribution function (ECDF) of the values of the sample 
$i$ and the feature-wise mean values of a group $j$ of samples specified 
by the drop-down menu **Group**. The sample for calculating $I_i$ is
excluded from the group $j$. The group can be set to `"all"`
(i.e. all samples except sample $i$ are used to calculate
$I_j$) or any other column in `colData(se)`. For any group except `"all"` the
group is taken to which the sample $i$ belongs to and the sample $i$ is 
excluded from the feature-wise calculation.

The underlying data set can be selected by the drop-down menu 
**Data set for the MA plot**. The sample $i$ can be selected by
the drop-down menu **Sample**. The group can be selected by 
the drop-down menu **Group**.

### Uniform Manifold Approximation and Projection (UMAP)

The panel depicts a plot of UMAP. The parameters **Minimum distance**, 
**Number of neighbors**, and **Spread**, required for the UMAP algorithm can be
set with the sliders. 

The different dimensions of the transformed data can be displayed by changing 
the values in the drop-down menus for the x-axis and y-axis.  

### Histogram for number of features

The plot shows how often a feature was missing in a certain number of samples.  

Examples: 

1. in the case of one sample (x-axis), the y-axis will denote the number of 
features for which only one feature was missing. 

2. in the case of the number of total samples (x-axis), the y-axis will denote
the number of features with completely missing observations (i.e. the number of 
features for which no feature was quantified in all samples). 

The binwidth is determined by the slider 
input (**Binwidth (Measured Values)** or **Binwidth (Missing Values)**). 

### Principal component analysis (PCA)

The panel depicts a plot of PCA. The data input can be **scale**d and 
**center**ed prior to calculating the principal components by adjusting the
respective tick marks. The different PCs can be displayed by changing the
values in the drop-down menus for the x-axis and y-axis. 

A scree plot, showing the explained variance per PC, is displayed in the 
right panel.

### Retrieve the features specified by intersection of sets

This panel builds upon the *Upset* panel. By selecting the check boxes,
the names of the features (taken from the `rownames` of the features) 
are printed as text that fulfill the defined intersection of sets.

Example: 
Five sets (A, B, C, D, and E) are found for a specified variable (e.g., sample 
type). When selecting the boxes for A and B (while not selecting the boxes 
for C, D, and E) the features that are presen for A and B (but not 
in the sets C, D, and E) are returned. 

Presence is defined by a feature being measured in at least one sample of a
set. 

### Intersection of sets among a variable (UpSet plot)

The plot shows the interaction of sets between different variables depending 
on their presence. The dots in the UpSet plot specify if the 
criteria for presence are fulfilled:
Presence is defined by a feature being measured in at least one sample of a
set. 
 
In each column the intersections are displayed together with the number 
of features regarding the type of intersection. The boxplots in the rows 
display the number of present features per set. 

All sets present in the data set are displayed.  Depending on the data set, 
however, not all intersections sets are displayed 
(see the help page for the `upset` function from the `UpSetR` package). 

### Mean-sd plots

The panel shows the mean-sd (standard deviation) plots for 

 - normalized+batch corrected+transformed (**transformed**) and 
 - normalized+batch corrected+transformed+imputed (**imputed**) assay values.
 
The **imputed** values are only displayed if there are missing values (`NA`s) in the 
**raw** data set.

The sd and mean are calculated feature-wise from the values of the
respective data set. The plot allows to visualize if there is a dependence
of the sd on the mean. The red line depicts the running median estimator 
(window-width 10%). In case of sd-mean independence, the running median
should be approximately horizontal. 

### Differential expression

Currently, two methods/tests are implemented for calculating differential 
expression between conditions: moderated t-tests from `limma` and the
Wald test from `proDA`. The approach of `proDA` does not require imputed 
values and will take the normalized+transformed+batch corrected 
(**batch corrected**) data set as input. The `limma` approach takes 
normalized+transformed+batch corrected+imputed intensities 
(**imputed**) as input.

#### Levels
Enter here the formula for the levels. The formula has to start with a `~` 
(tilde) and the `R`-specific symbolic form:
- `+` to add terms,
- `:` to denote an interaction term, 
- `*` to denote factor crossing (`a*b` is interpreted as `a+b+a:b`),
- `-` to remove the specified term, e.g. `~ x - 1` to specify no intercept,
- `+ 0` to alternatively specify a model without intercept.

The `colnames` of `Sample meta-data` can be added as terms.  

#### Contrasts
The `colnames` of the *Model matrix* can be used to calculate contrasts, e.g. 
`a - b` to specify the contrast between `a` and `b`. 


The tabs *Model matrix* and *Contrast matrix* show the model and contrast
matrix upon correct specification of the levels and contrasts. 
The tab *Top DE* shows the differential features in a tabular format, 
while the tab *Volcano plot* displays the information of 
log fold change (for `limma`)/difference (for `proDA`) against the 
p-values (displayed as `-log10(p-value)`. 

### Coefficient of variation among the samples

This panel shows the coefficient of variation values for raw (**raw**), 
normalized (**normalized**), normalized+transformed (**transformed**),
and normalized+transformed+batch corrected (**batch corrected**)
assay values. 
The different methods for normalization, transformation, and batch 
correction are specified in the side panel. 

The panel displays the coefficient of variation values from the samples of the
 `SummarizedExperiment` object. The coefficients of variation are calculated 
 according to the formula `sd(x) / mean(x) * 100` with `x` the sample values 
 and `sd` the standard deviation.
 

### Intersection of sets among a variable (UpSet plot)
The plot shows the interaction of sets between different variables depending 
on their absence. The dots in the UpSet plot specify if the 
criteria for absence are fulfilled:
Absence is defined by a feature with only missing values (i.e. no measured 
values) of a set. 
 
In each column the intersections are displayed together with the number 
of features regarding the type of intersection. The boxplots in the rows 
display the number of absent features per set. 

All sets present in the data set are displayed.  Depending on the data set, 
however, not all intersections sets are displayed 
(see the help page for the `upset` function from the `UpSetR` package). 

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_values.R
\name{transformAssay}
\alias{transformAssay}
\title{Transform the (count/intensity) values of a \code{data.frame}, 
\code{tbl} or \code{matrix}}
\usage{
transformAssay(
  a,
  method = c("none", "log", "log2", "log10", "vsn"),
  .offset = 1
)
}
\arguments{
\item{a}{\code{matrix} with samples in columns and features in rows}

\item{method}{\code{character}, one of \code{"none"}, \code{"log"}, 
\code{"log2"}, \code{"log10"}, or \code{"vsn"}}

\item{.offset}{\code{numeric(1)}, offset to add when \code{method} set to
\code{"log"}, \code{"log2"}, or \code{"log10"} and 
\code{a} contains values of 0, default to 1}
}
\value{
\code{matrix}
}
\description{
The function \code{transformAssay} transforms the (count/intensity) values 
of a  \code{matrix}. It uses either \code{log}, \code{log2}, \code{log10},  
variance stabilizing normalisation (\code{vsn}) or no transformation method 
(pass-through, \code{none}). The object
\code{x} has the samples in the columns and the features in the rows.
}
\details{
Internal use in \code{shinyQC}.
}
\examples{
a <- matrix(seq_len(1000), nrow = 100, ncol = 10, 
        dimnames = list(seq_len(100), paste("sample", seq_len(10))))
transformAssay(a, "none")
transformAssay(a, "log")
transformAssay(a, "log2")
transformAssay(a, "vsn")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_measuredvalues_missingvalues.R
\name{upsetCategory}
\alias{upsetCategory}
\title{UpSet plot to display measures values across sample types}
\usage{
upsetCategory(se, category = colnames(colData(se)), measured = TRUE)
}
\arguments{
\item{se}{\code{SummarizedExperiment},
 containing the intensity values in \code{assay(se)}, missing values are
encoded by \code{NA}}

\item{category}{\code{character}, corresponding to a column in 
\code{colData(se)}}

\item{measured}{\code{logical}, should the measured values 
(\code{measured = TRUE}) 
or missing values (\code{measured = FALSE}) be taken}
}
\value{
\code{upset} plot
}
\description{
The function \code{upsetCategory} displays the frequency of measured values 
per feature with respect to class/sample type to assess difference in
occurrences. Internally, the measured values per sample are obtained via
the \code{measuredCategory} function: this function will access the number
of measured/missing values per category and feature. From this, a binary 
\code{tbl} will be created specifying if the feature is present/missing, 
which will be given to the \code{upset} function from the \code{UpSetR} 
package.
}
\details{
Presence is defined by a feature being measured in at least one 
sample of a set.

Absence is defined by a feature with only missing values (i.e. 
no measured values) of a set.
}
\examples{
## create se
a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
            dimnames = list(seq_len(10), paste("sample", seq_len(10))))
a[c(1, 5, 8), seq_len(5)] <- NA
set.seed(1)
a <- a + rnorm(100)
cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
rD <- data.frame(spectra = rownames(a))
se <- SummarizedExperiment::SummarizedExperiment(assay = a, 
    rowData = rD, colData = cD)

upsetCategory(se, category = "type")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_measuredvalues_missingvalues.R
\name{barplotSamplesMeasuredMissing}
\alias{barplotSamplesMeasuredMissing}
\title{Barplot of number of measured/missing features of samples}
\usage{
barplotSamplesMeasuredMissing(tbl, measured = TRUE)
}
\arguments{
\item{tbl}{\code{tbl} object}

\item{measured}{\code{logical}, should the number of measured or missing 
values be plotted}
}
\value{
\code{gg} object from \code{ggplot2}
}
\description{
\code{barplotSamplesMeasuredMissing} plots the number of 
measured/missing features of samples as a barplot. The function will 
take as input the returned \code{tbl} of \code{samplesMeasuredMissing}.
}
\examples{
## create se
a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
            dimnames = list(seq_len(10), paste("sample", seq_len(10))))
a[c(1, 5, 8), seq_len(5)] <- NA
set.seed(1)
a <- a + rnorm(100)
cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
rD <- data.frame(spectra = rownames(a))
se <- SummarizedExperiment::SummarizedExperiment(assay = a, 
    rowData = rD, colData = cD)

## create the data.frame with information on number of measured/missing
## values
tbl <- samplesMeasuredMissing(se) 

## plot number of measured values
barplotSamplesMeasuredMissing(tbl, measured = TRUE)

## plot number of missing values
barplotSamplesMeasuredMissing(tbl, measured = FALSE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_values.R
\name{createDfFeature}
\alias{createDfFeature}
\title{Create data frame of (count/intensity) values for a selected feature
along data processing steps}
\usage{
createDfFeature(l, feature)
}
\arguments{
\item{l}{\code{list} containing matrices at different processing steps}

\item{feature}{\code{character}, element of \code{rownames} of the matrices 
in \code{l}}
}
\value{
\code{data.frame}
}
\description{
The function \code{createDfFeature} takes as input a list of matrices and 
returns the row \code{Feature} of each matrix as a column of a 
\code{data.frame}. The function \code{createDfFeature} provides the input 
for the function \code{featurePlot}.
}
\details{
Internal usage in \code{shinyQC}
}
\examples{
set.seed(1)
x1 <- matrix(rnorm(100), ncol = 10, nrow = 10, 
    dimnames = list(paste("feature", seq_len(10)), 
        paste("sample", seq_len(10))))
x2 <- x1 + 5
x3 <- x2 + 10

l <- list(x1 = x1, x2 = x2, x3 = x3)
createDfFeature(l, "feature 1")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_values.R
\name{cvFeaturePlot}
\alias{cvFeaturePlot}
\title{Plot of feature-wise coefficient of variation values}
\usage{
cvFeaturePlot(l, lines = FALSE)
}
\arguments{
\item{l}{\code{list} containing matrices}

\item{lines}{\code{logical}}
}
\value{
\code{plotly}
}
\description{
The function \code{cvFeaturePlot} returns a \code{plotly} plot of coefficient 
of variation values. It will create a violin plot and superseded points
of coefficient of variation values per list entry of \code{l}.
}
\details{
\code{lines = TRUE} will connect the points belonging to the same feature 
with a line. If there are less than two features, the violin plot will not be
plotted. The violin plots will be ordered according to the order in \code{l}
}
\examples{
x1 <- matrix(seq_len(100), ncol = 10, nrow = 10, 
    dimnames = list(paste("feature", seq_len(10)), 
        paste("sample", seq_len(10))))
x2 <- x1 + 5
x3 <- x2 + 10
l <- list(x1 = x1, x2 = x2, x3 = x3)
cvFeaturePlot(l, lines = FALSE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_measuredvalues_missingvalues.R
\name{measuredCategory}
\alias{measuredCategory}
\title{Obtain the number of measured intensities per sample type}
\usage{
measuredCategory(se, measured = TRUE, category = "type")
}
\arguments{
\item{se}{\code{SummarizedExperiment}}

\item{measured}{\code{logical}, should the measured values 
(\code{measured = TRUE}) or missing values (\code{measured = FALSE}) 
be taken}

\item{category}{\code{character}, corresponds to a column name in 
\code{colData(se)}}
}
\value{
\code{matrix} with number of measured/missing features per 
\code{category} type
}
\description{
The function \code{measuredCategory} creates a \code{tbl} with
the number of measured values per feature. 0 means that there were only 
missing values (\code{NA}) for the feature and sample type. 
\code{measuredCategory} will return a \code{tbl} where columns are the 
unique sample types and rows are the features as in \code{assay(se)}.
}
\details{
\code{measuredCategory} is a helper function.
}
\examples{
## create se
set.seed(1)
a <- matrix(rnorm(100), nrow = 10, ncol = 10,
            dimnames = list(seq_len(10), paste("sample", seq_len(10))))
a[c(1, 5, 8), seq_len(5)] <- NA
cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
rD <- data.frame(spectra = rownames(a))
se <- SummarizedExperiment::SummarizedExperiment(assay = a,
    rowData = rD, colData = cD)

measuredCategory(se, measured = TRUE, category = "type")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_values.R
\name{batchCorrectionAssay}
\alias{batchCorrectionAssay}
\title{Remove batch effects from (count/intensity) values of a 
\code{SummarizedExperiment}}
\usage{
batchCorrectionAssay(
  se,
  method = c("none", "removeBatchEffect (limma)", "ComBat"),
  batch = NULL,
  batch2 = NULL,
  ...
)
}
\arguments{
\item{se}{\code{SummarizedExperiment}}

\item{method}{\code{character}, one of \code{"none"} or 
\code{"removeBatchEffect"}}

\item{batch}{\code{character}, \code{NULL} or one of 
\code{colnames(colData(se))}}

\item{batch2}{\code{character}, \code{NULL} or one of
\code{colnames(colData(se))}}

\item{...}{further arguments passed to \code{removeBatchEffect} or 
\code{ComBat}}
}
\value{
\code{matrix}
}
\description{
The function \code{batchCorrectionAssay} removes the batch effect of 
(count/intensity) values of a \code{SummarizedExperiment}. 
It uses either the \code{removeBatchEffect} or \code{ComBat} functions 
or no batch effect correction method (pass-through, 
\code{none}).
}
\details{
The column \code{batch} in \code{colData(se)} contains the information 
on the batch identity. For \code{method = "removeBatchEffect (limma)"},
\code{batch2} may indicate a second series of batches. 
Internal use in \code{shinyQC}.

If \code{batch} is NULL and \code{method} is set to 
\code{method = "removeBatchEffect (limma)"} or \code{method = "ComBat"},
no batch correction will be performed (equivalent to 
\code{method = "none"}).

The method \code{ComBat} will only perform batch correction on valid 
features: (1) more or equal than two observations (no \code{NA}) per level 
and per feature, (2) variance greater than 0 per feature, and (3) more than
two valid features as given by (1) and (2). For non-valid features, values
are taken from \code{assay(se)}.
}
\examples{
## create se
a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
    dimnames = list(seq_len(10), paste("sample", seq_len(10))))
a[c(1, 5, 8), seq_len(5)] <- NA
set.seed(1)
a <- a + rnorm(100)
cD <- data.frame(name = colnames(a), 
    type = c(rep("1", 5), rep("2", 5)), batch = rep(c(1, 2), 5))
rD <- data.frame(spectra = rownames(a))
se <- SummarizedExperiment::SummarizedExperiment(assay = a, 
    rowData = rD, colData = cD)

## method = "removeBatchEffect (limma)"
batchCorrectionAssay(se, method = "removeBatchEffect (limma)", 
    batch = "batch", batch2 = NULL)

## method = "ComBat"
batchCorrectionAssay(se, method = "ComBat", 
    batch = "batch", batch2 = NULL)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_dimensionreduction.R
\name{plotPCAVar}
\alias{plotPCAVar}
\title{Plot of explained variance against the principal components}
\usage{
plotPCAVar(var_x, var_perm = NULL)
}
\arguments{
\item{var_x}{\code{numeric} (named \code{numeric} vector)}

\item{var_perm}{\code{matrix} with the explained variance obtained by 
permutation (function \code{permuteExplVar})}
}
\value{
\code{gg} object from \code{ggplot}
}
\description{
The function \code{plotPCAVar} plots the explained variance (in %) on the 
y-axis against the principal components for the measured and permuted values.
}
\details{
The argument \code{var_perm} is optional and visualization of permuted values 
can be omitted by setting \code{var_perm = NULL}.
}
\examples{
x <- matrix(seq_len(100), ncol = 10)
pca <- dimensionReduction(x = x, params = list(center = TRUE, scale = TRUE),
    type = "PCA")[[2]]
var_x <- explVar(d = pca, type = "PCA")
var_perm <- permuteExplVar(x = x, n = 100, center = TRUE, scale = TRUE)
plotPCAVar(var_x = var_x, var_perm = var_perm)

}
\author{
Thomas Naake
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_dimensionreduction.R
\name{dimensionReductionPlot}
\alias{dimensionReductionPlot}
\title{Plot the coordinates from \code{dimensionReduction} values}
\usage{
dimensionReductionPlot(
  tbl,
  se,
  color = c("none", colnames(se@colData)),
  size = c("none", colnames(se@colData)),
  explainedVar = NULL,
  x_coord,
  y_coord,
  height = 600,
  interactive = TRUE
)
}
\arguments{
\item{tbl}{\code{tbl} as obtained by the function \code{dimensionReduction}}

\item{se}{\code{SummarizedExperiment}}

\item{color}{\code{character}, one of \code{"none"} or 
\code{colnames(se@colData)}}

\item{size}{\code{character}, one of \code{"none"} or 
\code{colnames(se@colData)}}

\item{explainedVar}{NULL or named \code{numeric}, if \code{numeric} 
\code{explainedVar} contains the explained variance per principal component 
(names of \code{explainedVar} corresponds to the principal components)}

\item{x_coord}{\code{character}, column name of \code{tbl} that stores 
x coordinates}

\item{y_coord}{\code{character}, column name of \code{tbl} that stores 
y coordinates}

\item{height}{\code{numeric}, specifying the height of the plot (in pixels)}

\item{interactive}{\code{logical(1)}, if \code{TRUE} 
\code{dimensionReductionPlot} will return a \code{plotly} object, 
if \code{FALSE} \code{dimensionReductionPlot} will return a \code{gg} object}
}
\value{
\code{plotly} or \code{gg}
}
\description{
The function \code{dimensionReductionPlot} creates a dimension reduction plot. 
The function takes as input the \code{tbl} object obtained 
from the \code{dimensionReduction} function. The \code{tbl} contains 
transformed values by one of the dimension reduction methods.
}
\details{
The function \code{dimensionReductionPlot} is a wrapper for a
\code{ggplot/ggplotly} expression.
}
\examples{
library(SummarizedExperiment)

## create se
a <- matrix(seq_len(100), nrow = 10, ncol = 10, byrow = TRUE,
            dimnames = list(seq_len(10), paste("sample", seq_len(10))))
set.seed(1)
a <- a + rnorm(100)
cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)),
  median_vals = apply(a, 2, median))
rD <- data.frame(spectra = rownames(a))
se <- SummarizedExperiment(assay = a, rowData = rD, colData = cD)

pca <- dimensionReduction(x = assay(se), type = "PCA", params = list())[[1]]

dimensionReductionPlot(tbl = pca, se = se, color = "type", size = "median_vals",
    x_coord = "PC1", y_coord = "PC2")

}
\author{
Thomas Naake
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_values.R
\name{hoeffDValues}
\alias{hoeffDValues}
\title{Create values of Hoeffding's D statistics from M and A values}
\usage{
hoeffDValues(tbl, name = "raw", sample_n = NULL)
}
\arguments{
\item{tbl}{\code{tibble}, as obtained from the function \code{MAvalues}}

\item{name}{\code{character(1)}, name of the returned list}

\item{sample_n}{\code{numeric(1)}, number of features (subset) to be 
taken for calculation of Hoeffding's D values}
}
\value{
named list with Hoeffding's D values per sample
}
\description{
The function creates and returns Hoeffding's D statistics values 
from MA values. 

In case \code{sample_n} is set to a numerical value (e.g. 10000), a 
random subset containing \code{sample_n} is taken to calculate Hoeffding's D 
values to speed up the calculation. In case there are less features
than \code{sample_n}, all features are taken.
}
\details{
The function uses the function \code{hoeffd} from the \code{Hmisc} package to 
calculate the values.
}
\examples{
## create se
a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
            dimnames = list(seq_len(10), paste("sample", seq_len(10))))
a[c(1, 5, 8), seq_len(5)] <- NA
set.seed(1)
a <- a + rnorm(100)
cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
rD <- data.frame(spectra = rownames(a))
se <- SummarizedExperiment::SummarizedExperiment(assay = a, 
    rowData = rD, colData = cD)

tbl <- MAvalues(se)
hoeffDValues(tbl, "raw")

## normalized values
se_n <- se
assay(se_n) <- normalizeAssay(a, "sum")
tbl_n <- MAvalues(se_n, group = "all")
hoeffDValues(tbl_n, "normalized")

## transformed values
se_t <- se
assay(se_t) <- transformAssay(a, "log")
tbl_t <- MAvalues(se_t, group = "all")
hoeffDValues(tbl_t, "transformed")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_dimensionreduction.R
\name{plotPCAVarPvalue}
\alias{plotPCAVarPvalue}
\title{Plot p-values for the significance of principal components}
\usage{
plotPCAVarPvalue(var_x, var_perm)
}
\arguments{
\item{var_x}{\code{numeric}, measured variances}

\item{var_perm}{\code{matrix}, variances obtained by permutation}
}
\value{
\code{gg} object from \code{ggplot}
}
\description{
The function \code{plotPCAVarPvalue} plots the p-values of significances of 
principal components. Using the visual output, the optimal number of 
principal components can be selected.
}
\details{
Internal usage in \code{shinyQC}.
}
\examples{
x <- matrix(seq_len(100), ncol = 10)
pca <- dimensionReduction(x = x, params = list(center = TRUE, scale = TRUE), 
    type = "PCA")[[2]]
var_x <- explVar(d = pca, type = "PCA")
var_perm <- permuteExplVar(x = x, n = 100, center = TRUE, scale = TRUE)
plotPCAVarPvalue(var_x = var_x, var_perm = var_perm)

}
\author{
Thomas Naake
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_values.R
\name{hoeffDPlot}
\alias{hoeffDPlot}
\title{Create a plot from a list of Hoeffding's D values}
\usage{
hoeffDPlot(df, lines = TRUE)
}
\arguments{
\item{df}{\code{data.frame} containing one or multiple columns containing the 
Hoeffding's D statistics}

\item{lines}{\code{logical}, should points belonging to the same sample be 
connected}
}
\value{
\code{gg} object from \code{ggplot2}
}
\description{
The function \code{hoeffDPlot} creates via \code{ggplot} a violin plot per 
factor, a jitter plot of the data points and (optionally) connects the points
via lines. \code{hoeffDPlot} uses the \code{plotly} package to make the 
figure interactive.
}
\details{
The function \code{hoeffDPlot} will create the violin plot and jitter plot 
according to the specified order given by the colnames of \code{df}. 
\code{hoeffDPlot} will thus internally refactor the \code{colnames} of the 
supplied \code{data.frame} according to the order of the \code{colnames}.
}
\examples{
## create se
set.seed(1)
a <- matrix(rnorm(10000), nrow = 1000, ncol = 10, 
            dimnames = list(seq_len(1000), paste("sample", seq_len(10))))
a[c(1, 5, 8), seq_len(5)] <- NA
cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
rD <- data.frame(spectra = rownames(a))
se <- SummarizedExperiment::SummarizedExperiment(assay = a, 
    rowData = rD, colData = cD)

tbl <- MAvalues(se, log = FALSE, group = "all")
hd_r <- hoeffDValues(tbl, "raw")

## normalized values
se_n <- se
assay(se_n) <- normalizeAssay(a, "sum")
tbl_n <- MAvalues(se_n, log = FALSE, group = "all")
hd_n <- hoeffDValues(tbl_n, "normalized")

df <- data.frame(raw = hd_r, normalized = hd_n)
hoeffDPlot(df, lines = TRUE)
hoeffDPlot(df, lines = FALSE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_values.R
\name{MAplot}
\alias{MAplot}
\title{Create a MA plot}
\usage{
MAplot(
  tbl,
  group = c("all", colnames(tbl)),
  plot = c("all", unique(tbl[["name"]]))
)
}
\arguments{
\item{tbl}{\code{tibble} containing the M and A values, as obtained from the 
\code{MAvalues} function}

\item{group}{\code{character}, one of \code{colnames(colData(se))} 
(\code{se} used in \code{MAvalues}) or \code{"all"}}

\item{plot}{\code{character}, one of \code{colData(se)$name} (\code{se} 
used in \code{MAvalues}) or \code{"all"}}
}
\value{
\code{gg} object from \code{ggplot2}
}
\description{
The function creates a 2D histogram of M and A values.
}
\details{
\code{MAplot} returns a 2D hex histogram instead of a classical scatterplot 
due to computational reasons and better visualization of overlaying points.
The argument \code{plot} specifies the sample (refering to 
\code{colData(se)$name}) to be plotted. If \code{plot = "all"}, MA values 
for all samples will be plotted (samples will be plotted in facets). 
If the number of features (\code{tbl$Features}) is below 1000, points will be 
plotted (via \code{geom_points}), otherwise hexagons will be plotted
(via \code{geom_hex}).
}
\examples{
## create se
set.seed(1)
a <- matrix(rnorm(10000), nrow = 1000, ncol = 10,
            dimnames = list(seq_len(1000), paste("sample", seq_len(10))))
a[c(1, 5, 8), seq_len(5)] <- NA
cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
rD <- data.frame(spectra = rownames(a))
se <- SummarizedExperiment::SummarizedExperiment(assay = a,
    rowData = rD, colData = cD)

tbl <- MAvalues(se, log = FALSE, group = "all")
MAplot(tbl, group = "all", plot = "all")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_measuredvalues_missingvalues.R
\name{extractComb}
\alias{extractComb}
\title{Obtain the features that are present in a specified set}
\usage{
extractComb(se, combination, measured = TRUE, category = "type")
}
\arguments{
\item{se}{\code{SummarizedExperiment}}

\item{combination}{\code{character}, refers to factors in \code{category}}

\item{measured}{\code{logical}}

\item{category}{\code{character}, corresponding to a column name in 
\code{colData(se)}}
}
\value{
\code{character}
}
\description{
The function \code{extractComb} extracts the features that match a
\code{combination} depending if the features was measured or missing. 
The function will return the sets that match the \code{combination}, 
thus, the function might be useful when answering questions about which 
features are measured/missing under certain combinations (e.g. sample 
types or experimental conditions).
}
\details{
The function \code{extractComb} uses the \code{make_comb_mat} function from 
\code{ComplexHeatmap} package.

Presence is defined by a feature being measured in at least one sample of a 
set.

Absence is defined by a feature with only missing values (i.e. no measured 
values) of a set.
}
\examples{

## create se
a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
            dimnames = list(seq_len(10), paste("sample", seq_len(10))))
a[c(1, 5, 8), seq_len(5)] <- NA
set.seed(1)
a <- a + rnorm(100)
cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
rD <- data.frame(spectra = rownames(a))
se <- SummarizedExperiment::SummarizedExperiment(assay = a, rowData = rD, colData = cD)

extractComb(se, combination = "2", measured = TRUE, category = "type") 

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_dimensionreduction.R
\name{dimensionReduction}
\alias{dimensionReduction}
\title{Dimensionality reduction with dimensionReduction methods PCA,
PCoA, NMDS, UMAP and tSNE}
\usage{
dimensionReduction(
  x,
  type = c("PCA", "PCoA", "NMDS", "tSNE", "UMAP"),
  params = list()
)
}
\arguments{
\item{x}{\code{matrix}, containing no missing values, samples are in columns 
and features are in rows}

\item{type}{\code{character}, specifying the type/method to use for 
dimensionality reduction. One of \code{PCA}, \code{PCoA}, \code{NMDS}, 
\code{tSNE}, or \code{UMAP}.}

\item{params}{\code{list}, arguments/parameters given to the functions 
\code{stats::prcomp}, \code{stats::dist}, \code{Rtsne::Rtsne}, 
\code{umap::umap}}
}
\value{
list, first entry contains a \code{tbl}, second entry contains
the object returned from \code{prcomp} (PCA), \code{cmdscale} (PCoA),
\code{isoMDS} (NMDS), \code{Rtsne} (tSNE), or \code{umap} (UMAP)
}
\description{
The function \code{dimensionReduction} creates a \code{data.frame} 
with the coordinates of the projected data (first entry of returned output). 
The function allows for the 
following projections:
Principal Component Analysis (PCA), Principal Coordinates 
Analysis/Multidimensional Scaling (PCoA), Non-metric Multidimensional 
scaling (NMDS), t-distributed stochastic neighbor embedding (tSNE), and 
Uniform Manifold Approximation and Projection (UMAP).

The second list entry will contains the object returned from 
\code{prcomp} (PCA), \code{cmdscale} (PCoA), \code{isoMDS} (NMDS), 
\code{Rtsne} (tSNE), or \code{umap} (UMAP).
}
\details{
The function \code{dimensionReduction} is a wrapper around the following 
functions \code{stats::prcomp} (PCA), \code{stats::cmdscale} (PCoA), 
\code{MASS::isoMDS} (NMDS), \code{Rtsne::Rtsne} (tSNE), and 
\code{umap::umap} (UMAP). For the function \code{umap::umap} 
the method is set to \code{naive}.
}
\examples{
x <- matrix(rnorm(seq_len(10000)), ncol = 100)
rownames(x) <- paste("feature", seq_len(nrow(x)))
colnames(x) <- paste("sample", seq_len(ncol(x)))
params <- list(method = "euclidean", ## dist
    initial_dims = 10, max_iter = 100, dims = 3, perplexity = 3, ## tSNE
    min_dist = 0.1, n_neighbors = 15, spread = 1) ## UMAP
dimensionReduction(x, type = "PCA", params = params)
dimensionReduction(x, type = "PCoA", params = params)
dimensionReduction(x, type = "NMDS", params = params)
dimensionReduction(x, type = "tSNE", params = params)
dimensionReduction(x, type = "UMAP", params = params)

}
\author{
Thomas Naake
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_values.R
\name{driftPlot}
\alias{driftPlot}
\title{Plot the trend line for aggregated values}
\usage{
driftPlot(
  se,
  aggregation = c("median", "sum"),
  category = colnames(colData(se)),
  orderCategory = colnames(colData(se)),
  level = c("all", unique(colData(se)[, category])),
  method = c("loess", "lm")
)
}
\arguments{
\item{se}{\code{SummarizedExperiment}}

\item{aggregation}{\code{character}, type of aggregation of (count/intensity) 
values}

\item{category}{\code{character}, column of \code{colData(se)}}

\item{orderCategory}{\code{character}, column of \code{colData(se)}}

\item{level}{\code{character}, from which samples should the LOESS curve be
calculated, either \code{"all"} or one of the levels of the selected columns
of \code{colData(se)} (\code{"category"})}

\item{method}{\code{character}, either \code{"loess"} or \code{"lm"}}
}
\value{
\code{gg} object from \code{ggplot2}
}
\description{
The function \code{driftPlot} aggregates the (count/intensity) values from 
the \code{assay()} slot of a \code{SummarizedExperiment} by the \code{median} 
or \code{sum} of the (count/intensity) values. \code{driftPlot} then 
visualizes these aggregated values and adds a trend line (using either 
LOESS or a linear model) from (a subset of) the aggregated values. The 
subset is specified by the arguments \code{category} and \code{level}.
}
\details{
The x-values are sorted according to the \code{orderCategory} argument: The 
levels of the corresponding column in \code{colData(se)} are pasted with the 
sample names (in the column \code{name}) and factorized.
Internal usage in \code{shinyQC}.
}
\examples{
#' ## create se
set.seed(1)
a <- matrix(rnorm(1000), nrow = 10, ncol = 100, 
    dimnames = list(seq_len(10), paste("sample", seq_len(100))))
a[c(1, 5, 8), seq_len(5)] <- NA
cD <- data.frame(name = colnames(a), type = c(rep("1", 50), rep("2", 50)))
rD <- data.frame(spectra = rownames(a))
se <- SummarizedExperiment::SummarizedExperiment(assay = a, 
    rowData = rD, colData = cD)

driftPlot(se, aggregation = "sum", category = "type", 
    orderCategory = "type", level = "1", method = "loess")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_values.R
\name{MAvalues}
\alias{MAvalues}
\title{Create values (M and A) for MA plot}
\usage{
MAvalues(se, log2 = TRUE, group = c("all", colnames(colData(se))))
}
\arguments{
\item{se}{\code{SummarizedExperiment}}

\item{log2}{\code{logical}, specifies if values are 
\code{log2}-transformed prior to calculating M and A values. 
If the values are already transformed, \code{log2} should be set to 
\code{FALSE}. If \code{log2 = TRUE} and if there are values in 
\code{assay(se)} that are 0, the \code{log2} values are calculated by
\code{log2(assay(se) + 1)}}

\item{group}{\code{character}, either \code{"all"} or one of 
\code{colnames(colData(se))}}
}
\value{
\code{tbl} with columns \code{Feature}, \code{name} (sample name), 
\code{A}, \code{M} and additional columns of \code{colData(se)}
}
\description{
The function \code{MAvalues} will create MA values as input for the function 
\code{MAplot} and \code{hoeffDValues}. 
\code{M} and \code{A} are specified relative to specified samples which 
is determined by the \code{group} argument. In case of \code{group == "all"}, 
all samples (expect the specified one) are taken for the reference 
calculation. In case of \code{group != "all"} will use the samples belonging 
to the same group given in \code{colnames(colData(se))} expect the 
specified one.
}
\examples{
## create se
set.seed(1)
a <- matrix(rnorm(10000), nrow = 1000, ncol = 10, 
            dimnames = list(seq_len(1000), paste("sample", seq_len(10))))
a[c(1, 5, 8), seq_len(5)] <- NA
cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
rD <- data.frame(spectra = rownames(a))
se <- SummarizedExperiment(assay = a, rowData = rD, colData = cD)

MAvalues(se, log = FALSE, group = "all")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_dimensionreduction.R
\name{permuteExplVar}
\alias{permuteExplVar}
\title{Permute the expression values and retrieve the explained variance}
\usage{
permuteExplVar(x, n = 10, center = TRUE, scale = TRUE, sample_n = NULL)
}
\arguments{
\item{x}{\code{matrix} or \code{data.frame}, samples in columns and features 
in rows}

\item{n}{\code{numeric}, number of permutation rounds}

\item{center}{\code{logical}, passed to the function \code{explVar}}

\item{scale}{\code{logical}, passed to the function \code{explVar}}

\item{sample_n}{\code{numeric(1)}, number of features (subset) to be 
taken for calculation of permuted explained variance, the top 
\code{sample_n} varying values based on their standard deviation will be 
taken}
}
\value{
matrix with explained variance
}
\description{
The function \code{permuteExplVar} determines the explained variance of the 
permuted expression matrix (\code{x}). It is used to determine the optimal 
number of PCs for tSNE.
}
\details{
For the input of tSNE, typically, we want to reduce the initial number of 
dimensions linearly with PCA (used as the \code{initial_dims} arguments in 
the \code{Rtsne} funtion). The reduced data set is used for feeding 
into tSNE. By plotting the percentage of variance explained by the Princical
Components (PCs) we can estimate how many PCs we keep as input into tSNE.
However, if we select too many PCs, noise will be included as input to tSNE;
if we select too few PCs we might loose the important data structures. 
To get a better understanding how many PCs to include, randomization will
be employed and the observed variance will be compared to the permuted 
variance.
}
\examples{
 
x <- matrix(seq_len(100), nrow = 10, ncol = 10,
    dimnames = list(seq_len(10), paste("sample", seq_len(10))))
permuteExplVar(x = x, n = 10, center = TRUE, scale = TRUE, sample_n = NULL)

}
\author{
Thomas Naake
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_samplesfeatures.R
\name{hist_sample}
\alias{hist_sample}
\title{Plot a histogram of the number of a category}
\usage{
hist_sample(tbl, category = "type")
}
\arguments{
\item{tbl}{\code{tbl} as returned by \code{hist_sample_num}}

\item{category}{\code{character}, x-axis label of the plot}
}
\value{
\code{gg} object from \code{ggplot2}
}
\description{
\code{hist_sample} plots the number of a category (e.g. sample types)
as a histogram. It use the returned \code{tbl} from \code{hist_sample_num}.
}
\examples{
## create se
a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
            dimnames = list(seq_len(10), paste("sample", seq_len(10))))
a[c(1, 5, 8), seq_len(5)] <- NA
set.seed(1)
a <- a + rnorm(100)
cD <- data.frame(name = colnames(a), type = c(rep("1", 4), rep("2", 6)))
rD <- data.frame(spectra = rownames(a))
se <- SummarizedExperiment::SummarizedExperiment(assay = a, 
    rowData = rD, colData = cD)

tbl <- hist_sample_num(se, category = "type")
hist_sample(tbl)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_values.R
\name{ECDF}
\alias{ECDF}
\title{Create ECDF plot of a sample against a reference}
\usage{
ECDF(se, sample = colnames(se), group = c("all", colnames(colData(se))))
}
\arguments{
\item{se}{\code{SummarizedExperiment} object}

\item{sample}{\code{character}, name of the sample to compare against the 
group}

\item{group}{\code{character}, either \code{"all"} or one of 
\code{colnames(colData(se))}}
}
\value{
\code{gg} object from \code{ggplot2}
}
\description{
The function \code{ECDF} creates a plot of the empirical cumulative 
distribution function of a specified sample and an outgroup (reference). 
The reference is specified by the \code{group} argument. The row-wise 
(feature) mean values of the reference are calculated after excluding 
the specified \code{sample}.
}
\details{
Internal use in \code{shinyQC}. 

The function \code{ECDF} uses the \code{ks.test} function from \code{stats} 
to perform a two-sample Kolmogorov-Smirnov test. The Kolmogorov-Smirnov 
test is run with the alternative \code{"two.sided"}
(null hypothesis is that the true distribution function of the 
\code{sample} is equal to the hypothesized distribution function of the 
\code{group}).

The \code{exact} argument in \code{ks.test} is set to \code{NULL}, meaning 
that an exact p-value is computed if the product of the sample sizes is 
less than 10000 of \code{sample} and \code{group}. Otherwise, asymptotic 
distributions are used whose approximations might be inaccurate in low 
sample sizes.
}
\examples{
## create se
set.seed(1)
a <- matrix(rnorm(1000), nrow = 100, ncol = 10, 
    dimnames = list(seq_len(100), paste("sample", seq_len(10))))
a[c(1, 5, 8), seq_len(5)] <- NA
cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
rD <- data.frame(spectra = rownames(a))
se <- SummarizedExperiment(assay = a, rowData = rD, colData = cD)

ECDF(se, sample = "sample 1", group = "all")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_values.R
\name{sumDistSample}
\alias{sumDistSample}
\title{Plot the sum of distances to other samples}
\usage{
sumDistSample(d, title = "raw")
}
\arguments{
\item{d}{\code{matrix} containing distances, obtained from \code{distShiny}}

\item{title}{\code{character} specifying the title to be added to the plot}
}
\value{
\code{gg} object from \code{ggplot2}
}
\description{
The function \code{sumDistSample} creates a plot showing the sum of distance 
of a sample to other samples.
}
\examples{
a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
            dimnames = list(seq_len(10), paste("sample", seq_len(10))))
dist <- distShiny(a)

sumDistSample(dist, title = "raw")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_samplesfeatures.R
\name{mosaic}
\alias{mosaic}
\title{Mosaic plot for two factors in colData(se)}
\usage{
mosaic(se, f1, f2)
}
\arguments{
\item{se}{\code{SummarizedExperiment} object}

\item{f1}{\code{character}, \code{f1} is one of the column names in \code{colData(se)}}

\item{f2}{\code{character}, \code{f2} is one of the column names in \code{colData(se)}}
}
\value{
\code{gg} object from \code{ggplot2}
}
\description{
The function \code{mosaic} creates a mosaic plot of two factors from
an \code{SummarizedExperiment} object. The columns \code{f1} and \code{f2} 
are taken from \code{colData(se)}.
}
\details{
Code partly taken from
https://stackoverflow.com/questions/21588096/pass-string-to-facet-grid-ggplot2
}
\examples{
## create se
set.seed(1)
a <- matrix(rnorm(100), nrow = 10, ncol = 10,
            dimnames = list(seq_len(10), paste("sample", seq_len(10))))
a[c(1, 5, 8), seq_len(5)] <- NA
cD <- data.frame(name = colnames(a), 
    type = c(rep("1", 5), rep("2", 5)),
    cell_type = c("A", "B"))
rD <- data.frame(spectra = rownames(a))
se <- SummarizedExperiment::SummarizedExperiment(assay = a, 
    rowData = rD, colData = cD)

mosaic(se, "cell_type", "type")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_values.R
\name{distShiny}
\alias{distShiny}
\title{Create distance matrix from numerical matrix}
\usage{
distShiny(x, method = "euclidean")
}
\arguments{
\item{x}{\code{matrix} or \code{data.frame} with samples in columns and 
features in rows}

\item{method}{\code{character}, method for distance calculation}
}
\value{
\code{matrix}
}
\description{
The function \code{distShiny} takes as an input a numerical \code{matrix} or
\code{data.frame} and returns the distances between the rows and columns
based on the defined \code{method} (e.g. euclidean distance).
}
\details{
Internal use in \code{shinyQC}.
}
\examples{
x <- matrix(seq_len(100), nrow = 10, ncol = 10, 
        dimnames = list(seq_len(10), paste("sample", seq_len(10))))
distShiny(x = x)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_measuredvalues_missingvalues.R
\name{histFeature}
\alias{histFeature}
\title{Histogram for measured value per feature}
\usage{
histFeature(x, measured = TRUE, ...)
}
\arguments{
\item{x}{\code{matrix} containing intensities. Missing values are encoded 
as \code{NA}.}

\item{measured}{\code{logical}, should the measured values 
(\code{measured = TRUE}) or missing values (\code{measured = FALSE}) be taken}

\item{...}{additional parameters passed to \code{geom_histogram}, e.g. 
\code{binwidth}.}
}
\value{
\code{plotly} object from \code{ggplotly}
}
\description{
The function \code{histFeature} creates a histogram with the number
of measured/missing values per feature.
}
\examples{
x <- matrix(c(c(1, 1, 1), c(1, NA, 1), c(1, NA, 1), 
    c(1, 1, 1), c(NA, 1, 1), c(NA, 1, 1)), byrow = FALSE, nrow = 3)
colnames(x) <- c("A_1", "A_2", "A_3", "B_1", "B_2", "B_3")
histFeature(x, binwidth = 1)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_values.R
\name{imputeAssay}
\alias{imputeAssay}
\title{Impute missing values in a \code{matrix}}
\usage{
imputeAssay(
  a,
  method = c("BPCA", "kNN", "MLE", "Min", "MinDet", "MinProb", "none")
)
}
\arguments{
\item{a}{\code{matrix} with samples in columns and features in rows}

\item{method}{\code{character}, one of \code{"BPCA"}, \code{"kNN"}, 
\code{"MLE"}, \code{"Min"}, 
\code{"MinDet"}, \code{"MinProb"}, or \code{"none"}}
}
\value{
\code{matrix}
}
\description{
The function \code{impute} imputes missing values based on one of the 
following principles: Bayesian missing value imputation (\code{BPCA}), 
k-nearest neighbor averaging (\code{kNN}), Malimum likelihood-based 
imputation method using the EM algorithm (\code{MLE}), replacement by 
the smallest non-missing value
in the data (\code{Min}), replacement by the minimal value observed as
the q-th quantile (\code{MinDet}, default \code{q = 0.01}), and replacement
by random draws from a Gaussian distribution centred to a minimal value 
(\code{MinProb}).
}
\details{
\code{BPCA} wrapper for \code{pcaMethods::pca} with \code{methods = "bpca"}. 
\code{BPCA} is a missing at random (MAR) imputation method. 

\code{kNN} wrapper for \code{impute::impute.knn} with \code{k = 10}, 
\code{rowmax = 0.5}, \code{colmax = 0.5}, \code{maxp = 1500}. \code{kNN} 
is a MAR imputation method.

\code{MLE} wrapper for \code{imputeLCMD::impute.MAR} with 
\code{method = "MLE"}, 
\code{model.selector = 1}/\code{imputeLCMD::impute.wrapper.MLE}. 
\code{MLE} is a MAR imputation method.

\code{Min} imputes the missing values by the observed minimal value of 
\code{x}. \code{Min} is a missing not at random (MNAR) imputation method.

\code{MinDet} is a wrapper for \code{imputeLCMD::impute.MinDet} with 
\code{q = 0.01}. \code{MinDet} performs the imputation using a 
deterministic minimal value approach. The missing entries are
replaced with a minimal value, estimated from the \code{q}-th quantile 
from each sample. \code{MinDet} is a MNAR imputation method.

\code{MinProb} is a wrapper for \code{imputeLCMD::impute.MinProb} with 
\code{q = 0.01} and \code{tune.sigma = 1}. \code{MinProb} performs the 
imputation based on random draws from a Gaussion distribution with the 
mean set to the minimal value of a sample. \code{MinProb} is a 
MNAR imputation method.

\code{MinProb} does not impute values (not available within shiny 
application).
}
\examples{
a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
    dimnames = list(seq_len(10), paste("sample", seq_len(10))))
a[c(1, 5, 8), seq_len(5)] <- NA

imputeAssay(a, method = "kNN")
imputeAssay(a, method = "Min")
imputeAssay(a, method = "MinDet")
imputeAssay(a, method = "MinProb")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_measuredvalues_missingvalues.R
\name{histFeatureCategory}
\alias{histFeatureCategory}
\title{Histogram of features per sample type}
\usage{
histFeatureCategory(se, measured = TRUE, category = "type", ...)
}
\arguments{
\item{se}{\code{SummarizedExperiment}, the assay slot contains the intensity 
values per sample. Missing values are encoded as \code{NA}.}

\item{measured}{\code{logical}, should the measured values 
(\code{measured = TRUE}) or missing values (\code{measured = FALSE}) be taken}

\item{category}{\code{character}, corresponding to a column in 
\code{colData(se)}}

\item{...}{additional parameters passed to \code{geom_histogram}, e.g. 
\code{binwidth}.}
}
\value{
\code{plotly} object from \code{ggplotly}
}
\description{
The function \code{histFeatureCategory} creates histogram
plots for each sample type in \code{se}.
}
\examples{
## create se
a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
            dimnames = list(seq_len(10), paste("sample", seq_len(10))))
a[c(1, 5, 8), seq_len(5)] <- NA
set.seed(1)
a <- a + rnorm(100)
cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
rD <- data.frame(spectra = rownames(a))
se <- SummarizedExperiment::SummarizedExperiment(assay = a, 
    rowData = rD, colData = cD)

histFeatureCategory(se, measured = TRUE, category = "type")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_dimensionreduction.R
\name{explVar}
\alias{explVar}
\title{Retrieve the explained variance for each principal component (PCA) or
axis (PCoA)}
\usage{
explVar(d, type = c("PCA", "PCoA"))
}
\arguments{
\item{d}{\code{prcomp} or \code{list} from \code{cmdscale}}

\item{type}{\code{character}, one of \code{"PCA"} or \code{"PCoA"}}
}
\value{
\code{numeric} vector with the proportion of explained variance 
for each PC or Axis
}
\description{
The function \code{explVar} calculates the proportion of explained variance 
for each principal component (PC, \code{type = "PCA"}) and axis 
(\code{type = "PCoA"}).
}
\details{
\code{explVar} uses the function \code{prcomp} from the \code{stats} package 
to retrieve the explained standard deviation per PC 
(\code{type = "PCA"}) and the function \code{cmdscale} from the \code{stats} 
package to retrieve the explained variation based on eigenvalues per 
Axis (\code{type = "PCoA"}).
}
\examples{
x <- matrix(seq_len(100), nrow = 10, ncol = 10, 
    dimnames = list(seq_len(10), paste("sample", seq_len(10))))
set.seed(1)
x <- x + rnorm(100)

## run for PCA
pca <- dimensionReduction(x = x, 
    params = list(center = TRUE, scale = TRUE), type = "PCA")[[2]]
explVar(d = pca, type = "PCA")

## run for PCoA
pcoa <- dimensionReduction(x = x, 
    params = list(method = "euclidean"), type = "PCoA")[[2]]
explVar(d = pcoa, type = "PCoA")

}
\author{
Thomas Naake
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_values.R
\name{normalizeAssay}
\alias{normalizeAssay}
\title{Normalize a data sets (reduce technical sample effects)}
\usage{
normalizeAssay(
  a,
  method = c("none", "sum", "quantile division", "quantile"),
  probs = 0.75,
  multiplyByNormalizationValue = FALSE
)
}
\arguments{
\item{a}{\code{matrix} with samples in columns and features in rows}

\item{method}{\code{character}, one of \code{"none"}, \code{"sum"}, 
\code{"quantile division"}, \code{"quantile"}}

\item{probs}{\code{numeric}, ranging between \code{[0, 1)}. \code{probs} 
is used as the divisor for quantile division in 
\code{method = "quantile division"}}

\item{multiplyByNormalizationValue}{\code{logical}, if TRUE, normalization 
values will be calculated and the values in \code{a} will be multiplied by 
the values The parameter is only relavant for \code{method = "sum"} and 
\code{method = "quantile division"}}
}
\value{
\code{matrix}
}
\description{
The function \code{normalizeAssay} performs normalization by sum of the 
(count/intensity) values per sample (\code{method = "sum"}), quantile 
division per sample (\code{method = "quantile division"}), 
or by quantile normalization (adjusting the value distributions that they 
become identical in statistical properties, \code{method = "quantile"}). 
The value for quantile division (e.g., the 75% quantile per sample) can be 
specified by the \code{probs} argument. Quantile normalization is 
performed by using the \code{normalizeQuantiles} function from \code{limma}.

For the methods \code{"sum"} and \code{"quantile division"}, normalization
will be done depending on the \code{multiplyByNormalizationValue} parameter.
If set to \code{TRUE}, normalization values (e.g. sum or quantile) will be
calculated per sample. In a next step, adjusted normalization values will 
be calculated for each sample in relation to the median normalization 
values across all samples. Finally, the values in \code{a} are 
multiplied by these adjusted normalization values.
If \code{multiplyByNormalizationValue} is set to \code{FALSE}, 
normalization values (e.g. sum or quantile) will be
calculated per sample. The values in \code{a} are sample-wise divided by
the normalization values.
}
\details{
Internal usage in \code{shinyQC}. If \code{method} is set to \code{"none"}, 
the object \code{x} is returned as is (pass-through).

If \code{probs} is NULL, \code{probs} is internally set to 0.75 if 
\code{method = "quantile division"}.

Depending on the values in \code{a}, if \code{multiplyByNormalizationValue}
is set to \code{TRUE} the returned normalized values will be in the same 
order of magnitude than the original values, while if \code{FALSE}, the 
returned values will be in a smaller order of magnitude.
}
\examples{
a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
        dimnames = list(seq_len(10), paste("sample", seq_len(10))))
normalizeAssay(a, "sum")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_dimensionreduction.R
\name{tblPCALoadings}
\alias{tblPCALoadings}
\title{Return tibble with PCA loadings for features}
\usage{
tblPCALoadings(x, params)
}
\arguments{
\item{x}{\code{matrix}, containing no missing values}

\item{params}{\code{list}, arguments/parameters given to the function 
\code{stats::prcomp}}
}
\value{
\code{tbl}
}
\description{
The function \code{tblPCALoadings} returns a \code{tibble} with loadings 
values for the features (row entries) in \code{x}.
}
\details{
The function \code{tblPCALoadings} acccesses the list entry \code{rotation} 
of the \code{prcomp} object.
}
\examples{
set.seed(1)
x <- matrix(rnorm(seq_len(10000)), ncol = 100)
rownames(x) <- paste("feature", seq_len(nrow(x)))
colnames(x) <- paste("sample", seq_len(ncol(x)))
params <- list(method = "euclidean", ## dist
    initial_dims = 10, max_iter = 100, dims = 3, perplexity = 3, ## tSNE
    min_dist = 0.1, n_neighbors = 15, spread = 1) ## UMAP
tblPCALoadings(x, params)

}
\author{
Thomas Naake
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_values.R
\name{plotCV}
\alias{plotCV}
\title{Plot CV values}
\usage{
plotCV(df)
}
\arguments{
\item{df}{\code{data.frame} containing one or multiple columns containing 
the coefficients of variation}
}
\value{
\code{gg} object from \code{ggplot2}
}
\description{
The function \code{plotCV} displays the coefficient of variation values of 
set of values supplied in a \code{data.frame} object. The function will 
create a plot using the \code{ggplot2} package and will print the values 
in the different columns in different colors.
}
\details{
Internal usage in \code{shinyQC}.
}
\examples{
x1 <- matrix(seq_len(10), ncol = 2)
x2 <- matrix(seq(11, 20), ncol = 2)
x3 <- matrix(seq(21, 30), ncol = 2)
x4 <- matrix(seq(31, 40), ncol = 2)

## calculate cv values
cv1 <- cv(x1, "x1")
cv2 <- cv(x2, "x2")
cv3 <- cv(x3, "x3")
cv4 <- cv(x4, "x4")

df <- data.frame(cv1, cv2, cv3, cv4)
plotCV(df)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_values.R
\name{createBoxplot}
\alias{createBoxplot}
\title{Create a boxplot of (count/intensity) values per sample}
\usage{
createBoxplot(
  se,
  orderCategory = colnames(colData(se)),
  title = "",
  log = TRUE,
  violin = FALSE
)
}
\arguments{
\item{se}{\code{SummarizedExperiment} containing the (count/intensity) values 
in the \code{assay} slot}

\item{orderCategory}{\code{character}, one of \code{colnames(colData(se))}}

\item{title}{\code{character} or \code{numeric} of \code{length(1)}}

\item{log}{\code{logical}, if \code{TRUE} (count/intensity) values are 
displayed as log values}

\item{violin}{\code{logical}, if \code{FALSE} a boxplot is created, if 
\code{TRUE} a violin plot is created}
}
\value{
\code{gg} object from \code{ggplot2}
}
\description{
The function \code{create_boxplot} creates a boxplot per sample for the 
intensity/count values.
}
\details{
Internal usage in \code{shinyQC}.
}
\examples{
## create se
a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
    dimnames = list(seq_len(10), paste("sample", seq_len(10))))
a[c(1, 5, 8), seq_len(5)] <- NA
set.seed(1)
a <- a + rnorm(100)
cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
rD <- data.frame(spectra = rownames(a))
se <- SummarizedExperiment::SummarizedExperiment(assay = a, 
    rowData = rD, colData = cD)

createBoxplot(se, orderCategory = "name", title = "", log = TRUE, 
    violin = FALSE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_values.R
\name{featurePlot}
\alias{featurePlot}
\title{Create a plot of (count/intensity) values over the samples}
\usage{
featurePlot(df)
}
\arguments{
\item{df}{\code{data.frame}}
}
\value{
\code{gg} object from \code{ggplot2}
}
\description{
The function \code{featurePlot} creates a plot of (count/intensity) values 
for different data processing steps (referring to columns in the 
\code{data.frame}) over the different samples (referring to rows in 
the \code{data.frame}).
}
\details{
Internal usage in \code{shinyQC}.
}
\examples{
set.seed(1)
x1 <- matrix(rnorm(100), ncol = 10, nrow = 10, 
    dimnames = list(paste("feature", seq_len(10)), 
        paste("sample", seq_len(10))))
x2 <- x1 + 5
x3 <- x2 + 10
l <- list(x1 = x1, x2 = x2, x3 = x3)
df <- createDfFeature(l, "feature 1")
featurePlot(df)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_values.R
\name{cv}
\alias{cv}
\title{Calculate coefficient of variation}
\usage{
cv(x, name = "raw")
}
\arguments{
\item{x}{\code{matrix}}

\item{name}{\code{character}, the name of the returned list}
}
\value{
\code{list}
}
\description{
The function \code{cv} calculates the coefficient of variation from columns  
of a matrix. The coefficients of variation are calculated according to the 
formula \code{sd(y) / mean(y) * 100} with \code{y} the column values, thus,
the function returns the coefficient of variation in percentage.
}
\details{
The function returned a named \code{list} (the name is specified by the 
\code{name} argument) containing the coefficient of variation of the 
columns of \code{x}.
}
\examples{
x <- matrix(seq_len(10), ncol = 2)
cv(x)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_values.R
\name{distSample}
\alias{distSample}
\title{Create a heatmap using distance information between samples}
\usage{
distSample(d, se, label = "name", title = "raw", ...)
}
\arguments{
\item{d}{\code{matrix} containing distances, obtained from \code{distShiny}}

\item{se}{\code{SummarizedExperiment}}

\item{label}{\code{character}, refers to a column in \code{colData(se)}}

\item{title}{\code{character}}

\item{...}{further arguments passed to \code{ComplexHeatmap::Heatmap}}
}
\value{
\code{Heatmap} object from \code{ComplexHeatmap}
}
\description{
The function \code{distSample} creates a heatmap from a distance matrix 
created by the function \code{distShiny}. The heatmap is annotated by the 
column specified by the \code{label} column in \code{colData(se)}.
}
\details{
Internal use in \code{shinyQC}
}
\examples{
## create se
a <- matrix(seq_len(100), nrow = 10, ncol = 10,
            dimnames = list(seq_len(10), paste("sample", seq_len(10))))
a[c(1, 5, 8), seq_len(5)] <- NA
set.seed(1)
a <- a + rnorm(100)
a_i <- imputeAssay(a, method = "MinDet")
cD <- data.frame(name = colnames(a_i),
    type = c(rep("1", 5), rep("2", 5)))
rD <- data.frame(spectra = rownames(a_i))
se <- SummarizedExperiment::SummarizedExperiment(assay = a_i, rowData = rD,
    colData = cD)

dist <- distShiny(a_i)
distSample(dist, se, label = "type", title = "imputed", 
    show_row_names = TRUE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_dimensionreduction.R
\name{plotPCALoadings}
\alias{plotPCALoadings}
\title{Plot for PCA loadings of features}
\usage{
plotPCALoadings(tbl, x_coord, y_coord)
}
\arguments{
\item{tbl}{\code{tbl} as obtained by the function \code{dimensionReduction}}

\item{x_coord}{\code{character}, column name of \code{tbl} that stores x 
coordinates}

\item{y_coord}{\code{character}, column name of \code{tbl} that stores y 
coordinates}
}
\value{
\code{plotly}
}
\description{
The function \code{plotPCALoadings} creates a loadings plot of the features.
}
\details{
The function takes as input the output of the function 
\code{tblPlotPCALoadings}. It uses the \code{ggplotly} function from 
\code{plotly} to create an interactive \code{plotly} plot.
}
\examples{
x <- matrix(rnorm(seq_len(10000)), ncol = 100)
rownames(x) <- paste("feature", seq_len(nrow(x)))
colnames(x) <- paste("sample", seq_len(ncol(x)))
params <- list(method = "euclidean", ## dist
    initial_dims = 10, max_iter = 100, dims = 3, perplexity = 3, ## tSNE
    min_dist = 0.1, n_neighbors = 15, spread = 1) ## UMAP
tbl <- tblPCALoadings(x, params)
plotPCALoadings(tbl, x_coord = "PC1", y_coord = "PC2")

}
\author{
Thomas Naake
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_samplesfeatures.R
\name{hist_sample_num}
\alias{hist_sample_num}
\title{Return the number of a category}
\usage{
hist_sample_num(se, category = "type")
}
\arguments{
\item{se}{\code{SummarizedExperiment} object}

\item{category}{\code{character}, corresponding to a column in \code{colData(se)}}
}
\value{
\code{tbl}
}
\description{
\code{hist_sample_num} returns the number of a category 
(e.g. sample types) as a \code{tbl}.
The function will retrieve first the column \code{category} in \code{colData(se)}. 
The function will return a \code{tbl} containing the numerical 
values of the quantities.
}
\examples{
## create se
a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
    dimnames = list(seq_len(10), paste("sample", seq_len(10))))
a[c(1, 5, 8), seq_len(5)] <- NA
set.seed(1)
a <- a + rnorm(100)
cD <- data.frame(name = colnames(a), type = c(rep("1", 4), rep("2", 6)))
rD <- data.frame(spectra = rownames(a))
se <- SummarizedExperiment::SummarizedExperiment(assay = a, 
    rowData = rD, colData = cD)

hist_sample_num(se, category = "type")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_measuredvalues_missingvalues.R
\name{samplesMeasuredMissing}
\alias{samplesMeasuredMissing}
\title{Create tibble containing number of measured/missing features 
of samples}
\usage{
samplesMeasuredMissing(se)
}
\arguments{
\item{se}{\code{SummarizedExperiment} object}
}
\value{
\code{tbl} with number of measured/missing features per sample
}
\description{
\code{samplesMeasuredMissing} returns a \code{tbl} with 
the number of measured/missing
features of samples. The function will take as input a 
\code{SummarizedExperiment} object and will access its \code{assay()} slot
}
\examples{
## create se
a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
            dimnames = list(seq_len(10), paste("sample", seq_len(10))))
a[c(1, 5, 8), seq_len(5)] <- NA
set.seed(1)
a <- a + rnorm(100)
sample <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
featData <- data.frame(spectra = rownames(a))
se <- SummarizedExperiment::SummarizedExperiment(assay = a, 
    rowData = featData, colData = sample)

## create the data.frame with information on number of measured/missing
## values
samplesMeasuredMissing(se)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tab_de.R
\name{volcanoPlot}
\alias{volcanoPlot}
\title{Volcano plot of fold changes/differences against p-values}
\usage{
volcanoPlot(df, type = c("ttest", "proDA"))
}
\arguments{
\item{df}{\code{data.frame} as received from \code{topTable} (\code{ttest}) 
or \code{test_diff} (proDA)}

\item{type}{\code{character}}
}
\value{
\code{plotly}
}
\description{
The function \code{ComplexHeatmap} creates a volcano plot. On the y-axis the
-log10(p-values) are displayed, while on the x-axis the fold 
changes/differences are displayed.
The output of the function  differs depending on the
\code{type} parameter. For \code{type == "ttest"}, the fold changes are 
plotted; for \code{type == "proDA"}, the  differences are plotted.
}
\details{
Internal use in \code{shinyQC}.
}
\examples{
## create se
a <- matrix(seq_len(100), nrow = 10, ncol = 10, 
            dimnames = list(seq_len(10), paste("sample", seq_len(10))))
a[c(1, 5, 8), seq_len(5)] <- NA
set.seed(1)
a <- a + rnorm(100)
a_i <- imputeAssay(a, method = "MinDet")
cD <- data.frame(sample = colnames(a), 
    type = c(rep("1", 5), rep("2", 5)))
rD <- data.frame(spectra = rownames(a))
se <- SummarizedExperiment::SummarizedExperiment(assay = a, 
                                rowData = rD, colData = cD)
se_i <- SummarizedExperiment::SummarizedExperiment(assay = a_i, 
                                rowData = rD, colData = cD)

## create model and contrast matrix
modelMatrix_expr <- stats::formula("~ 0 + type")
contrast_expr <- "type1-type2"
modelMatrix <- model.matrix(modelMatrix_expr, data = colData(se))
contrastMatrix <- limma::makeContrasts(contrasts = contrast_expr, 
                                levels = modelMatrix)

## ttest
fit <- limma::lmFit(a_i, design = modelMatrix)
fit <- limma::contrasts.fit(fit, contrastMatrix)
fit <- limma::eBayes(fit, trend = TRUE)
df_ttest <- limma::topTable(fit, n = Inf, adjust = "fdr", p = 0.05)
df_ttest <- cbind(name = rownames(df_ttest), df_ttest)

## plot
volcanoPlot(df_ttest, type = "ttest")

## proDA
\donttest{
fit <- proDA::proDA(a, design = modelMatrix)
df_proDA <- proDA::test_diff(fit = fit, contrast = contrast_expr,
        sort_by = "adj_pval")

## plot
volcanoPlot(df_proDA, type = "proDA")
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/shinyQC.R
\name{shinyQC}
\alias{shinyQC}
\title{Shiny application for initial QC exploration of -omics data sets}
\usage{
shinyQC(se, app_server = FALSE)
}
\arguments{
\item{se}{\code{SummarizedExperiment} object (can be omitted)}

\item{app_server}{\code{logical} (set to \code{TRUE} if run under a server 
environment)}
}
\value{
\code{shiny} application, 
\code{SummarizedExperiment} upon exiting the \code{shiny} application
}
\description{
The shiny application allows to explore -omics
data sets especially with a focus on quality control. \code{shinyQC} gives
information on the type of samples included (if this was previously
specified within the \code{SummarizedExperiment} object). It gives 
information on the number of missing and measured values across features 
and across sets (e.g. quality control samples, control, and treatment 
groups, only displayed for \code{SummarizedExperiment} objects that 
contain missing values).

\code{shinyQC} includes functionality to display (count/intensity) values 
across samples (to detect drifts in intensity values during the 
measurement), to display
mean-sd plots, MA plots, ECDF plots, and distance plots between samples.
\code{shinyQC} includes functionality to perform dimensionality reduction
(currently limited to PCA, PCoA, NMDS, tSNE, and UMAP). Additionally,
it includes functionality to perform differential expression analysis
(currently limited to moderated t-tests and the Wald test).
}
\details{
\code{rownames(se)} should be set to the corresponding name of features, 
while \code{colnames(se)} should be set to the sample IDs. 
\code{rownames(se)} and \code{colnames(se)} are not allowed to be NULL.
\code{colnames(se)}, \code{colnames(assay(se))} and 
\code{rownames(colData(se))} all have to be identical.

\code{shinyQC} allows to subset the supplied \code{SummarizedExperiment} object. 

On exit of the shiny application, the (subsetted) \code{SummarizedExperiment} 
object is returned with information on the processing steps (normalization, 
transformation, batch correction and imputation). The object will 
only returned if \code{app_server = FALSE} and if the function call is assigned
to an object, e.g. \code{tmp <- shinyQC(se)}. 

If the \code{se} argument is omitted the app will load an interface that allows 
for data upload.
}
\examples{
library(dplyr)
library(SummarizedExperiment)

## create se
set.seed(1)
a <- matrix(rnorm(100, mean = 10, sd = 2), nrow = 10, ncol = 10, 
            dimnames = list(seq_len(10), paste("sample", seq_len(10))))
a[c(1, 5, 8), seq_len(5)] <- NA
cD <- data.frame(name = colnames(a), type = c(rep("1", 5), rep("2", 5)))
rD <- data.frame(spectra = rownames(a))
se <- SummarizedExperiment(assay = a, rowData = rD, colData = cD)

\donttest{shinyQC(se)}

}
\author{
Thomas Naake
}
